---@type table<MarioAnimID, string>
local bowsAnimTable = {
	-- FLAG_STYLE_ANIMS
	[MARIO_ANIM_RUNNING] = '0b_run',
    [MARIO_ANIM_CROUCHING] = '0b_crouch',
    [MARIO_ANIM_START_CROUCHING] = '0b_crouch_start',
    [MARIO_ANIM_STOP_CROUCHING] = '0b_crouch_stop',
    [MARIO_ANIM_CROUCH_FROM_FAST_LONGJUMP] = '0b_longjump_land',
    [MARIO_ANIM_CROUCH_FROM_SLOW_LONGJUMP] = '0b_longjump_land',
	[MARIO_ANIM_FAST_LONGJUMP] = '0b_longjump',
	[MARIO_ANIM_SLOW_LONGJUMP] = '0b_longjump',
	[MARIO_ANIM_CRAWLING] = '0b_crawl',
	[MARIO_ANIM_START_CRAWLING] = '0b_crawl_start',
	[MARIO_ANIM_STOP_CRAWLING] = '0b_crawl_stop',
	[MARIO_ANIM_SLIDE_DIVE] = '0b_dive_slide',
	[MARIO_ANIM_DIVE] = '0b_dive_slide',
	[MARIO_ANIM_TAKE_CAP_OFF_THEN_ON] = '0b_level_win',
	[MARIO_ANIM_WALK_WITH_LIGHT_OBJ] = '0b_obj_walk',
	[MARIO_ANIM_SLOW_WALK_WITH_LIGHT_OBJ] = '0b_obj_walk',
	[MARIO_ANIM_RUN_WITH_LIGHT_OBJ] = '0b_obj_walk',
	[MARIO_ANIM_IDLE_WITH_LIGHT_OBJ] = '0b_obj_idle',
	[MARIO_ANIM_JUMP_LAND_WITH_LIGHT_OBJ] = '0b_obj_land',
	[MARIO_ANIM_FALL_LAND_WITH_LIGHT_OBJ] = '0b_obj_land',
	[MARIO_ANIM_JUMP_WITH_LIGHT_OBJ] = '0b_obj_jump',
	[MARIO_ANIM_FALL_WITH_LIGHT_OBJ] = '0b_obj_fall',
	[MARIO_ANIM_FALL_FROM_SLIDING_WITH_LIGHT_OBJ] = '0b_obj_slidefall',
	[MARIO_ANIM_SLIDING_ON_BOTTOM_WITH_LIGHT_OBJ] = '0b_obj_slide',
	[MARIO_ANIM_STAND_UP_FROM_SLIDING_WITH_LIGHT_OBJ] = '0b_obj_slideup',
	[MARIO_ANIM_PICK_UP_LIGHT_OBJ] = '0b_obj_pick',
	[MARIO_ANIM_GROUND_KICK] = '0b_punch3',
	[MARIO_ANIM_START_GROUND_POUND] = '0b_pound',
	--[MARIO_ANIM_GROUND_POUND] = '0b_pound_loop',
	--[MARIO_ANIM_TRIPLE_JUMP_GROUND_POUND] = '0b_pound',
	--[MARIO_ANIM_GROUND_POUND_LANDING] = '0b_pound_land',
	-- FLAG_SIZE_ANIMS
    [MARIO_ANIM_IDLE_ON_LEDGE] = '1b_ledge_idle',
    [MARIO_ANIM_CLIMB_DOWN_LEDGE] = '1b_ledge_down',
    [MARIO_ANIM_FAST_LEDGE_GRAB] = '1b_ledge_hop',
    [MARIO_ANIM_SLOW_LEDGE_GRAB] = '1b_ledge_climb',
	[MARIO_ANIM_DYING_IN_QUICKSAND] = '1b_sand_die',
	-- pole animations
	-- hang anims
	-- FLAG_CAN_USE_FIREBALL
	[MARIO_ANIM_BREAKDANCE] = '2b_fire_shoot',
}


smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_START_GROUND_POUND], 0, 189, 0, 14, 14, {
	0x0000, 0x0036, 0x0037, 0x003B, 0x0041, 0x0047, 0x004D, 0x0052, 0x0056, 
	0x0058, 0x0051, 0x0042, 0x0033, 0x002C, 0x002E, 0x0034, 0x0039, 0x003B, 
	0x0000, 0x0001, 0x0003, 0x0005, 0x0008, 0x000C, 0x000F, 0x0013, 0x0015, 
	0x0017, 0x0018, 0x0018, 0x0019, 0x0000, 0x3FFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x4A68, 0x497A, 0x46E8, 0x4305, 0x3E27, 0x38A1, 
	0x32C6, 0x2CEC, 0x2766, 0x2287, 0x1EA5, 0x1C13, 0x1B25, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFCBD, 0xFCBD, 0xFCBE, 0xFCC0, 0xFCC1, 0xFCC3, 0xFCC5, 0xFCC7, 0xFCC9, 
	0xFCCB, 0xFCCC, 0xFCCD, 0x13EC, 0x1405, 0x1449, 0x14B1, 0x1532, 0x15C5, 
	0x1661, 0x16FD, 0x1790, 0x1812, 0x187A, 0x18BE, 0x18D7, 0x0000, 0x0006, 
	0x0015, 0x002D, 0x004A, 0x006C, 0x008F, 0x00B2, 0x00D4, 0x00F1, 0x0109, 
	0x0118, 0x011E, 0x0000, 0x000F, 0x003A, 0x007A, 0x00CB, 0x0127, 0x0187, 
	0x01E8, 0x0244, 0x0295, 0x02D5, 0x0300, 0x030F, 0x0190, 0x0249, 0x044A, 
	0x0751, 0x0B1C, 0x0F69, 0x13F9, 0x1888, 0x1CD6, 0x20A1, 0x23A8, 0x25A8, 
	0x2662, 0x0001, 0xFFFE, 0xC170, 0x9BD7, 0x9C6D, 0x9E11, 0xA095, 0xA3CD, 
	0xA78C, 0xABA5, 0xAFEB, 0xB431, 0xB84A, 0xBC09, 0xBF41, 0xC1C6, 0xC369, 
	0xC3FF, 0xC4EC, 0xC52A, 0xC5D8, 0xC6E3, 0xC838, 0xC9C5, 0xCB77, 0xCD3C, 
	0xCF00, 0xD0B3, 0xD240, 0xD395, 0xD49F, 0xD54D, 0xD58B, 0x194D, 0x193E, 
	0x1916, 0x18D7, 0x1887, 0x182B, 0x17C5, 0x175B, 0x16F1, 0x168B, 0x162E, 
	0x15DF, 0x15A0, 0x1577, 0x1569, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xD609, 0xD5B2, 
	0xD4C0, 0xD34B, 0xD16E, 0xCF44, 0xCCE5, 0xCA6C, 0xC7F3, 0xC595, 0xC36A, 
	0xC18D, 0xC019, 0xBF26, 0xBECF, 0xFF89, 0xF97F, 0xF06E, 0x0001, 0xFFFE, 
	0xC170, 0x492C, 0x493D, 0x496E, 0x49B4, 0x4A0B, 0x4A68, 0x4AC6, 0x4B1C, 
	0x4B63, 0x4B93, 0x4BA5, 0x2EC5, 0x2E5A, 0x2D37, 0x2B8B, 0x2983, 0x274D, 
	0x2518, 0x2310, 0x2163, 0x2041, 0x1FD6, 0xF6C0, 0xF878, 0xFD21, 0x03FF, 
	0x0C56, 0x1568, 0x1E7B, 0x26D1, 0x2DAF, 0x3257, 0x340F, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0xDBBD, 0xDB22, 0xD97E, 0xD713, 0xD423, 0xD0F1, 
	0xCDBF, 0xCACF, 0xC864, 0xC6C0, 0xC625, 0x0000, 0x0005, 0x0012, 0x0025, 
	0x003D, 0x0056, 0x0070, 0x0088, 0x009B, 0x00A8, 0x00AD, 0xFFFF, 0xFFEB, 
	0xFFB3, 0xFF62, 0xFEFF, 0xFE93, 0xFE27, 0xFDC4, 0xFD73, 0xFD3B, 0xFD27, 
	0xED8B, 0xED4E, 0xECA6, 0xEBB0, 0xEA85, 0xE940, 0xE7FB, 0xE6D0, 0xE5DA, 
	0xE533, 0xE4F5, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xBF5E, 0x002A, 0x0029, 0x0026, 0x0021, 0x001B, 0x0015, 0x000F, 
	0x0009, 0x0004, 0x0001, 0xFFFF, 0x0063, 0x0004, 0xFF03, 0xFD89, 0xFBBE, 
	0xF9CA, 0xF7D7, 0xF60B, 0xF491, 0xF391, 0xF332, 0xB182, 0xB04D, 0xAD06, 
	0xA831, 0xA254, 0x9BF1, 0x958F, 0x8FB2, 0x8ADD, 0x8796, 0x8660, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x4A26, 0x4988, 0x47DC, 
	0x4565, 0x4267, 0x3F26, 0x3BE4, 0x38E6, 0x3670, 0x34C3, 0x3426, 0x0095, 
	0xFF08, 0xCC41, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xBF5E, 0x007E, 0x0057, 0xFFEA, 0xFF45, 0xFE73, 0xFD83, 0xFC7F, 
	0xFB75, 0xFA71, 0xF980, 0xF8AF, 0xF80A, 0xF79D, 0xF777, 0xFE93, 0xFEBB, 
	0xFF2A, 0xFFD3, 0x00AB, 0x01A2, 0x02AC, 0x03BD, 0x04C8, 0x05BF, 0x0696, 
	0x073F, 0x07AE, 0x07D6, 0x854C, 0x851F, 0x84A1, 0x83E1, 0x82ED, 0x81D5, 
	0x80A6, 0x7F71, 0x7E42, 0x7D2A, 0x7C36, 0x7B76, 0x7AF8, 0x7ACB, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x5341, 0x52CD, 0x518A, 0x4F9E, 0x4D2F, 0x4A61, 0x475B, 0x4442, 0x413C, 
	0x3E6F, 0x3BFF, 0x3A13, 0x38D1, 0x385D, 0x001B, 0x025B, 0xCB24, 
},
{
	0x0001, 0x0000, 0x0011, 0x0001, 0x000D, 0x0012, 0x0001, 0x001F, 0x0001, 
	0x0020, 0x0001, 0x0021, 0x000B, 0x0022, 0x000C, 0x002D, 0x000D, 0x0039, 
	0x000B, 0x0046, 0x000C, 0x0051, 0x000D, 0x005D, 0x000D, 0x006A, 0x000D, 
	0x0077, 0x000D, 0x0084, 0x0001, 0x0091, 0x0001, 0x0092, 0x0001, 0x0093, 
	0x000F, 0x0094, 0x000F, 0x00A3, 0x000F, 0x00B2, 0x000F, 0x00C1, 0x000F, 
	0x00D0, 0x000F, 0x00DF, 0x0001, 0x00EE, 0x0001, 0x00EF, 0x0001, 0x00F0, 
	0x0001, 0x00F1, 0x0001, 0x00F2, 0x0001, 0x00F3, 0x000B, 0x00F4, 0x000B, 
	0x00FF, 0x000B, 0x010A, 0x000D, 0x0115, 0x000A, 0x0122, 0x000B, 0x012C, 
	0x000B, 0x0137, 0x000B, 0x0142, 0x000B, 0x014D, 0x000D, 0x0158, 0x000D, 
	0x0165, 0x0001, 0x0172, 0x000B, 0x0173, 0x000B, 0x017E, 0x000B, 0x0189, 
	0x000C, 0x0194, 0x000D, 0x01A0, 0x000B, 0x01AD, 0x0001, 0x01B8, 0x0001, 
	0x01B9, 0x0001, 0x01BA, 0x000D, 0x01BB, 0x000D, 0x01C8, 0x0001, 0x01D5, 
	0x000E, 0x01D6, 0x000E, 0x01E4, 0x000E, 0x01F2, 0x000E, 0x0200, 0x000E, 
	0x020E, 0x000E, 0x021C, 0x0001, 0x022A, 0x0001, 0x022B, 0x0001, 0x022C, 
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_GROUND_KICK], 0, 189, 0, 25, 25, {
	0x0000, 0x00AA, 0x003D, 0x003D, 0x003D, 0x003D, 0x003D, 0x003D, 0x003D, 
	0x003D, 0x003D, 0x003D, 0x003D, 0x003D, 0x003C, 0x003A, 0x0036, 0x0031, 
	0x002B, 0x0025, 0x001F, 0x0018, 0x0012, 0x000C, 0x0007, 0x0003, 0x0001, 
	0x0000, 0x0000, 0x3FFF, 0x0000, 0xEF60, 0xEF60, 0xEF60, 0xEF60, 0xEF60, 
	0xEF60, 0xEF60, 0xEF60, 0xEF86, 0xEFF2, 0xF09B, 0xF179, 0xF283, 0xF3AF, 
	0xF4F6, 0xF64F, 0xF7B0, 0xF911, 0xFA69, 0xFBB0, 0xFCDD, 0xFDE6, 0xFEC4, 
	0xFF6D, 0xFFD9, 0xFFFF, 0xFFFF, 0x40A1, 0xDA7D, 0xDBE8, 0xE071, 0xE884, 
	0xF48E, 0x04FB, 0x17C8, 0x2133, 0x20C1, 0x1F82, 0x1D9C, 0x1B31, 0x1865, 
	0x155D, 0x123C, 0x0F25, 0x0C3E, 0x09A3, 0x0759, 0x0561, 0x03B9, 0x025F, 
	0x0154, 0x0097, 0x0026, 0x0000, 0x0314, 0x0252, 0x0059, 0xFD94, 0xFA74, 
	0xF768, 0xF4F3, 0xF3EC, 0xF427, 0xF4C9, 0xF5BB, 0xF6E8, 0xF83A, 0xF99C, 
	0xFAF6, 0xFC34, 0xFD3F, 0xFE11, 0xFEB4, 0xFF2E, 0xFF86, 0xFFC1, 0xFFE5, 
	0xFFF7, 0xFFFE, 0xFFFF, 0x1F18, 0x1FB4, 0x2129, 0x22E6, 0x245A, 0x24F7, 
	0x19F7, 0x0E7A, 0x0D9F, 0x0D00, 0x0C91, 0x0C47, 0x0C18, 0x0BF8, 0x0BDC, 
	0x0BBA, 0x0B86, 0x0B39, 0x0AD7, 0x0A69, 0x09F6, 0x0986, 0x0921, 0x08CF, 
	0x0898, 0x0884, 0xF39D, 0xF4F3, 0xF874, 0xFD5E, 0x02F0, 0x0866, 0x0D1F, 
	0x10FC, 0x13FD, 0x1622, 0x176B, 0x17D9, 0x1780, 0x1686, 0x1508, 0x131E, 
	0x10E5, 0x0E76, 0x0BEC, 0x0963, 0x06F4, 0x04BA, 0x02D1, 0x0152, 0x0059, 
	0xFFFF, 0x0462, 0x0491, 0x04FF, 0x0583, 0x05F1, 0x0620, 0x057D, 0x03E7, 
	0x01D6, 0xFFC5, 0xFE2E, 0xFD8B, 0xFD95, 0xFDAE, 0xFDD5, 0xFE08, 0xFE42, 
	0xFE82, 0xFEC5, 0xFF08, 0xFF48, 0xFF83, 0xFFB5, 0xFFDC, 0xFFF6, 0xFFFF, 
	0x19A1, 0x1756, 0x115E, 0x0915, 0xFFD8, 0xF704, 0xEFB5, 0xEA09, 0xE5DC, 
	0xE30C, 0xE175, 0xE0F6, 0xE15C, 0xE27A, 0xE432, 0xE665, 0xE8F4, 0xEBC0, 
	0xEEAB, 0xF196, 0xF463, 0xF6F1, 0xF924, 0xFADC, 0xFBFB, 0xFC61, 0x0001, 
	0xFFFE, 0xC117, 0xC3EE, 0xC3F9, 0xC427, 0xC48A, 0xC536, 0xC63D, 0xC7B4, 
	0xC9AB, 0xCC2F, 0xCF29, 0xD27B, 0xD606, 0xD9AD, 0xDD62, 0xE117, 0xE4BF, 
	0xE84D, 0xEBB2, 0xEEE3, 0xF1D2, 0xF472, 0xF6B5, 0xF88E, 0xF9F1, 0xFACF, 
	0xFB1C, 0xDE84, 0xDE73, 0xDE47, 0xDE0A, 0xDDC8, 0xDD8B, 0xDD5F, 0xDD4E, 
	0xDE9D, 0xE180, 0xE463, 0xE5B3, 0xE56D, 0xE4A8, 0xE379, 0xE1F7, 0xE035, 
	0xDE48, 0xDC47, 0xDA46, 0xD85A, 0xD697, 0xD515, 0xD3E6, 0xD321, 0xD2DB, 
	0xF5B5, 0xF5AE, 0xF593, 0xF558, 0xF4F2, 0xF454, 0xF374, 0xF246, 0xF0C3, 
	0xEEF9, 0xECFA, 0xEADA, 0xE8A9, 0xE671, 0xE439, 0xE20A, 0xDFEA, 0xDDE3, 
	0xDBFC, 0xDA3C, 0xD8AC, 0xD753, 0xD639, 0xD565, 0xD4E1, 0xD4B3, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xB975, 0xB989, 0xB9C3, 
	0xBA20, 0xBA9D, 0xBB35, 0xBBE7, 0xBCAE, 0xBD87, 0xBE6F, 0xBF63, 0xC05F, 
	0xC160, 0xC263, 0xC364, 0xC460, 0xC554, 0xC63C, 0xC715, 0xC7DC, 0xC88E, 
	0xC926, 0xC9A3, 0xCA00, 0xCA3A, 0xCA4E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xF97B, 0xED8B, 0x0001, 0xFFFE, 0xC170, 
	0x0A96, 0x0BAA, 0x0EA9, 0x133E, 0x190F, 0x1FC5, 0x26E5, 0x2D6B, 0x322E, 
	0x3406, 0x337F, 0x3204, 0x2FB6, 0x2CB8, 0x292F, 0x253D, 0x2104, 0x1CA8, 
	0x184D, 0x1414, 0x1022, 0x0C98, 0x099B, 0x074D, 0x05D1, 0x054B, 0x2B43, 
	0x2A7B, 0x287E, 0x25D8, 0x2311, 0x20B5, 0x1F2C, 0x1E5B, 0x1E0A, 0x1DFC, 
	0x1E24, 0x1E94, 0x1F43, 0x2026, 0x2132, 0x225E, 0x239E, 0x24E9, 0x2633, 
	0x2774, 0x289F, 0x29AC, 0x2A8F, 0x2B3D, 0x2BAE, 0x2BD6, 0xD2FE, 0xD4D2, 
	0xD995, 0xE036, 0xE7A4, 0xEECD, 0xF4C5, 0xF93E, 0xFC0B, 0xFD03, 0xFC79, 
	0xFAF3, 0xF894, 0xF581, 0xF1DE, 0xEDCF, 0xE978, 0xE4FC, 0xE081, 0xDC2A, 
	0xD81A, 0xD477, 0xD164, 0xCF06, 0xCD7F, 0xCCF5, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xD756, 0xD815, 0xD9DC, 0xDBFC, 
	0xDDC3, 0xDE82, 0xDE58, 0xDDE0, 0xDD22, 0xDC27, 0xDAF8, 0xD99E, 0xD821, 
	0xD689, 0xD4E1, 0xD32F, 0xD17E, 0xCFD5, 0xCE3E, 0xCCC1, 0xCB66, 0xCA37, 
	0xC93C, 0xC87F, 0xC806, 0xC7DC, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xF548, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xBF5E, 
	0xCC3E, 0xCBCB, 0xCA97, 0xC8D9, 0xC6C9, 0xC49D, 0xC28C, 0xC0CE, 0xBF9A, 
	0xBF28, 0xC0CA, 0xC502, 0xCAC6, 0xD10E, 0xD6D3, 0xDB0A, 0xDCAD, 0xDC75, 
	0xDBDE, 0xDB05, 0xDA03, 0xD8F3, 0xD7F1, 0xD718, 0xD681, 0xD649, 0xE46F, 
	0xE46E, 0xE46D, 0xE468, 0xE45E, 0xE44E, 0xE436, 0xE415, 0xE3E9, 0xE3B0, 
	0xE360, 0xE2F6, 0xE282, 0xE20F, 0xE1AC, 0xE167, 0xE14D, 0xE1AD, 0xE2AF, 
	0xE424, 0xE5DE, 0xE7AF, 0xE969, 0xEADE, 0xEBE0, 0xEC40, 0xB8F0, 0xB939, 
	0xB9FC, 0xBB16, 0xBC64, 0xBDC3, 0xBF12, 0xC02B, 0xC0EE, 0xC137, 0xC009, 
	0xBCFF, 0xB8D8, 0xB451, 0xB02A, 0xAD20, 0xABF2, 0xAC47, 0xAD2B, 0xAE74, 
	0xAFFA, 0xB195, 0xB31C, 0xB465, 0xB548, 0xB59D, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x2C8D, 0x2C8D, 0x2C8D, 0x2C8D, 0x2C8D, 0x2C8D, 0x2C8D, 0x2C8D, 
	0x2C8D, 0x2C8D, 0x2D02, 0x2E31, 0x2FD0, 0x3193, 0x3332, 0x3461, 0x34D6, 
	0x344D, 0x32DE, 0x30C9, 0x2E53, 0x2BBB, 0x2944, 0x2730, 0x25C0, 0x2537, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xD405, 0xD405, 0xD402, 0xD3F9, 0xD3E8, 0xD3CD, 0xD3A4, 0xD36B, 0xD31F, 
	0xD2BE, 0xD244, 0xD1AF, 0xD0FD, 0xD02A, 0xCF34, 0xCE18, 0xCCD4, 0xCB4C, 
	0xC97C, 0xC783, 0xC580, 0xC394, 0xC1DF, 0xC07F, 0xBF94, 0xBF3F, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xBF5E, 0x1B09, 0x1B09, 0x1B09, 0x1B09, 0x1B09, 0x1B09, 
	0x1B1F, 0x1B58, 0x1BA1, 0x1BEB, 0x1C23, 0x1C3A, 0x1C35, 0x1C29, 0x1C16, 
	0x1BFD, 0x1BE1, 0x1BC2, 0x1BA1, 0x1B81, 0x1B62, 0x1B45, 0x1B2D, 0x1B1A, 
	0x1B0D, 0x1B09, 0x1144, 0x1144, 0x1144, 0x1144, 0x1144, 0x1144, 0x114F, 
	0x1169, 0x118C, 0x11AE, 0x11C9, 0x11D3, 0x11D1, 0x11CB, 0x11C2, 0x11B7, 
	0x11AA, 0x119B, 0x118C, 0x117C, 0x116E, 0x1160, 0x1155, 0x114C, 0x1146, 
	0x1144, 0xAC43, 0xAC43, 0xAC43, 0xAC43, 0xAC43, 0xAC43, 0xAC4D, 0xAC64, 
	0xAC83, 0xACA2, 0xACBA, 0xACC3, 0xACC1, 0xACBC, 0xACB4, 0xACAA, 0xAC9E, 
	0xAC91, 0xAC83, 0xAC76, 0xAC69, 0xAC5D, 0xAC52, 0xAC4A, 0xAC45, 0xAC43, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x1E4A, 0xFB0D, 
	0xFB0D, 0xFB0E, 0xFB10, 0xFB14, 0xFB1C, 0xFB27, 0xFB36, 0xFB4A, 0xFB64, 
	0xFB85, 0xFBAD, 0xFBE2, 0xFC2A, 0xFC80, 0xFCE1, 0xFD49, 0xFDB5, 0xFE22, 
	0xFE8C, 0xFEEE, 0xFF47, 0xFF92, 0xFFCC, 0xFFF2, 0xFFFF, 0xF060, 0xF060, 
	0xF064, 0xF06E, 0xF081, 0xF0A1, 0xF0D0, 0xF112, 0xF169, 0xF1DA, 0xF267, 
	0xF312, 0xF3E2, 0xF4D3, 0xF5DD, 0xF6F9, 0xF81F, 0xF948, 0xFA6A, 0xFB7F, 
	0xFC7F, 0xFD62, 0xFE20, 0xFEB1, 0xFF0E, 0xFF2F, 0xCA35, 0xCA37, 0xCA3B, 
	0xCA43, 0xCA4B, 0xCA55, 0xCA60, 0xCA6A, 0xCA72, 0xCA7A, 0xCA7E, 0xCA80, 
	0xCA7E, 0xCA77, 0xCA6C, 0xCA5F, 0xCA4F, 0xCA3E, 0xCA2C, 0xCA1A, 0xCA08, 
	0xC9F9, 0xC9EB, 0xC9E1, 0xC9DA, 0xC9D7, 
},
{
	0x0001, 0x0000, 0x0001, 0x0001, 0x001A, 0x0002, 0x0001, 0x001C, 0x0001, 
	0x001D, 0x0001, 0x001E, 0x001A, 0x001F, 0x0001, 0x0039, 0x0001, 0x003A, 
	0x001A, 0x003B, 0x001A, 0x0055, 0x001A, 0x006F, 0x001A, 0x0089, 0x001A, 
	0x00A3, 0x001A, 0x00BD, 0x0001, 0x00D7, 0x0001, 0x00D8, 0x0001, 0x00D9, 
	0x001A, 0x00DA, 0x001A, 0x00F4, 0x001A, 0x010E, 0x0018, 0x0128, 0x0001, 
	0x0140, 0x001A, 0x0141, 0x001A, 0x015B, 0x0001, 0x0175, 0x0001, 0x0176, 
	0x0001, 0x0177, 0x0001, 0x0178, 0x0001, 0x0179, 0x001A, 0x017A, 0x001A, 
	0x0194, 0x001A, 0x01AE, 0x0019, 0x01C8, 0x0001, 0x01E1, 0x001A, 0x01E2, 
	0x0018, 0x01FC, 0x0015, 0x0214, 0x0001, 0x0229, 0x0018, 0x022A, 0x0018, 
	0x0242, 0x0001, 0x025A, 0x001A, 0x025B, 0x001A, 0x0275, 0x001A, 0x028F, 
	0x0017, 0x02A9, 0x001A, 0x02C0, 0x001A, 0x02DA, 0x001A, 0x02F4, 0x0001, 
	0x030E, 0x001A, 0x030F, 0x0018, 0x0329, 0x0018, 0x0341, 0x0001, 0x0359, 
	0x001A, 0x035A, 0x001A, 0x0374, 0x001A, 0x038E, 0x001A, 0x03A8, 0x001A, 
	0x03C2, 0x0001, 0x03DC, 0x001A, 0x03DD, 0x001A, 0x03F7, 0x001A, 0x0411, 
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_PICK_UP_LIGHT_OBJ], 0, 189, 0, 10, 10, {
	0x0000, 0x0000, 0x0001, 0x0001, 0x0002, 0x0002, 0x0003, 0x0003, 0x0002, 
	0x0000, 0x0098, 0x009A, 0x009B, 0x009B, 0x009A, 0x0015, 0x001A, 0x001F, 
	0x0020, 0x0019, 0x000F, 0x0004, 0xFFFE, 0xFFFF, 0x0003, 0x0007, 0x0000, 
	0x3FFF, 0x0000, 0x17E6, 0x1588, 0x135F, 0x10A3, 0x0D8C, 0x0A54, 0x0733, 
	0x0461, 0x0218, 0x008F, 0x0000, 0x00F4, 0xFED8, 0xFE7E, 0xFE63, 0xFE7B, 
	0xFEB6, 0xFF06, 0xFF5E, 0xFFAE, 0xFFE9, 0x0000, 0x56B3, 0x582E, 0x55D4, 
	0x523F, 0x4DD7, 0x4902, 0x4428, 0x3FAE, 0x3BFD, 0x397A, 0x388D, 0x1F34, 
	0x232F, 0x2941, 0x2F6D, 0x30EF, 0x2A5B, 0x1F1E, 0x14B6, 0x0BB7, 0x038E, 
	0xFFFF, 0xEFAA, 0xEDC2, 0xF1A3, 0xF683, 0xF9FE, 0xFA90, 0xF9BC, 0xF9A7, 
	0xFBBE, 0xFE93, 0xFFFF, 0x184B, 0x1154, 0x0DC3, 0x0ADD, 0x088D, 0x0772, 
	0x06ED, 0x0507, 0xFF7A, 0xF88C, 0xF526, 0xD7ED, 0xDA07, 0xD6D4, 0xD2CC, 
	0xD31D, 0xD95F, 0xE280, 0xECB9, 0xF63D, 0xFD42, 0xFFFF, 0xFC02, 0xF9D1, 
	0xFA73, 0xFC5D, 0xFDD8, 0xFE7B, 0xFF03, 0xFF6F, 0xFFBF, 0xFFEF, 0xFEA5, 
	0xF088, 0xEF89, 0xF038, 0xF257, 0xF592, 0xFA20, 0xFFD8, 0x05D7, 0x0B3A, 
	0x0F1C, 0x109A, 0x0001, 0xFFFE, 0xC117, 0xC170, 0xC260, 0xC390, 0xC4E8, 
	0xC64F, 0xC7AC, 0xC8E6, 0xC9E6, 0xCA91, 0xCACF, 0xB560, 0x2DB6, 0x2978, 
	0x252E, 0x20FE, 0x1D0C, 0x1DF0, 0x2010, 0x2299, 0x24B9, 0x259D, 0x97BE, 
	0xEEA4, 0xF109, 0xF317, 0xF4D2, 0xF63E, 0xF204, 0xE7F0, 0xDBE9, 0xD1D6, 
	0xCD9C, 0x0416, 0x82F7, 0x835D, 0x8419, 0x8510, 0x8628, 0x8F12, 0x9F93, 
	0xB22C, 0xC15D, 0xC7A6, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xDD72, 0xDFA0, 0xE26B, 0xE5C1, 0xE966, 0xED1F, 0xEC01, 
	0xE958, 0xE62A, 0xE381, 0xE263, 0xE572, 0xDAF1, 0xD9CA, 0xDA20, 0xDB96, 
	0xDDD1, 0xE072, 0xE31E, 0xE57A, 0xE729, 0xE7CD, 0xF159, 0xEE81, 0xEEE2, 
	0xEFE5, 0xF15C, 0xF319, 0xF4ED, 0xF6A9, 0xF820, 0xF923, 0xF983, 0xF24F, 
	0xF3C5, 0xF325, 0xF20C, 0xF0A1, 0xEF07, 0xED65, 0xEBDF, 0xEA9A, 0xE9BC, 
	0xE96A, 0x0001, 0xFFFE, 0xC170, 0xC170, 0xC13A, 0xC103, 0xC170, 0xC2BB, 
	0xC484, 0xC672, 0xC836, 0xC97F, 0xC9FE, 0xF162, 0xF4DB, 0xF4EB, 0xF4D1, 
	0xF496, 0xF447, 0xF39F, 0xF2B9, 0xF1CD, 0xF116, 0xF0CC, 0x1B87, 0x1AFD, 
	0x195D, 0x1778, 0x156F, 0x1360, 0x124F, 0x11AA, 0x1155, 0x1135, 0x1131, 
	0x882E, 0x8A3E, 0x8AF2, 0x8BAC, 0x8C63, 0x8D13, 0x89AC, 0x818E, 0x77DD, 
	0x6FBF, 0x6C57, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xE4C3, 0xDD74, 0xD883, 
	0xD4CA, 0xD475, 0xD7F5, 0xDE0E, 0xE483, 0xEA58, 0xEE92, 0xF032, 0x1EB5, 
	0x1CF7, 0x135E, 0x05FB, 0xFE21, 0xFD73, 0xFF13, 0x02F5, 0x0796, 0x0B77, 
	0x0D18, 0x1399, 0x1264, 0x0CC6, 0x04EC, 0x0043, 0xFFB7, 0x0243, 0x0854, 
	0x0F91, 0x15A2, 0x182D, 0xF0F7, 0xF6A6, 0xF621, 0xF28E, 0xF66A, 0x027A, 
	0x010D, 0xFDA5, 0xF996, 0xF62F, 0xF4C2, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xBF5E, 0xF5C6, 
	0xF370, 0xF066, 0xECA3, 0xE892, 0xE49C, 0xE12D, 0xDE0F, 0xDB26, 0xD8FE, 
	0xD826, 0x05EF, 0x046A, 0x00A2, 0xFB07, 0xF4B7, 0xEED1, 0xEA75, 0xE82D, 
	0xE757, 0xE74F, 0xE771, 0x9802, 0x9A05, 0x9BC8, 0x9DBB, 0x9FFF, 0xA2B4, 
	0xA5FE, 0xAB3E, 0xB218, 0xB80A, 0xBA93, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x2C93, 0x2C73, 
	0x2DD5, 0x2FBB, 0x31D3, 0x33CE, 0x355B, 0x3664, 0x3712, 0x3770, 0x378C, 
	0xFDB9, 0xFE35, 0xFF2A, 0x0066, 0x01A3, 0x029B, 0x0309, 0x026A, 0x00F7, 
	0xFF7F, 0xFED3, 0x008F, 0x00E0, 0x0153, 0x01D5, 0x024A, 0x0296, 0x029E, 
	0x0213, 0x010E, 0x0012, 0xFFA1, 0xB78B, 0xB310, 0xB2C3, 0xB390, 0xB4DD, 
	0xB614, 0xB69D, 0xB60E, 0xB4D3, 0xB398, 0xB309, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xBF5E, 
	0x08EE, 0x0B34, 0x0C46, 0x0AD0, 0x081E, 0x05DA, 0x05AF, 0x0951, 0x0F70, 
	0x1533, 0x17C1, 0x124E, 0x129E, 0x1379, 0x1578, 0x1811, 0x1A62, 0x1B8B, 
	0x1ACF, 0x18D1, 0x16C0, 0x15CC, 0xC173, 0xC1AC, 0xBF0A, 0xB722, 0xAC6A, 
	0xA280, 0x9D04, 0x9E99, 0xA4C1, 0xAB6C, 0xAE8D, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x39F8, 0x34AF, 0x3E0F, 0x415B, 0x435C, 0x42FA, 0x3641, 0x33F8, 0x3312, 
	0x32F8, 0x3311, 0x000B, 0x002D, 0x0108, 0x01DE, 0x02B6, 0x0386, 0x0444, 
	0x0480, 0x0310, 0x015D, 0x008C, 0xFF36, 0xFF3B, 0xFF47, 0xFEB6, 0xFE03, 
	0xFD6A, 0xFD2B, 0xFF55, 0x0059, 0x011E, 0x016D, 0xC434, 0xC09A, 0xBB78, 
	0xBB1C, 0xBB95, 0xBBE5, 0xBB0E, 0xB2B8, 0xB513, 0xB94F, 0xBB93, 
},
{
	0x000A, 0x0000, 0x0005, 0x000A, 0x000B, 0x000F, 0x0001, 0x001A, 0x0001, 
	0x001B, 0x0001, 0x001C, 0x000B, 0x001D, 0x000B, 0x0028, 0x000B, 0x0033, 
	0x000B, 0x003E, 0x000B, 0x0049, 0x000B, 0x0054, 0x000B, 0x005F, 0x000B, 
	0x006A, 0x000B, 0x0075, 0x0001, 0x0080, 0x0001, 0x0081, 0x000B, 0x0082, 
	0x000B, 0x008D, 0x000B, 0x0098, 0x000B, 0x00A3, 0x0009, 0x00AE, 0x0008, 
	0x00B7, 0x000B, 0x00BF, 0x000B, 0x00CA, 0x000B, 0x00D5, 0x000B, 0x00E0, 
	0x0001, 0x00EB, 0x0001, 0x00EC, 0x000B, 0x00ED, 0x000B, 0x00F8, 0x000B, 
	0x0103, 0x000B, 0x010E, 0x000B, 0x0119, 0x000B, 0x0124, 0x000B, 0x012F, 
	0x000B, 0x013A, 0x000B, 0x0145, 0x000B, 0x0150, 0x000A, 0x015B, 0x000A, 
	0x0165, 0x0001, 0x016F, 0x000B, 0x0170, 0x000B, 0x017B, 0x000B, 0x0186, 
	0x000B, 0x0191, 0x0009, 0x019C, 0x000B, 0x01A5, 0x000B, 0x01B0, 0x000B, 
	0x01BB, 0x000B, 0x01C6, 0x000A, 0x01D1, 0x000A, 0x01DB, 0x0001, 0x01E5, 
	0x000B, 0x01E6, 0x000B, 0x01F1, 0x000B, 0x01FC, 0x000A, 0x0207, 0x000B, 
	0x0211, 0x000B, 0x021C, 0x000B, 0x0227, 0x000B, 0x0232, 0x000B, 0x023D, 
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_STAND_UP_FROM_SLIDING_WITH_LIGHT_OBJ], 0, 189, 0, 13, 13, {
	0x0000, 0x0036, 0x0036, 0x0036, 0x003D, 0x004D, 0x005C, 0x0067, 0x0075, 
	0x008C, 0x009E, 0x00A1, 0x009D, 0x009A, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0001, 0x0001, 0x0002, 0x0003, 0x0004, 0x0005, 0x0006, 0x0006, 0x0007, 
	0x0000, 0x3FFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x1E68, 0x1D8E, 
	0x1E68, 0x2226, 0x2672, 0x2B15, 0x2FDD, 0x3495, 0x3907, 0x3D00, 0x3BBD, 
	0x3A6B, 0x3921, 0x388D, 0x0000, 0xFFA8, 0xFF39, 0xFF1B, 0xFF15, 0xFF15, 
	0xFF1B, 0xFF33, 0xFF5D, 0xFF93, 0xFFC7, 0xFFF0, 0x0000, 0xFFFF, 0xFCBD, 
	0xFCB1, 0xFCD5, 0xFD5A, 0xFE05, 0xFEA6, 0xFF31, 0xFF8F, 0xFFBA, 0xFFDA, 
	0xFFF0, 0xFFFC, 0x0000, 0xFFFF, 0x13EC, 0x1831, 0x1DBB, 0x1F39, 0x1FAB, 
	0x20A4, 0x2596, 0x268C, 0x1D6F, 0x10B0, 0x038E, 0xF94B, 0xF526, 0xFEE2, 
	0xFE61, 0xFE44, 0xFE69, 0xFE9A, 0xFED1, 0xFF0C, 0xFF48, 0xFF81, 0xFFB3, 
	0xFFDB, 0xFFF6, 0xFFFF, 0x030F, 0x02E6, 0x02C2, 0x027C, 0x0229, 0x01CE, 
	0x0170, 0x0113, 0x00BD, 0x0071, 0x0035, 0x000E, 0x0000, 0x09D5, 0x0303, 
	0x0135, 0x0267, 0x0404, 0x05EB, 0x07FC, 0x0A15, 0x0C17, 0x0DDF, 0x0F4D, 
	0x1041, 0x109A, 0xFFFE, 0x0001, 0xC170, 0xFEF7, 0xFD28, 0xF8A3, 0xF2C2, 
	0xECE1, 0xE85B, 0xE68C, 0xE875, 0xED63, 0xF41F, 0xFB77, 0x0235, 0x0722, 
	0x090B, 0xC507, 0xC55F, 0xC648, 0xC796, 0xC91D, 0xCAB0, 0xCC23, 0xCD52, 
	0xCE3C, 0xCEE9, 0xCF62, 0xCFAE, 0xCFD6, 0xCFE1, 0xEF6B, 0xF146, 0xF5EA, 
	0xFBF3, 0x01FD, 0x06A1, 0x087D, 0x0680, 0x015F, 0xFA5B, 0xF2B8, 0xEBB5, 
	0xE695, 0xE498, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xE263, 
	0xE7CD, 0xF983, 0xE96A, 0xFFFE, 0x0001, 0xC170, 0xF0CC, 0x1131, 0x6C57, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0xF032, 0x0D18, 0x182D, 0xF4C2, 0xFFFF, 0xFFF9, 0xFFFF, 0x0026, 
	0x005A, 0x0089, 0x00B5, 0x00C7, 0x0096, 0x0058, 0x002F, 0x000E, 0xFFFF, 
	0x0000, 0xFFFF, 0xFF48, 0xFFFF, 0x0411, 0x0968, 0x0E57, 0x12F3, 0x14D5, 
	0x0FBF, 0x0938, 0x04FA, 0x0176, 0x0000, 0xFFFF, 0xBF5E, 0xBF5A, 0xBF5E, 
	0xBF77, 0xBF98, 0xBFB6, 0xBFD3, 0xBFDE, 0xBFBF, 0xBF97, 0xBF7D, 0xBF67, 
	0xBF5E, 0xFAB1, 0xFCF0, 0xFFB2, 0x002F, 0x0003, 0xFFD6, 0x0162, 0xFFE2, 
	0xF439, 0xE79F, 0xE014, 0xDA65, 0xD826, 0xF79C, 0xFB84, 0x004B, 0x0114, 
	0x00B7, 0x0058, 0x0117, 0x005E, 0xFB03, 0xF4A2, 0xEEFF, 0xE9C1, 0xE771, 
	0x9D31, 0x8FC2, 0x8106, 0x82EA, 0x89E8, 0x902A, 0x91EE, 0x94BD, 0x9E23, 
	0xA84C, 0xB066, 0xB785, 0xBA93, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x09C7, 0x204B, 0x3DED, 0x48E5, 0x4E99, 0x50E8, 0x4CD2, 
	0x4421, 0x3937, 0x3108, 0x319A, 0x354C, 0x378C, 0x00D0, 0x0069, 0x0095, 
	0x0259, 0x04AD, 0x068B, 0x05C5, 0x07E6, 0x0A48, 0x0AE7, 0x06F7, 0x018D, 
	0xFED3, 0xFF37, 0xFF1F, 0xFF08, 0xFF0F, 0xFF22, 0xFF3F, 0xFF94, 0xFFA4, 
	0x0067, 0x00EF, 0x0098, 0xFFF8, 0xFFA1, 0xC1A9, 0xC70A, 0xCC41, 0xC9B7, 
	0xC4AC, 0xC008, 0xBE5E, 0xBF90, 0xBC8E, 0xB929, 0xB676, 0xB411, 0xB309, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xBF5E, 0xFFC2, 0xFF80, 0x00AA, 0x0495, 0x0991, 0x0E04, 0x10BF, 
	0x12E8, 0x15DD, 0x180E, 0x1868, 0x180C, 0x17C1, 0x0BBA, 0x0577, 0xFED9, 
	0x0043, 0x0437, 0x0821, 0x0B4E, 0x0E01, 0x0F54, 0x1065, 0x127D, 0x14BF, 
	0x15CC, 0x9C0C, 0x8E42, 0x7F98, 0x82B9, 0x8B66, 0x9350, 0x9741, 0x9AC2, 
	0xA054, 0xA597, 0xA9AC, 0xAD1B, 0xAE8D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0640, 0x1F1C, 0x3F4A, 0x49A5, 0x4DD5, 
	0x4F7A, 0x4DCA, 0x4735, 0x39E2, 0x2EA6, 0x2E01, 0x3106, 0x3311, 0xFFA0, 
	0x00AB, 0x001B, 0xFB57, 0xF50A, 0xEF94, 0xEF22, 0xEFEF, 0xF504, 0xF9F4, 
	0xFD24, 0xFF94, 0x008C, 0x0254, 0x027C, 0x025B, 0x01BD, 0x00DD, 0xFF88, 
	0xFBD4, 0xF9EB, 0xFAFF, 0xFCAF, 0xFE95, 0x0088, 0x016D, 0xC292, 0xC6EE, 
	0xCB24, 0xC939, 0xC545, 0xC11E, 0xBC96, 0xBBDC, 0xBF74, 0xC21A, 0xC062, 
	0xBD41, 0xBB93, 
},
{
	0x0001, 0x0000, 0x000D, 0x0001, 0x000D, 0x000E, 0x0001, 0x001B, 0x0001, 
	0x001C, 0x0001, 0x001D, 0x0008, 0x001E, 0x000E, 0x0026, 0x000E, 0x0034, 
	0x000E, 0x0042, 0x000E, 0x0050, 0x000D, 0x005E, 0x000D, 0x006B, 0x000D, 
	0x0078, 0x000D, 0x0085, 0x0001, 0x0092, 0x0001, 0x0093, 0x0001, 0x0094, 
	0x000E, 0x0095, 0x000E, 0x00A3, 0x000E, 0x00B1, 0x0001, 0x00BF, 0x000E, 
	0x00C0, 0x0001, 0x00CE, 0x0001, 0x00CF, 0x0001, 0x00D0, 0x0001, 0x00D1, 
	0x0001, 0x00D2, 0x0001, 0x00D3, 0x0001, 0x00D4, 0x0001, 0x00D5, 0x0001, 
	0x00D6, 0x0001, 0x00D7, 0x000E, 0x00D8, 0x000E, 0x00E6, 0x0001, 0x00F4, 
	0x0001, 0x00F5, 0x0001, 0x00F6, 0x0001, 0x00F7, 0x000E, 0x00F8, 0x000E, 
	0x0106, 0x000D, 0x0114, 0x000D, 0x0121, 0x000D, 0x012E, 0x000D, 0x013B, 
	0x000C, 0x0148, 0x000D, 0x0154, 0x000D, 0x0161, 0x000D, 0x016E, 0x000D, 
	0x017B, 0x000D, 0x0188, 0x000E, 0x0195, 0x000E, 0x01A3, 0x0001, 0x01B1, 
	0x000D, 0x01B2, 0x000D, 0x01BF, 0x000D, 0x01CC, 0x000C, 0x01D9, 0x000E, 
	0x01E5, 0x000D, 0x01F3, 0x000D, 0x0200, 0x000D, 0x020D, 0x000D, 0x021A, 
	
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_SLIDING_ON_BOTTOM_WITH_LIGHT_OBJ], 0, 189, 0, 0, 1, {
	0x0000, 0x0036, 0x0000, 0x0000, 0x3FFF, 0x0000, 0xFFFF, 0xFFFF, 0x1E68, 
	0x0000, 0xFCBD, 0x13EC, 0xFEE2, 0x030F, 0x09D5, 0xFFFE, 0x0001, 0xC170, 
	0xFEF7, 0xC507, 0xEF6B, 0xFFFF, 0x0000, 0xE263, 0xE7CD, 0xF983, 0xE96A, 
	0xFFFE, 0x0001, 0xC170, 0xF0CC, 0x1131, 0x6C57, 0x0000, 0x0000, 0xF032, 
	0x0D18, 0x182D, 0xF4C2, 0xFFFF, 0xFFFF, 0xBF5E, 0xFAB1, 0xF79C, 0x9D31, 
	0x0000, 0xFFFF, 0x09C7, 0x00D0, 0xFF37, 0xC1A9, 0xFFFF, 0xFFFF, 0xBF5E, 
	0xFFC2, 0x0BBA, 0x9C0C, 0xFFFF, 0x0000, 0x0640, 0xFFA0, 0x0254, 0xC292, 
},
{
	0x0001, 0x0000, 0x0001, 0x0001, 0x0001, 0x0002, 0x0001, 0x0003, 0x0001, 
	0x0004, 0x0001, 0x0005, 0x0001, 0x0006, 0x0001, 0x0007, 0x0001, 0x0008, 
	0x0001, 0x0009, 0x0001, 0x000A, 0x0001, 0x000B, 0x0001, 0x000C, 0x0001, 
	0x000D, 0x0001, 0x000E, 0x0001, 0x000F, 0x0001, 0x0010, 0x0001, 0x0011, 
	0x0001, 0x0012, 0x0001, 0x0013, 0x0001, 0x0014, 0x0001, 0x0015, 0x0001, 
	0x0016, 0x0001, 0x0017, 0x0001, 0x0018, 0x0001, 0x0019, 0x0001, 0x001A, 
	0x0001, 0x001B, 0x0001, 0x001C, 0x0001, 0x001D, 0x0001, 0x001E, 0x0001, 
	0x001F, 0x0001, 0x0020, 0x0001, 0x0021, 0x0001, 0x0022, 0x0001, 0x0023, 
	0x0001, 0x0024, 0x0001, 0x0025, 0x0001, 0x0026, 0x0001, 0x0027, 0x0001, 
	0x0028, 0x0001, 0x0029, 0x0001, 0x002A, 0x0001, 0x002B, 0x0001, 0x002C, 
	0x0001, 0x002D, 0x0001, 0x002E, 0x0001, 0x002F, 0x0001, 0x0030, 0x0001, 
	0x0031, 0x0001, 0x0032, 0x0001, 0x0033, 0x0001, 0x0034, 0x0001, 0x0035, 
	0x0001, 0x0036, 0x0001, 0x0037, 0x0001, 0x0038, 0x0001, 0x0039, 0x0001, 
	0x003A, 0x0001, 0x003B, 0x0001, 0x003C, 0x0001, 0x003D, 0x0001, 0x003E, 
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_FALL_FROM_SLIDING_WITH_LIGHT_OBJ], 0, 189, 0, 14, 14, {
	0x0000, 0x0036, 0x0000, 0x0000, 0x3FFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x1E68, 0x1EC3, 0x1FC3, 0x214D, 0x2344, 0x258D, 0x280E, 0x2AAA, 0x2D46, 
	0x2FC6, 0x320F, 0x3407, 0x3590, 0x3690, 0x36EC, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFCBD, 0xFCC9, 0xFCEB, 0xFD20, 0xFD63, 0xFDB0, 
	0xFE06, 0xFE5E, 0xFEB7, 0xFF0C, 0xFF5A, 0xFF9D, 0xFFD1, 0xFFF3, 0x0000, 
	0x13EC, 0x13C5, 0x1358, 0x12B2, 0x11DC, 0x10E4, 0x0FD4, 0x0EB8, 0x0D9D, 
	0x0C8D, 0x0B95, 0x0ABF, 0x0A18, 0x09AC, 0x0985, 0xFEB5, 0xFEAB, 0xFEA1, 
	0xFEB9, 0xFED6, 0xFEF9, 0xFF1F, 0xFF46, 0xFF6E, 0xFF93, 0xFFB6, 0xFFD4, 
	0xFFEB, 0xFFFA, 0xFFFF, 0x02FD, 0x02EB, 0x02C2, 0x0293, 0x0257, 0x0211, 
	0x01C5, 0x0175, 0x0126, 0x00DA, 0x0094, 0x0058, 0x0029, 0x000A, 0x0000, 
	0x076D, 0x06E9, 0x0664, 0x07A3, 0x093A, 0x0B15, 0x0D1C, 0x0F39, 0x1156, 
	0x135D, 0x1538, 0x16D0, 0x180F, 0x18DE, 0x1928, 0x0001, 0xFFFE, 0xC170, 
	0xFC9B, 0xFC7C, 0xFC26, 0xFBA1, 0xFAF7, 0xFA31, 0xF959, 0xF877, 0xF796, 
	0xF6BD, 0xF5F7, 0xF54D, 0xF4C9, 0xF472, 0xF453, 0xC4EC, 0xC50A, 0xC55C, 
	0xC5DB, 0xC67D, 0xC739, 0xC807, 0xC8DE, 0xC9B5, 0xCA83, 0xCB3F, 0xCBE1, 
	0xCC60, 0xCCB2, 0xCCD0, 0xF1F2, 0xF210, 0xF265, 0xF2E8, 0xF38F, 0xF452, 
	0xF526, 0xF604, 0xF6E2, 0xF7B7, 0xF87A, 0xF921, 0xF9A3, 0xF9F9, 0xFA17, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0xE263, 0xE7CD, 0xF983, 0xE96A, 0x0001, 0xFFFE, 0xC170, 
	0xF0CC, 0xF0C2, 0xF0A5, 0xF078, 0xF03F, 0xEFFC, 0xEFB4, 0xEF68, 0xEF1C, 
	0xEED4, 0xEE91, 0xEE58, 0xEE2C, 0xEE0F, 0xEE04, 0x1131, 0x1137, 0x1149, 
	0x1165, 0x1189, 0x11B2, 0x11DF, 0x120F, 0x123E, 0x126B, 0x1294, 0x12B8, 
	0x12D4, 0x12E6, 0x12EC, 0x6C57, 0x6C36, 0x6BD9, 0x6B4A, 0x6A94, 0x69BF, 
	0x68D7, 0x67E5, 0x66F3, 0x660A, 0x6536, 0x647F, 0x63F1, 0x6394, 0x6373, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xF032, 0x0D18, 0x182D, 0xF4C2, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xBF5E, 0xFAB1, 0xFAAD, 0xFAA1, 0xFA90, 0xFA7A, 0xFA60, 0xFA43, 0xFA26, 
	0xFA08, 0xF9EC, 0xF9D2, 0xF9BB, 0xF9AA, 0xF99F, 0xF99B, 0xF79C, 0xF772, 
	0xF6FB, 0xF646, 0xF55E, 0xF450, 0xF328, 0xF1F4, 0xF0C0, 0xEF98, 0xEE8A, 
	0xEDA2, 0xECEC, 0xEC76, 0xEC4C, 0x9D31, 0x9CE1, 0x9C00, 0x9AA6, 0x98EC, 
	0x96E9, 0x94B6, 0x926B, 0x901F, 0x8DEC, 0x8BEA, 0x8A2F, 0x88D5, 0x87F4, 
	0x87A4, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x09C7, 0x0AE8, 0x0E12, 0x12EF, 0x1927, 0x2063, 0x284D, 0x308D, 
	0x38CE, 0x40B8, 0x47F4, 0x4E2B, 0x5308, 0x5632, 0x5754, 0x00D0, 0x00CA, 
	0x00B8, 0x009D, 0x007B, 0x0053, 0x0027, 0xFFF9, 0xFFCC, 0xFFA0, 0xFF78, 
	0xFF56, 0xFF3B, 0xFF29, 0xFF23, 0xFF37, 0xFF3D, 0xFF4E, 0xFF69, 0xFF8B, 
	0xFFB3, 0xFFDE, 0x000C, 0x0039, 0x0064, 0x008C, 0x00AE, 0x00C9, 0x00DA, 
	0x00E1, 0xC1A9, 0xC21A, 0xC355, 0xC539, 0xC7A5, 0xCA76, 0xCD8A, 0xD0C0, 
	0xD3F6, 0xD70A, 0xD9DB, 0xDC47, 0xDE2B, 0xDF66, 0xDFD7, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xBF5E, 
	0xFFC2, 0x0032, 0x016A, 0x034B, 0x05B1, 0x087C, 0x0B8A, 0x0EB9, 0x11E8, 
	0x14F6, 0x17C1, 0x1A27, 0x1C08, 0x1D40, 0x1DB0, 0x0BBA, 0x0BA1, 0x0B5E, 
	0x0AF5, 0x0A70, 0x09D5, 0x092B, 0x087A, 0x07CA, 0x0720, 0x0685, 0x0600, 
	0x0597, 0x0553, 0x053B, 0x9C0C, 0x9C94, 0x9E0E, 0xA053, 0xA33B, 0xA69C, 
	0xAA4E, 0xAE29, 0xB204, 0xB5B6, 0xB918, 0xBBFF, 0xBE44, 0xBFBF, 0xC046, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0640, 0x067E, 0x072D, 0x083A, 0x0992, 0x0B21, 
	0x0CD7, 0x0E9F, 0x1067, 0x121C, 0x13AC, 0x1504, 0x1611, 0x16C0, 0x16FE, 
	0xFFA0, 0xFF9B, 0xFF8C, 0xFF76, 0xFF59, 0xFF38, 0xFF13, 0xFEED, 0xFEC7, 
	0xFEA2, 0xFE81, 0xFE64, 0xFE4E, 0xFE3F, 0xFE3A, 0x0254, 0x024A, 0x022B, 
	0x01FC, 0x01C0, 0x017A, 0x012D, 0x00DE, 0x008E, 0x0041, 0xFFFC, 0xFFBF, 
	0xFF90, 0xFF72, 0xFF67, 0xC292, 0xC2F3, 0xC402, 0xC5A3, 0xC7B7, 0xCA23, 
	0xCCC9, 0xCF8C, 0xD24E, 0xD4F4, 0xD760, 0xD975, 0xDB15, 0xDC24, 0xDC85, 
},
{
	0x0001, 0x0000, 0x0001, 0x0001, 0x0001, 0x0002, 0x0001, 0x0003, 0x0001, 
	0x0004, 0x0001, 0x0005, 0x000C, 0x0006, 0x0009, 0x0012, 0x000F, 0x001B, 
	0x000F, 0x002A, 0x000F, 0x0039, 0x000F, 0x0048, 0x000F, 0x0057, 0x000F, 
	0x0066, 0x000F, 0x0075, 0x0001, 0x0084, 0x0001, 0x0085, 0x0001, 0x0086, 
	0x000F, 0x0087, 0x000F, 0x0096, 0x000F, 0x00A5, 0x000F, 0x00B4, 0x000E, 
	0x00C3, 0x0001, 0x00D1, 0x0001, 0x00D2, 0x0001, 0x00D3, 0x0001, 0x00D4, 
	0x0001, 0x00D5, 0x0001, 0x00D6, 0x0001, 0x00D7, 0x000F, 0x00D8, 0x000F, 
	0x00E7, 0x000F, 0x00F6, 0x000A, 0x0105, 0x000C, 0x010F, 0x0001, 0x011B, 
	0x0001, 0x011C, 0x0001, 0x011D, 0x0001, 0x011E, 0x000D, 0x011F, 0x000F, 
	0x012C, 0x0001, 0x013B, 0x000F, 0x013C, 0x000F, 0x014B, 0x000F, 0x015A, 
	0x000E, 0x0169, 0x000D, 0x0177, 0x000F, 0x0184, 0x000F, 0x0193, 0x000F, 
	0x01A2, 0x000F, 0x01B1, 0x000D, 0x01C0, 0x000F, 0x01CD, 0x0001, 0x01DC, 
	0x000F, 0x01DD, 0x000F, 0x01EC, 0x000F, 0x01FB, 0x000F, 0x020A, 0x000F, 
	0x0219, 0x000F, 0x0228, 0x000F, 0x0237, 0x000F, 0x0246, 0x000F, 0x0255, 
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_FALL_WITH_LIGHT_OBJ], 0, 189, 0, 1, 1, {
	0x0000, 0x00AA, 0x0000, 0x0000, 0x3FFF, 0x0000, 0x0000, 0xFFFF, 0x367D, 
	0xFFFF, 0x0000, 0x0A74, 0x0000, 0xFFFF, 0x1681, 0x0001, 0xFFFE, 0xC170, 
	0x0E59, 0xC8A6, 0xDFB8, 0xFFFF, 0x0000, 0xE263, 0xE7CD, 0xF983, 0xE96A, 
	0x0001, 0xFFFE, 0xC170, 0xEC87, 0x13CF, 0x6033, 0xFFFF, 0x0000, 0xF032, 
	0x0D18, 0x182D, 0xF4C2, 0xFFFF, 0xFFFF, 0xBF5E, 0xF869, 0xEB44, 0x8832, 
	0xFFFF, 0x0000, 0x565B, 0xFF95, 0x00DB, 0xDDFB, 0xFFFF, 0xFFFF, 0xBF5E, 
	0x1E12, 0x0884, 0xBEE4, 0xFFFF, 0x0000, 0x1C6F, 0xFDFE, 0xFF5B, 0xD844, 
},
{
	0x0001, 0x0000, 0x0001, 0x0001, 0x0001, 0x0002, 0x0001, 0x0003, 0x0001, 
	0x0004, 0x0001, 0x0005, 0x0001, 0x0006, 0x0001, 0x0007, 0x0001, 0x0008, 
	0x0001, 0x0009, 0x0001, 0x000A, 0x0001, 0x000B, 0x0001, 0x000C, 0x0001, 
	0x000D, 0x0001, 0x000E, 0x0001, 0x000F, 0x0001, 0x0010, 0x0001, 0x0011, 
	0x0001, 0x0012, 0x0001, 0x0013, 0x0001, 0x0014, 0x0001, 0x0015, 0x0001, 
	0x0016, 0x0001, 0x0017, 0x0001, 0x0018, 0x0001, 0x0019, 0x0001, 0x001A, 
	0x0001, 0x001B, 0x0001, 0x001C, 0x0001, 0x001D, 0x0001, 0x001E, 0x0001, 
	0x001F, 0x0001, 0x0020, 0x0001, 0x0021, 0x0001, 0x0022, 0x0001, 0x0023, 
	0x0001, 0x0024, 0x0001, 0x0025, 0x0001, 0x0026, 0x0001, 0x0027, 0x0001, 
	0x0028, 0x0001, 0x0029, 0x0001, 0x002A, 0x0001, 0x002B, 0x0001, 0x002C, 
	0x0001, 0x002D, 0x0001, 0x002E, 0x0001, 0x002F, 0x0001, 0x0030, 0x0001, 
	0x0031, 0x0001, 0x0032, 0x0001, 0x0033, 0x0001, 0x0034, 0x0001, 0x0035, 
	0x0001, 0x0036, 0x0001, 0x0037, 0x0001, 0x0038, 0x0001, 0x0039, 0x0001, 
	0x003A, 0x0001, 0x003B, 0x0001, 0x003C, 0x0001, 0x003D, 0x0001, 0x003E, 
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_JUMP_WITH_LIGHT_OBJ], 0, 189, 0, 9, 9, {
	0x0000, 0x009A, 0x009D, 0x00A0, 0x00A3, 0x00A6, 0x00A9, 0x00AB, 0x00AD, 
	0x00AF, 0x00B1, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x3FFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x4B4B, 0x4971, 
	0x452F, 0x3FDB, 0x3ACA, 0x3754, 0x3602, 0x3607, 0x36B3, 0x3754, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0xFFCF, 0xFF4F, 0xFE96, 0xFDBA, 0xFCD3, 0xFBF7, 0xFB3E, 0xFABE, 
	0xFA8E, 0x03DF, 0x0286, 0xFEE4, 0xFA38, 0xF5BE, 0xF2B4, 0xF128, 0xF07C, 
	0xF0EC, 0xF2B4, 0x0000, 0x000C, 0x002E, 0x005E, 0x0097, 0x00D4, 0x010D, 
	0x013D, 0x015E, 0x016B, 0x0000, 0xFFE0, 0xFF8C, 0xFF13, 0xFE84, 0xFDEC, 
	0xFD5D, 0xFCE4, 0xFC90, 0xFC71, 0x1113, 0x118B, 0x11FE, 0x1267, 0x135B, 
	0x14C5, 0x165C, 0x17D8, 0x18F1, 0x195E, 0x0001, 0xFFFE, 0xC170, 0x199C, 
	0x17F9, 0x1395, 0x0D39, 0x05B0, 0xFDC2, 0xF638, 0xEFDD, 0xEB79, 0xE9D6, 
	0xCD48, 0xCD2E, 0xCCE9, 0xCC86, 0xCC10, 0xCB93, 0xCB1D, 0xCABA, 0xCA75, 
	0xCA5B, 0xBFBC, 0xC23B, 0xC8EC, 0xD29D, 0xDE1A, 0xEA30, 0xF5AD, 0xFF5D, 
	0x060F, 0x088F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xE263, 0xE249, 0xE203, 0xE19D, 0xE125, 0xE0A7, 0xE02E, 0xDFC9, 
	0xDF83, 0xDF69, 0xE7CD, 0xF983, 0xE96A, 0x0001, 0xFFFE, 0xC9FE, 0xFC89, 
	0xFC34, 0xFB4F, 0xFA03, 0xF879, 0xF6DB, 0xF552, 0xF406, 0xF321, 0xF2CB, 
	0x140F, 0x1404, 0x13E9, 0x13C2, 0x1394, 0x1363, 0x1334, 0x130D, 0x12F2, 
	0x12E8, 0x54A6, 0x557F, 0x57C5, 0x5B0F, 0x5EF5, 0x630F, 0x66F5, 0x6A40, 
	0x6C85, 0x6D5E, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xF032, 0x0D18, 0x182D, 0xF4C2, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xBF5E, 0xF456, 0xF85C, 0xF9EC, 0xFA01, 0xF993, 
	0xF99B, 0xFA2E, 0xFA8E, 0xFA75, 0xF99B, 0xF0E2, 0xF102, 0xF019, 0xEEAB, 
	0xED3B, 0xEC4C, 0xEC3A, 0xEC9F, 0xECDB, 0xEC4C, 0xA296, 0x9AD4, 0x946D, 
	0x8F35, 0x8B00, 0x87A4, 0x85A9, 0x855C, 0x8632, 0x87A4, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x5683, 0x59F9, 0x5A92, 0x5984, 
	0x5808, 0x5754, 0x5794, 0x57E8, 0x57F2, 0x5754, 0xFED2, 0xFEE2, 0xFEF4, 
	0xFF07, 0xFF17, 0xFF23, 0xFF21, 0xFF14, 0xFF0E, 0xFF23, 0x005B, 0x0089, 
	0x00AA, 0x00C1, 0x00D2, 0x00E1, 0x00EB, 0x00EE, 0x00EA, 0x00E1, 0xCB79, 
	0xD202, 0xD6EE, 0xDAA0, 0xDD78, 0xDFD7, 0xE196, 0xE23B, 0xE1AE, 0xDFD7, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xBF5E, 0x0390, 0x06C5, 0x0CC6, 0x13F4, 
	0x1AB0, 0x1F59, 0x2145, 0x2162, 0x207A, 0x1F59, 0xFF55, 0xFD3D, 0xFD4C, 
	0xFE8F, 0x0014, 0x00E9, 0x00B3, 0x002B, 0x0003, 0x00E9, 0x9112, 0x989A, 
	0xA4B4, 0xB294, 0xBF6A, 0xC86B, 0xCC70, 0xCCFE, 0xCB41, 0xC86B, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x2F66, 
	0x2839, 0x203B, 0x184F, 0x1158, 0x0C39, 0x093F, 0x0833, 0x0929, 0x0C39, 
	0x0104, 0x0129, 0x0148, 0x0161, 0x0175, 0x0185, 0x0196, 0x01A3, 0x01A2, 
	0x0185, 0x0124, 0x00DC, 0x008F, 0x0046, 0x0006, 0xFFD6, 0xFFC8, 0xFFD6, 
	0xFFE4, 0xFFD6, 0xCA3F, 0xD346, 0xDC34, 0xE47D, 0xEB95, 0xF0EF, 0xF413, 
	0xF503, 0xF3E8, 0xF0EF, 
},
{
	0x0001, 0x0000, 0x000A, 0x0001, 0x0006, 0x000B, 0x0001, 0x0011, 0x0001, 
	0x0012, 0x0001, 0x0013, 0x0004, 0x0014, 0x000A, 0x0018, 0x000A, 0x0022, 
	0x000A, 0x002C, 0x000A, 0x0036, 0x000A, 0x0040, 0x000A, 0x004A, 0x000A, 
	0x0054, 0x000A, 0x005E, 0x0001, 0x0068, 0x0001, 0x0069, 0x0001, 0x006A, 
	0x000A, 0x006B, 0x000A, 0x0075, 0x000A, 0x007F, 0x0009, 0x0089, 0x0008, 
	0x0092, 0x000A, 0x009A, 0x0001, 0x00A4, 0x0001, 0x00A5, 0x0001, 0x00A6, 
	0x0001, 0x00A7, 0x0001, 0x00A8, 0x0001, 0x00A9, 0x000A, 0x00AA, 0x000A, 
	0x00B4, 0x000A, 0x00BE, 0x000A, 0x00C8, 0x000A, 0x00D2, 0x0001, 0x00DC, 
	0x0001, 0x00DD, 0x0001, 0x00DE, 0x0001, 0x00DF, 0x000A, 0x00E0, 0x0003, 
	0x00EA, 0x0001, 0x00ED, 0x000A, 0x00EE, 0x000A, 0x00F8, 0x000A, 0x0102, 
	0x0008, 0x010C, 0x0008, 0x0114, 0x000A, 0x011C, 0x000A, 0x0126, 0x000A, 
	0x0130, 0x000A, 0x013A, 0x000A, 0x0144, 0x0003, 0x014E, 0x0001, 0x0151, 
	0x000A, 0x0152, 0x000A, 0x015C, 0x000A, 0x0166, 0x0009, 0x0170, 0x0009, 
	0x0179, 0x000A, 0x0182, 0x000A, 0x018C, 0x000A, 0x0196, 0x000A, 0x01A0, 
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_JUMP_LAND_WITH_LIGHT_OBJ], 0, 189, 0, 18, 18, {
	0x0000, 0x009A, 0x0091, 0x0086, 0x007E, 0x007D, 0x0081, 0x0088, 0x008F, 
	0x0093, 0x0097, 0x009A, 0x009D, 0x009D, 0x009D, 0x009D, 0x009C, 0x009B, 
	0x009B, 0x009A, 0xFFF4, 0xFFF2, 0xFFF0, 0xFFF0, 0xFFF1, 0xFFF4, 0xFFF6, 
	0xFFF9, 0xFFFC, 0xFFFF, 0x0000, 0x0001, 0x0003, 0x0004, 0x0005, 0x0006, 
	0x0006, 0x0007, 0x0000, 0x3FFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x3CB2, 0x3D0E, 0x3D4E, 0x3D6D, 0x3D55, 0x3CFC, 0x3C73, 0x3BC9, 0x3B0E, 
	0x3A51, 0x39A3, 0x3913, 0x38B1, 0x388D, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x171C, 0x1D70, 
	0x246B, 0x25D8, 0x2154, 0x1B08, 0x138D, 0x0B7D, 0x0373, 0xFC08, 0xF5D8, 
	0xF17B, 0xEF4D, 0xEEE5, 0xEFBF, 0xF152, 0xF319, 0xF48C, 0xF526, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xF3A9, 0xEF3A, 0xEAF8, 0xEB44, 0xF262, 0xFD42, 0x084B, 0x0FE3, 
	0x129C, 0x128B, 0x1154, 0x109A, 0x10A6, 0x10AB, 0x10AA, 0x10A6, 0x10A1, 
	0x109C, 0x109A, 0x0001, 0xFFFE, 0xC170, 0xC152, 0xC134, 0xC170, 0xC203, 
	0xC2AE, 0xC36B, 0xC435, 0xC508, 0xC5DE, 0xC6B2, 0xC781, 0xC843, 0xC8F6, 
	0xC993, 0xCA15, 0xCA79, 0xCAB8, 0xCACF, 0xF70F, 0xF779, 0xF8A8, 0xFA82, 
	0xFCEF, 0xFFD7, 0x0322, 0x06B5, 0x0A7A, 0x0E57, 0x1234, 0x15F8, 0x198C, 
	0x1CD6, 0x1FBD, 0x222B, 0x2405, 0x2533, 0x259D, 0xCA45, 0xCA4C, 0xCA62, 
	0xCA84, 0xCAB1, 0xCAE6, 0xCB22, 0xCB64, 0xCBA9, 0xCBF0, 0xCC37, 0xCC7C, 
	0xCCBE, 0xCCFB, 0xCD30, 0xCD5D, 0xCD7F, 0xCD94, 0xCD9C, 0xEB79, 0xEB27, 
	0xEA3F, 0xE8D2, 0xE6F4, 0xE4B7, 0xE22F, 0xDF6F, 0xDC89, 0xD990, 0xD696, 
	0xD3B0, 0xD0F0, 0xCE68, 0xCC2B, 0xCA4D, 0xC8E0, 0xC7F8, 0xC7A6, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xE263, 0xE376, 0xE607, 0xE917, 
	0xEBA8, 0xECBC, 0xEC8F, 0xEC13, 0xEB56, 0xEA66, 0xE952, 0xE828, 0xE6F7, 
	0xE5CD, 0xE4B9, 0xE3C9, 0xE30C, 0xE28F, 0xE263, 0xE7CD, 0xF983, 0xE96A, 
	0x0001, 0xFFFE, 0xC9FE, 0xE95D, 0xE982, 0xE9EA, 0xEA88, 0xEB51, 0xEC39, 
	0xED32, 0xEE31, 0xEF2B, 0xF012, 0xF0DB, 0xF179, 0xF1E1, 0xF207, 0xF1E6, 
	0xF198, 0xF13B, 0xF0ED, 0xF0CC, 0x0B9E, 0x0BA6, 0x0BBF, 0x0BE7, 0x0C1D, 
	0x0C5F, 0x0CAD, 0x0D04, 0x0D64, 0x0DCB, 0x0E39, 0x0EAB, 0x0F21, 0x0F99, 
	0x1011, 0x1080, 0x10DB, 0x111A, 0x1131, 0x48C1, 0x478D, 0x4553, 0x4420, 
	0x4563, 0x48D1, 0x4DDD, 0x53FF, 0x5AAC, 0x6158, 0x677A, 0x6C87, 0x6FF4, 
	0x7137, 0x70B5, 0x6F80, 0x6E0E, 0x6CD9, 0x6C57, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xF032, 0x0D18, 0x182D, 
	0xF4C2, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0xBF5E, 0xDF32, 0xE172, 0xE335, 0xE47B, 0xE48F, 
	0xE370, 0xE12B, 0xDE8B, 0xDC5D, 0xDA9D, 0xD90E, 0xD826, 0xD7D7, 0xD7B9, 
	0xD7BD, 0xD7D7, 0xD7FA, 0xD819, 0xD826, 0xE402, 0xDED5, 0xDBE1, 0xD9B2, 
	0xD8D0, 0xD9A8, 0xDC44, 0xDF81, 0xE237, 0xE45E, 0xE650, 0xE771, 0xE7D3, 
	0xE7F9, 0xE7F4, 0xE7D3, 0xE7A8, 0xE782, 0xE771, 0xA8BC, 0xA51B, 0xA262, 
	0xA0B7, 0xA166, 0xA424, 0xA8A5, 0xADA4, 0xB1D3, 0xB563, 0xB8AA, 0xBA93, 
	0xBB37, 0xBB77, 0xBB6E, 0xBB37, 0xBAEE, 0xBAAF, 0xBA93, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x38B5, 0x3FF8, 
	0x43B9, 0x4637, 0x4690, 0x44FD, 0x41FA, 0x3E79, 0x3BB2, 0x39D2, 0x385C, 
	0x378C, 0x373F, 0x3720, 0x3725, 0x373F, 0x3761, 0x377F, 0x378C, 0x048A, 
	0x034B, 0x0259, 0x019F, 0x017E, 0x012A, 0xFF86, 0xFFA3, 0xFFE0, 0xFF92, 
	0xFF1E, 0xFED3, 0xFEBF, 0xFEB8, 0xFEB9, 0xFEBF, 0xFEC8, 0xFED0, 0xFED3, 
	0x0038, 0x001A, 0x001F, 0x0021, 0x0007, 0xFFE3, 0xFFD0, 0xFFC4, 0xFFBA, 
	0xFFB1, 0xFFA7, 0xFFA1, 0xFF9F, 0xFF9F, 0xFF9F, 0xFF9F, 0xFFA0, 0xFFA1, 
	0xBDCB, 0xBB44, 0xB919, 0xB782, 0xB75E, 0xB78C, 0xB6E0, 0xB602, 0xB528, 
	0xB459, 0xB387, 0xB309, 0xB2E2, 0xB2D2, 0xB2D5, 0xB2E2, 0xB2F3, 0xB303, 
	0xB309, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0xBF5E, 0x1433, 0x10F2, 0x1057, 0x1043, 0x109A, 
	0x1154, 0x1259, 0x137E, 0x1498, 0x15CC, 0x1706, 0x17C1, 0x17FD, 0x1814, 
	0x1810, 0x17FD, 0x17E2, 0x17CB, 0x17C1, 0x16E1, 0x1A1E, 0x1B01, 0x1B6B, 
	0x1B59, 0x1AC6, 0x19DA, 0x18CF, 0x17E2, 0x1709, 0x1641, 0x15CC, 0x15A5, 
	0x1596, 0x1598, 0x15A5, 0x15B7, 0x15C6, 0x15CC, 0xA18A, 0x9A38, 0x98D3, 
	0x989E, 0x99AD, 0x9C08, 0x9F4B, 0xA2E0, 0xA630, 0xA97F, 0xACAD, 0xAE8D, 
	0xAF29, 0xAF66, 0xAF5D, 0xAF29, 0xAEE4, 0xAEA7, 0xAE8D, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x3796, 0x3BDF, 0x4135, 0x4688, 
	0x4891, 0x45FC, 0x40EC, 0x3B44, 0x36EA, 0x34A3, 0x338D, 0x3311, 0x32C9, 
	0x32AD, 0x32B1, 0x32C9, 0x32E9, 0x3305, 0x3311, 0xFE2B, 0xFD6A, 0xFDC2, 
	0xFE4C, 0xFEB6, 0xFEE2, 0xFEF7, 0xFF07, 0xFF23, 0xFF4F, 0xFF88, 0xFFD2, 
	0x003E, 0x00C0, 0x0133, 0x0173, 0x0143, 0x00CE, 0x008C, 0xFDFA, 0xFE27, 
	0xFDFB, 0xFDC0, 0xFDA0, 0xFDA9, 0xFDC5, 0xFDE9, 0xFE09, 0xFE22, 0xFE3B, 
	0xFE55, 0xFE62, 0xFE64, 0xFE7C, 0xFEC9, 0xFFAA, 0x00D7, 0x016D, 0xC0E5, 
	0xC405, 0xBEB4, 0xB7FB, 0xB407, 0xB45B, 0xB6B8, 0xB9AF, 0xBBD2, 0xBCA3, 
	0xBCD4, 0xBCBD, 0xBC70, 0xBBEA, 0xBB5F, 0xBB08, 0xBB19, 0xBB65, 0xBB93, 
},
{
	0x0001, 0x0000, 0x0013, 0x0001, 0x0012, 0x0014, 0x0001, 0x0026, 0x0001, 
	0x0027, 0x0001, 0x0028, 0x0008, 0x0029, 0x000E, 0x0031, 0x000E, 0x003F, 
	0x000F, 0x004D, 0x000E, 0x005C, 0x0013, 0x006A, 0x0013, 0x007D, 0x0013, 
	0x0090, 0x0013, 0x00A3, 0x0001, 0x00B6, 0x0001, 0x00B7, 0x0013, 0x00B8, 
	0x0013, 0x00CB, 0x0013, 0x00DE, 0x0013, 0x00F1, 0x0010, 0x0104, 0x0011, 
	0x0114, 0x0013, 0x0125, 0x0001, 0x0138, 0x0001, 0x0139, 0x0001, 0x013A, 
	0x0001, 0x013B, 0x0001, 0x013C, 0x0001, 0x013D, 0x0013, 0x013E, 0x0013, 
	0x0151, 0x0013, 0x0164, 0x0013, 0x0177, 0x0011, 0x018A, 0x0001, 0x019B, 
	0x0001, 0x019C, 0x0001, 0x019D, 0x0001, 0x019E, 0x0006, 0x019F, 0x000E, 
	0x01A5, 0x0001, 0x01B3, 0x0013, 0x01B4, 0x0013, 0x01C7, 0x0013, 0x01DA, 
	0x0009, 0x01ED, 0x0012, 0x01F6, 0x0013, 0x0208, 0x0013, 0x021B, 0x0012, 
	0x022E, 0x0013, 0x0240, 0x0006, 0x0253, 0x000E, 0x0259, 0x0001, 0x0267, 
	0x0013, 0x0268, 0x0013, 0x027B, 0x0013, 0x028E, 0x0006, 0x02A1, 0x0013, 
	0x02A7, 0x0013, 0x02BA, 0x0013, 0x02CD, 0x0013, 0x02E0, 0x0013, 0x02F3, 
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_SLIDE_DIVE], 0, 189, 0, 19, 30, {
	0x0000, 0x0109, 0x0103, 0x00F4, 0x00E1, 0x00CE, 0x00B7, 0x009F, 0x008A, 
	0x0077, 0x006C, 0x006D, 0x0075, 0x0079, 0x0061, 0x0064, 0x0068, 0x005C, 
	0x0051, 0x0053, 0x0056, 0x0000, 0x0000, 0x0001, 0x0002, 0x0003, 0x0004, 
	0x0004, 0x0003, 0x0001, 0x0000, 0x0000, 0x3FFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x52E9, 0x5839, 0x61ED, 0x6C23, 0x72F4, 0x77D6, 0x7B1C, 
	0x7D18, 0x7E1D, 0x7E7E, 0x7E8B, 0x7E4D, 0x7DA6, 0x7CB4, 0x7B96, 0x7A68, 
	0x794A, 0x7858, 0x77B1, 0x7773, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x1995, 0x17DB, 0x135F, 
	0x0D31, 0x065F, 0xFFF6, 0xFB07, 0xF869, 0xF775, 0xF6F4, 0xF676, 0xF66C, 
	0xF6F4, 0xF7CF, 0xF8AA, 0xF986, 0xFA64, 0xFB45, 0xFC2A, 0xFD14, 0x01EE, 
	0x01ED, 0x01EC, 0x025A, 0x02C8, 0x02C2, 0x02B2, 0x029C, 0x0287, 0x0277, 
	0x0270, 0x010C, 0x010D, 0x0110, 0xFF43, 0xFC43, 0xFA3C, 0xF8E0, 0xF80D, 
	0xF7A1, 0xF779, 0xF773, 0xE07B, 0xE066, 0xE02E, 0xDC99, 0xD651, 0xD135, 
	0xCDC8, 0xCBB4, 0xCAA3, 0xCA3E, 0xCA2F, 0xFFFE, 0x0001, 0xC170, 0x0268, 
	0x032E, 0x053F, 0x0837, 0x0BB2, 0x0F4D, 0x12A6, 0x1617, 0x1A0A, 0x1E2B, 
	0x22E7, 0x27D2, 0x2B51, 0x2D7E, 0x2F79, 0x3137, 0x32A9, 0x33C1, 0xD800, 
	0xD92D, 0xDC1F, 0xDFF0, 0xE3BF, 0xE6A7, 0xE7C6, 0xE335, 0xDB0B, 0xD75E, 
	0xDDA8, 0xE870, 0xEF61, 0xF0F0, 0xF15A, 0xF0F3, 0xF010, 0xEF06, 0x7B6C, 
	0x7A25, 0x76C3, 0x71F0, 0x6C58, 0x66A5, 0x6184, 0x5C68, 0x56E4, 0x51CF, 
	0x4CCA, 0x4834, 0x4603, 0x461B, 0x46EC, 0x483F, 0x49DE, 0x4B95, 0x4A49, 
	0x4B95, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xE875, 0xE85A, 0xE820, 0xE7E5, 
	0xE7CB, 0xE7F0, 0xE875, 0xE995, 0xEB45, 0xED34, 0xEF15, 0xF096, 0xF16B, 
	0xF1CF, 0xF230, 0xF28D, 0xF2E4, 0xF332, 0xF377, 0xF3AE, 0xFA8B, 0xFE4D, 
	0x0743, 0x11F3, 0x1AE8, 0x1EAA, 0x1EA7, 0x1E8E, 0x1E4A, 0x1DC7, 0x1CEE, 
	0x1B66, 0x1922, 0x167E, 0x13D7, 0x1189, 0x0FDD, 0x0ECC, 0x0E3C, 0x0E11, 
	0x0985, 0x08E1, 0x075A, 0x0588, 0x0401, 0x035D, 0x0418, 0x05ED, 0x0852, 
	0x0ABF, 0x0CA8, 0x0DDB, 0x0E96, 0x0EF5, 0x0F19, 0x0F1E, 0x0CD8, 0x07D8, 
	0x02D9, 0x0093, 0xF482, 0xF3E3, 0xF269, 0xF0A6, 0xEF2B, 0xEE8D, 0xEEAD, 
	0xEF21, 0xF008, 0xF180, 0xF3A9, 0xF686, 0xF9AA, 0xFC90, 0xFEB0, 0xFF83, 
	0xFE2B, 0xFB36, 0xF840, 0xF6E8, 0xFFFE, 0x0001, 0xC170, 0x69A2, 0x67CA, 
	0xE2F9, 0xDC46, 0xD4C6, 0xCD8E, 0xC7B5, 0xC370, 0xC04D, 0xBE5E, 0xBDBA, 
	0xBDFC, 0xBE7B, 0xBE90, 0xBE0E, 0xBD51, 0xBC7C, 0xBBB7, 0x556A, 0x5646, 
	0x2784, 0x2481, 0x213D, 0x1E46, 0x1C27, 0x1BE7, 0x1CD8, 0x1CFB, 0x1B85, 
	0x1967, 0x173E, 0x15A7, 0x149E, 0x13B9, 0x12FD, 0x1271, 0x009C, 0xFE2A, 
	0x77C8, 0x6EDF, 0x64DB, 0x5B26, 0x532A, 0x4CED, 0x47EC, 0x44C6, 0x438D, 
	0x438B, 0x443D, 0x451D, 0x4617, 0x4759, 0x48C4, 0x4A36, 0x48EA, 0x4A36, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xE80C, 0xE89F, 0xEA0A, 0xEBDE, 0xEDA9, 0xEEFB, 0xEF62, 0xEE93, 0xECDB, 
	0xEAA9, 0xE86D, 0xE698, 0xE59A, 0xE53F, 0xE504, 0xE4E4, 0xE4DD, 0xE4E9, 
	0xE504, 0xE52C, 0x1904, 0x1588, 0x0D37, 0x034C, 0xFAFB, 0xF77E, 0xF80C, 
	0xF95D, 0xFAF0, 0xFC42, 0xFCCF, 0xFC8B, 0xFBE6, 0xFB23, 0xFA7E, 0xFA3A, 
	0xFB68, 0xFE00, 0x0099, 0x01C6, 0x0E48, 0x0E48, 0x0E48, 0x0E48, 0x0E48, 
	0x0E48, 0x0C2A, 0x071E, 0x0118, 0xFC0B, 0xF9ED, 0xF9F2, 0xFA14, 0xFA70, 
	0xFB23, 0xFC4B, 0xFF7B, 0x04A5, 0x0974, 0x0B93, 0xE983, 0xE983, 0xE983, 
	0xE983, 0xE983, 0xE983, 0xE98C, 0xE9C7, 0xEA6A, 0xEBA6, 0xEDAF, 0xF11A, 
	0xF5C7, 0xFADB, 0xFF7B, 0x02CE, 0x04A4, 0x0595, 0x05EE, 0x05FB, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xC5E3, 
	0xF549, 0xF5ED, 0xF75F, 0xF9FB, 0xFBBE, 0xF9B8, 0xF70E, 0xF5F3, 0xF549, 
	0xF4F2, 0xF54E, 0xF5FE, 0xF66A, 0xF6D0, 0xF734, 0xF798, 0xF7FF, 0xF86C, 
	0xF8E4, 0xF96A, 0xFC69, 0xFAF5, 0xF8AD, 0xF6A0, 0xF5C2, 0xF863, 0xFB77, 
	0xFCCB, 0xFD8F, 0xFDB4, 0xFC3F, 0xFA81, 0xF9E3, 0xF97B, 0xF92A, 0xF8D3, 
	0xF857, 0xF796, 0xF699, 0xF580, 0xBD44, 0xB7BE, 0xADDE, 0xA15D, 0x9A7A, 
	0xA7EB, 0xB80A, 0xBE37, 0xC156, 0xC1FE, 0xBCCB, 0xB62D, 0xB337, 0xB0A9, 
	0xAE68, 0xAC59, 0xAA61, 0xA864, 0xA64D, 0xA41F, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0x1553, 0x109D, 0x0BA8, 0x0E43, 0x135C, 0x17DE, 0x1D97, 0x2611, 
	0x2F58, 0x35EB, 0x3750, 0x3601, 0x35EB, 0x3877, 0x3BF1, 0x3F9D, 0x42BD, 
	0x4496, 0x454F, 0x45A0, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xE453, 0xE873, 0xED3E, 0xEC59, 
	0xE9AB, 0xE756, 0xE449, 0xDFC3, 0xDACD, 0xD749, 0xD653, 0xD6CE, 0xD749, 
	0xD749, 0xD749, 0xD749, 0xD749, 0xD749, 0xD737, 0xD708, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xBF5E, 0x03D0, 0x036C, 0x02BE, 0x01E6, 0x0181, 0x02A9, 0x0401, 0x048F, 
	0x04DF, 0x04F5, 0x0473, 0x03EB, 0x03EF, 0x0415, 0x0447, 0x0472, 0x0481, 
	0x0460, 0x0413, 0x03AC, 0x03AB, 0x0401, 0x047C, 0x04DC, 0x04D2, 0x0393, 
	0x024E, 0x01DE, 0x01B9, 0x01D9, 0x02BD, 0x0392, 0x037B, 0x0316, 0x029C, 
	0x0248, 0x0253, 0x02F9, 0x041F, 0x057F, 0xBE37, 0xBA47, 0xB3CE, 0xAC52, 
	0xA9F5, 0xB8B6, 0xC88F, 0xCDE2, 0xCFAF, 0xCEDC, 0xC6F1, 0xBF57, 0xBF37, 
	0xC0B1, 0xC2E6, 0xC4F4, 0xC5FD, 0xC521, 0xC2A9, 0xBF8A, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x1927, 0x12C2, 0x0B42, 0x0C70, 0x1054, 0x13B5, 0x1826, 0x1EBC, 
	0x25F5, 0x2B14, 0x2C55, 0x2B7C, 0x2B14, 0x2BCB, 0x2CA3, 0x2DA8, 0x2EE3, 
	0x3060, 0x31FA, 0x3388, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xDF07, 0xE25F, 0xE5C2, 0xE37F, 0xDF5B, 0xDBAE, 
	0xD70A, 0xD02A, 0xC8A6, 0xC352, 0xC1DC, 0xC297, 0xC352, 0xC329, 0xC2D7, 
	0xC299, 0xC2AD, 0xC352, 0xC464, 0xC595, 
},
{
	0x0001, 0x0000, 0x0014, 0x0001, 0x000A, 0x0015, 0x0001, 0x001F, 0x0001, 
	0x0020, 0x0001, 0x0021, 0x0013, 0x0022, 0x0003, 0x0035, 0x0014, 0x0038, 
	0x0014, 0x004C, 0x0012, 0x0060, 0x0014, 0x0072, 0x000B, 0x0086, 0x000B, 
	0x0091, 0x000B, 0x009C, 0x0001, 0x00A7, 0x0001, 0x00A8, 0x0001, 0x00A9, 
	0x0012, 0x00AA, 0x0012, 0x00BC, 0x0014, 0x00CE, 0x0014, 0x00E2, 0x0014, 
	0x00F6, 0x0014, 0x010A, 0x0014, 0x011E, 0x0014, 0x0132, 0x0014, 0x0146, 
	0x0001, 0x015A, 0x0001, 0x015B, 0x0001, 0x015C, 0x0012, 0x015D, 0x0012, 
	0x016F, 0x0014, 0x0181, 0x0012, 0x0195, 0x0012, 0x01A7, 0x0014, 0x01B9, 
	0x0014, 0x01CD, 0x0014, 0x01E1, 0x0014, 0x01F5, 0x0010, 0x0209, 0x0014, 
	0x0219, 0x0001, 0x022D, 0x0014, 0x022E, 0x0014, 0x0242, 0x0014, 0x0256, 
	0x0014, 0x026A, 0x0014, 0x027E, 0x0014, 0x0292, 0x0012, 0x02A6, 0x0014, 
	0x02B8, 0x0014, 0x02CC, 0x0012, 0x02E0, 0x0014, 0x02F2, 0x0001, 0x0306, 
	0x0014, 0x0307, 0x0014, 0x031B, 0x0014, 0x032F, 0x0013, 0x0343, 0x0014, 
	0x0356, 0x0014, 0x036A, 0x0012, 0x037E, 0x0012, 0x0390, 0x0014, 0x03A2, 
	
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_DYING_IN_QUICKSAND], 0, 189, 0, 99, 99, {
	0x0000, 0x00BD, 0x00BD, 0x00BD, 0x00BD, 0x00BD, 0x00BD, 0x00BD, 0x00BD, 
	0x00BD, 0x00BD, 0x00BD, 0x00BD, 0x00BD, 0x00BD, 0x00BF, 0x00C2, 0x00C6, 
	0x00CA, 0x00CF, 0x00D4, 0x00D9, 0x00DE, 0x00E2, 0x00E6, 0x00E9, 0x00EB, 
	0x00EC, 0x00EA, 0x00E6, 0x00E0, 0x00D9, 0x00D1, 0x00CA, 0x00C3, 0x00BF, 
	0x00BD, 0x00BD, 0x00BF, 0x00C2, 0x00C6, 0x00CB, 0x00CF, 0x00D4, 0x00D8, 
	0x00DC, 0x00DE, 0x00DE, 0x00DE, 0x00DE, 0x00DE, 0x00DE, 0x00DD, 0x00DD, 
	0x00DC, 0x00DB, 0x00DA, 0x00D9, 0x00D8, 0x00D6, 0x00D5, 0x00D2, 0x00D0, 
	0x00CD, 0x00CA, 0x00C7, 0x00C3, 0x00BE, 0x00BA, 0x00B5, 0x00AF, 0x00A9, 
	0x00A2, 0x009B, 0x0094, 0x008B, 0x0083, 0x0079, 0x006F, 0x0065, 0x005A, 
	0x004F, 0x0044, 0x0039, 0x002E, 0x0022, 0x0017, 0x000C, 0x0002, 0xFFF8, 
	0xFFEE, 0xFFE5, 0xFFDC, 0xFFD4, 0xFFCD, 0xFFC7, 0xFFC2, 0xFFBD, 0xFFBA, 
	0xFFB8, 0x0000, 0x0000, 0x3FFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFF8, 0xFFE1, 0xFFBC, 0xFF8A, 0xFF4C, 0xFF03, 0xFEAF, 0xFE52, 
	0xFDED, 0xFD80, 0xFD0D, 0xFC94, 0xFC17, 0xFB96, 0xFB12, 0xFA8D, 0xFA06, 
	0xF980, 0xF8FB, 0xF878, 0xF7F8, 0xF77B, 0xF704, 0xF692, 0xF627, 0xF5C4, 
	0xF569, 0xF518, 0xF4D2, 0xF497, 0xF468, 0xF446, 0xF433, 0xF42F, 0x46AF, 
	0xFFFF, 0x0048, 0x00C0, 0x00D8, 0x0000, 0xFDC1, 0xFA85, 0xF703, 0xF3F8, 
	0xF148, 0xEE77, 0xEBAB, 0xE90B, 0xE6BE, 0xE4E9, 0xE3B3, 0xE30A, 0xE2BA, 
	0xE2B7, 0xE2F5, 0xE368, 0xE405, 0xE4C1, 0xE58E, 0xE662, 0xE778, 0xE8F9, 
	0xEABE, 0xEC9E, 0xEE74, 0xF016, 0xF057, 0xEFB4, 0xF08B, 0xF538, 0x03B5, 
	0x179E, 0x23BC, 0x2709, 0x2962, 0x2AE2, 0x2BA6, 0x2BC8, 0x2B65, 0x2A99, 
	0x297F, 0x2833, 0x26D1, 0x2530, 0x2321, 0x20B2, 0x1DF1, 0x1AED, 0x17B5, 
	0x1457, 0x10E1, 0x0D64, 0x09EC, 0x068A, 0x02DE, 0xFEA6, 0xFA1B, 0xF575, 
	0xF0EB, 0xECB7, 0xE911, 0xE630, 0xE44D, 0xE31E, 0xE230, 0xE17D, 0xE100, 
	0xE0B1, 0xE08C, 0xE08B, 0xE0A6, 0xE0DA, 0xE11F, 0xE16F, 0xE1C5, 0xE21C, 
	0xE26C, 0xE2B0, 0xE2E2, 0xE2FC, 0xE2F9, 0xE2E3, 0xE2CA, 0xE2AF, 0xE293, 
	0xE275, 0xE258, 0xE23B, 0xE220, 0xE207, 0xE1F1, 0xE1DF, 0xE1D1, 0xE1C8, 
	0xE1C5, 0x0000, 0x0006, 0x0011, 0x0013, 0x0000, 0xFF9A, 0xFEFE, 0xFE9C, 
	0xFEE6, 0xFFFD, 0x0190, 0x0362, 0x0539, 0x06D8, 0x0804, 0x0882, 0x087A, 
	0x083A, 0x07C2, 0x0710, 0x0624, 0x04FC, 0x0397, 0x01F5, 0x0015, 0xFD62, 
	0xF9A3, 0xF55C, 0xF110, 0xED45, 0xEA7D, 0xE92C, 0xE921, 0xE9EA, 0xEB14, 
	0xED75, 0xF0C7, 0xF2F0, 0xF3A9, 0xF41C, 0xF45C, 0xF47B, 0xF48B, 0xF4A0, 
	0xF4CA, 0xF51D, 0xF5AA, 0xF684, 0xF7AF, 0xF91A, 0xFAB7, 0xFC79, 0xFE53, 
	0x0037, 0x0219, 0x03EB, 0x059F, 0x0728, 0x087A, 0x09AB, 0x0AD4, 0x0BEB, 
	0x0CE2, 0x0DB0, 0x0E47, 0x0E9E, 0x0EA7, 0x0E57, 0x0DC5, 0x0D12, 0x0C41, 
	0x0B55, 0x0A52, 0x093C, 0x0815, 0x06E1, 0x05A3, 0x045F, 0x0319, 0x01D3, 
	0x0091, 0xFF57, 0xFE28, 0xFD07, 0xFBF8, 0xFAFD, 0xFA09, 0xF90B, 0xF808, 
	0xF704, 0xF604, 0xF50C, 0xF421, 0xF347, 0xF283, 0xF1D8, 0xF14C, 0xF0E2, 
	0xF09F, 0xF088, 0x0F09, 0x0CAE, 0x073A, 0x0118, 0xFCB4, 0xFA72, 0xF91F, 
	0xF8BC, 0xF949, 0xFA9A, 0xFC69, 0xFE92, 0x00F2, 0x0365, 0x05C9, 0x07FA, 
	0x0A43, 0x0CE6, 0x0FB4, 0x1281, 0x151D, 0x1759, 0x1908, 0x19FC, 0x1A05, 
	0x184C, 0x1497, 0x0FA4, 0x0A30, 0x04F9, 0x00BE, 0xFD33, 0xF9FA, 0xF7BA, 
	0xF716, 0xFA8F, 0x0084, 0x0368, 0x029B, 0x0141, 0xFF79, 0xFD60, 0xFB15, 
	0xF8B4, 0xF65D, 0xF42C, 0xF240, 0xF0B7, 0xEF5C, 0xEDF0, 0xEC83, 0xEB24, 
	0xE9E1, 0xE8CB, 0xE7F0, 0xE75F, 0xE727, 0xE758, 0xE801, 0xE984, 0xEC0D, 
	0xEF53, 0xF310, 0xF6FC, 0xFACF, 0xFE44, 0x0111, 0x02F1, 0x042B, 0x053A, 
	0x0621, 0x06E5, 0x0789, 0x0812, 0x0882, 0x08DF, 0x092B, 0x096C, 0x09A4, 
	0x09D8, 0x0A0B, 0x0A42, 0x0A80, 0x0ACA, 0x0B22, 0x0B8E, 0x0C0C, 0x0C95, 
	0x0D26, 0x0DBC, 0x0E53, 0x0EE9, 0x0F7A, 0x1002, 0x107E, 0x10EB, 0x1146, 
	0x118B, 0x11B6, 0x11C6, 0xFFFF, 0xFFB1, 0xFF2F, 0xFF15, 0x0000, 0x0286, 
	0x0630, 0x0A04, 0x0D0A, 0x0F41, 0x114D, 0x1331, 0x14EE, 0x1684, 0x17F3, 
	0x193F, 0x1A74, 0x1B81, 0x1C33, 0x1C56, 0x1BBA, 0x1A9C, 0x195B, 0x17F5, 
	0x1668, 0x14B2, 0x12D1, 0x10C3, 0x0E86, 0x0C17, 0x0975, 0x05EB, 0x0134, 
	0xFBED, 0xF6B6, 0xF230, 0xEEF8, 0xEDA2, 0xED1D, 0xECBC, 0xEC80, 0xEC65, 
	0xEC69, 0xEC8C, 0xECCB, 0xED24, 0xED96, 0xEE1F, 0xEEBD, 0xEF6E, 0xF031, 
	0xF103, 0xF1E4, 0xF2D0, 0xF3C7, 0xF4C6, 0xF5CC, 0xF6D7, 0xF7E5, 0xF980, 
	0xFBFF, 0xFF18, 0x027E, 0x05E7, 0x0907, 0x0B93, 0x0D3E, 0x0DBF, 0x0D7E, 
	0x0D19, 0x0C93, 0x0BEE, 0x0B2E, 0x0A53, 0x0961, 0x085B, 0x0741, 0x0619, 
	0x04E2, 0x03A1, 0x0258, 0x0108, 0xFFB5, 0xFE61, 0xFD0E, 0xFBBF, 0xFA77, 
	0xF938, 0xF803, 0xF6DD, 0xF5C7, 0xF4C4, 0xF3D6, 0xF2FF, 0xF243, 0xF1A4, 
	0xF124, 0xF0C5, 0xF08A, 0xF076, 0xFFFF, 0xFFFD, 0xFFF9, 0xFFF9, 0xFFFF, 
	0x0011, 0x0029, 0x0045, 0x0060, 0x0081, 0x00AD, 0x00DC, 0x0106, 0x0123, 
	0x012B, 0x0116, 0x00B6, 0x000A, 0xFF4E, 0xFEBF, 0xFE98, 0xFEC0, 0xFEF3, 
	0xFF31, 0xFF77, 0xFFC5, 0x0019, 0x0072, 0x00CF, 0x012E, 0x018F, 0x01F0, 
	0x0250, 0x02AD, 0x0307, 0x035B, 0x03AA, 0x03F1, 0x0431, 0x0470, 0x04B0, 
	0x04EF, 0x052D, 0x056A, 0x05A6, 0x05E1, 0x061A, 0x0652, 0x0688, 0x06BB, 
	0x06EC, 0x071B, 0x0747, 0x0770, 0x0796, 0x07B8, 0x07D7, 0x07F2, 0x080A, 
	0x0807, 0x07DE, 0x079B, 0x0748, 0x06F3, 0x06A8, 0x0672, 0x065E, 0x0678, 
	0x06B1, 0x06F1, 0x0738, 0x0786, 0x07DA, 0x0833, 0x0891, 0x08F3, 0x0958, 
	0x09C0, 0x0A2A, 0x0A96, 0x0B02, 0x0B6F, 0x0BDB, 0x0C46, 0x0CB0, 0x0D17, 
	0x0D7C, 0x0DDD, 0x0E39, 0x0E91, 0x0EE4, 0x0F31, 0x0F77, 0x0FB5, 0x0FEC, 
	0x101A, 0x103F, 0x105A, 0x106B, 0x1071, 0xEE87, 0xEFF4, 0xF33F, 0xF6EF, 
	0xF987, 0xFA9F, 0xFB02, 0xFB04, 0xFAFA, 0xFB08, 0xFB18, 0xFB1F, 0xFB10, 
	0xFAE2, 0xFA89, 0xF9FB, 0xF8DE, 0xF72B, 0xF551, 0xF3BE, 0xF2E1, 0xF28A, 
	0xF23E, 0xF1FC, 0xF1C4, 0xF197, 0xF174, 0xF15B, 0xF14C, 0xF148, 0xF14E, 
	0xF15D, 0xF177, 0xF19B, 0xF1C9, 0xF201, 0xF242, 0xF294, 0xF302, 0xF38A, 
	0xF428, 0xF4D8, 0xF598, 0xF662, 0xF733, 0xF809, 0xF8DE, 0xF9B0, 0xFA7A, 
	0xFB3A, 0xFBEB, 0xFC8A, 0xFD13, 0xFD83, 0xFDD5, 0xFE07, 0xFE14, 0xFDF9, 
	0xFDB2, 0xFCC6, 0xFAE5, 0xF84E, 0xF53C, 0xF1ED, 0xEE9D, 0xEB88, 0xE8EC, 
	0xE705, 0xE589, 0xE405, 0xE27A, 0xE0EA, 0xDF55, 0xDDBE, 0xDC26, 0xDA8D, 
	0xD8F6, 0xD761, 0xD5D0, 0xD445, 0xD2BF, 0xD142, 0xCFCE, 0xCE64, 0xCD06, 
	0xCBB5, 0xCA72, 0xC93F, 0xC81D, 0xC70D, 0xC611, 0xC52A, 0xC459, 0xC3A0, 
	0xC2FF, 0xC279, 0xC20E, 0xC1C1, 0xC191, 0xC181, 0x0001, 0xFFFE, 0xC170, 
	0xFD1E, 0xFCC6, 0xFBD1, 0xFA59, 0xF87C, 0xF653, 0xF3FC, 0xF191, 0xEF2E, 
	0xECEE, 0xEA84, 0xE7A8, 0xE480, 0xE131, 0xDDE2, 0xDAB8, 0xD7DA, 0xD56C, 
	0xD396, 0xD27C, 0xD245, 0xD2B7, 0xD37B, 0xD488, 0xD5D7, 0xD762, 0xD91F, 
	0xDB08, 0xDD15, 0xDF3E, 0xE17D, 0xE3C8, 0xE61A, 0xE869, 0xEAAF, 0xECE4, 
	0xEF01, 0xF0FD, 0xF2D2, 0xF477, 0xF5E6, 0xF716, 0xF801, 0xF89D, 0xF8E5, 
	0xF8D0, 0xF857, 0xF772, 0xF4CA, 0xEF71, 0xE7FF, 0xDF0C, 0xD52E, 0xCAFE, 
	0xC112, 0xB803, 0xB068, 0xAAD8, 0xA7EB, 0xA73C, 0xA7E2, 0xA9AB, 0xAC66, 
	0xAFE5, 0xB3F4, 0xB865, 0xBD07, 0xC1A8, 0xC618, 0xCA26, 0xCDA3, 0xD05C, 
	0xD223, 0xD2C5, 0xD1A3, 0xD0E4, 0xCEE5, 0xCC08, 0xC8AD, 0xC533, 0xC1FB, 
	0xBF65, 0xBDD1, 0xBDA0, 0xBED1, 0xC0FF, 0xC3F4, 0xC77B, 0xCB5B, 0xCF60, 
	0xD352, 0xD6FB, 0xDA26, 0xDC9A, 0xDE23, 0xDF16, 0xDFEC, 0xE0A7, 0xE14A, 
	0xE1D5, 0xE24B, 0xE2AC, 0xE2FB, 0xE33A, 0xE369, 0xE38B, 0xE3A1, 0xE3AD, 
	0xE3B1, 0xE3AD, 0xE3A5, 0xE399, 0xE38B, 0xE37C, 0xE36F, 0xE365, 0xE360, 
	0xE361, 0xE36A, 0xE37D, 0xE39B, 0xE3C6, 0xE422, 0xE4C2, 0xE58C, 0xE666, 
	0xE736, 0xE7E1, 0xE84E, 0xE862, 0xE803, 0xE718, 0xE587, 0xE32F, 0xE01B, 
	0xDC6C, 0xD845, 0xD3C7, 0xCF15, 0xCA51, 0xC59D, 0xC11B, 0xBCED, 0xB935, 
	0xB615, 0xB3B0, 0xB227, 0xB19C, 0xC40C, 0xC3B4, 0xC2CF, 0xC194, 0xC03A, 
	0xBEF7, 0xBE03, 0xBD94, 0xBDE1, 0xBF20, 0xC17E, 0xC4DA, 0xC8F7, 0xCD96, 
	0xD279, 0xD762, 0xDC15, 0xE052, 0xE3DC, 0xE676, 0xE7E0, 0xE872, 0xE8AE, 
	0xE89D, 0xE846, 0xE7B1, 0xE6E6, 0xE5ED, 0xE4CD, 0xE38F, 0xE23A, 0xE0D6, 
	0xDF6B, 0xDE00, 0xDC9D, 0xDB4B, 0xDA10, 0xD8F5, 0xD802, 0xD73E, 0xD6B1, 
	0xD662, 0xD65B, 0xD6A2, 0xD73F, 0xD83B, 0xD99C, 0xDB6B, 0xDF16, 0xE599, 
	0xEE4F, 0xF88F, 0x03B5, 0x0F1B, 0x1A1A, 0x240D, 0x2C4C, 0x3233, 0x351B, 
	0x3565, 0x340A, 0x3149, 0x2D5E, 0x2887, 0x2302, 0x1D0C, 0x16E3, 0x10C5, 
	0x0AEE, 0x059D, 0x0110, 0xFD83, 0xFB35, 0xFA62, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xD1F6, 0xD1D7, 0xD180, 0xD0F7, 0xD042, 
	0xCF69, 0xCE70, 0xCD60, 0xCC3D, 0xCB10, 0xC9DE, 0xC8AE, 0xC786, 0xC66C, 
	0xC568, 0xC480, 0xC3BA, 0xC31D, 0xC2AF, 0xC276, 0xC27A, 0xC2A9, 0xC2EB, 
	0xC341, 0xC3A8, 0xC420, 0xC4A8, 0xC53E, 0xC5E1, 0xC690, 0xC74A, 0xC80D, 
	0xC8D9, 0xC9AC, 0xCA85, 0xCB63, 0xCC45, 0xCD2A, 0xCE10, 0xCEF6, 0xCFDB, 
	0xD0BE, 0xD19E, 0xD279, 0xD34E, 0xD41D, 0xD4E4, 0xD5A2, 0xD655, 0xD6FD, 
	0xD798, 0xD825, 0xD8A3, 0xD911, 0xD96E, 0xD9B8, 0xD9EF, 0xDA10, 0xDA1C, 
	0xFF89, 0xFF9A, 0xFFCC, 0x001B, 0x0084, 0x0106, 0x019E, 0x0248, 0x0303, 
	0x03CB, 0x049E, 0x0579, 0x065A, 0x073E, 0x0822, 0x097C, 0x0B7A, 0x0DAE, 
	0x0FAB, 0x1104, 0x114A, 0x10DA, 0x105A, 0x0FCA, 0x0F2B, 0x0E7F, 0x0DC7, 
	0x0D03, 0x0C36, 0x0B5F, 0x0A80, 0x0999, 0x08AE, 0x07BD, 0x06C8, 0x05D1, 
	0x04D9, 0x03DF, 0x02E7, 0x01F0, 0x00FB, 0x000B, 0xFF1F, 0xFE39, 0xFD5B, 
	0xFC84, 0xFBB7, 0xFAF3, 0xFA3C, 0xF990, 0xF8F2, 0xF863, 0xF7E3, 0xF774, 
	0xF716, 0xF6CC, 0xF696, 0xF674, 0xF669, 0xF97F, 0xF97E, 0xF97A, 0xF96E, 
	0xF959, 0xF936, 0xF903, 0xF8BC, 0xF85F, 0xF7E8, 0xF754, 0xF69F, 0xF5C7, 
	0xF4C9, 0xF3A1, 0xF15B, 0xED98, 0xE931, 0xE500, 0xE1DE, 0xE0A5, 0xE0B3, 
	0xE0D5, 0xE109, 0xE14E, 0xE1A3, 0xE208, 0xE27A, 0xE2FA, 0xE385, 0xE41B, 
	0xE4BB, 0xE563, 0xE612, 0xE6C9, 0xE784, 0xE844, 0xE906, 0xE9CB, 0xEA91, 
	0xEB57, 0xEC1B, 0xECDE, 0xED9D, 0xEE57, 0xEF0C, 0xEFBA, 0xF061, 0xF0FE, 
	0xF192, 0xF21B, 0xF298, 0xF308, 0xF36A, 0xF3BC, 0xF3FE, 0xF42E, 0xF44C, 
	0xF456, 0xF06E, 0xF098, 0xF10C, 0xF1C0, 0xF2A5, 0xF3B0, 0xF4D5, 0xF606, 
	0xF738, 0xF85D, 0xF96A, 0xFA52, 0xFB08, 0xFB80, 0xFBAE, 0xFB02, 0xF942, 
	0xF6E7, 0xF465, 0xF235, 0xF0CC, 0xEFED, 0xEF08, 0xEE1F, 0xED33, 0xEC43, 
	0xEB51, 0xEA5C, 0xE967, 0xE870, 0xE779, 0xE683, 0xE58E, 0xE49B, 0xE3A9, 
	0xE2BB, 0xE1D0, 0xE0E9, 0xE006, 0xDF29, 0xDE51, 0xDD80, 0xDCB6, 0xDBF4, 
	0xDB3A, 0xDA88, 0xD9E0, 0xD942, 0xD8AF, 0xD827, 0xD7AA, 0xD73A, 0xD6D7, 
	0xD682, 0xD63B, 0xD602, 0xD5D9, 0xD5C0, 0xD5B8, 0x0001, 0xFFFE, 0xC170, 
	0x0BC6, 0x0C91, 0x0ECB, 0x1235, 0x1694, 0x1BAA, 0x213A, 0x2709, 0x2CD8, 
	0x326B, 0x3785, 0x3BE9, 0x3F5B, 0x419D, 0x4273, 0x41D3, 0x3FFC, 0x3D1C, 
	0x3963, 0x3500, 0x3021, 0x2AF4, 0x25AA, 0x2071, 0x1B78, 0x16ED, 0x12FF, 
	0x0FDE, 0x0DB8, 0x0CBC, 0x0D19, 0x18AB, 0x3121, 0x4A67, 0xD86A, 0x4E64, 
	0x3781, 0x2B9B, 0x2EBA, 0x3486, 0x3C45, 0x453F, 0x4EBC, 0xD800, 0xE055, 
	0xE702, 0xEB4E, 0xEC7F, 0xEB8F, 0xE9FD, 0xE7D5, 0xE525, 0xE1FD, 0xDE68, 
	0xDA77, 0xD635, 0xD1B2, 0xCCFB, 0x4820, 0x432B, 0x3E2C, 0x3931, 0x3448, 
	0x2F7F, 0x2AE3, 0x2682, 0x226C, 0x1EAC, 0x1B52, 0x186B, 0x15CD, 0x1348, 
	0x10E3, 0x0EA3, 0x0C8F, 0x0AAC, 0x0900, 0x0791, 0x0664, 0x0581, 0x04EC, 
	0x04AC, 0x04C6, 0x0541, 0x0622, 0x076F, 0x09A8, 0x0D22, 0x11A4, 0x16F2, 
	0x1CD3, 0x230C, 0x2964, 0x2FA0, 0xB585, 0xBADA, 0xBF66, 0xC2ED, 0xC536, 
	0xC605, 0x29C2, 0x298D, 0x28FC, 0x2820, 0x270E, 0x25D8, 0x2492, 0x234E, 
	0x221F, 0x2119, 0x204E, 0x1FD2, 0x1FB7, 0x2011, 0x20F2, 0x224F, 0x2409, 
	0x2615, 0x286B, 0x2B00, 0x2DCB, 0x30C1, 0x33DA, 0x370B, 0x3A4B, 0x3D90, 
	0x40D0, 0x4402, 0x471B, 0x4A12, 0x4CDE, 0x4FD0, 0x52DB, 0x556B, 0x2919, 
	0x55F5, 0x5373, 0x5222, 0x527D, 0x531E, 0x53F3, 0x54EA, 0x55F0, 0x290E, 
	0x2821, 0x275C, 0x26D1, 0x2694, 0x2689, 0x268B, 0x2698, 0x26AF, 0x26D1, 
	0x26FB, 0x272D, 0x2767, 0x27A7, 0x27EC, 0x57C9, 0x577B, 0x5729, 0x56D5, 
	0x567F, 0x5629, 0x55D2, 0x557D, 0x5529, 0x54D8, 0x548A, 0x5441, 0x53F3, 
	0x5399, 0x5336, 0x52CD, 0x525E, 0x51EC, 0x517A, 0x510A, 0x509E, 0x5038, 
	0x4FDB, 0x4F88, 0x4F43, 0x4F0C, 0x4EE7, 0x4ED5, 0x4EE1, 0x4F0C, 0x4F54, 
	0x4FB1, 0x501F, 0x5098, 0x5116, 0x5196, 0x2DF0, 0x2D80, 0x2D1F, 0x2CD3, 
	0x2CA2, 0x2C90, 0xD5E6, 0xD690, 0xD869, 0xDB3E, 0xDEDD, 0xE311, 0xE7A7, 
	0xEC6B, 0xF12B, 0xF5B3, 0xF9CF, 0xFD4B, 0xFFF5, 0x0198, 0x0202, 0x0142, 
	0xFF9D, 0xFD33, 0xFA22, 0xF688, 0xF284, 0xEE35, 0xE9B9, 0xE530, 0xE0B7, 
	0xDC6D, 0xD870, 0xD4E1, 0xD1DC, 0xCF81, 0xCDED, 0xD182, 0xDB0E, 0xE557, 
	0x6B24, 0xE629, 0xDC4E, 0xDA9B, 0xE2EC, 0xEDE1, 0xFAA9, 0x0872, 0x166C, 
	0xA3C5, 0xAFAC, 0xB950, 0xBFE0, 0xC28A, 0xC28C, 0xC1BC, 0xC028, 0xBDE4, 
	0xBAFE, 0xB788, 0xB392, 0xAF2E, 0xAA6B, 0xA55C, 0x2010, 0x1A98, 0x1504, 
	0x0F65, 0x09CD, 0x044C, 0xFEF2, 0xF9D1, 0xF4F9, 0xF07A, 0xEC66, 0xE8CE, 
	0xE587, 0xE25E, 0xDF54, 0xDC69, 0xD99E, 0xD6F3, 0xD46A, 0xD202, 0xCFBD, 
	0xCD9C, 0xCB9D, 0xC9C3, 0xC80F, 0xC67F, 0xC517, 0xC3D5, 0xC2D6, 0xC22E, 
	0xC1D3, 0xC1BA, 0xC1D7, 0xC220, 0xC289, 0xC308, 0x4392, 0x441C, 0x4499, 
	0x4501, 0x4547, 0x4561, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xD6D9, 0xD6F3, 0xD73B, 0xD7AC, 0xD83F, 
	0xD8EC, 0xD9AD, 0xDA7C, 0xDB51, 0xDC27, 0xDCF6, 0xDDB7, 0xDE64, 0xDEF7, 
	0xDF67, 0xDFB6, 0xDFEA, 0xE008, 0xE014, 0xE012, 0xE009, 0xDFFB, 0xDFEF, 
	0xDFE8, 0xDFEB, 0xDFFE, 0xE023, 0xE061, 0xE0BB, 0xE137, 0xE1D9, 0xE405, 
	0xE7E9, 0xEBB9, 0xEDAA, 0xEB8F, 0xE731, 0xE4B3, 0xE487, 0xE45C, 0xE432, 
	0xE409, 0xE3E2, 0xE3BC, 0xE397, 0xE374, 0xE353, 0xE333, 0xE314, 0xE2F8, 
	0xE2DD, 0xE2C3, 0xE2AC, 0xE296, 0xE282, 0xE270, 0xE261, 0xE253, 0xE247, 
	0xE23D, 0xE235, 0xE230, 0xE22D, 0xE22C, 0xE22D, 0xE231, 0xE237, 0xE240, 
	0xE24B, 0xE259, 0xE269, 0xE27C, 0xE292, 0xE2AA, 0xE2C5, 0xE2E3, 0xE304, 
	0xE328, 0xE34E, 0xE378, 0xE3A5, 0xE3D4, 0xE407, 0xE43D, 0xE477, 0xE4B3, 
	0xE521, 0xE5E5, 0xE6EE, 0xE82F, 0xE999, 0xEB1C, 0xECAA, 0xEE33, 0xEFA9, 
	0xF0FC, 0xF21E, 0xF300, 0xF392, 0xF3C6, 0xF991, 0xF975, 0xF92A, 0xF8BB, 
	0xF835, 0xF7A2, 0xF70F, 0xF686, 0xF615, 0xF5C6, 0xF5A5, 0xF5BE, 0xF61D, 
	0xF6CE, 0xF7DB, 0xF95E, 0xFB5D, 0xFDC2, 0x007C, 0x0375, 0x069C, 0x09DC, 
	0x0D22, 0x105A, 0x1372, 0x1655, 0x18F0, 0x1B30, 0x1D01, 0x1E50, 0x1F09, 
	0x1B3E, 0x11ED, 0x0766, 0xFFF9, 0xFE01, 0xFEFE, 0xFFFA, 0xFFFA, 0xFFFA, 
	0xFFFA, 0xFFFA, 0xFFF9, 0xFFF9, 0xFFF8, 0xFFF7, 0xFFF6, 0xFFF6, 0xFFF5, 
	0xFFF4, 0xFFF3, 0xFFF2, 0xFFF1, 0xFFF0, 0xFFEF, 0xFFEE, 0xFFED, 0xFFEC, 
	0xFFEB, 0xFFEA, 0xFFE9, 0xFFE8, 0xFFE7, 0xFFE7, 0xFFE6, 0xFFE6, 0xFFE5, 
	0xFFE5, 0xFFE5, 0xFFE5, 0xFFE5, 0xFFE5, 0xFFE5, 0xFFE6, 0xFFE6, 0xFFE7, 
	0xFFE8, 0xFFE9, 0xFFEB, 0xFFEC, 0xFFEE, 0xFFF0, 0xFFF2, 0xFFF5, 0xFFF7, 
	0xFFFA, 0x0000, 0x0009, 0x0016, 0x0026, 0x0038, 0x004B, 0x005F, 0x0072, 
	0x0084, 0x0095, 0x00A3, 0x00AE, 0x00B6, 0x00B8, 0x0CE2, 0x0CC4, 0x0C6F, 
	0x0BEE, 0x0B4E, 0x0A99, 0x09DA, 0x091C, 0x086B, 0x07D0, 0x0758, 0x070E, 
	0x06FC, 0x072D, 0x07AD, 0x088E, 0x09D0, 0x0B63, 0x0D37, 0x0F3E, 0x1167, 
	0x13A2, 0x15E1, 0x1813, 0x1A29, 0x1C13, 0x1DC2, 0x1F26, 0x202F, 0x20CE, 
	0x20F3, 0x1D3C, 0x14DB, 0x0BA4, 0x0568, 0x04B2, 0x0706, 0x08AB, 0x08BA, 
	0x08C9, 0x08D7, 0x08E4, 0x08F0, 0x08FB, 0x0906, 0x090F, 0x0918, 0x091F, 
	0x0926, 0x092C, 0x0932, 0x0936, 0x093A, 0x093D, 0x0940, 0x0942, 0x0943, 
	0x0944, 0x0944, 0x0943, 0x0942, 0x0940, 0x093E, 0x093B, 0x0938, 0x0935, 
	0x0930, 0x092C, 0x0927, 0x0922, 0x091C, 0x0916, 0x0910, 0x0909, 0x0902, 
	0x08FB, 0x08F4, 0x08EC, 0x08E5, 0x08DD, 0x08D5, 0x08CC, 0x08C4, 0x08BC, 
	0x08B3, 0x08AB, 0x089B, 0x0881, 0x085C, 0x0830, 0x07FE, 0x07C9, 0x0792, 
	0x075C, 0x0728, 0x06FA, 0x06D2, 0x06B2, 0x069E, 0x0697, 0xE290, 0xE270, 
	0xE216, 0xE18B, 0xE0DB, 0xE00E, 0xDF2E, 0xDE45, 0xDD5D, 0xDC80, 0xDBB7, 
	0xDB0C, 0xDA89, 0xDA38, 0xDA23, 0xDA47, 0xDA9A, 0xDB14, 0xDBAF, 0xDC64, 
	0xDD2E, 0xDE06, 0xDEE5, 0xDFC5, 0xE0A0, 0xE16F, 0xE22C, 0xE2D0, 0xE356, 
	0xE3B5, 0xE3EA, 0xE2FE, 0xE0B7, 0xDE25, 0xDC54, 0xDBD9, 0xDC16, 0xDC54, 
	0xDC53, 0xDC52, 0xDC50, 0xDC4E, 0xDC4B, 0xDC47, 0xDC43, 0xDC3F, 0xDC3A, 
	0xDC35, 0xDC2F, 0xDC29, 0xDC24, 0xDC1D, 0xDC17, 0xDC11, 0xDC0B, 0xDC05, 
	0xDBFE, 0xDBF9, 0xDBF3, 0xDBED, 0xDBE8, 0xDBE3, 0xDBDF, 0xDBDB, 0xDBD7, 
	0xDBD4, 0xDBD2, 0xDBD0, 0xDBCF, 0xDBCE, 0xDBCF, 0xDBD0, 0xDBD2, 0xDBD5, 
	0xDBD9, 0xDBDE, 0xDBE4, 0xDBEC, 0xDBF4, 0xDBFE, 0xDC08, 0xDC15, 0xDC22, 
	0xDC31, 0xDC42, 0xDC54, 0xDC75, 0xDCB0, 0xDD00, 0xDD60, 0xDDCD, 0xDE42, 
	0xDEBA, 0xDF30, 0xDFA1, 0xE007, 0xE05F, 0xE0A3, 0xE0CF, 0xE0DE, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xBF5E, 0xFCDB, 0xFA50, 0xAB15, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x29F6, 0x00AB, 0xFF16, 0xC897, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xBF5E, 0x0F9B, 0x0761, 0xB183, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x344A, 0xFF33, 
	0x0238, 0xBB3A, 
},
{
	0x0001, 0x0000, 0x0063, 0x0001, 0x0001, 0x0064, 0x0001, 0x0065, 0x0001, 
	0x0066, 0x0001, 0x0067, 0x001F, 0x0068, 0x0023, 0x0087, 0x0001, 0x00AA, 
	0x0064, 0x00AB, 0x0064, 0x010F, 0x0064, 0x0173, 0x0064, 0x01D7, 0x0064, 
	0x023B, 0x0064, 0x029F, 0x0001, 0x0303, 0x0001, 0x0304, 0x0001, 0x0305, 
	0x004A, 0x0306, 0x004A, 0x0350, 0x004A, 0x039A, 0x0061, 0x03E4, 0x0063, 
	0x0445, 0x003B, 0x04A8, 0x003B, 0x04E3, 0x003B, 0x051E, 0x003B, 0x0559, 
	0x0001, 0x0594, 0x0001, 0x0595, 0x0001, 0x0596, 0x0064, 0x0597, 0x0064, 
	0x05FB, 0x0064, 0x065F, 0x0063, 0x06C3, 0x0064, 0x0726, 0x0064, 0x078A, 
	0x0064, 0x07EE, 0x0064, 0x0852, 0x0064, 0x08B6, 0x0022, 0x091A, 0x0022, 
	0x093C, 0x0001, 0x095E, 0x0001, 0x095F, 0x0001, 0x0960, 0x0001, 0x0961, 
	0x0022, 0x0962, 0x0023, 0x0984, 0x0001, 0x09A7, 0x0001, 0x09A8, 0x0001, 
	0x09A9, 0x0001, 0x09AA, 0x0022, 0x09AB, 0x0022, 0x09CD, 0x0001, 0x09EF, 
	0x0001, 0x09F0, 0x0001, 0x09F1, 0x0001, 0x09F2, 0x0023, 0x09F3, 0x0023, 
	0x0A16, 0x0001, 0x0A39, 0x0001, 0x0A3A, 0x0001, 0x0A3B, 0x0001, 0x0A3C, 
	
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_RUNNING], 0, 189, 0, 0, 71, {
	0x0000, 0x00C0, 0x00BD, 0x00B8, 0x00B4, 0x00B1, 0x00AF, 0x00AD, 0x00AB, 
	0x00AC, 0x00AE, 0x00B0, 0x00B3, 0x00B7, 0x00BA, 0x00BE, 0x00C2, 0x00C5, 
	0x00C8, 0x00CB, 0x00CE, 0x00D1, 0x00D3, 0x00D6, 0x00D8, 0x00D9, 0x00D9, 
	0x00D9, 0x00D8, 0x00D7, 0x00D5, 0x00D2, 0x00D0, 0x00CD, 0x00CA, 0x00C8, 
	0x00C5, 0x00C1, 0x00BD, 0x00B9, 0x00B5, 0x00B2, 0x00B0, 0x00AE, 0x00AD, 
	0x00AC, 0x00AB, 0x00AB, 0x00AB, 0x00AC, 0x00AD, 0x00AF, 0x00B2, 0x00B6, 
	0x00BC, 0x00C2, 0x00C6, 0x00CA, 0x00CD, 0x00CF, 0x00D2, 0x00D4, 0x00D6, 
	0x00D8, 0x00D9, 0x00D9, 0x00D8, 0x00D5, 0x00D3, 0x00CF, 0x00CA, 0x00C5, 
	0x00C3, 0x0000, 0x0000, 0x3FFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x3A85, 0x3AA5, 0x3AFB, 0x3B75, 0x3C01, 0x3C8C, 0x3D06, 
	0x3D5C, 0x3D7D, 0x3D7A, 0x3D70, 0x3D60, 0x3D4B, 0x3D30, 0x3D11, 0x3CEE, 
	0x3CC8, 0x3CA0, 0x3C75, 0x3C49, 0x3C1C, 0x3BEF, 0x3BC2, 0x3B96, 0x3B6C, 
	0x3B43, 0x3B1D, 0x3AFB, 0x3ADC, 0x3AC2, 0x3AAC, 0x3A9C, 0x3A92, 0x3A8F, 
	0x3AAA, 0x3AF0, 0x3B55, 0x3BCD, 0x3C4B, 0x3CC4, 0x3D2A, 0x3D71, 0x3D8D, 
	0x3D8D, 0x3D89, 0x3D7F, 0x3D72, 0x3D61, 0x3D4C, 0x3D35, 0x3D1B, 0x3CFE, 
	0x3CDF, 0x3CBF, 0x3C9E, 0x3C7B, 0x3C58, 0x3C34, 0x3C11, 0x3BEE, 0x3BCC, 
	0x3BAB, 0x3B8C, 0x3B6E, 0x3B53, 0x3B3A, 0x3B24, 0x3B11, 0x3B02, 0x3AF6, 
	0x3AEF, 0x3AED, 0xE9F7, 0xEA12, 0xEA5F, 0xEADB, 0xEB84, 0xEC57, 0xED50, 
	0xEE6C, 0xEFA8, 0xF102, 0xF275, 0xF400, 0xF59E, 0xF74E, 0xF90B, 0xFAD3, 
	0xFCA3, 0xFE77, 0x004E, 0x0222, 0x03F1, 0x05B9, 0x0777, 0x0926, 0x0AC5, 
	0x0C4F, 0x0DC3, 0x0F1C, 0x1059, 0x1175, 0x126E, 0x1340, 0x13E9, 0x1466, 
	0x14B3, 0x14CD, 0x14B4, 0x146B, 0x13F5, 0x1355, 0x128D, 0x11A1, 0x1092, 
	0x0F65, 0x0E1C, 0x0CB9, 0x0B3F, 0x09B2, 0x0814, 0x0668, 0x04B1, 0x02F1, 
	0x012B, 0xFF62, 0xFD99, 0xFBD4, 0xFA14, 0xF85C, 0xF6B0, 0xF512, 0xF385, 
	0xF20B, 0xF0A9, 0xEF5F, 0xEE32, 0xED24, 0xEC37, 0xEB6F, 0xEACF, 0xEA59, 
	0xEA10, 0xE9F7, 0xFFFF, 0x0819, 0x081A, 0x081C, 0x0820, 0x0826, 0x082C, 
	0x0834, 0x083D, 0x0847, 0x0852, 0x085E, 0x086A, 0x0877, 0x0885, 0x0893, 
	0x08A2, 0x08B0, 0x08BF, 0x08CE, 0x08DD, 0x08EB, 0x08FA, 0x0908, 0x0915, 
	0x0922, 0x092F, 0x093B, 0x0946, 0x0950, 0x0959, 0x0960, 0x0967, 0x096C, 
	0x0970, 0x0973, 0x0974, 0x0973, 0x0971, 0x096D, 0x0968, 0x0961, 0x095A, 
	0x0951, 0x0948, 0x093D, 0x0932, 0x0926, 0x091A, 0x090D, 0x08FF, 0x08F1, 
	0x08E3, 0x08D5, 0x08C6, 0x08B8, 0x08AA, 0x089B, 0x088E, 0x0880, 0x0873, 
	0x0866, 0x085A, 0x084F, 0x0845, 0x083B, 0x0833, 0x082B, 0x0825, 0x0820, 
	0x081C, 0x081A, 0x0819, 0x14CC, 0x14B2, 0x1466, 0x13EB, 0x1344, 0x1273, 
	0x117D, 0x1064, 0x0F2C, 0x0DD6, 0x0C66, 0x0AE0, 0x0946, 0x079C, 0x05E3, 
	0x0420, 0x0256, 0x0087, 0xFEB5, 0xFCE6, 0xFB1B, 0xF959, 0xF7A0, 0xF5F6, 
	0xF45C, 0xF2D5, 0xF166, 0xF010, 0xEED7, 0xEDBE, 0xECC8, 0xEBF8, 0xEB51, 
	0xEAD6, 0xEA8A, 0xEA70, 0xEA88, 0xEAD0, 0xEB45, 0xEBE4, 0xECAA, 0xED94, 
	0xEEA0, 0xEFCB, 0xF111, 0xF271, 0xF3E7, 0xF570, 0xF70A, 0xF8B3, 0xFA66, 
	0xFC22, 0xFDE3, 0xFFA7, 0x016D, 0x032E, 0x04EA, 0x069D, 0x0846, 0x09E0, 
	0x0B69, 0x0CDF, 0x0E3F, 0x0F85, 0x10B0, 0x11BC, 0x12A6, 0x136C, 0x140B, 
	0x1480, 0x14C8, 0x14E0, 0x01E7, 0x01E8, 0x01EA, 0x01ED, 0x01F1, 0x01F7, 
	0x01FD, 0x0204, 0x020C, 0x0215, 0x021E, 0x0228, 0x0233, 0x023E, 0x0249, 
	0x0255, 0x0260, 0x026C, 0x0278, 0x0284, 0x0290, 0x029B, 0x02A7, 0x02B2, 
	0x02BC, 0x02C6, 0x02D0, 0x02D8, 0x02E0, 0x02E8, 0x02EE, 0x02F3, 0x02F7, 
	0x02FB, 0x02FD, 0x02FD, 0x02FC, 0x02F6, 0x02EE, 0x02E3, 0x02D5, 0x02C5, 
	0x02B2, 0x029E, 0x0287, 0x026E, 0x0254, 0x0239, 0x021C, 0x01FF, 0x01E0, 
	0x01C1, 0x01A2, 0x0183, 0x0163, 0x0144, 0x0125, 0x0106, 0x00E9, 0x00CC, 
	0x00B1, 0x0097, 0x007E, 0x0068, 0x0053, 0x0040, 0x0030, 0x0022, 0x0017, 
	0x000F, 0x000A, 0x0008, 0xF6AA, 0xFFFE, 0x0001, 0xC170, 0x0EB4, 0x0E86, 
	0x0E00, 0x0D26, 0x0BFF, 0x0A8F, 0x08DD, 0x06EC, 0x04C4, 0x0268, 0xFFDE, 
	0xFD2D, 0xFA59, 0xF767, 0xF45D, 0xF141, 0xEE17, 0xEAE5, 0xE7B0, 0xE47E, 
	0xE154, 0xDE38, 0xDB2E, 0xD83C, 0xD568, 0xD2B7, 0xD02E, 0xCDD2, 0xCBAA, 
	0xC9B9, 0xC807, 0xC697, 0xC570, 0xC496, 0xC410, 0xC3E2, 0xC40D, 0xC48D, 
	0xC55B, 0xC673, 0xC7D0, 0xC96D, 0xCB45, 0xCD53, 0xCF93, 0xD1FE, 0xD492, 
	0xD748, 0xDA1B, 0xDD07, 0xE007, 0xE315, 0xE62D, 0xE94B, 0xEC68, 0xEF80, 
	0xF28F, 0xF58E, 0xF87A, 0xFB4E, 0xFE03, 0x0098, 0x0304, 0x0543, 0x0752, 
	0x092A, 0x0AC7, 0x0C24, 0x0D3C, 0x0E0A, 0x0E89, 0x0EB4, 0xBCCD, 0xBCDA, 
	0xBD02, 0xBD42, 0xBD9A, 0xBE07, 0xBE87, 0xBF1A, 0xBFBD, 0xC070, 0xC130, 
	0xC1FC, 0xC2D2, 0xC3B1, 0xC497, 0xC583, 0xC672, 0xC764, 0xC857, 0xC949, 
	0xCA38, 0xCB24, 0xCC0A, 0xCCE9, 0xCDBF, 0xCE8B, 0xCF4B, 0xCFFE, 0xD0A1, 
	0xD134, 0xD1B5, 0xD221, 0xD279, 0xD2B9, 0xD2E1, 0xD2EE, 0xD2E2, 0xD2BC, 
	0xD27F, 0xD22C, 0xD1C5, 0xD14B, 0xD0BF, 0xD023, 0xCF79, 0xCEC2, 0xCDFF, 
	0xCD32, 0xCC5C, 0xCB7E, 0xCA9B, 0xC9B4, 0xC8C9, 0xC7DE, 0xC6F2, 0xC607, 
	0xC520, 0xC43D, 0xC360, 0xC28A, 0xC1BC, 0xC0F9, 0xC042, 0xBF98, 0xBEFC, 
	0xBE70, 0xBDF6, 0xBD8F, 0xBD3C, 0xBCFF, 0xBCDA, 0xBCCD, 0x9643, 0x96AD, 
	0x97E3, 0x99D9, 0x9C83, 0x9FD3, 0xA3BE, 0xA837, 0xAD32, 0xB2A2, 0xB87C, 
	0xBEB2, 0xC539, 0xCC04, 0xD307, 0xDA34, 0xE181, 0xE8E0, 0xF046, 0xF7A5, 
	0xFEF2, 0x0620, 0x0D23, 0x13EE, 0x1A75, 0x20AB, 0x2685, 0x2BF5, 0x30F0, 
	0x3569, 0x3954, 0x3CA4, 0x3F4E, 0x4144, 0x427A, 0x42E4, 0x4280, 0x415A, 
	0x3F7F, 0x3CF9, 0x39D3, 0x361B, 0x31D9, 0x2D1B, 0x27EB, 0x2255, 0x1C64, 
	0x1623, 0x0F9E, 0x08E0, 0x01F5, 0xFAE7, 0xF3C2, 0xEC93, 0xE564, 0xDE3F, 
	0xD732, 0xD047, 0xC989, 0xC304, 0xBCC3, 0xB6D2, 0xB13C, 0xAC0C, 0xA74E, 
	0xA30C, 0x9F54, 0x9C2E, 0x99A8, 0x97CD, 0x96A7, 0x9643, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xDD42, 0xDD39, 
	0xDD1F, 0xDCF5, 0xDCBC, 0xDC74, 0xDC20, 0xDBC0, 0xDB55, 0xDAE0, 0xDA62, 
	0xD9DC, 0xD950, 0xD8BE, 0xD827, 0xD78C, 0xD6EF, 0xD651, 0xD5B2, 0xD513, 
	0xD476, 0xD3DC, 0xD345, 0xD2B3, 0xD226, 0xD1A1, 0xD123, 0xD0AE, 0xD042, 
	0xCFE2, 0xCF8E, 0xCF47, 0xCF0D, 0xCEE3, 0xCEC9, 0xCEC0, 0xCEC9, 0xCEE1, 
	0xCF09, 0xCF40, 0xCF83, 0xCFD3, 0xD02F, 0xD095, 0xD105, 0xD17D, 0xD1FD, 
	0xD283, 0xD30F, 0xD3A0, 0xD435, 0xD4CD, 0xD567, 0xD601, 0xD69C, 0xD735, 
	0xD7CD, 0xD862, 0xD8F3, 0xD97F, 0xDA06, 0xDA86, 0xDAFE, 0xDB6D, 0xDBD3, 
	0xDC2F, 0xDC7F, 0xDCC3, 0xDCF9, 0xDD21, 0xDD3A, 0xDD42, 0xDFD0, 0xDFDD, 
	0xE001, 0xE03C, 0xE08C, 0xE0F0, 0xE165, 0xE1EC, 0xE282, 0xE325, 0xE3D5, 
	0xE490, 0xE554, 0xE620, 0xE6F3, 0xE7CB, 0xE8A6, 0xE984, 0xEA62, 0xEB3F, 
	0xEC1B, 0xECF3, 0xEDC5, 0xEE92, 0xEF56, 0xF011, 0xF0C0, 0xF164, 0xF1FA, 
	0xF280, 0xF2F6, 0xF359, 0xF3A9, 0xF3E4, 0xF409, 0xF415, 0xF40A, 0xF3E7, 
	0xF3AF, 0xF363, 0xF305, 0xF295, 0xF215, 0xF186, 0xF0EA, 0xF043, 0xEF90, 
	0xEED4, 0xEE10, 0xED45, 0xEC75, 0xEBA1, 0xEACB, 0xE9F3, 0xE91B, 0xE844, 
	0xE770, 0xE6A0, 0xE5D5, 0xE511, 0xE456, 0xE3A3, 0xE2FB, 0xE25F, 0xE1D0, 
	0xE151, 0xE0E1, 0xE082, 0xE036, 0xDFFE, 0xDFDC, 0xDFD0, 0x047B, 0xED8B, 
	0xFFFE, 0x0001, 0xC170, 0x3039, 0x3068, 0x30F1, 0x31CE, 0x32FA, 0x3471, 
	0x362B, 0x3824, 0x3A56, 0x3CBD, 0x3F51, 0x420F, 0x44F0, 0x47EF, 0x4B06, 
	0x4E31, 0x5169, 0x54AA, 0x57ED, 0x5B2D, 0x5E65, 0xE190, 0xE4A7, 0xE7A6, 
	0xEA87, 0xED45, 0xEFD9, 0xF23F, 0xF472, 0xF66B, 0xF825, 0xF99B, 0xFAC8, 
	0xFBA5, 0xFC2E, 0xFC5D, 0xFC31, 0xFBAF, 0xFADD, 0xF9C1, 0xF85D, 0xF6B9, 
	0xF4D9, 0xF2C1, 0xF077, 0xEE00, 0xEB61, 0xE89F, 0xE5BF, 0xE2C6, 0xDFB9, 
	0x5C9D, 0x5976, 0x564B, 0x5320, 0x4FF9, 0x4CDD, 0x49D0, 0x46D7, 0x43F6, 
	0x4134, 0x3E95, 0x3C1F, 0x39D5, 0x37BD, 0x35DD, 0x3438, 0x32D5, 0x31B8, 
	0x30E7, 0x3065, 0x3039, 0x33AC, 0x33B8, 0x33D9, 0x3410, 0x345A, 0x34B6, 
	0x3523, 0x359F, 0x362A, 0x36C1, 0x3764, 0x3810, 0x38C6, 0x3983, 0x3A45, 
	0x3B0D, 0x3BD8, 0x3CA5, 0x3D73, 0x3E3F, 0x3F0A, 0x402E, 0x3F6B, 0x3EAE, 
	0x3DF8, 0x3D4C, 0x3CA9, 0x3C12, 0x3B87, 0x3B0B, 0x3A9E, 0x3A42, 0x39F8, 
	0x39C1, 0x39A0, 0x3994, 0x399F, 0x39BF, 0x39F3, 0x3A39, 0x3A90, 0x3AF8, 
	0x3B6E, 0x3BF2, 0x3C82, 0x3D1D, 0x3DC3, 0x3E70, 0x3F26, 0x3FE1, 0x40A1, 
	0x3E9A, 0x3DD3, 0x3D0C, 0x3C44, 0x3B7D, 0x3AB9, 0x39F9, 0x393E, 0x3888, 
	0x37DA, 0x3735, 0x369A, 0x360A, 0x3586, 0x3510, 0x34A8, 0x3451, 0x340A, 
	0x33D7, 0x33B7, 0x33AC, 0x3473, 0x3460, 0x3429, 0x33D0, 0x3358, 0x32C1, 
	0x3210, 0x3145, 0x3063, 0x2F6C, 0x2E63, 0x2D49, 0x2C21, 0x2AED, 0x29AF, 
	0x286A, 0x271E, 0x25D0, 0x2481, 0x2332, 0x21E7, 0xA0A1, 0x9F63, 0x9E2F, 
	0x9D07, 0x9BED, 0x9AE4, 0x99ED, 0x990B, 0x9841, 0x978F, 0x96F9, 0x9680, 
	0x9627, 0x95F0, 0x95DD, 0x95EF, 0x9623, 0x9677, 0x96EA, 0x9778, 0x9821, 
	0x98E2, 0x99B9, 0x9AA5, 0x9BA2, 0x9CAF, 0x9DCB, 0x9EF3, 0xA024, 0xA15E, 
	0x229F, 0x23E2, 0x2528, 0x266E, 0x27B2, 0x28F2, 0x2A2C, 0x2B5E, 0x2C85, 
	0x2DA1, 0x2EAE, 0x2FAC, 0x3097, 0x316E, 0x322F, 0x32D8, 0x3367, 0x33D9, 
	0x342D, 0x3461, 0x3473, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xCE21, 0xCE2C, 0xCE4D, 0xCE83, 0xCECB, 
	0xCF26, 0xCF90, 0xD00A, 0xD092, 0xD126, 0xD1C5, 0xD26E, 0xD320, 0xD3D9, 
	0xD498, 0xD55C, 0xD622, 0xD6EB, 0xD7B5, 0xD87E, 0xD944, 0xDA08, 0xDAC7, 
	0xDB80, 0xDC32, 0xDCDB, 0xDD7A, 0xDE0E, 0xDE96, 0xDF10, 0xDF7A, 0xDFD5, 
	0xE01D, 0xE053, 0xE074, 0xE07F, 0xE074, 0xE055, 0xE022, 0xDFDE, 0xDF88, 
	0xDF23, 0xDEAF, 0xDE2D, 0xDDA0, 0xDD08, 0xDC66, 0xDBBC, 0xDB0A, 0xDA53, 
	0xD996, 0xD8D6, 0xD814, 0xD750, 0xD68C, 0xD5CA, 0xD50A, 0xD44D, 0xD396, 
	0xD2E4, 0xD23A, 0xD198, 0xD100, 0xD073, 0xCFF1, 0xCF7D, 0xCF18, 0xCEC2, 
	0xCE7E, 0xCE4B, 0xCE2C, 0xCE21, 0x0000, 0x000D, 0x0032, 0x006F, 0x00C1, 
	0x0127, 0x019F, 0x0229, 0x02C3, 0x036A, 0x041F, 0x04DE, 0x05A7, 0x0679, 
	0x0751, 0x082E, 0x090F, 0x09F2, 0x0AD6, 0x0BB9, 0x0C9A, 0x0D77, 0x0E4F, 
	0x0F21, 0x0FEA, 0x10A9, 0x115E, 0x1205, 0x129F, 0x1329, 0x13A1, 0x1408, 
	0x145A, 0x1496, 0x14BB, 0x14C8, 0x14BC, 0x1499, 0x145F, 0x1412, 0x13B1, 
	0x133E, 0x12BB, 0x1229, 0x1189, 0x10DD, 0x1026, 0x0F65, 0x0E9C, 0x0DCC, 
	0x0CF7, 0x0C1E, 0x0B42, 0x0A64, 0x0987, 0x08AB, 0x07D1, 0x06FC, 0x062C, 
	0x0563, 0x04A3, 0x03EB, 0x033F, 0x029F, 0x020D, 0x018A, 0x0117, 0x00B6, 
	0x0069, 0x002F, 0x000C, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xF548, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0xFF5A, 0xFDA5, 0xFB3A, 0xF876, 0xF5B1, 0xF347, 
	0xF192, 0xF0EC, 0xF122, 0xF1BA, 0xF2A4, 0xF3D0, 0xF530, 0xF6B2, 0xF848, 
	0xF9E2, 0xFB71, 0xFCE4, 0xFE2D, 0xFF3B, 0xFFFF, 0x0081, 0x00D6, 0x0104, 
	0x0111, 0x0106, 0x00E7, 0x00BB, 0x0088, 0x0056, 0x002A, 0x000B, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0xC5E3, 0xC5F0, 0xC601, 0xC5F3, 0xC5A7, 0xC4FA, 0xC3CA, 
	0xC1F7, 0xBF5E, 0xBBFF, 0xB804, 0xB38B, 0xAEB5, 0xA9A0, 0xA46B, 0x9F36, 
	0x9A20, 0x9547, 0x90CB, 0x8CCB, 0x8967, 0x86BC, 0x84D6, 0x8398, 0x82EB, 
	0x82B7, 0x82E3, 0x8358, 0x83FD, 0x84BA, 0x8577, 0x861B, 0x8690, 0x86BC, 
	0x00D0, 0x002B, 0xFE78, 0xFC0D, 0xF944, 0xF675, 0xF3F8, 0xF225, 0xF155, 
	0xF151, 0xF1A1, 0xF239, 0xF30D, 0xF40E, 0xF531, 0xF66A, 0xF7AB, 0xF8E9, 
	0xFA16, 0xFB26, 0xFC0D, 0xFCBD, 0xFD31, 0xFD71, 0xFD89, 0xFD84, 0xFD6D, 
	0xFD4F, 0xFD34, 0xFD29, 0xFD1A, 0xFCF6, 0xFCD2, 0xFCBD, 0xFCB8, 0xFCB4, 
	0xFCB2, 0xFCB1, 0xFCB1, 0xFCB2, 0xFCB3, 0xFCB5, 0xFCB8, 0xFCBA, 0xFCBB, 
	0xFCBD, 0xFCBD, 0xFCBA, 0xFCB3, 0xFCA8, 0xFC9C, 0xFC90, 0xFC85, 0xFC7D, 
	0xFC7A, 0xFC7E, 0xFC89, 0xFC9E, 0xFCBD, 0xFCED, 0xFD2F, 0xFD7F, 0xFDD9, 
	0xFE3A, 0xFE9E, 0xFF00, 0xFF5E, 0xFFB4, 0xFFFD, 0x0036, 0x005B, 0x0068, 
	0x0000, 0x0006, 0x0014, 0x0026, 0x0036, 0x0040, 0x003D, 0x002A, 0xFFFF, 
	0xFFC2, 0xFF77, 0xFF23, 0xFEC6, 0xFE64, 0xFDFE, 0xFD96, 0xFD2F, 0xFCCB, 
	0xFC6C, 0xFC15, 0xFBC7, 0xFB84, 0xFB52, 0xFB30, 0xFB1D, 0xFB14, 0xFB13, 
	0xFB16, 0xFB1A, 0xFB1C, 0xFB22, 0xFB34, 0xFB54, 0xFB84, 0xFBC0, 0xFC01, 
	0xFC47, 0xFC90, 0xFCDB, 0xFD25, 0xFD6F, 0xFDB7, 0xFDFA, 0xFE39, 0xFE70, 
	0xFEA0, 0xFEC7, 0xFEE3, 0xFEF5, 0xFEFF, 0xFF02, 0xFEFF, 0xFEF9, 0xFEEF, 
	0xFEE4, 0xFED9, 0xFED0, 0xFEC9, 0xFEC7, 0xCE22, 0xCD35, 0xCAC2, 0xC745, 
	0xC33B, 0xBF21, 0xBB74, 0xB8AF, 0xB751, 0xB711, 0xB749, 0xB7E6, 0xB8D6, 
	0xBA04, 0xBB5F, 0xBCD4, 0xBE4F, 0xBFBE, 0xC10F, 0xC22D, 0xC307, 0xC38A, 
	0xC38B, 0xC308, 0xC22A, 0xC117, 0xBFF8, 0xBEF5, 0xBE35, 0xBDE1, 0xBE24, 
	0xBF0A, 0xC092, 0xC2B9, 0xC541, 0xC7E7, 0xCAA7, 0xCD7B, 0xD05E, 0xD34A, 
	0xD63A, 0xD928, 0xDC10, 0xDEEB, 0xE1B4, 0xE466, 0xE6FC, 0xE981, 0xEC02, 
	0xEE7D, 0xF0EF, 0xF355, 0xF5AD, 0xF7F2, 0xFA23, 0xFC3D, 0xFE3C, 0x001E, 
	0x01E0, 0x0394, 0x0549, 0x06F9, 0x089D, 0x0A30, 0x0BAB, 0x0D08, 0x0E40, 
	0x0F4E, 0x102A, 0x10D0, 0x1137, 0x115B, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x3C70, 0x3CE6, 0x3E1E, 0x3FD9, 
	0x41D7, 0x43D8, 0x459C, 0x46E4, 0x4770, 0x4793, 0x47C1, 0x47ED, 0x480B, 
	0x480F, 0x47EB, 0x4793, 0x46FA, 0x4614, 0x44D4, 0x432D, 0x4113, 0x3E79, 
	0x3A5E, 0x343D, 0x2CC6, 0x24AC, 0x1C9C, 0x1549, 0x0F62, 0x0B97, 0x0CE3, 
	0x132E, 0x1A8E, 0x1F1A, 0x20D2, 0x2255, 0x23A7, 0x24CC, 0x25CA, 0x26A4, 
	0x275E, 0x27FD, 0x2885, 0x28FB, 0x2963, 0x29C2, 0x2A1A, 0x2A4E, 0x2A43, 
	0x2A06, 0x29A4, 0x292C, 0x28A9, 0x282A, 0x27BA, 0x2769, 0x2742, 0x2752, 
	0x27A8, 0x2852, 0x294B, 0x2A82, 0x2BE8, 0x2D6C, 0x2EFF, 0x3090, 0x3210, 
	0x336E, 0x349A, 0x3585, 0x361D, 0x3653, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xD749, 0xD6C5, 0xD560, 0xD35A, 0xD0F0, 0xCE60, 0xCBE8, 
	0xC9C5, 0xC836, 0xC709, 0xC5E6, 0xC4CF, 0xC3C6, 0xC2CE, 0xC1E9, 0xC119, 
	0xC060, 0xBFC0, 0xBF3C, 0xBED7, 0xBE91, 0xBE6F, 0xBE8E, 0xBF01, 0xBFB7, 
	0xC09E, 0xC1A5, 0xC2BA, 0xC3CC, 0xC4C9, 0xC5A1, 0xC641, 0xC698, 0xC695, 
	0xC621, 0xC540, 0xC40B, 0xC296, 0xC0F9, 0xBF4B, 0xBDA3, 0xBC17, 0xBABE, 
	0xB9B0, 0xB901, 0xB8CB, 0xB923, 0xBA29, 0xBBD8, 0xBE13, 0xC0BB, 0xC3B1, 
	0xC6D6, 0xCA0C, 0xCD33, 0xD02E, 0xD2DE, 0xD524, 0xD6E1, 0xD833, 0xD951, 
	0xDA3F, 0xDB01, 0xDB9B, 0xDC12, 0xDC6C, 0xDCAB, 0xDCD4, 0xDCED, 0xDCF9, 
	0xDCFD, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xBF5E, 0x0068, 
	0x0000, 0xFFF4, 0xFFD4, 0xFFA7, 0xFF72, 0xFF3B, 0xFF08, 0xFEE0, 0xFEC7, 
	0xFEBA, 0xFEB1, 0xFEAC, 0xFEAA, 0xFEAA, 0xFEAD, 0xFEB0, 0xFEB5, 0xFEBA, 
	0xFEBF, 0xFEC3, 0xFEC6, 0xFEC7, 0x8B50, 0x8C33, 0x8E99, 0x921E, 0x9660, 
	0x9AFB, 0x9F8D, 0xA3B1, 0xA705, 0xA9BE, 0xAC56, 0xAED1, 0xB136, 0xB387, 
	0xB5CA, 0xB803, 0xBA37, 0xBC6B, 0xBEA3, 0xC0E4, 0xC333, 0xC593, 0xC830, 
	0xCB14, 0xCE18, 0xD113, 0xD3DD, 0xD64D, 0xD83B, 0xD97F, 0xD909, 0xD6A5, 
	0xD373, 0xD094, 0xCE4A, 0xCC14, 0xC9EA, 0xC7C5, 0xC59C, 0xC368, 0xC120, 
	0xBEBD, 0xBC37, 0xB946, 0xB5F5, 0xB2B6, 0xAFFC, 0xADAA, 0xAB5B, 0xA90F, 
	0xA6C6, 0xA482, 0xA244, 0xA00C, 0x9DDD, 0x9BB6, 0x9999, 0x9786, 0x9580, 
	0x9366, 0x9121, 0x8EC1, 0x8C54, 0x89EA, 0x8790, 0x8557, 0x834D, 0x8180, 
	0x8001, 0x7EDC, 0x7E21, 0x7DE0, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x1B99, 0x1BF7, 0x1CF1, 0x1E56, 0x1FF5, 0x219B, 0x2317, 
	0x2439, 0x24CE, 0x24E3, 0x24AF, 0x243F, 0x23A6, 0x22F1, 0x2230, 0x2173, 
	0x20CA, 0x2043, 0x1FEF, 0x1FDC, 0x201B, 0x20BB, 0x220F, 0x2439, 0x2700, 
	0x2A2A, 0x2D7E, 0x30C2, 0x33BE, 0x3638, 0x3816, 0x3981, 0x3AA1, 0x3B9F, 
	0x3C9D, 0x3D9F, 0x3EA1, 0x3FA1, 0x409D, 0x4191, 0x427C, 0x435B, 0x442A, 
	0x44E8, 0x4592, 0x4625, 0x469F, 0x471F, 0x47BC, 0x4866, 0x490C, 0x499F, 
	0x4A0E, 0x4A49, 0x4A41, 0x49E5, 0x4924, 0x47F0, 0x4637, 0x43AC, 0x402F, 
	0x3BF2, 0x3728, 0x3206, 0x2CBE, 0x2784, 0x228B, 0x1E07, 0x1A2A, 0x1728, 
	0x1534, 0x1482, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xC352, 0xC360, 0xC388, 0xC3CA, 0xC427, 0xC49D, 0xC52C, 0xC5D4, 0xC695, 
	0xC76D, 0xC859, 0xC957, 0xCA62, 0xCB77, 0xCC94, 0xCDB4, 0xCED4, 0xCFF2, 
	0xD109, 0xD216, 0xD317, 0xD407, 0xD4E3, 0xD5AC, 0xD665, 0xD70F, 0xD7AF, 
	0xD846, 0xD8D8, 0xD966, 0xDA6D, 0xDBB6, 0xDC3B, 0xDAF4, 0xD825, 0xD4D5, 
	0xD120, 0xCD24, 0xC8FE, 0xC4CA, 0xC0A5, 0xBCAC, 0xB8FD, 0xB5B3, 0xB2ED, 
	0xB0C6, 0xAF5C, 0xAED0, 0xAF1A, 0xB017, 0xB1A3, 0xB39C, 0xB5DD, 0xB845, 
	0xBAAF, 0xBCF8, 0xBEFE, 0xC09D, 0xC1B1, 0xC25B, 0xC2D7, 0xC329, 0xC357, 
	0xC369, 0xC362, 0xC349, 0xC325, 0xC2F9, 0xC2CE, 0xC2A7, 0xC28C, 0xC282, 
},
{
	0x0001, 0x0000, 0x0048, 0x0001, 0x0001, 0x0049, 0x0001, 0x004A, 0x0001, 
	0x004B, 0x0001, 0x004C, 0x0041, 0x004D, 0x003A, 0x008E, 0x0048, 0x00C8, 
	0x0048, 0x0110, 0x0001, 0x0158, 0x0048, 0x0159, 0x0048, 0x01A1, 0x0048, 
	0x01E9, 0x0001, 0x0231, 0x0001, 0x0232, 0x0001, 0x0233, 0x0001, 0x0234, 
	0x0048, 0x0235, 0x0048, 0x027D, 0x0048, 0x02C5, 0x0048, 0x030D, 0x0048, 
	0x0355, 0x0048, 0x039D, 0x0048, 0x03E5, 0x0001, 0x042D, 0x0001, 0x042E, 
	0x0001, 0x042F, 0x0001, 0x0430, 0x0001, 0x0431, 0x0048, 0x0432, 0x0048, 
	0x047A, 0x0048, 0x04C2, 0x0048, 0x050A, 0x0001, 0x0552, 0x0048, 0x0553, 
	0x0048, 0x059B, 0x0046, 0x05E3, 0x0001, 0x0629, 0x0047, 0x062A, 0x0048, 
	0x0671, 0x0022, 0x06B9, 0x0048, 0x06DB, 0x003B, 0x0723, 0x0048, 0x075E, 
	0x0048, 0x07A6, 0x0048, 0x07EE, 0x0048, 0x0836, 0x0046, 0x087E, 0x0047, 
	0x08C4, 0x0047, 0x090B, 0x0045, 0x0952, 0x0048, 0x0997, 0x0001, 0x09DF, 
	0x0001, 0x09E0, 0x0016, 0x09E1, 0x0048, 0x09F7, 0x0046, 0x0A3F, 0x0048, 
	0x0A85, 0x0048, 0x0ACD, 0x0046, 0x0B15, 0x0048, 0x0B5B, 0x0048, 0x0BA3, 
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_WALK_WITH_LIGHT_OBJ], 0, 189, 0, 0, 99, {
	0x0000, 0x00B3, 0x00B3, 0x00B3, 0x00B4, 0x00B5, 0x00B6, 0x00B8, 0x00B9, 
	0x00BB, 0x00BC, 0x00BE, 0x00C0, 0x00C1, 0x00C3, 0x00C4, 0x00C5, 0x00C6, 
	0x00C7, 0x00C8, 0x00C8, 0x00C8, 0x00C7, 0x00C6, 0x00C5, 0x00C4, 0x00C2, 
	0x00C1, 0x00BF, 0x00BD, 0x00BC, 0x00BA, 0x00B8, 0x00B6, 0x00B5, 0x00B4, 
	0x00B3, 0x00B2, 0x00B3, 0x00B3, 0x00B4, 0x00B3, 0x00B2, 0x00B1, 0x00B1, 
	0x00B2, 0x00B4, 0x00B6, 0x00B8, 0x00BA, 0x00BD, 0x00BF, 0x00C1, 0x00C3, 
	0x00C5, 0x00C7, 0x00C9, 0x00CA, 0x00CB, 0x00CC, 0x00CC, 0x00CC, 0x00CC, 
	0x00CB, 0x00CB, 0x00CA, 0x00C9, 0x00C9, 0x00C8, 0x00C6, 0x00C5, 0x00C4, 
	0x00C3, 0x00C1, 0x00C0, 0x00BF, 0x00BD, 0x00BC, 0x00BA, 0x00B9, 0x00B8, 
	0x00B7, 0x00B5, 0x00B4, 0x00B3, 0x00B2, 0x00B1, 0x00B0, 0x00B0, 0x00AF, 
	0x00AF, 0x00AF, 0x00AF, 0x00B0, 0x00B0, 0x00B1, 0x00B1, 0x00B2, 0x00B2, 
	0x00B3, 0xFFFF, 0x0000, 0x3FFF, 0x0000, 0x03C4, 0x03C1, 0x03B9, 0x03AC, 
	0x039A, 0x0383, 0x0367, 0x0347, 0x0324, 0x02FC, 0x02D1, 0x02A2, 0x0270, 
	0x023B, 0x0204, 0x01C9, 0x018D, 0x014E, 0x010E, 0x00CC, 0x0089, 0x0044, 
	0xFFFE, 0xFFB8, 0xFF71, 0xFF2A, 0xFEE2, 0xFE9B, 0xFE54, 0xFE0D, 0xFDC8, 
	0xFD83, 0xFD40, 0xFCFE, 0xFCBD, 0xFC7F, 0xFC42, 0xFC08, 0xFBD1, 0xFB9C, 
	0xFB6A, 0xFB3B, 0xFB10, 0xFAE8, 0xFAC4, 0xFAA5, 0xFA89, 0xFA72, 0xFA60, 
	0xFA53, 0xFA4B, 0xFA48, 0xFA4B, 0xFA54, 0xFA63, 0xFA78, 0xFA91, 0xFAB0, 
	0xFAD4, 0xFAFC, 0xFB28, 0xFB58, 0xFB8C, 0xFBC3, 0xFBFD, 0xFC3B, 0xFC7B, 
	0xFCBD, 0xFD01, 0xFD48, 0xFD8F, 0xFDD9, 0xFE23, 0xFE6E, 0xFEB9, 0xFF05, 
	0xFF51, 0xFF9D, 0xFFE8, 0x0032, 0x007B, 0x00C3, 0x0109, 0x014E, 0x0190, 
	0x01D0, 0x020D, 0x0248, 0x027F, 0x02B3, 0x02E3, 0x0310, 0x0338, 0x035B, 
	0x037A, 0x0394, 0x03A8, 0x03B8, 0x03C1, 0x03C4, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x388D, 0xFFE6, 0xFFE6, 0xFFE4, 0xFFE0, 
	0xFFDC, 0xFFD7, 0xFFD1, 0xFFCA, 0xFFC2, 0xFFBA, 0xFFB1, 0xFFA8, 0xFF9F, 
	0xFF95, 0xFF8C, 0xFF83, 0xFF7A, 0xFF71, 0xFF69, 0xFF61, 0xFF5A, 0xFF54, 
	0xFF4F, 0xFF4A, 0xFF47, 0xFF44, 0xFF42, 0xFF40, 0xFF3F, 0xFF3E, 0xFF3E, 
	0xFF3E, 0xFF3E, 0xFF3E, 0xFF3F, 0xFF3F, 0xFF40, 0xFF41, 0xFF42, 0xFF43, 
	0xFF43, 0xFF44, 0xFF44, 0xFF45, 0xFF44, 0xFF44, 0xFF43, 0xFF43, 0xFF42, 
	0xFF41, 0xFF40, 0xFF3F, 0xFF3E, 0xFF3C, 0xFF3C, 0xFF3B, 0xFF3A, 0xFF3A, 
	0xFF3A, 0xFF3A, 0xFF3A, 0xFF3B, 0xFF3C, 0xFF3E, 0xFF40, 0xFF43, 0xFF46, 
	0xFF4A, 0xFF4F, 0xFF54, 0xFF5A, 0xFF61, 0xFF69, 0xFF71, 0xFF79, 0xFF82, 
	0xFF8B, 0xFF95, 0xFF9E, 0xFFA8, 0xFFB2, 0xFFBC, 0xFFC5, 0xFFCF, 0xFFD8, 
	0xFFE1, 0xFFE9, 0xFFF1, 0xFFF9, 0xFFFF, 0x0006, 0x000B, 0x000D, 0x000B, 
	0x0005, 0xFFFE, 0xFFF5, 0xFFEE, 0xFFE9, 0xFFE6, 0xFF09, 0xFF06, 0xFEFC, 
	0xFEEC, 0xFED7, 0xFEBE, 0xFEA1, 0xFE81, 0xFE5E, 0xFE3A, 0xFE14, 0xFDEE, 
	0xFDC7, 0xFDA2, 0xFD7D, 0xFD5B, 0xFD3B, 0xFD1F, 0xFD06, 0xFCF2, 0xFCE4, 
	0xFCDB, 0xFCD9, 0xFCDE, 0xFCEA, 0xFCFE, 0xFD1A, 0xFD3B, 0xFD62, 0xFD8E, 
	0xFDBE, 0xFDF2, 0xFE28, 0xFE61, 0xFE9B, 0xFED7, 0xFF12, 0xFF4D, 0xFF86, 
	0xFFBE, 0xFFF3, 0x0025, 0x0053, 0x007D, 0x00A5, 0x00CE, 0x00F9, 0x0124, 
	0x0150, 0x017C, 0x01A8, 0x01D4, 0x0200, 0x022A, 0x0254, 0x027C, 0x02A3, 
	0x02C8, 0x02EB, 0x030B, 0x0329, 0x0343, 0x035B, 0x036F, 0x037F, 0x038B, 
	0x0393, 0x0396, 0x0394, 0x038D, 0x0383, 0x0374, 0x0361, 0x034A, 0x0331, 
	0x0314, 0x02F5, 0x02D3, 0x02AF, 0x0289, 0x0262, 0x0239, 0x0210, 0x01E6, 
	0x01BB, 0x0190, 0x0166, 0x013C, 0x0113, 0x00EA, 0x00C3, 0x009E, 0x0071, 
	0x0036, 0xFFF3, 0xFFAF, 0xFF70, 0xFF3B, 0xFF16, 0xFF09, 0xF260, 0xF264, 
	0xF270, 0xF283, 0xF29D, 0xF2BD, 0xF2E2, 0xF30C, 0xF33B, 0xF36D, 0xF3A2, 
	0xF3DA, 0xF414, 0xF44F, 0xF48B, 0xF4C7, 0xF503, 0xF53E, 0xF577, 0xF5AE, 
	0xF5E2, 0xF613, 0xF641, 0xF669, 0xF690, 0xF6B9, 0xF6E2, 0xF70D, 0xF738, 
	0xF763, 0xF78F, 0xF7BA, 0xF7E5, 0xF80E, 0xF837, 0xF85E, 0xF884, 0xF8A8, 
	0xF8C9, 0xF8E9, 0xF905, 0xF91E, 0xF934, 0xF946, 0xF955, 0xF95F, 0xF965, 
	0xF966, 0xF961, 0xF952, 0xF93D, 0xF920, 0xF8FD, 0xF8D5, 0xF8A9, 0xF879, 
	0xF846, 0xF810, 0xF7DA, 0xF7A2, 0xF76B, 0xF735, 0xF701, 0xF6CF, 0xF6A1, 
	0xF676, 0xF651, 0xF631, 0xF616, 0xF5FD, 0xF5E7, 0xF5D2, 0xF5C0, 0xF5AF, 
	0xF59F, 0xF590, 0xF582, 0xF575, 0xF568, 0xF55C, 0xF54F, 0xF542, 0xF534, 
	0xF526, 0xF517, 0xF506, 0xF4F4, 0xF4E0, 0xF4CA, 0xF4B2, 0xF498, 0xF47B, 
	0xF44C, 0xF404, 0xF3AD, 0xF34F, 0xF2F5, 0xF2A9, 0xF274, 0xF260, 0xFBED, 
	0xFBEF, 0xFBF8, 0xFC05, 0xFC18, 0xFC2F, 0xFC4B, 0xFC6A, 0xFC8E, 0xFCB5, 
	0xFCDF, 0xFD0C, 0xFD3C, 0xFD6E, 0xFDA3, 0xFDD9, 0xFE11, 0xFE4A, 0xFE84, 
	0xFEBE, 0xFEFA, 0xFF35, 0xFF70, 0xFFAB, 0xFFE5, 0x001E, 0x0056, 0x008C, 
	0x00C0, 0x00F3, 0x0122, 0x0150, 0x017A, 0x01A1, 0x01C4, 0x01E4, 0x01FF, 
	0x0216, 0x0229, 0x0236, 0x023F, 0x0243, 0x0242, 0x023D, 0x0234, 0x0227, 
	0x0217, 0x0204, 0x01ED, 0x01D4, 0x01B8, 0x019A, 0x017A, 0x0158, 0x0134, 
	0x010F, 0x00E9, 0x00C3, 0x009B, 0x0073, 0x004B, 0x0024, 0xFFFC, 0xFFD6, 
	0xFFB0, 0xFF8B, 0xFF67, 0xFF46, 0xFF26, 0xFF08, 0xFEEC, 0xFED2, 0xFEB8, 
	0xFE9E, 0xFE84, 0xFE6B, 0xFE51, 0xFE38, 0xFE1F, 0xFE06, 0xFDED, 0xFDD4, 
	0xFDBB, 0xFDA2, 0xFD8A, 0xFD71, 0xFD58, 0xFD3F, 0xFD25, 0xFD0C, 0xFCF3, 
	0xFCD9, 0xFCC0, 0xFCA6, 0xFC8C, 0xFC71, 0xFC4E, 0xFC22, 0xFBFC, 0xFBED, 
	0x0000, 0xFFFF, 0x0000, 0xFFFE, 0xFFFD, 0xFFFC, 0xFFFB, 0xFFFA, 0xFFF8, 
	0xFFF6, 0xFFF4, 0xFFF2, 0xFFF0, 0xFFEE, 0xFFEB, 0xFFE9, 0xFFE6, 0xFFE4, 
	0xFFE1, 0xFFDE, 0xFFDC, 0xFFD9, 0xFFD7, 0xFFD4, 0xFFD1, 0xFFCF, 0xFFCD, 
	0xFFCA, 0xFFC8, 0xFFC6, 0xFFC4, 0xFFC2, 0xFFC1, 0xFFBF, 0xFFBE, 0xFFBD, 
	0xFFBC, 0xFFBB, 0xFFBB, 0xFFBB, 0xFFBB, 0xFFBB, 0xFFBC, 0xFFBD, 0xFFBE, 
	0xFFC0, 0xFFC1, 0xFFC3, 0xFFC5, 0xFFC7, 0xFFC9, 0xFFCC, 0xFFCE, 0xFFD1, 
	0xFFD3, 0xFFD6, 0xFFD9, 0xFFDC, 0xFFDF, 0xFFE2, 0xFFE5, 0xFFE7, 0xFFEA, 
	0xFFED, 0xFFF0, 0xFFF2, 0xFFF5, 0xFFF7, 0xFFFA, 0xFFFC, 0xFFFE, 0xFFFF, 
	0x0001, 0x0003, 0x0005, 0x0006, 0x0008, 0x000A, 0x000B, 0x000D, 0x000F, 
	0x0010, 0x0012, 0x0013, 0x0014, 0x0016, 0x0017, 0x0018, 0x0019, 0x001A, 
	0x001A, 0x001B, 0x001C, 0x001C, 0x001C, 0x001C, 0x0018, 0x000E, 0x0004, 
	0x0000, 0x109A, 0x109B, 0x109F, 0x10A4, 0x10AC, 0x10B6, 0x10C2, 0x10CF, 
	0x10DE, 0x10EE, 0x1100, 0x1113, 0x1126, 0x113B, 0x1151, 0x1167, 0x117E, 
	0x1196, 0x11AD, 0x11C5, 0x11DD, 0x11F5, 0x120C, 0x1224, 0x123B, 0x1251, 
	0x1267, 0x127C, 0x128F, 0x12A2, 0x12B4, 0x12C4, 0x12D3, 0x12E0, 0x12EC, 
	0x12F6, 0x12FE, 0x1303, 0x1307, 0x1308, 0x1306, 0x1302, 0x12FA, 0x12F0, 
	0x12E3, 0x12D4, 0x12C3, 0x12AF, 0x129B, 0x1284, 0x126C, 0x1253, 0x123A, 
	0x121F, 0x1204, 0x11E8, 0x11CC, 0x11B1, 0x1195, 0x117A, 0x115F, 0x1146, 
	0x112D, 0x1115, 0x10FF, 0x10EA, 0x10D7, 0x10C6, 0x10B8, 0x10AB, 0x10A1, 
	0x109A, 0x1096, 0x1096, 0x109A, 0x10A0, 0x10A9, 0x10B5, 0x10C3, 0x10D3, 
	0x10E4, 0x10F7, 0x110A, 0x111E, 0x1132, 0x1147, 0x115A, 0x116D, 0x117F, 
	0x1190, 0x119F, 0x11AC, 0x11B6, 0x11BE, 0x11C3, 0x11C5, 0x1196, 0x1130, 
	0x10C9, 0x109A, 0x0001, 0xFFFE, 0xC170, 0x1685, 0x167E, 0x1667, 0x1643, 
	0x1611, 0x15D2, 0x1586, 0x152F, 0x14CD, 0x1460, 0x13EA, 0x136A, 0x12E2, 
	0x1251, 0x11BA, 0x111B, 0x1076, 0x0FCC, 0x0F1D, 0x0E6A, 0x0DB2, 0x0CF8, 
	0x0C3B, 0x0B7D, 0x0ABD, 0x09FD, 0x093C, 0x087C, 0x07BE, 0x0701, 0x0647, 
	0x0590, 0x04DC, 0x042D, 0x0383, 0x02DE, 0x0240, 0x01A8, 0x0118, 0x008F, 
	0x0010, 0xFF98, 0xFF2B, 0xFEC9, 0xFE72, 0xFE27, 0xFDE8, 0xFDB6, 0xFD91, 
	0xFD7B, 0xFD73, 0xFD7B, 0xFD92, 0xFDB8, 0xFDEC, 0xFE2E, 0xFE7C, 0xFED7, 
	0xFF3C, 0xFFAD, 0x0029, 0x00AD, 0x013A, 0x01D0, 0x026C, 0x0310, 0x03BA, 
	0x0469, 0x051E, 0x05D6, 0x0693, 0x0752, 0x0813, 0x08D6, 0x099A, 0x0A5F, 
	0x0B23, 0x0BE6, 0x0CA8, 0x0D67, 0x0E23, 0x0EDC, 0x0F90, 0x103F, 0x10E9, 
	0x118D, 0x122A, 0x12BF, 0x134C, 0x13D0, 0x144B, 0x14BC, 0x1522, 0x157C, 
	0x15CA, 0x160C, 0x1640, 0x1666, 0x167D, 0x1685, 0xCE6A, 0xCE69, 0xCE67, 
	0xCE64, 0xCE5F, 0xCE59, 0xCE52, 0xCE4A, 0xCE40, 0xCE36, 0xCE2B, 0xCE1F, 
	0xCE12, 0xCE04, 0xCDF6, 0xCDE7, 0xCDD7, 0xCDC7, 0xCDB6, 0xCDA5, 0xCD94, 
	0xCD82, 0xCD70, 0xCD5E, 0xCD4C, 0xCD3A, 0xCD28, 0xCD15, 0xCD03, 0xCCF1, 
	0xCCE0, 0xCCCE, 0xCCBD, 0xCCAD, 0xCC9D, 0xCC8D, 0xCC7E, 0xCC70, 0xCC62, 
	0xCC55, 0xCC49, 0xCC3E, 0xCC33, 0xCC2A, 0xCC22, 0xCC1B, 0xCC15, 0xCC10, 
	0xCC0D, 0xCC0A, 0xCC0A, 0xCC0A, 0xCC0D, 0xCC10, 0xCC15, 0xCC1B, 0xCC23, 
	0xCC2B, 0xCC35, 0xCC40, 0xCC4B, 0xCC58, 0xCC65, 0xCC73, 0xCC82, 0xCC92, 
	0xCCA2, 0xCCB3, 0xCCC4, 0xCCD5, 0xCCE7, 0xCCF9, 0xCD0B, 0xCD1E, 0xCD31, 
	0xCD43, 0xCD56, 0xCD68, 0xCD7B, 0xCD8D, 0xCD9F, 0xCDB0, 0xCDC1, 0xCDD2, 
	0xCDE2, 0xCDF1, 0xCE00, 0xCE0E, 0xCE1C, 0xCE28, 0xCE34, 0xCE3F, 0xCE48, 
	0xCE51, 0xCE58, 0xCE5F, 0xCE63, 0xCE67, 0xCE69, 0xCE6A, 0xD779, 0xD781, 
	0xD798, 0xD7BD, 0xD7EF, 0xD82F, 0xD87C, 0xD8D4, 0xD937, 0xD9A5, 0xDA1D, 
	0xDA9E, 0xDB28, 0xDBBB, 0xDC54, 0xDCF5, 0xDD9C, 0xDE48, 0xDEF9, 0xDFAF, 
	0xE069, 0xE125, 0xE1E4, 0xE2A5, 0xE367, 0xE42A, 0xE4ED, 0xE5AF, 0xE670, 
	0xE72F, 0xE7EC, 0xE8A5, 0xE95B, 0xEA0C, 0xEAB9, 0xEB60, 0xEC00, 0xEC9A, 
	0xED2C, 0xEDB6, 0xEE37, 0xEEAF, 0xEF1D, 0xEF81, 0xEFD9, 0xF025, 0xF065, 
	0xF098, 0xF0BD, 0xF0D3, 0xF0DB, 0xF0D3, 0xF0BB, 0xF095, 0xF060, 0xF01E, 
	0xEFCF, 0xEF73, 0xEF0C, 0xEE9A, 0xEE1E, 0xED98, 0xED09, 0xEC72, 0xEBD3, 
	0xEB2D, 0xEA81, 0xE9CF, 0xE919, 0xE85E, 0xE79F, 0xE6DE, 0xE61A, 0xE554, 
	0xE48E, 0xE3C7, 0xE300, 0xE23B, 0xE177, 0xE0B5, 0xDFF7, 0xDF3C, 0xDE85, 
	0xDDD3, 0xDD27, 0xDC81, 0xDBE3, 0xDB4C, 0xDABD, 0xDA37, 0xD9BA, 0xD948, 
	0xD8E1, 0xD886, 0xD836, 0xD7F4, 0xD7BF, 0xD799, 0xD781, 0xD779, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0xE263, 0xE264, 0xE268, 0xE26F, 0xE278, 0xE283, 0xE291, 
	0xE2A1, 0xE2B2, 0xE2C6, 0xE2DB, 0xE2F3, 0xE30B, 0xE325, 0xE341, 0xE35D, 
	0xE37B, 0xE39A, 0xE3BA, 0xE3DA, 0xE3FB, 0xE41D, 0xE43F, 0xE461, 0xE484, 
	0xE4A7, 0xE4C9, 0xE4EC, 0xE50F, 0xE531, 0xE552, 0xE573, 0xE594, 0xE5B3, 
	0xE5D2, 0xE5F0, 0xE60D, 0xE628, 0xE642, 0xE65B, 0xE672, 0xE687, 0xE69B, 
	0xE6AD, 0xE6BC, 0xE6CA, 0xE6D5, 0xE6DE, 0xE6E5, 0xE6E9, 0xE6EA, 0xE6E9, 
	0xE6E5, 0xE6DE, 0xE6D5, 0xE6C9, 0xE6BB, 0xE6AA, 0xE698, 0xE683, 0xE66D, 
	0xE655, 0xE63C, 0xE621, 0xE605, 0xE5E7, 0xE5C8, 0xE5A9, 0xE588, 0xE567, 
	0xE545, 0xE522, 0xE4FF, 0xE4DC, 0xE4B8, 0xE495, 0xE471, 0xE44E, 0xE42B, 
	0xE409, 0xE3E7, 0xE3C5, 0xE3A5, 0xE385, 0xE366, 0xE349, 0xE32C, 0xE311, 
	0xE2F8, 0xE2E0, 0xE2CA, 0xE2B5, 0xE2A3, 0xE293, 0xE285, 0xE279, 0xE26F, 
	0xE268, 0xE264, 0xE263, 0xE7CD, 0xF983, 0xE96A, 0x0001, 0xFFFE, 0xC170, 
	0xF0CC, 0xF0CE, 0xF0D4, 0xF0DE, 0xF0EC, 0xF0FC, 0xF10F, 0xF125, 0xF13C, 
	0xF155, 0xF16F, 0xF18A, 0xF1A6, 0xF1C2, 0xF1DD, 0xF1F9, 0xF213, 0xF22C, 
	0xF243, 0xF259, 0xF26C, 0xF27C, 0xF289, 0xF293, 0xF29A, 0xF29C, 0xF29C, 
	0xF29C, 0xF29C, 0xF29C, 0xF29C, 0xF29B, 0xF29B, 0xF29B, 0xF29A, 0xF299, 
	0xF298, 0xF297, 0xF296, 0xF295, 0xF293, 0xF291, 0xF28F, 0xF28C, 0xF289, 
	0xF286, 0xF283, 0xF27F, 0xF27B, 0xF277, 0xF272, 0xF26D, 0xF267, 0xF260, 
	0xF259, 0xF251, 0xF249, 0xF241, 0xF238, 0xF22E, 0xF224, 0xF21A, 0xF210, 
	0xF205, 0xF1FA, 0xF1EF, 0xF1E4, 0xF1D8, 0xF1CD, 0xF1C1, 0xF1B5, 0xF1A9, 
	0xF19D, 0xF192, 0xF186, 0xF17A, 0xF16F, 0xF163, 0xF158, 0xF14D, 0xF142, 
	0xF138, 0xF12E, 0xF124, 0xF11A, 0xF111, 0xF109, 0xF100, 0xF0F9, 0xF0F1, 
	0xF0EB, 0xF0E5, 0xF0DF, 0xF0DA, 0xF0D6, 0xF0D2, 0xF0D0, 0xF0CE, 0xF0CC, 
	0x1131, 0x1131, 0x1131, 0x1131, 0x1131, 0x1131, 0x1131, 0x1131, 0x1131, 
	0x1131, 0x1131, 0x1131, 0x1131, 0x1131, 0x1131, 0x1131, 0x1131, 0x1131, 
	0x1131, 0x1131, 0x1131, 0x1131, 0x1131, 0x1131, 0x1131, 0x1131, 0x1129, 
	0x1114, 0x10F1, 0x10C3, 0x108A, 0x1048, 0x0FFF, 0x0FAE, 0x0F58, 0x0EFD, 
	0x0EA0, 0x0E40, 0x0DE0, 0x0D81, 0x0D23, 0x0CC9, 0x0C72, 0x0C22, 0x0BD8, 
	0x0B96, 0x0B5D, 0x0B2F, 0x0B0C, 0x0AF7, 0x0AEF, 0x0AF1, 0x0AF7, 0x0B01, 
	0x0B0E, 0x0B1E, 0x0B31, 0x0B48, 0x0B61, 0x0B7D, 0x0B9C, 0x0BBD, 0x0BE0, 
	0x0C06, 0x0C2D, 0x0C56, 0x0C80, 0x0CAC, 0x0CD9, 0x0D07, 0x0D36, 0x0D66, 
	0x0D96, 0x0DC7, 0x0DF8, 0x0E29, 0x0E5A, 0x0E8A, 0x0EBB, 0x0EEA, 0x0F19, 
	0x0F47, 0x0F74, 0x0FA0, 0x0FCB, 0x0FF3, 0x101B, 0x1040, 0x1063, 0x1084, 
	0x10A3, 0x10BF, 0x10D8, 0x10EF, 0x1102, 0x1113, 0x1120, 0x1129, 0x112F, 
	0x1131, 0x6C57, 0x6C57, 0x6C57, 0x6C57, 0x6C57, 0x6C57, 0x6C57, 0x6C57, 
	0x6C57, 0x6C57, 0x6C57, 0x6C57, 0x6C57, 0x6C57, 0x6C57, 0x6C57, 0x6C57, 
	0x6C57, 0x6C57, 0x6C57, 0x6C57, 0x6C57, 0x6C57, 0x6C57, 0x6C57, 0x6C57, 
	0x6C54, 0x6C4A, 0x6C3B, 0x6C27, 0x6C0E, 0x6BF1, 0x6BD1, 0x6BAE, 0x6B88, 
	0x6B60, 0x6B37, 0x6B0E, 0x6AE4, 0x6ABA, 0x6A91, 0x6A69, 0x6A43, 0x6A20, 
	0x6A00, 0x69E3, 0x69CA, 0x69B6, 0x69A7, 0x699D, 0x699A, 0x699B, 0x699D, 
	0x69A2, 0x69A7, 0x69AE, 0x69B7, 0x69C1, 0x69CC, 0x69D8, 0x69E6, 0x69F4, 
	0x6A04, 0x6A14, 0x6A25, 0x6A37, 0x6A49, 0x6A5D, 0x6A70, 0x6A84, 0x6A99, 
	0x6AAE, 0x6AC3, 0x6AD8, 0x6AEE, 0x6B03, 0x6B19, 0x6B2E, 0x6B43, 0x6B58, 
	0x6B6D, 0x6B81, 0x6B94, 0x6BA8, 0x6BBA, 0x6BCC, 0x6BDD, 0x6BEE, 0x6BFD, 
	0x6C0B, 0x6C19, 0x6C25, 0x6C30, 0x6C3A, 0x6C43, 0x6C4A, 0x6C50, 0x6C54, 
	0x6C56, 0x6C57, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xF032, 0x0D18, 0x182D, 0xF4C2, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xBF5E, 0xF628, 0xF629, 
	0xF62E, 0xF634, 0xF63C, 0xF645, 0xF64E, 0xF657, 0xF65E, 0xF664, 0xF668, 
	0xF669, 0xF666, 0xF660, 0xF654, 0xF643, 0xF62C, 0xF60F, 0xF5EA, 0xF5BD, 
	0xF588, 0xF54A, 0xF505, 0xF4B8, 0xF464, 0xF409, 0xF3A9, 0xF342, 0xF2D7, 
	0xF266, 0xF1F1, 0xF179, 0xF0FD, 0xF07E, 0xEFFC, 0xEF78, 0xEED7, 0xEE09, 
	0xED1F, 0xEC2B, 0xEB3E, 0xEA69, 0xE9BD, 0xE94C, 0xE915, 0xE909, 0xE920, 
	0xE952, 0xE998, 0xE9EA, 0xEA41, 0xEA95, 0xEAE7, 0xEB3E, 0xEB99, 0xEBF8, 
	0xEC5A, 0xECBE, 0xED24, 0xED8D, 0xEDF6, 0xEE5F, 0xEEC9, 0xEF32, 0xEF9B, 
	0xF002, 0xF067, 0xF0C9, 0xF12C, 0xF190, 0xF1F6, 0xF25D, 0xF2C5, 0xF32D, 
	0xF393, 0xF3F9, 0xF45D, 0xF4BF, 0xF51D, 0xF579, 0xF5D0, 0xF623, 0xF671, 
	0xF6B9, 0xF6F5, 0xF720, 0xF73C, 0xF74C, 0xF753, 0xF752, 0xF74C, 0xF744, 
	0xF731, 0xF70D, 0xF6DF, 0xF6AD, 0xF67B, 0xF651, 0xF633, 0xF628, 0xF799, 
	0xF7A1, 0xF7B8, 0xF7DE, 0xF80F, 0xF84C, 0xF892, 0xF8E0, 0xF934, 0xF98D, 
	0xF9E9, 0xFA47, 0xFAA5, 0xFB02, 0xFB5D, 0xFBB3, 0xFC04, 0xFC4D, 0xFC8E, 
	0xFCC5, 0xFCF2, 0xFD1A, 0xFD3D, 0xFD5B, 0xFD75, 0xFD8C, 0xFDA0, 0xFDB2, 
	0xFDC3, 0xFDD3, 0xFDE3, 0xFDF4, 0xFE06, 0xFE1B, 0xFE32, 0xFE4C, 0xFE6B, 
	0xFE90, 0xFEB8, 0xFEE1, 0xFF09, 0xFF2D, 0xFF4D, 0xFF66, 0xFF7F, 0xFF9E, 
	0xFFBE, 0xFFD7, 0xFFE5, 0xFFE2, 0xFFC6, 0xFF8D, 0xFF3D, 0xFEE0, 0xFE7A, 
	0xFE0B, 0xFD94, 0xFD19, 0xFC99, 0xFC17, 0xFB95, 0xFB13, 0xFA94, 0xFA19, 
	0xF9A4, 0xF936, 0xF8D1, 0xF877, 0xF826, 0xF7DD, 0xF79B, 0xF75E, 0xF727, 
	0xF6F3, 0xF6C2, 0xF693, 0xF665, 0xF638, 0xF60A, 0xF5DB, 0xF5A9, 0xF573, 
	0xF539, 0xF4FA, 0xF4A6, 0xF435, 0xF3B6, 0xF337, 0xF2C5, 0xF26F, 0xF241, 
	0xF24B, 0xF2A5, 0xF34E, 0xF42A, 0xF51C, 0xF609, 0xF6D4, 0xF763, 0xF799, 
	0xAAEB, 0xAAE2, 0xAAC7, 0xAA9F, 0xAA6A, 0xAA2B, 0xA9E6, 0xA99C, 0xA94F, 
	0xA903, 0xA8BA, 0xA877, 0xA83B, 0xA809, 0xA7E5, 0xA7CF, 0xA7CC, 0xA7DC, 
	0xA803, 0xA844, 0xA8A1, 0xA91A, 0xA9AC, 0xAA55, 0xAB13, 0xABE2, 0xACC0, 
	0xADAB, 0xAEA0, 0xAF9C, 0xB09E, 0xB1A1, 0xB2A5, 0xB3A5, 0xB4A0, 0xB594, 
	0xB68D, 0xB79A, 0xB8B6, 0xB9DD, 0xBB0C, 0xBC3E, 0xBD6F, 0xBE9C, 0xBFD6, 
	0xC12A, 0xC28A, 0xC3E7, 0xC533, 0xC65F, 0xC75F, 0xC823, 0xC8C2, 0xC95D, 
	0xC9F2, 0xCA81, 0xCB09, 0xCB87, 0xCBFD, 0xCC67, 0xCCC5, 0xCD17, 0xCD5B, 
	0xCD90, 0xCDB5, 0xCDC9, 0xCDCC, 0xCDBB, 0xCD99, 0xCD68, 0xCD2A, 0xCCDD, 
	0xCC81, 0xCC17, 0xCB9F, 0xCB17, 0xCA81, 0xC9DD, 0xC929, 0xC867, 0xC795, 
	0xC6B5, 0xC5C6, 0xC4C7, 0xC38F, 0xC200, 0xC02E, 0xBE2D, 0xBC11, 0xB9EE, 
	0xB7D8, 0xB5E4, 0xB425, 0xB272, 0xB0AA, 0xAEEE, 0xAD5D, 0xAC16, 0xAB3B, 
	0xAAEB, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x378C, 0x3745, 0x3678, 0x3534, 0x3389, 0x3183, 0x2F33, 0x2CA6, 0x29EB, 
	0x2710, 0x2424, 0x2136, 0x1E55, 0x1B8D, 0x18EF, 0x1689, 0x1469, 0x129E, 
	0x1137, 0x1041, 0x0FBD, 0x0F99, 0x0FCB, 0x1049, 0x1108, 0x11FE, 0x1320, 
	0x1464, 0x15BF, 0x1728, 0x1893, 0x19F7, 0x1B49, 0x1C7E, 0x1D8D, 0x1E6A, 
	0x1F2A, 0x1FE4, 0x2092, 0x212D, 0x21AF, 0x2211, 0x224D, 0x225D, 0x2224, 
	0x219F, 0x20E6, 0x2014, 0x1F43, 0x1E8D, 0x1E0D, 0x1DDD, 0x1DDE, 0x1DE3, 
	0x1DED, 0x1DFD, 0x1E14, 0x1E34, 0x1E5E, 0x1E93, 0x1ED4, 0x1F23, 0x1F80, 
	0x1FEE, 0x206C, 0x20FE, 0x21A3, 0x225D, 0x2334, 0x242D, 0x2545, 0x2676, 
	0x27BF, 0x291A, 0x2A83, 0x2BF8, 0x2D73, 0x2EF2, 0x306F, 0x31E8, 0x3358, 
	0x34BC, 0x3610, 0x374F, 0x3876, 0x3981, 0x3A6C, 0x3B33, 0x3BD3, 0x3C47, 
	0x3C8C, 0x3C9D, 0x3C77, 0x3C1B, 0x3B94, 0x3AE9, 0x3A24, 0x394D, 0x386D, 
	0x378C, 0xFEC5, 0xFEC2, 0xFEBB, 0xFEAF, 0xFEA1, 0xFE91, 0xFE7F, 0xFE6D, 
	0xFE5B, 0xFE4A, 0xFE3B, 0xFE2F, 0xFE27, 0xFE23, 0xFE24, 0xFE2C, 0xFE3B, 
	0xFE51, 0xFE70, 0xFE98, 0xFED0, 0xFF1A, 0xFF75, 0xFFDC, 0x004E, 0x00C8, 
	0x0148, 0x01CA, 0x024C, 0x02CB, 0x0346, 0x03B8, 0x0420, 0x047A, 0x04C5, 
	0x04FD, 0x01F6, 0x0315, 0x0440, 0x04DE, 0x04AA, 0x03FE, 0x0335, 0x02A7, 
	0x025B, 0x0219, 0x01DF, 0x01AD, 0x017F, 0x0155, 0x012C, 0x0104, 0x00DA, 
	0x00AF, 0x0084, 0x0059, 0x002E, 0x0003, 0xFFDA, 0xFFB1, 0xFF8B, 0xFF66, 
	0xFF43, 0xFF23, 0xFF06, 0xFEED, 0xFED7, 0xFEC5, 0xFEB6, 0xFEAA, 0xFEA2, 
	0xFE9B, 0xFE97, 0xFE95, 0xFE94, 0xFE95, 0xFE98, 0xFE9B, 0xFE9F, 0xFEA4, 
	0xFEA9, 0xFEAE, 0xFEB3, 0xFEB8, 0xFEBC, 0xFEBF, 0xFEC1, 0xFEC2, 0xFEC3, 
	0xFEC4, 0xFEC5, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC5, 0x0008, 0x0009, 
	0x000C, 0x0011, 0x0017, 0x001E, 0x0026, 0x002F, 0x0038, 0x0041, 0x004A, 
	0x0052, 0x0059, 0x0060, 0x0065, 0x0068, 0x0069, 0x0068, 0x0065, 0x005E, 
	0x0055, 0x0048, 0x0039, 0x0027, 0x0012, 0xFFFC, 0xFFE4, 0xFFCB, 0xFFB1, 
	0xFF96, 0xFF7B, 0xFF60, 0xFF45, 0xFF2A, 0xFF11, 0xFEF8, 0xFEC4, 0xFEAA, 
	0xFE91, 0xFE77, 0xFE56, 0xFE31, 0xFE13, 0xFE07, 0xFE0B, 0xFE15, 0xFE23, 
	0xFE34, 0xFE47, 0xFE5C, 0xFE72, 0xFE87, 0xFE9D, 0xFEB5, 0xFECF, 0xFEE9, 
	0xFF05, 0xFF21, 0xFF3D, 0xFF59, 0xFF74, 0xFF8D, 0xFFA5, 0xFFBB, 0xFFCF, 
	0xFFE0, 0xFFEE, 0xFFF8, 0xFFFF, 0x0003, 0x0005, 0x0004, 0x0002, 0xFFFE, 
	0xFFF9, 0xFFF2, 0xFFEB, 0xFFE3, 0xFFDB, 0xFFD3, 0xFFCB, 0xFFC3, 0xFFBD, 
	0xFFB7, 0xFFB2, 0xFFAF, 0xFFAD, 0xFFAE, 0xFFBF, 0xFFE3, 0x0008, 0x001E, 
	0x0022, 0x0023, 0x0020, 0x001A, 0x0014, 0x000E, 0x0009, 0x0008, 0xC07A, 
	0xC089, 0xC0B5, 0xC0FA, 0xC156, 0xC1C4, 0xC242, 0xC2CC, 0xC360, 0xC3F9, 
	0xC496, 0xC531, 0xC5CA, 0xC65B, 0xC6E2, 0xC75B, 0xC7C4, 0xC819, 0xC857, 
	0xC87B, 0xC885, 0xC879, 0xC859, 0xC826, 0xC7E5, 0xC796, 0xC73B, 0xC6D7, 
	0xC66C, 0xC5FC, 0xC589, 0xC516, 0xC4A4, 0xC436, 0xC3CD, 0xC36D, 0xC127, 
	0xBFB5, 0xBE42, 0xBCAB, 0xBA91, 0xB821, 0xB614, 0xB523, 0xB538, 0xB5B5, 
	0xB67C, 0xB771, 0xB878, 0xB973, 0xBA46, 0xBAD5, 0xBB39, 0xBB9D, 0xBC00, 
	0xBC61, 0xBCBE, 0xBD16, 0xBD69, 0xBDB4, 0xBDF6, 0xBE2F, 0xBE5D, 0xBE7E, 
	0xBE92, 0xBE98, 0xBE8D, 0xBE71, 0xBE39, 0xBDE1, 0xBD6C, 0xBCE0, 0xBC41, 
	0xBB94, 0xBADE, 0xBA23, 0xB968, 0xB8B1, 0xB805, 0xB766, 0xB6DB, 0xB667, 
	0xB610, 0xB5DA, 0xB5CA, 0xB5E5, 0xB5F2, 0xB5CF, 0xB59B, 0xB577, 0xB585, 
	0xB5E5, 0xB6E1, 0xB879, 0xBA62, 0xBC4C, 0xBDEA, 0xBEF0, 0xBF0F, 0xBDFB, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xBF5E, 0x14B9, 0x14B7, 0x14B1, 0x14A7, 0x1499, 0x1486, 0x146E, 0x1452, 
	0x1431, 0x140C, 0x13E1, 0x13B1, 0x137C, 0x1342, 0x1302, 0x12BD, 0x1272, 
	0x1221, 0x11CA, 0x116D, 0x110A, 0x10A1, 0x1031, 0x0FBB, 0x0F2D, 0x0E7A, 
	0x0DA8, 0x0CBB, 0x0BB8, 0x0AA7, 0x098B, 0x0869, 0x0749, 0x062D, 0x051D, 
	0x041D, 0x030B, 0x01D2, 0x0089, 0xFF49, 0xFE2A, 0xFD44, 0xFCAF, 0xFC85, 
	0xFC9F, 0xFCC9, 0xFD02, 0xFD48, 0xFD9A, 0xFDF8, 0xFE5E, 0xFECE, 0xFF44, 
	0xFFC1, 0x0042, 0x00C7, 0x014F, 0x01D7, 0x0260, 0x02E7, 0x036C, 0x03ED, 
	0x0469, 0x04DF, 0x054E, 0x05B4, 0x0611, 0x0662, 0x06A8, 0x06E3, 0x0714, 
	0x073D, 0x075E, 0x077A, 0x0792, 0x07A6, 0x07B9, 0x07CB, 0x07DE, 0x07F3, 
	0x080C, 0x0829, 0x084C, 0x0876, 0x08A9, 0x08E6, 0x092E, 0x0983, 0x09FA, 
	0x0AA2, 0x0B71, 0x0C5D, 0x0D5B, 0x0E62, 0x0F67, 0x105F, 0x1194, 0x1304, 
	0x1438, 0x14B9, 0x0963, 0x096A, 0x097E, 0x099F, 0x09CA, 0x09FE, 0x0A3C, 
	0x0A80, 0x0ACA, 0x0B19, 0x0B6B, 0x0BC0, 0x0C16, 0x0C6B, 0x0CBF, 0x0D11, 
	0x0D5E, 0x0DA7, 0x0DE9, 0x0E24, 0x0E56, 0x0E7E, 0x0E9B, 0x0EAC, 0x0EA6, 
	0x0E83, 0x0E47, 0x0DF8, 0x0D99, 0x0D2F, 0x0CBE, 0x0C4B, 0x0BDA, 0x0B6F, 
	0x0B0F, 0x0ABF, 0x0A7B, 0x0A3D, 0x0A04, 0x09CF, 0x099E, 0x0970, 0x0943, 
	0x0918, 0x08EB, 0x08BC, 0x088B, 0x0859, 0x0826, 0x07F1, 0x07BD, 0x0788, 
	0x0753, 0x071F, 0x06EC, 0x06BB, 0x068B, 0x065D, 0x0631, 0x0609, 0x05E3, 
	0x05C1, 0x05A3, 0x0588, 0x0573, 0x0562, 0x0557, 0x0551, 0x0552, 0x0559, 
	0x0568, 0x057C, 0x0596, 0x05B6, 0x05DA, 0x0602, 0x062F, 0x065F, 0x0691, 
	0x06C7, 0x06FE, 0x0737, 0x0772, 0x07AD, 0x07E8, 0x0824, 0x085E, 0x0898, 
	0x08E2, 0x0948, 0x09BE, 0x0A3A, 0x0AB0, 0x0B18, 0x0B64, 0x0B8B, 0x0B3E, 
	0x0A80, 0x09BC, 0x0963, 0xC2A3, 0xC2B5, 0xC2E8, 0xC338, 0xC3A2, 0xC423, 
	0xC4B7, 0xC559, 0xC608, 0xC6BE, 0xC779, 0xC835, 0xC8EE, 0xC9A1, 0xCA4B, 
	0xCAE6, 0xCB71, 0xCBE8, 0xCC46, 0xCC88, 0xCCAC, 0xCCAC, 0xCC86, 0xCC36, 
	0xCB96, 0xCA8B, 0xC923, 0xC76B, 0xC570, 0xC340, 0xC0E8, 0xBE75, 0xBBF5, 
	0xB975, 0xB703, 0xB4AB, 0xB208, 0xAED5, 0xAB58, 0xA7D4, 0xA48C, 0xA1C4, 
	0x9FBF, 0x9EC3, 0x9E71, 0x9E3E, 0x9E29, 0x9E2E, 0x9E4D, 0x9E82, 0x9ECD, 
	0x9F2A, 0x9F98, 0xA014, 0xA09E, 0xA131, 0xA1CE, 0xA270, 0xA317, 0xA3C0, 
	0xA46A, 0xA511, 0xA5B4, 0xA652, 0xA6E7, 0xA772, 0xA7F1, 0xA862, 0xA8C8, 
	0xA92A, 0xA98A, 0xA9E6, 0xAA41, 0xAA9B, 0xAAF5, 0xAB4F, 0xABAB, 0xAC08, 
	0xAC68, 0xACCC, 0xAD34, 0xADA0, 0xAE13, 0xAE8C, 0xAF0C, 0xAF94, 0xB024, 
	0xB0BF, 0xB172, 0xB24C, 0xB348, 0xB464, 0xB59C, 0xB6EC, 0xB851, 0xB9C7, 
	0xBC00, 0xBEF4, 0xC188, 0xC2A3, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x2A1A, 0x2A11, 0x29F6, 0x29CD, 
	0x2998, 0x295A, 0x2914, 0x28CA, 0x287E, 0x2833, 0x27EB, 0x27A8, 0x276D, 
	0x273D, 0x271B, 0x2708, 0x2707, 0x271B, 0x2746, 0x278B, 0x27EC, 0x286C, 
	0x290E, 0x29D3, 0x2B07, 0x2CDD, 0x2F38, 0x31F7, 0x34FC, 0x3828, 0x3B5D, 
	0x3E7B, 0x4163, 0x43F7, 0x4617, 0x47A4, 0x488C, 0x48DC, 0x48A7, 0x47FF, 
	0x46F7, 0x45A3, 0x4414, 0x425E, 0x4087, 0x3E8C, 0x3C71, 0x3A39, 0x37E9, 
	0x3585, 0x3311, 0x3092, 0x2E0A, 0x2B7E, 0x28F3, 0x266C, 0x23EE, 0x217C, 
	0x1F1B, 0x1CCE, 0x1A9A, 0x1883, 0x168C, 0x14BB, 0x1312, 0x1196, 0x104C, 
	0x0F36, 0x0E5D, 0x0DC0, 0x0D5C, 0x0D2C, 0x0D2B, 0x0D55, 0x0DA6, 0x0E19, 
	0x0EA9, 0x0F53, 0x1011, 0x10DF, 0x11B9, 0x129A, 0x137E, 0x1460, 0x153C, 
	0x160D, 0x16CF, 0x177E, 0x1839, 0x1920, 0x1A2D, 0x1B5D, 0x1CAA, 0x1E10, 
	0x1F89, 0x2110, 0x2359, 0x265C, 0x28FB, 0x2A1A, 0x0406, 0x040E, 0x0423, 
	0x0444, 0x0470, 0x04A6, 0x04E5, 0x052A, 0x0575, 0x05C4, 0x0617, 0x066A, 
	0x06BE, 0x0711, 0x0761, 0x07AE, 0x07F5, 0x0835, 0x086E, 0x089E, 0x08C2, 
	0x08DB, 0x08E7, 0x08E4, 0x0231, 0x0171, 0x00C9, 0x0038, 0xFFBB, 0xFF51, 
	0xFEF9, 0xFEAF, 0xFE73, 0xFE43, 0xFE1D, 0xFDFF, 0xFE08, 0xFE4D, 0xFEBD, 
	0xFF45, 0xFFD4, 0x0057, 0x00BC, 0x00F2, 0x0108, 0x011A, 0x0128, 0x0132, 
	0x013A, 0x013E, 0x0141, 0x0140, 0x013E, 0x013A, 0x0135, 0x012F, 0x0128, 
	0x0121, 0x0119, 0x0112, 0x010B, 0x0104, 0x00FF, 0x00FB, 0x00F9, 0x00F8, 
	0x00FA, 0x00FE, 0x0102, 0x0103, 0x0101, 0x00FE, 0x00FA, 0x00F5, 0x00F0, 
	0x00ED, 0x00EA, 0x00EA, 0x00ED, 0x00F2, 0x00FC, 0x010B, 0x011F, 0x0138, 
	0x0158, 0x0180, 0x01AF, 0x01E7, 0x024E, 0x02FC, 0x03D8, 0x04CA, 0x05BA, 
	0x0691, 0x0736, 0x0790, 0x071C, 0x05E2, 0x049C, 0x0406, 0x017C, 0x017C, 
	0x017B, 0x017A, 0x0179, 0x0177, 0x0175, 0x0173, 0x0171, 0x016E, 0x016C, 
	0x0169, 0x0166, 0x0164, 0x0161, 0x015F, 0x015D, 0x015B, 0x0159, 0x0158, 
	0x0156, 0x0156, 0x0155, 0x0156, 0x0188, 0x0189, 0x018A, 0x018A, 0x018A, 
	0x0189, 0x0187, 0x0185, 0x0182, 0x017F, 0x017B, 0x0177, 0x0171, 0x0169, 
	0x015E, 0x0153, 0x0148, 0x013F, 0x0137, 0x0133, 0x0131, 0x012F, 0x012D, 
	0x012B, 0x012A, 0x0129, 0x0128, 0x0127, 0x0126, 0x0126, 0x0126, 0x0125, 
	0x0125, 0x0125, 0x0125, 0x0126, 0x0126, 0x0126, 0x0127, 0x0127, 0x0128, 
	0x0128, 0x0129, 0x0129, 0x0128, 0x0125, 0x0121, 0x011B, 0x0114, 0x010D, 
	0x0105, 0x00FE, 0x00F7, 0x00F1, 0x00ED, 0x00EB, 0x00EA, 0x00ED, 0x00F2, 
	0x00FA, 0x0107, 0x0117, 0x012C, 0x0146, 0x017D, 0x01DD, 0x0258, 0x02DF, 
	0x0363, 0x03D5, 0x0426, 0x0448, 0x03DA, 0x02E4, 0x01ED, 0x017C, 0xB646, 
	0xB652, 0xB676, 0xB6AF, 0xB6FB, 0xB759, 0xB7C7, 0xB843, 0xB8CA, 0xB95B, 
	0xB9F5, 0xBA95, 0xBB39, 0xBBE0, 0xBC87, 0xBD2D, 0xBDCF, 0xBE6D, 0xBF03, 
	0xBF91, 0xC013, 0xC089, 0xC0F1, 0xC148, 0xBC8B, 0xBBC8, 0xBB06, 0xBA4C, 
	0xB9A0, 0xB909, 0xB88C, 0xB831, 0xB7FD, 0xB7F6, 0xB823, 0xB88B, 0xB98B, 
	0xBB52, 0xBD9D, 0xC02B, 0xC2B9, 0xC505, 0xC6CC, 0xC7CD, 0xC849, 0xC8B1, 
	0xC906, 0xC949, 0xC97C, 0xC9A1, 0xC9B9, 0xC9C6, 0xC9C9, 0xC9C4, 0xC9B7, 
	0xC9A6, 0xC991, 0xC97A, 0xC962, 0xC94B, 0xC937, 0xC927, 0xC91C, 0xC918, 
	0xC91D, 0xC92C, 0xC946, 0xC96E, 0xC9A9, 0xC9F8, 0xCA5A, 0xCACA, 0xCB46, 
	0xCBCB, 0xCC56, 0xCCE3, 0xCD6F, 0xCDF8, 0xCE7A, 0xCEF2, 0xCF5D, 0xCFB9, 
	0xD001, 0xD032, 0xD04B, 0xD047, 0xD024, 0xCFDE, 0xCF26, 0xCDC5, 0xCBE1, 
	0xC99E, 0xC722, 0xC493, 0xC213, 0xBFCA, 0xBD1A, 0xB9F7, 0xB75C, 0xB646, 	
},
{
	0x0001, 0x0000, 0x0063, 0x0001, 0x0001, 0x0064, 0x0001, 0x0065, 0x0001, 
	0x0066, 0x0001, 0x0067, 0x0064, 0x0068, 0x0061, 0x00CC, 0x0001, 0x012D, 
	0x0064, 0x012E, 0x0064, 0x0192, 0x0064, 0x01F6, 0x0064, 0x025A, 0x0064, 
	0x02BE, 0x0064, 0x0322, 0x0001, 0x0386, 0x0001, 0x0387, 0x0001, 0x0388, 
	0x0064, 0x0389, 0x0064, 0x03ED, 0x0064, 0x0451, 0x005E, 0x04B5, 0x0062, 
	0x0513, 0x0064, 0x0575, 0x0001, 0x05D9, 0x0001, 0x05DA, 0x0001, 0x05DB, 
	0x0001, 0x05DC, 0x0001, 0x05DD, 0x0001, 0x05DE, 0x0063, 0x05DF, 0x0064, 
	0x0642, 0x0064, 0x06A6, 0x0064, 0x070A, 0x0062, 0x076E, 0x0001, 0x07D0, 
	0x0001, 0x07D1, 0x0001, 0x07D2, 0x0001, 0x07D3, 0x0063, 0x07D4, 0x0063, 
	0x0837, 0x0001, 0x089A, 0x0064, 0x089B, 0x0064, 0x08FF, 0x0064, 0x0963, 
	0x0061, 0x09C7, 0x0064, 0x0A28, 0x0064, 0x0A8C, 0x0060, 0x0AF0, 0x0064, 
	0x0B50, 0x0064, 0x0BB4, 0x0063, 0x0C18, 0x0063, 0x0C7B, 0x0001, 0x0CDE, 
	0x0064, 0x0CDF, 0x0064, 0x0D43, 0x0064, 0x0DA7, 0x0064, 0x0E0B, 0x0063, 
	0x0E6F, 0x0064, 0x0ED2, 0x0064, 0x0F36, 0x0064, 0x0F9A, 0x0064, 0x0FFE, 
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_IDLE_WITH_LIGHT_OBJ], 0, 189, 0, 0, 60, {
	0x0000, 0x009A, 0x0098, 0x0096, 0x0094, 0x0092, 0x0090, 0x008F, 0x008E, 
	0x008D, 0x008D, 0x008D, 0x008D, 0x008E, 0x0090, 0x0092, 0x0094, 0x0096, 
	0x0097, 0x0099, 0x009A, 0x009A, 0x009A, 0x0099, 0x0097, 0x0096, 0x0094, 
	0x0092, 0x0090, 0x008E, 0x008D, 0x008D, 0x008D, 0x008E, 0x0090, 0x0092, 
	0x0094, 0x0096, 0x0097, 0x0099, 0x009A, 0x009A, 0x009A, 0x0099, 0x0097, 
	0x0096, 0x0094, 0x0092, 0x0090, 0x008E, 0x008D, 0x008D, 0x008D, 0x008E, 
	0x0090, 0x0092, 0x0094, 0x0096, 0x0097, 0x0099, 0x009A, 0x0007, 0x0000, 
	0x3FFF, 0x0000, 0x0000, 0x0000, 0x388D, 0xFFFF, 0xFFE7, 0xFFC8, 0xFFA3, 
	0xFF7C, 0xFF54, 0xFF2E, 0xFF0D, 0xFEF2, 0xFEE0, 0xFEDA, 0xFEDF, 0xFEEE, 
	0xFF05, 0xFF23, 0xFF46, 0xFF6B, 0xFF92, 0xFFB9, 0xFFDE, 0xFFFF, 0x0022, 
	0x004A, 0x0075, 0x00A1, 0x00CC, 0x00F4, 0x0116, 0x0132, 0x0144, 0x014A, 
	0x0144, 0x0132, 0x0118, 0x00F6, 0x00CE, 0x00A3, 0x0078, 0x004C, 0x0024, 
	0xFFFF, 0xFFDB, 0xFFB3, 0xFF87, 0xFF5C, 0xFF31, 0xFF09, 0xFEE7, 0xFECD, 
	0xFEBB, 0xFEB5, 0xFEBE, 0xFED7, 0xFEFC, 0xFF29, 0xFF5A, 0xFF8B, 0xFFB8, 
	0xFFDD, 0xFFF6, 0xFFFF, 0xFFFF, 0x0040, 0x0093, 0x00F5, 0x015D, 0x01C7, 
	0x022C, 0x0285, 0x02CC, 0x02FB, 0x030D, 0x02FE, 0x02D6, 0x0298, 0x0249, 
	0x01EE, 0x018A, 0x0122, 0x00BB, 0x0059, 0xFFFF, 0xFFA4, 0xFF3A, 0xFEC8, 
	0xFE53, 0xFDE0, 0xFD76, 0xFD1A, 0xFCD2, 0xFCA2, 0xFC91, 0xFCA2, 0xFCD0, 
	0xFD17, 0xFD72, 0xFDDA, 0xFE4C, 0xFEC1, 0xFF34, 0xFFA0, 0xFFFF, 0x005F, 
	0x00CB, 0x013E, 0x01B3, 0x0225, 0x028D, 0x02E8, 0x032F, 0x035D, 0x036E, 
	0x0356, 0x0313, 0x02B0, 0x0239, 0x01B7, 0x0135, 0x00BD, 0x005B, 0x0018, 
	0xFFFF, 0xF526, 0xF5AA, 0xF62F, 0xF6AF, 0xF72A, 0xF79A, 0xF7FD, 0xF850, 
	0xF88F, 0xF8B7, 0xF8C6, 0xF8AC, 0xF865, 0xF7FD, 0xF77F, 0xF6F6, 0xF66D, 
	0xF5EF, 0xF587, 0xF540, 0xF526, 0xF540, 0xF586, 0xF5ED, 0xF66B, 0xF6F4, 
	0xF77D, 0xF7FB, 0xF862, 0xF8A9, 0xF8C3, 0xF8A9, 0xF863, 0xF7FB, 0xF77D, 
	0xF6F4, 0xF66B, 0xF5EE, 0xF586, 0xF540, 0xF526, 0xF540, 0xF586, 0xF5EE, 
	0xF66B, 0xF6F4, 0xF77D, 0xF7FB, 0xF863, 0xF8A9, 0xF8C3, 0xF8A9, 0xF863, 
	0xF7FB, 0xF77D, 0xF6F4, 0xF66B, 0xF5EE, 0xF586, 0xF540, 0xF526, 0x0230, 
	0x0250, 0x02AF, 0x0346, 0x0410, 0x0507, 0x0627, 0x076A, 0x08CB, 0x0A43, 
	0x0BCE, 0x0D67, 0x0F08, 0x10AC, 0x124D, 0x13E5, 0x1571, 0x16E9, 0x184A, 
	0x198D, 0x1AAD, 0x1BA4, 0x1C6E, 0x1D05, 0x1D63, 0x1D84, 0x1D52, 0x1CC1, 
	0x1BDC, 0x1AAC, 0x193C, 0x1795, 0x15C1, 0x13CB, 0x11BC, 0x0F9E, 0x0D7B, 
	0x0B5D, 0x094D, 0x0757, 0x0583, 0x03DD, 0x026C, 0x013D, 0x0057, 0xFFC6, 
	0xFF93, 0xFF9D, 0xFFB8, 0xFFE2, 0x0018, 0x0057, 0x009B, 0x00E2, 0x0129, 
	0x016D, 0x01AB, 0x01E1, 0x020B, 0x0226, 0x0230, 0xFAFB, 0xFAFF, 0xFB0B, 
	0xFB1F, 0xFB3A, 0xFB5A, 0xFB80, 0xFBAA, 0xFBD8, 0xFC09, 0xFC3D, 0xFC72, 
	0xFCA9, 0xFCE0, 0xFD16, 0xFD4C, 0xFD7F, 0xFDB1, 0xFDDF, 0xFE09, 0xFE2F, 
	0xFE4F, 0xFE69, 0xFE7D, 0xFE8A, 0xFE8E, 0xFE7F, 0xFE53, 0xFE0E, 0xFDB3, 
	0xFD45, 0xFCC6, 0xFC3A, 0xFBA3, 0xFB05, 0xFA62, 0xF9BE, 0xF91C, 0xF87D, 
	0xF7E7, 0xF75A, 0xF6DC, 0xF66D, 0xF612, 0xF5CD, 0xF5A2, 0xF593, 0xF5A7, 
	0xF5DF, 0xF636, 0xF6A5, 0xF726, 0xF7B3, 0xF847, 0xF8DA, 0xF967, 0xF9E8, 
	0xFA57, 0xFAAE, 0xFAE7, 0xFAFB, 0x109A, 0x1098, 0x1091, 0x1085, 0x1077, 
	0x1064, 0x104F, 0x1037, 0x101D, 0x1002, 0x0FE4, 0x0FC6, 0x0FA8, 0x0F89, 
	0x0F6A, 0x0F4C, 0x0F2F, 0x0F13, 0x0EF9, 0x0EE1, 0x0ECC, 0x0EBA, 0x0EAB, 
	0x0EA0, 0x0E99, 0x0E96, 0x0E97, 0x0E9A, 0x0E9F, 0x0EA6, 0x0EAE, 0x0EB8, 
	0x0EC4, 0x0ED1, 0x0EDF, 0x0EEF, 0x0EFF, 0x0F11, 0x0F23, 0x0F37, 0x0F4B, 
	0x0F5F, 0x0F74, 0x0F8A, 0x0FA0, 0x0FB6, 0x0FCC, 0x0FE2, 0x0FF8, 0x100D, 
	0x1022, 0x1035, 0x1048, 0x1059, 0x1069, 0x1077, 0x1083, 0x108D, 0x1094, 
	0x1098, 0x109A, 0xFFFE, 0x0001, 0xCACF, 0xCB29, 0xCB70, 0xCBA7, 0xCBCE, 
	0xCBE8, 0xCBF4, 0xCBF6, 0xCBEE, 0xCBDF, 0xCBC8, 0xCBAD, 0xCB8E, 0xCB6E, 
	0xCB4D, 0xCB2C, 0xCB0F, 0xCAF5, 0xCAE1, 0xCAD3, 0xCACF, 0x259D, 0x2596, 
	0x2581, 0x255F, 0x2530, 0x24F7, 0x24B4, 0x2468, 0x2414, 0x23B9, 0x2358, 
	0x22F2, 0x2289, 0x221C, 0x21AD, 0x213D, 0x20CD, 0x205E, 0x1FF1, 0x1F87, 
	0x1F21, 0x1EC0, 0x1E65, 0x1E11, 0x1DC5, 0x1D82, 0x1D49, 0x1D1B, 0x1CF9, 
	0x1CE4, 0x1CDC, 0x1CE4, 0x1CF9, 0x1D1B, 0x1D49, 0x1D82, 0x1DC5, 0x1E11, 
	0x1E65, 0x1EC0, 0x1F21, 0x1F87, 0x1FF1, 0x205E, 0x20CD, 0x213D, 0x21AD, 
	0x221C, 0x2289, 0x22F2, 0x2358, 0x23B9, 0x2414, 0x2468, 0x24B4, 0x24F7, 
	0x2530, 0x255F, 0x2581, 0x2596, 0x259D, 0xCD9C, 0xCD9F, 0xCDA6, 0xCDB3, 
	0xCDC4, 0xCDD9, 0xCDF2, 0xCE0E, 0xCE2E, 0xCE4F, 0xCE73, 0xCE99, 0xCEC0, 
	0xCEE8, 0xCF12, 0xCF3B, 0xCF64, 0xCF8E, 0xCFB6, 0xCFDD, 0xD003, 0xD027, 
	0xD048, 0xD068, 0xD084, 0xD09D, 0xD0B2, 0xD0C3, 0xD0CF, 0xD0D7, 0xD0DA, 
	0xD0D7, 0xD0CF, 0xD0C3, 0xD0B2, 0xD09D, 0xD084, 0xD068, 0xD048, 0xD027, 
	0xD003, 0xCFDD, 0xCFB6, 0xCF8E, 0xCF64, 0xCF3B, 0xCF12, 0xCEE8, 0xCEC0, 
	0xCE99, 0xCE73, 0xCE4F, 0xCE2E, 0xCE0E, 0xCDF2, 0xCDD9, 0xCDC4, 0xCDB3, 
	0xCDA6, 0xCD9F, 0xCD9C, 0xC7A6, 0xC7AE, 0xC7C4, 0xC7E9, 0xC81B, 0xC858, 
	0xC8A0, 0xC8F1, 0xC94C, 0xC9AD, 0xCA15, 0xCA82, 0xCAF4, 0xCB69, 0xCBE0, 
	0xCC58, 0xCCD0, 0xCD47, 0xCDBC, 0xCE2D, 0xCE9B, 0xCF03, 0xCF64, 0xCFBE, 
	0xD010, 0xD058, 0xD095, 0xD0C7, 0xD0EB, 0xD102, 0xD10A, 0xD102, 0xD0EB, 
	0xD0C7, 0xD095, 0xD058, 0xD010, 0xCFBE, 0xCF64, 0xCF03, 0xCE9B, 0xCE2D, 
	0xCDBC, 0xCD47, 0xCCD0, 0xCC58, 0xCBE0, 0xCB69, 0xCAF4, 0xCA82, 0xCA15, 
	0xC9AD, 0xC94C, 0xC8F1, 0xC8A0, 0xC858, 0xC81B, 0xC7E9, 0xC7C4, 0xC7AE, 
	0xC7A6, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xE263, 0xE271, 0xE299, 0xE2DB, 0xE333, 0xE3A1, 0xE421, 0xE4B2, 
	0xE553, 0xE601, 0xE6BB, 0xE77E, 0xE848, 0xE919, 0xE9ED, 0xEAC3, 0xEB99, 
	0xEC6D, 0xED3E, 0xEE08, 0xEECC, 0xEF85, 0xF033, 0xF0D4, 0xF165, 0xF1E6, 
	0xF253, 0xF2AB, 0xF2ED, 0xF315, 0xF323, 0xF315, 0xF2ED, 0xF2AB, 0xF253, 
	0xF1E6, 0xF165, 0xF0D4, 0xF033, 0xEF85, 0xEECC, 0xEE08, 0xED3E, 0xEC6D, 
	0xEB99, 0xEAC3, 0xE9ED, 0xE919, 0xE848, 0xE77E, 0xE6BB, 0xE601, 0xE553, 
	0xE4B2, 0xE421, 0xE3A1, 0xE333, 0xE2DB, 0xE299, 0xE271, 0xE263, 0xE7CD, 
	0xF983, 0xE96A, 0xFFFE, 0x0001, 0xC9FE, 0xCA50, 0xCA92, 0xCAC4, 0xCAE8, 
	0xCAFF, 0xCB0A, 0xCB0C, 0xCB05, 0xCAF6, 0xCAE2, 0xCAC9, 0xCAAD, 0xCA8F, 
	0xCA71, 0xCA54, 0xCA38, 0xCA21, 0xCA0E, 0xCA02, 0xC9FE, 0xF0CC, 0xF0B9, 
	0xF085, 0xF038, 0xEFDB, 0xEF75, 0xEF10, 0xEEB3, 0xEE66, 0xEE32, 0xEE1F, 
	0xEE32, 0xEE66, 0xEEB3, 0xEF10, 0xEF75, 0xEFDB, 0xF038, 0xF085, 0xF0B9, 
	0xF0CC, 0xF0CB, 0xF0C8, 0xF0C4, 0xF0BF, 0xF0BA, 0xF0B5, 0xF0B0, 0xF0AC, 
	0xF0A9, 0xF0A8, 0xF0A9, 0xF0AC, 0xF0B0, 0xF0B5, 0xF0BA, 0xF0BF, 0xF0C4, 
	0xF0C8, 0xF0CB, 0xF0CC, 0xF0B9, 0xF085, 0xF038, 0xEFDB, 0xEF75, 0xEF10, 
	0xEEB3, 0xEE66, 0xEE32, 0xEE1F, 0xEE32, 0xEE66, 0xEEB3, 0xEF10, 0xEF75, 
	0xEFDB, 0xF038, 0xF085, 0xF0B9, 0xF0CC, 0x1131, 0x111D, 0x10E6, 0x1095, 
	0x1033, 0x0FC8, 0x0F5D, 0x0EFB, 0x0EAA, 0x0E73, 0x0E5F, 0x0E68, 0x0E83, 
	0x0EAE, 0x0EE8, 0x0F30, 0x0F84, 0x0FE2, 0x104A, 0x10BA, 0x1131, 0x11AD, 
	0x122A, 0x12A6, 0x131D, 0x138B, 0x13EC, 0x143F, 0x147E, 0x14A6, 0x14B4, 
	0x14A6, 0x147E, 0x143F, 0x13EC, 0x138B, 0x131D, 0x12A6, 0x122A, 0x11AD, 
	0x1131, 0x10BA, 0x104A, 0x0FE2, 0x0F84, 0x0F30, 0x0EE8, 0x0EAE, 0x0E83, 
	0x0E68, 0x0E5F, 0x0E73, 0x0EAA, 0x0EFB, 0x0F5D, 0x0FC8, 0x1033, 0x1095, 
	0x10E6, 0x111D, 0x1131, 0x6C57, 0x6C24, 0x6B9B, 0x6AD0, 0x69DA, 0x68CE, 
	0x67C2, 0x66CC, 0x6601, 0x6578, 0x6545, 0x6578, 0x6601, 0x66CC, 0x67C2, 
	0x68CE, 0x69DA, 0x6AD0, 0x6B9B, 0x6C24, 0x6C57, 0x6C3E, 0x6BFB, 0x6B98, 
	0x6B1F, 0x6A9C, 0x6A19, 0x69A0, 0x693D, 0x68FA, 0x68E1, 0x68FA, 0x693D, 
	0x69A0, 0x6A19, 0x6A9C, 0x6B1F, 0x6B98, 0x6BFB, 0x6C3E, 0x6C57, 0x6C24, 
	0x6B9B, 0x6AD0, 0x69DA, 0x68CE, 0x67C2, 0x66CC, 0x6601, 0x6578, 0x6545, 
	0x6578, 0x6601, 0x66CC, 0x67C2, 0x68CE, 0x69DA, 0x6AD0, 0x6B9B, 0x6C24, 
	0x6C57, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xF032, 0x0D18, 0x182D, 0xF4C2, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xBF5E, 0xBF91, 0xBFD4, 
	0xC022, 0xC076, 0xC0CB, 0xC11C, 0xC163, 0xC19C, 0xC1C2, 0xC1D0, 0xC1BE, 
	0xC18F, 0xC149, 0xC0F3, 0xC097, 0xC03A, 0xBFE5, 0xBF9F, 0xBF6F, 0xBF5E, 
	0xBF6F, 0xBF9F, 0xBFE5, 0xC03A, 0xC097, 0xC0F3, 0xC149, 0xC18F, 0xC1BE, 
	0xC1D0, 0xC1BE, 0xC18F, 0xC149, 0xC0F3, 0xC097, 0xC03A, 0xBFE5, 0xBF9F, 
	0xBF6F, 0xBF5E, 0xBF6F, 0xBF9F, 0xBFE5, 0xC03A, 0xC097, 0xC0F3, 0xC149, 
	0xC18F, 0xC1BE, 0xC1D0, 0xC1BE, 0xC18F, 0xC149, 0xC0F3, 0xC097, 0xC03A, 
	0xBFE5, 0xBF9F, 0xBF6F, 0xBF5E, 0xD826, 0xD8BA, 0xD95E, 0xDA0B, 0xDABA, 
	0xDB63, 0xDBFE, 0xDC84, 0xDCED, 0xDD32, 0xDD4B, 0xDD26, 0xDCC2, 0xDC2E, 
	0xDB7B, 0xDAB8, 0xD9F6, 0xD943, 0xD8AF, 0xD84B, 0xD826, 0xD84B, 0xD8AF, 
	0xD943, 0xD9F6, 0xDAB8, 0xDB7B, 0xDC2E, 0xDCC2, 0xDD26, 0xDD4B, 0xDD26, 
	0xDCC2, 0xDC2E, 0xDB7B, 0xDAB8, 0xD9F6, 0xD943, 0xD8AF, 0xD84B, 0xD826, 
	0xD84B, 0xD8AF, 0xD943, 0xD9F6, 0xDAB8, 0xDB7B, 0xDC2E, 0xDCC2, 0xDD26, 
	0xDD4B, 0xDD26, 0xDCC2, 0xDC2E, 0xDB7B, 0xDAB8, 0xD9F6, 0xD943, 0xD8AF, 
	0xD84B, 0xD826, 0xE771, 0xE6B6, 0xE614, 0xE58B, 0xE519, 0xE4BC, 0xE473, 
	0xE43D, 0xE418, 0xE403, 0xE3FC, 0xE415, 0xE458, 0xE4BB, 0xE534, 0xE5B7, 
	0xE63A, 0xE6B2, 0xE715, 0xE759, 0xE771, 0xE759, 0xE715, 0xE6B2, 0xE63A, 
	0xE5B7, 0xE534, 0xE4BB, 0xE458, 0xE415, 0xE3FC, 0xE415, 0xE458, 0xE4BB, 
	0xE534, 0xE5B7, 0xE63A, 0xE6B2, 0xE715, 0xE759, 0xE771, 0xE759, 0xE715, 
	0xE6B2, 0xE63A, 0xE5B7, 0xE534, 0xE4BB, 0xE458, 0xE415, 0xE3FC, 0xE415, 
	0xE458, 0xE4BB, 0xE534, 0xE5B7, 0xE63A, 0xE6B2, 0xE715, 0xE759, 0xE771, 
	0xBA93, 0xB99F, 0xB89A, 0xB78F, 0xB687, 0xB58D, 0xB4AB, 0xB3E9, 0xB352, 
	0xB2F1, 0xB2CE, 0xB306, 0xB39D, 0xB47C, 0xB58A, 0xB6B1, 0xB7D7, 0xB8E6, 
	0xB9C5, 0xBA5C, 0xBA93, 0xBA5C, 0xB9C5, 0xB8E6, 0xB7D7, 0xB6B1, 0xB58A, 
	0xB47C, 0xB39D, 0xB306, 0xB2CE, 0xB306, 0xB39D, 0xB47C, 0xB58A, 0xB6B1, 
	0xB7D7, 0xB8E6, 0xB9C5, 0xBA5C, 0xBA93, 0xBA5C, 0xB9C5, 0xB8E6, 0xB7D7, 
	0xB6B1, 0xB58A, 0xB47C, 0xB39D, 0xB306, 0xB2CE, 0xB306, 0xB39D, 0xB47C, 
	0xB58A, 0xB6B1, 0xB7D7, 0xB8E6, 0xB9C5, 0xBA5C, 0xBA93, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x378C, 
	0x39B1, 0x3B78, 0x3CEB, 0x3E11, 0x3EF3, 0x3F99, 0x400C, 0x4054, 0x4078, 
	0x4083, 0x4043, 0x3F94, 0x3E93, 0x3D5B, 0x3C07, 0x3AB4, 0x397C, 0x387B, 
	0x37CC, 0x378C, 0x37CC, 0x387B, 0x397C, 0x3AB4, 0x3C07, 0x3D5B, 0x3E93, 
	0x3F94, 0x4043, 0x4083, 0x4043, 0x3F94, 0x3E93, 0x3D5B, 0x3C07, 0x3AB4, 
	0x397C, 0x387B, 0x37CC, 0x378C, 0x37CC, 0x387B, 0x397C, 0x3AB4, 0x3C07, 
	0x3D5B, 0x3E93, 0x3F94, 0x4043, 0x4083, 0x4043, 0x3F94, 0x3E93, 0x3D5B, 
	0x3C07, 0x3AB4, 0x397C, 0x387B, 0x37CC, 0x378C, 0xFED3, 0xFED5, 0xFED6, 
	0xFED8, 0xFED9, 0xFEDA, 0xFEDC, 0xFEDC, 0xFEDD, 0xFEDE, 0xFEDE, 0xFEDD, 
	0xFEDD, 0xFEDB, 0xFEDA, 0xFED8, 0xFED7, 0xFED5, 0xFED4, 0xFED3, 0xFED3, 
	0xFED3, 0xFED4, 0xFED5, 0xFED7, 0xFED8, 0xFEDA, 0xFEDB, 0xFEDD, 0xFEDD, 
	0xFEDE, 0xFEDD, 0xFEDD, 0xFEDB, 0xFEDA, 0xFED8, 0xFED7, 0xFED5, 0xFED4, 
	0xFED3, 0xFED3, 0xFED3, 0xFED4, 0xFED5, 0xFED7, 0xFED8, 0xFEDA, 0xFEDB, 
	0xFEDD, 0xFEDD, 0xFEDE, 0xFEDD, 0xFEDD, 0xFEDB, 0xFEDA, 0xFED8, 0xFED7, 
	0xFED5, 0xFED4, 0xFED3, 0xFFA1, 0xFF98, 0xFF92, 0xFF8C, 0xFF89, 0xFF86, 
	0xFF85, 0xFF84, 0xFF84, 0xFF84, 0xFF84, 0xFF84, 0xFF87, 0xFF8A, 0xFF8E, 
	0xFF92, 0xFF97, 0xFF9B, 0xFF9E, 0xFFA0, 0xFFA1, 0xFFA0, 0xFF9E, 0xFF9B, 
	0xFF97, 0xFF92, 0xFF8E, 0xFF8A, 0xFF87, 0xFF84, 0xFF84, 0xFF84, 0xFF87, 
	0xFF8A, 0xFF8E, 0xFF92, 0xFF97, 0xFF9B, 0xFF9E, 0xFFA0, 0xFFA1, 0xFFA0, 
	0xFF9E, 0xFF9B, 0xFF97, 0xFF92, 0xFF8E, 0xFF8A, 0xFF87, 0xFF84, 0xFF84, 
	0xFF84, 0xFF87, 0xFF8A, 0xFF8E, 0xFF92, 0xFF97, 0xFF9B, 0xFF9E, 0xFFA0, 
	0xFFA1, 0xB309, 0xB1DE, 0xB0F2, 0xB03E, 0xAFBA, 0xAF5F, 0xAF26, 0xAF06, 
	0xAEF8, 0xAEF6, 0xAEF7, 0xAF14, 0xAF63, 0xAFD8, 0xB066, 0xB100, 0xB19A, 
	0xB228, 0xB29D, 0xB2EC, 0xB309, 0xB2EC, 0xB29D, 0xB228, 0xB19A, 0xB100, 
	0xB066, 0xAFD8, 0xAF63, 0xAF14, 0xAEF7, 0xAF14, 0xAF63, 0xAFD8, 0xB066, 
	0xB100, 0xB19A, 0xB228, 0xB29D, 0xB2EC, 0xB309, 0xB2EC, 0xB29D, 0xB228, 
	0xB19A, 0xB100, 0xB066, 0xAFD8, 0xAF63, 0xAF14, 0xAEF7, 0xAF14, 0xAF63, 
	0xAFD8, 0xB066, 0xB100, 0xB19A, 0xB228, 0xB29D, 0xB2EC, 0xB309, 0x0000, 
	0xFFFF, 0xBF5E, 0x17C1, 0x1740, 0x16C5, 0x1652, 0x15E8, 0x158A, 0x1539, 
	0x14F7, 0x14C6, 0x14A8, 0x149D, 0x14B3, 0x14F1, 0x154B, 0x15B8, 0x162F, 
	0x16A6, 0x1714, 0x176E, 0x17AB, 0x17C1, 0x17AB, 0x176E, 0x1714, 0x16A6, 
	0x162F, 0x15B8, 0x154B, 0x14F1, 0x14B3, 0x149D, 0x14B3, 0x14F1, 0x154B, 
	0x15B8, 0x162F, 0x16A6, 0x1714, 0x176E, 0x17AB, 0x17C1, 0x17AB, 0x176E, 
	0x1714, 0x16A6, 0x162F, 0x15B8, 0x154B, 0x14F1, 0x14B3, 0x149D, 0x14B3, 
	0x14F1, 0x154B, 0x15B8, 0x162F, 0x16A6, 0x1714, 0x176E, 0x17AB, 0x17C1, 
	0x15CC, 0x166D, 0x16F7, 0x176C, 0x17CE, 0x181E, 0x185C, 0x188B, 0x18AA, 
	0x18BD, 0x18C2, 0x18AD, 0x1873, 0x181F, 0x17B8, 0x1747, 0x16D7, 0x1670, 
	0x161B, 0x15E2, 0x15CC, 0x15E2, 0x161B, 0x1670, 0x16D7, 0x1747, 0x17B8, 
	0x181F, 0x1873, 0x18AD, 0x18C2, 0x18AD, 0x1873, 0x181F, 0x17B8, 0x1747, 
	0x16D7, 0x1670, 0x161B, 0x15E2, 0x15CC, 0x15E2, 0x161B, 0x1670, 0x16D7, 
	0x1747, 0x17B8, 0x181F, 0x1873, 0x18AD, 0x18C2, 0x18AD, 0x1873, 0x181F, 
	0x17B8, 0x1747, 0x16D7, 0x1670, 0x161B, 0x15E2, 0x15CC, 0xAE8D, 0xAD82, 
	0xAC8E, 0xABB3, 0xAAF1, 0xAA4A, 0xA9BF, 0xA951, 0xA901, 0xA8D0, 0xA8C0, 
	0xA8E9, 0xA95A, 0xAA01, 0xAACB, 0xABA6, 0xAC82, 0xAD4C, 0xADF2, 0xAE63, 
	0xAE8D, 0xAE63, 0xADF2, 0xAD4C, 0xAC82, 0xABA6, 0xAACB, 0xAA01, 0xA95A, 
	0xA8E9, 0xA8C0, 0xA8E9, 0xA95A, 0xAA01, 0xAACB, 0xABA6, 0xAC82, 0xAD4C, 
	0xADF2, 0xAE63, 0xAE8D, 0xAE63, 0xADF2, 0xAD4C, 0xAC82, 0xABA6, 0xAACB, 
	0xAA01, 0xA95A, 0xA8E9, 0xA8C0, 0xA8E9, 0xA95A, 0xAA01, 0xAACB, 0xABA6, 
	0xAC82, 0xAD4C, 0xADF2, 0xAE63, 0xAE8D, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x3311, 0x3535, 0x373F, 0x3925, 0x3AE2, 0x3C6D, 
	0x3DC1, 0x3ED6, 0x3FA4, 0x4026, 0x4052, 0x3FF3, 0x3EF1, 0x3D75, 0x3BA8, 
	0x39B1, 0x37BB, 0x35EE, 0x3472, 0x3370, 0x3311, 0x3370, 0x3472, 0x35EE, 
	0x37BB, 0x39B1, 0x3BA8, 0x3D75, 0x3EF1, 0x3FF3, 0x4052, 0x3FF3, 0x3EF1, 
	0x3D75, 0x3BA8, 0x39B1, 0x37BB, 0x35EE, 0x3472, 0x3370, 0x3311, 0x3370, 
	0x3472, 0x35EE, 0x37BB, 0x39B1, 0x3BA8, 0x3D75, 0x3EF1, 0x3FF3, 0x4052, 
	0x3FF3, 0x3EF1, 0x3D75, 0x3BA8, 0x39B1, 0x37BB, 0x35EE, 0x3472, 0x3370, 
	0x3311, 0x008C, 0x008E, 0x0094, 0x009C, 0x00A6, 0x00B1, 0x00BB, 0x00C5, 
	0x00CD, 0x00D3, 0x00D5, 0x00D3, 0x00CD, 0x00C5, 0x00BB, 0x00B1, 0x00A6, 
	0x009C, 0x0094, 0x008E, 0x008C, 0x008E, 0x0094, 0x009C, 0x00A6, 0x00B1, 
	0x00BB, 0x00C5, 0x00CD, 0x00D3, 0x00D5, 0x00D3, 0x00CD, 0x00C5, 0x00BB, 
	0x00B1, 0x00A6, 0x009C, 0x0094, 0x008E, 0x008C, 0x008E, 0x0094, 0x009C, 
	0x00A6, 0x00B1, 0x00BB, 0x00C5, 0x00CD, 0x00D3, 0x00D5, 0x00D3, 0x00CD, 
	0x00C5, 0x00BB, 0x00B1, 0x00A6, 0x009C, 0x0094, 0x008E, 0x008C, 0x016D, 
	0x016C, 0x0169, 0x0165, 0x0160, 0x015B, 0x0155, 0x0150, 0x014C, 0x014A, 
	0x0148, 0x0149, 0x014C, 0x0150, 0x0155, 0x015B, 0x0160, 0x0165, 0x0169, 
	0x016C, 0x016D, 0x016C, 0x0169, 0x0165, 0x0160, 0x015B, 0x0155, 0x0150, 
	0x014C, 0x0149, 0x0148, 0x0149, 0x014C, 0x0150, 0x0155, 0x015B, 0x0160, 
	0x0165, 0x0169, 0x016C, 0x016D, 0x016C, 0x0169, 0x0165, 0x0160, 0x015B, 
	0x0155, 0x0150, 0x014C, 0x0149, 0x0148, 0x0149, 0x014C, 0x0150, 0x0155, 
	0x015B, 0x0160, 0x0165, 0x0169, 0x016C, 0x016D, 0xBB93, 0xBA8F, 0xB991, 
	0xB89D, 0xB7BA, 0xB6EC, 0xB638, 0xB5A3, 0xB532, 0xB4EB, 0xB4D2, 0xB503, 
	0xB586, 0xB648, 0xB733, 0xB833, 0xB932, 0xBA1D, 0xBADF, 0xBB62, 0xBB93, 
	0xBB62, 0xBADF, 0xBA1D, 0xB932, 0xB833, 0xB733, 0xB648, 0xB586, 0xB503, 
	0xB4D2, 0xB503, 0xB586, 0xB648, 0xB733, 0xB833, 0xB932, 0xBA1D, 0xBADF, 
	0xBB62, 0xBB93, 0xBB62, 0xBADF, 0xBA1D, 0xB932, 0xB833, 0xB733, 0xB648, 
	0xB586, 0xB503, 0xB4D2, 0xB503, 0xB586, 0xB648, 0xB733, 0xB833, 0xB932, 
	0xBA1D, 0xBADF, 0xBB62, 0xBB93, 
},
{
	0x0001, 0x0000, 0x003C, 0x0001, 0x0001, 0x003D, 0x0001, 0x003E, 0x0001, 
	0x003F, 0x0001, 0x0040, 0x0001, 0x0041, 0x0001, 0x0042, 0x0001, 0x0043, 
	0x003D, 0x0044, 0x003D, 0x0081, 0x003D, 0x00BE, 0x003D, 0x00FB, 0x003D, 
	0x0138, 0x003D, 0x0175, 0x0001, 0x01B2, 0x0001, 0x01B3, 0x0015, 0x01B4, 
	0x003D, 0x01C9, 0x003D, 0x0206, 0x003D, 0x0243, 0x001A, 0x0280, 0x0025, 
	0x029A, 0x003D, 0x02BF, 0x0001, 0x02FC, 0x0001, 0x02FD, 0x0001, 0x02FE, 
	0x0001, 0x02FF, 0x0001, 0x0300, 0x0015, 0x0301, 0x003D, 0x0316, 0x003D, 
	0x0353, 0x003D, 0x0390, 0x003D, 0x03CD, 0x003C, 0x040A, 0x0001, 0x0446, 
	0x0001, 0x0447, 0x0001, 0x0448, 0x0001, 0x0449, 0x003B, 0x044A, 0x0001, 
	0x0485, 0x003D, 0x0486, 0x003D, 0x04C3, 0x003D, 0x0500, 0x003D, 0x053D, 
	0x003C, 0x057A, 0x003A, 0x05B6, 0x003D, 0x05F0, 0x003C, 0x062D, 0x003D, 
	0x0669, 0x003D, 0x06A6, 0x0001, 0x06E3, 0x0001, 0x06E4, 0x0001, 0x06E5, 
	0x003D, 0x06E6, 0x003D, 0x0723, 0x003D, 0x0760, 0x0038, 0x079D, 0x003B, 
	0x07D5, 0x003D, 0x0810, 0x003D, 0x084D, 0x003D, 0x088A, 0x003D, 0x08C7, 
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_FAST_LONGJUMP], 0, 189, 0, 20, 20, {
	0x0000, 0x00AF, 0x00AD, 0x00AC, 0x00AA, 0x00A9, 0x00A8, 0x00A6, 0x00A5, 
	0x00A4, 0x00A2, 0x00A1, 0x00A0, 0x009E, 0x009D, 0x009B, 0x009A, 0x0099, 
	0x0097, 0x0096, 0x0095, 0x0091, 0xFFDD, 0x0000, 0x3FFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x4BC8, 0x455F, 0x3F5B, 0x3B73, 0x3960, 0x37B2, 0x365C, 0x3553, 
	0x348A, 0x33F5, 0x3389, 0x3339, 0x32F8, 0x3315, 0x33C1, 0x34C8, 0x35F4, 
	0x3712, 0x37EB, 0x386C, 0x394D, 0xFC7E, 0xFBC6, 0xFA10, 0xF804, 0xF64E, 
	0xF596, 0xF5D0, 0xF672, 0xF76D, 0xF8B1, 0xFA2D, 0xFBD1, 0xFD8D, 0xFF52, 
	0x010F, 0x02B3, 0x042F, 0x0573, 0x066E, 0x0710, 0x074A, 0x0606, 0x052F, 
	0x0329, 0x00B7, 0xFE9A, 0xFD94, 0xFD5D, 0xFD2E, 0xFD06, 0xFCE4, 0xFCC7, 
	0xFCB0, 0xFC9D, 0xFC8E, 0xFC83, 0xFC7C, 0xFC76, 0xFC73, 0xFC71, 0x0902, 
	0x0878, 0x0731, 0x05A9, 0x0461, 0x03D8, 0x0448, 0x0582, 0x0768, 0x09DA, 
	0x0CB9, 0x0FE6, 0x1342, 0x16AE, 0x1A0A, 0x1D37, 0x2016, 0x2288, 0x246E, 
	0x25A8, 0x2618, 0x0441, 0x04B0, 0x05B9, 0x06F5, 0x07FB, 0x08AA, 0x0928, 
	0x097C, 0x09AE, 0x09C9, 0x09D2, 0x09D4, 0x091F, 0x073A, 0x047D, 0x013E, 
	0xFDD2, 0xFA92, 0xF7D5, 0xF5F1, 0xF53C, 0xFC5A, 0xFC5C, 0xFC63, 0xFC76, 
	0xFC9C, 0xFCF6, 0xFD91, 0xFE50, 0xFF15, 0xFFC6, 0x0046, 0x0077, 0x0063, 
	0x002D, 0xFFDF, 0xFF83, 0xFF23, 0xFEC7, 0xFE7A, 0xFE44, 0xFE30, 0x048A, 
	0x0592, 0x07D5, 0x0A18, 0x0B1F, 0x0AA6, 0x0954, 0x074B, 0x04B2, 0x01AC, 
	0xFE5C, 0xFAE9, 0xF774, 0xF415, 0xF0E3, 0xEDF2, 0xEB59, 0xE92D, 0xE785, 
	0xE677, 0xE618, 0x0001, 0xFFFE, 0xC170, 0xD9F2, 0xD5D9, 0xCC8B, 0xC282, 
	0xBB32, 0xB5F3, 0xB116, 0xAAEC, 0xA1C6, 0x93F7, 0x00CF, 0xEBA4, 0xD8CF, 
	0xCCA5, 0xC645, 0xC1B3, 0xBEA3, 0xBCC7, 0xBBD3, 0xBB79, 0xBB6C, 0xE823, 
	0xE694, 0xE2FA, 0xDEF0, 0xDBC1, 0xD981, 0xD7F6, 0xD6E5, 0xD612, 0xD542, 
	0xABAF, 0xACA2, 0xAD5C, 0xADA7, 0xACE1, 0xAAE5, 0xA82D, 0xA538, 0xA280, 
	0xA084, 0x9FBF, 0xD2F0, 0xD572, 0xDBA2, 0xE380, 0xEB7B, 0xF3D1, 0xFD31, 
	0x084B, 0x15CD, 0x2667, 0xBA15, 0xCE15, 0xDEED, 0xE927, 0xEE22, 0xF1B3, 
	0xF417, 0xF58B, 0xF649, 0xF690, 0xF69A, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xF0A9, 
	0xEAB9, 0xDFB1, 0xD9C1, 0xDA40, 0xDB9A, 0xDD97, 0xE001, 0xE2A1, 0xE542, 
	0xE7AC, 0xE9A9, 0xEB02, 0xEB82, 0xE6CF, 0xE8BD, 0xF321, 0x0001, 0xFFFE, 
	0xC170, 0x1A25, 0x1CD3, 0x21CC, 0x2479, 0x1E4C, 0x0E44, 0xF81D, 0x5F97, 
	0x4870, 0x3666, 0x2C21, 0x27FA, 0x2733, 0x2775, 0x2824, 0x291C, 0x2A37, 
	0x2B52, 0x2C4A, 0x2CF8, 0x2D3B, 0x2215, 0x2578, 0x2BC1, 0x2F24, 0x2F1D, 
	0x2EF8, 0x2E98, 0x521D, 0x5342, 0x54F3, 0x5721, 0x5915, 0x59ED, 0x59AD, 
	0x5904, 0x5814, 0x5702, 0x55F0, 0x5500, 0x5457, 0x5417, 0xCED8, 0xCE96, 
	0xCCCA, 0xC7E9, 0xBB7C, 0xA718, 0x8F4E, 0xF8AB, 0xE7BE, 0xE117, 0xE240, 
	0xE4E6, 0xE7C5, 0xEA06, 0xEBB8, 0xECEF, 0xEDC0, 0xEE3E, 0xEE7F, 0xEE97, 
	0xEE9B, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xEE1C, 
	0xE788, 0xDB50, 0xD4BC, 0xD59B, 0xD7F2, 0xDB56, 0xDF5A, 0xE393, 0xE798, 
	0xEAFB, 0xED52, 0xEE31, 0x1DA9, 0x184A, 0xF971, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0xBF5E, 0x01CA, 0x03A1, 0x0506, 0x054C, 0x044D, 0x030B, 
	0x0214, 0x015D, 0x00DF, 0x0090, 0x0067, 0x005C, 0x00EF, 0x0279, 0x04B4, 
	0x0759, 0x0A21, 0x0CC6, 0x0F00, 0x108B, 0x111E, 0xF961, 0xF9F6, 0xFA8D, 
	0xFB04, 0xFB65, 0xFB65, 0xFB63, 0xFB5F, 0xFB57, 0xFB4A, 0xFB36, 0xFB1B, 
	0xFAA5, 0xF9A0, 0xF835, 0xF68F, 0xF4D8, 0xF338, 0xF1DC, 0xF0EC, 0xF093, 
	0x91B0, 0x8615, 0x7D63, 0x7BFA, 0x82D9, 0x8BD2, 0x9318, 0x98C8, 0x9D01, 
	0x9FE1, 0xA184, 0xA20A, 0xA13F, 0x9F21, 0x9C0F, 0x986C, 0x9498, 0x90F5, 
	0x8DE3, 0x8BC5, 0x8AFA, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x4EF3, 
	0x5039, 0x529A, 0x526D, 0x4C1D, 0x48EA, 0x46A6, 0x4527, 0x4440, 0x43C6, 
	0x438F, 0x436E, 0x4341, 0x4304, 0x42BE, 0x4274, 0x422C, 0x41EA, 0x41B4, 
	0x418F, 0x4182, 0xFBC2, 0xFC08, 0xFC44, 0xFC61, 0xFC61, 0xFC60, 0xFC5F, 
	0xFC5C, 0xFC5A, 0xFC57, 0xFC56, 0xFC55, 0xFC5B, 0xFC6C, 0xFC85, 0xFCA2, 
	0xFCC1, 0xFCDE, 0xFCF7, 0xFD08, 0xFD0E, 0x00DA, 0x01AE, 0x0267, 0x02C5, 
	0x02CE, 0x02CD, 0x02C9, 0x02C5, 0x02C0, 0x02BC, 0x02B8, 0x02B7, 0x02BC, 
	0x02C8, 0x02DA, 0x02F0, 0x0306, 0x031B, 0x032D, 0x033A, 0x033F, 0xBFB4, 
	0xC7A2, 0xCE8C, 0xD20A, 0xD253, 0xD246, 0xD226, 0xD1F9, 0xD1C8, 0xD19B, 
	0xD17A, 0xD16D, 0xD1B3, 0xD26F, 0xD380, 0xD4C2, 0xD616, 0xD759, 0xD869, 
	0xD925, 0xD96B, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xBF5E, 0xFE68, 
	0xFE91, 0xFEB0, 0xFEB4, 0xFE99, 0xFE6C, 0xFE34, 0xFDF8, 0xFDC2, 0xFD98, 
	0xFD7C, 0xFD76, 0xFD6A, 0xFD35, 0xFCD4, 0xFC59, 0xFBD1, 0xFB4D, 0xFADB, 
	0xFA8C, 0xFA6E, 0x01C7, 0x0211, 0x0243, 0x023D, 0x01F4, 0x017D, 0x00EF, 
	0x005E, 0xFFDE, 0xFF85, 0xFF6E, 0xFF72, 0xFF8E, 0x0024, 0x015E, 0x0303, 
	0x04DB, 0x06AD, 0x0840, 0x095C, 0x09C7, 0x9DA7, 0xAB79, 0xB6FC, 0xBBA8, 
	0xB877, 0xB0B2, 0xA645, 0x9B1E, 0x912C, 0x8A5D, 0x885C, 0x88DE, 0x89E5, 
	0x8AD6, 0x8B96, 0x8C2A, 0x8C97, 0x8CE2, 0x8D12, 0x8D2A, 0x8D31, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x4B9E, 0x4361, 0x3C3D, 0x38BB, 0x39B9, 
	0x3D77, 0x428D, 0x4798, 0x4B2F, 0x4BEF, 0x4732, 0x4168, 0x3DE5, 0x3C00, 
	0x3A94, 0x3990, 0x38E1, 0x3877, 0x3840, 0x382C, 0x3829, 0xFD0B, 0xFCA0, 
	0xFC41, 0xFC0E, 0xFC0A, 0xFC1F, 0xFC44, 0xFC70, 0xFC9B, 0xFCBD, 0xFCD8, 
	0xFCEB, 0xFCF2, 0xFCE9, 0xFCD1, 0xFCAF, 0xFC88, 0xFC61, 0xFC3F, 0xFC27, 
	0xFC1E, 0xFDB3, 0xFE6C, 0xFF0E, 0xFF61, 0xFF5F, 0xFF31, 0xFEE6, 0xFE8D, 
	0xFE38, 0xFDF4, 0xFDBD, 0xFD97, 0xFD88, 0xFDAD, 0xFE10, 0xFE9A, 0xFF3A, 
	0xFFD9, 0x0065, 0x00C7, 0x00EC, 0xC3B8, 0xCC70, 0xD41A, 0xD818, 0xD81C, 
	0xD610, 0xD2AE, 0xCEAF, 0xCACC, 0xC7BE, 0xC543, 0xC38A, 0xC2E5, 0xC47C, 
	0xC8AD, 0xCE9A, 0xD565, 0xDC30, 0xE21D, 0xE64E, 0xE7E5, 
},
{
	0x0001, 0x0000, 0x0015, 0x0001, 0x0001, 0x0016, 0x0001, 0x0017, 0x0001, 
	0x0018, 0x0001, 0x0019, 0x0011, 0x001A, 0x0015, 0x002B, 0x0015, 0x0040, 
	0x0015, 0x0055, 0x0013, 0x006A, 0x0015, 0x007D, 0x0015, 0x0092, 0x0015, 
	0x00A7, 0x0015, 0x00BC, 0x0001, 0x00D1, 0x0001, 0x00D2, 0x0001, 0x00D3, 
	0x0015, 0x00D4, 0x0015, 0x00E9, 0x0015, 0x00FE, 0x000B, 0x0113, 0x0001, 
	0x011E, 0x000E, 0x011F, 0x0001, 0x012D, 0x0001, 0x012E, 0x0001, 0x012F, 
	0x0001, 0x0130, 0x0001, 0x0131, 0x0001, 0x0132, 0x0015, 0x0133, 0x0015, 
	0x0148, 0x0015, 0x015D, 0x0005, 0x0172, 0x0014, 0x0177, 0x000D, 0x018B, 
	0x0001, 0x0198, 0x0001, 0x0199, 0x0001, 0x019A, 0x0015, 0x019B, 0x0014, 
	0x01B0, 0x0001, 0x01C4, 0x0015, 0x01C5, 0x0015, 0x01DA, 0x0015, 0x01EF, 
	0x0015, 0x0204, 0x0014, 0x0219, 0x0015, 0x022D, 0x0015, 0x0242, 0x0015, 
	0x0257, 0x0015, 0x026C, 0x0015, 0x0281, 0x0014, 0x0296, 0x0001, 0x02AA, 
	0x0015, 0x02AB, 0x0015, 0x02C0, 0x0015, 0x02D5, 0x000D, 0x02EA, 0x0013, 
	0x02F7, 0x0015, 0x030A, 0x0015, 0x031F, 0x0015, 0x0334, 0x0015, 0x0349, 
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_BREAKDANCE], 0, 189, 0, 0, 25, {
	0x0000, 0x00AA, 0x00AA, 0x00AA, 0x00A6, 0x009B, 0x008E, 0x0084, 0x007F, 
	0x007F, 0x007F, 0x007F, 0x007F, 0x007F, 0x007F, 0x0080, 0x0082, 0x0086, 
	0x008A, 0x008F, 0x0095, 0x009A, 0x009F, 0x00A3, 0x00A7, 0x00A9, 0x00AA, 
	0x0000, 0x0000, 0x3FFF, 0x0000, 0xFFFF, 0xFFFF, 0x40A1, 0xF921, 0xF8F7, 
	0xFA16, 0xFC8C, 0xFF02, 0x0022, 0x0021, 0x001F, 0x001D, 0x001B, 0x001A, 
	0x0018, 0x0016, 0x0015, 0x0013, 0x0011, 0x000F, 0x000D, 0x000B, 0x0009, 
	0x0006, 0x0004, 0x0003, 0x0001, 0x0000, 0xFFA3, 0xFC8E, 0xFD13, 0xFE37, 
	0xFF5E, 0xFFE8, 0xFFED, 0xFFEF, 0xFFEF, 0xFFF0, 0xFFF0, 0xFFF1, 0xFFF2, 
	0xFFF3, 0xFFF5, 0xFFF6, 0xFFF7, 0xFFF8, 0xFFFA, 0xFFFB, 0xFFFC, 0xFFFD, 
	0xFFFE, 0xFFFE, 0xFFFF, 0xF4D8, 0xEE64, 0xF44C, 0x01D8, 0x10C8, 0x1ADA, 
	0x1EC3, 0x2034, 0x2068, 0x2067, 0x2060, 0x204A, 0x2021, 0x1FDD, 0x1F78, 
	0x1EEB, 0x1E2E, 0x1CC7, 0x1A70, 0x1773, 0x141E, 0x10BA, 0x0D93, 0x0AF6, 
	0x092D, 0x0884, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xF57B, 0xEFF8, 0xE3D8, 0xD7B8, 0xD235, 0xD7E9, 0xE280, 0xE834, 0xE5CD, 
	0xE157, 0xDEF0, 0xDEF0, 0xDEF0, 0xDEF0, 0xDEF0, 0xDEF0, 0xDEF0, 0xDFF2, 
	0xE2A7, 0xE692, 0xEB37, 0xF01A, 0xF4BF, 0xF8AA, 0xFB5F, 0xFC61, 0xFFFE, 
	0x0001, 0xC170, 0xFB1C, 0xFB02, 0xFA4A, 0xF7B1, 0xF346, 0xEE6A, 0xEA7D, 
	0xE8E0, 0xE911, 0xE99A, 0xEA6F, 0xEB80, 0xECC2, 0xEE26, 0xEF9E, 0xF11E, 
	0xF29E, 0xF415, 0xF57D, 0xF6CD, 0xF7FF, 0xF90A, 0xF9E6, 0xFA8D, 0xFAF7, 
	0xFB1C, 0xD2DB, 0xCF52, 0xCBC9, 0xCD3D, 0xD0B3, 0xD4D5, 0xD84C, 0xD9C0, 
	0xD9AD, 0xD97A, 0xD92A, 0xD8C4, 0xD84B, 0xD7C5, 0xD737, 0xD6A6, 0xD615, 
	0xD587, 0xD4FF, 0xD47F, 0xD40B, 0xD3A5, 0xD351, 0xD312, 0xD2E9, 0xD2DB, 
	0xD4B3, 0xDDE7, 0xE71B, 0xE335, 0xD9E7, 0xCECD, 0xC57F, 0xC198, 0xC199, 
	0xC19B, 0xC1A1, 0xC1AD, 0xC1C0, 0xC1DD, 0xC205, 0xC29B, 0xC3E4, 0xC5B8, 
	0xC7EE, 0xCA5C, 0xCCDB, 0xCF41, 0xD166, 0xD320, 0xD448, 0xD4B3, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xCA4E, 0xC7CA, 0xC240, 0xBCB7, 
	0xBA33, 0xBA33, 0xBA33, 0xBA33, 0xBA33, 0xBA33, 0xBA33, 0xBA33, 0xBA33, 
	0xBA33, 0xBA33, 0xBA93, 0xBB9A, 0xBD23, 0xBF0A, 0xC128, 0xC359, 0xC577, 
	0xC75D, 0xC8E7, 0xC9EE, 0xCA4E, 0xFFFF, 0xFFC9, 0xFF51, 0xFEDA, 0xFEA3, 
	0xFEA6, 0xFEAC, 0xFEB7, 0xFEC5, 0xFED5, 0xFEE8, 0xFEFE, 0xFF14, 0xFF2C, 
	0xFF45, 0xFF5E, 0xFF76, 0xFF8E, 0xFFA5, 0xFFBA, 0xFFCD, 0xFFDE, 0xFFEC, 
	0xFFF6, 0xFFFD, 0x0000, 0xF97B, 0xFBD7, 0x0109, 0x0639, 0x0895, 0x087C, 
	0x0833, 0x07BF, 0x0726, 0x066C, 0x0597, 0x04AB, 0x03AE, 0x02A4, 0x0193, 
	0x007F, 0xFF6C, 0xFE62, 0xFD65, 0xFC79, 0xFBA4, 0xFAEA, 0xFA51, 0xF9DE, 
	0xF994, 0xF97B, 0xED8B, 0xEC70, 0xEA00, 0xE790, 0xE674, 0xE680, 0xE6A3, 
	0xE6D9, 0xE721, 0xE778, 0xE7DC, 0xE84B, 0xE8C2, 0xE93F, 0xE9BF, 0xEA40, 
	0xEAC1, 0xEB3E, 0xEBB5, 0xEC23, 0xEC87, 0xECDF, 0xED27, 0xED5D, 0xED7F, 
	0xED8B, 0xFFFE, 0x0001, 0xC170, 0x054B, 0x0563, 0x060B, 0x0877, 0x0C9D, 
	0x1130, 0x14E3, 0x1668, 0x163B, 0x15BA, 0x14F4, 0x13F4, 0x12C7, 0x117A, 
	0x1019, 0x0EB1, 0x0D49, 0x0BE8, 0x0A96, 0x095A, 0x083A, 0x073F, 0x066F, 
	0x05D2, 0x056E, 0x054B, 0x2BD6, 0x2D4E, 0x2EC6, 0x2DA2, 0x2AE8, 0x27A8, 
	0x24EE, 0x23CA, 0x23E0, 0x241C, 0x247A, 0x24F4, 0x2582, 0x261F, 0x26C5, 
	0x276F, 0x2818, 0x28BE, 0x295C, 0x29F0, 0x2A77, 0x2AEC, 0x2B4E, 0x2B97, 
	0x2BC6, 0x2BD6, 0xCCF5, 0xD5E2, 0xDECF, 0xDA9B, 0xD094, 0xC49E, 0xBA98, 
	0xB664, 0xB665, 0xB66E, 0xB686, 0xB6B6, 0xB704, 0xB779, 0xB81C, 0xB934, 
	0xBAEA, 0xBD16, 0xBF92, 0xC237, 0xC4DE, 0xC760, 0xC997, 0xCB5C, 0xCC88, 
	0xCCF5, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xC7DC, 0xC6CB, 0xC472, 0xC219, 0xC108, 0xC108, 0xC108, 
	0xC108, 0xC108, 0xC108, 0xC108, 0xC108, 0xC108, 0xC108, 0xC108, 0xC131, 
	0xC1A0, 0xC247, 0xC315, 0xC3FB, 0xC4E9, 0xC5CF, 0xC69D, 0xC744, 0xC7B4, 
	0xC7DC, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFD3B, 0xF727, 0xF112, 0xEE4E, 0xEE6C, 0xEEC1, 0xEF49, 0xEFFC, 
	0xF0D6, 0xF1D0, 0xF2E4, 0xF40D, 0xF545, 0xF685, 0xF7C8, 0xF908, 0xFA40, 
	0xFB69, 0xFC7D, 0xFD77, 0xFE51, 0xFF04, 0xFF8C, 0xFFE1, 0xFFFF, 0xF548, 
	0xF334, 0xEEA1, 0xEA0E, 0xE7F9, 0xE810, 0xE850, 0xE8B6, 0xE93D, 0xE9E1, 
	0xEA9D, 0xEB6D, 0xEC4C, 0xED36, 0xEE27, 0xEF1A, 0xF00B, 0xF0F6, 0xF1D5, 
	0xF2A5, 0xF361, 0xF404, 0xF48B, 0xF4F1, 0xF532, 0xF548, 0xFFFF, 0x0000, 
	0xBF5E, 0xD649, 0xD649, 0xD649, 0xD710, 0xD8EB, 0xDB22, 0xDCFD, 0xDDC5, 
	0xDDC5, 0xDDC5, 0xDDC5, 0xDDC5, 0xDDC5, 0xDDC5, 0xDD9F, 0xDD37, 0xDC99, 
	0xDBD4, 0xDAF4, 0xDA07, 0xD91A, 0xD83A, 0xD774, 0xD6D7, 0xD66F, 0xD649, 
	0xEC40, 0xEC40, 0xEC40, 0xEADF, 0xE796, 0xE3AB, 0xE062, 0xDF01, 0xDF01, 
	0xDF01, 0xDF01, 0xDF01, 0xDF01, 0xDF01, 0xDF44, 0xDFFC, 0xE113, 0xE270, 
	0xE3FC, 0xE5A0, 0xE744, 0xE8D1, 0xEA2E, 0xEB45, 0xEBFD, 0xEC40, 0xB59D, 
	0xB59D, 0xB59D, 0xB459, 0xB153, 0xADB7, 0xAAB2, 0xA96D, 0xA96D, 0xA96D, 
	0xA96D, 0xA96D, 0xA96D, 0xA96D, 0xA9AA, 0xAA54, 0xAB55, 0xAC96, 0xAE03, 
	0xAF85, 0xB108, 0xB274, 0xB3B6, 0xB4B6, 0xB560, 0xB59D, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x2537, 0x2537, 0x2537, 0x28E9, 
	0x31BB, 0x3C41, 0x4512, 0x48C5, 0x48C5, 0x48C5, 0x48C5, 0x48C5, 0x48C5, 
	0x48C5, 0x4812, 0x4623, 0x4337, 0x3F8D, 0x3B65, 0x36FE, 0x3297, 0x2E6F, 
	0x2AC5, 0x27D9, 0x25EA, 0x2537, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xBF3F, 0xBF3F, 0xBF3F, 0xBD40, 0xB87D, 0xB2CE, 0xAE0B, 0xAC0C, 
	0xAC0C, 0xAC0C, 0xAC0C, 0xAC0C, 0xAC0C, 0xAC0C, 0xAC6D, 0xAD78, 0xAF0C, 
	0xB106, 0xB345, 0xB5A6, 0xB806, 0xBA45, 0xBC3F, 0xBDD3, 0xBEDF, 0xBF3F, 
	0xFFFF, 0x0000, 0xBF5E, 0x1B09, 0x1B09, 0x1B09, 0x1A20, 0x17F4, 0x155C, 
	0x1330, 0x1247, 0x1247, 0x1247, 0x1247, 0x1247, 0x1247, 0x1247, 0x1273, 
	0x12ED, 0x13A5, 0x148C, 0x1592, 0x16A8, 0x17BE, 0x18C4, 0x19AB, 0x1A63, 
	0x1ADD, 0x1B09, 0x1144, 0x1144, 0x1144, 0x1238, 0x147D, 0x1733, 0x1978, 
	0x1A6C, 0x1A6C, 0x1A6C, 0x1A6C, 0x1A6C, 0x1A6C, 0x1A6C, 0x1A3E, 0x19BE, 
	0x18FE, 0x180C, 0x16FA, 0x15D8, 0x14B6, 0x13A4, 0x12B2, 0x11F2, 0x1172, 
	0x1144, 0xAC43, 0xAC43, 0xAC43, 0xAA83, 0xA654, 0xA157, 0x9D29, 0x9B68, 
	0x9B68, 0x9B68, 0x9B68, 0x9B68, 0x9B68, 0x9B68, 0x9BBD, 0x9CA7, 0x9E0A, 
	0x9FC7, 0xA1BF, 0xA3D6, 0xA5EC, 0xA7E4, 0xA9A1, 0xAB04, 0xABEE, 0xAC43, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x1E4A, 0x1E4A, 0x1E4A, 
	0x21FC, 0x2ACE, 0x3554, 0x3E25, 0x41D8, 0x41D8, 0x41D8, 0x41D8, 0x41D8, 
	0x41D8, 0x41D8, 0x4125, 0x3F36, 0x3C4A, 0x38A0, 0x3478, 0x3011, 0x2BAA, 
	0x2782, 0x23D8, 0x20EC, 0x1EFD, 0x1E4A, 0xFFFF, 0xFFFF, 0xFFFF, 0x0009, 
	0x0020, 0x003B, 0x0052, 0x005B, 0x005B, 0x005B, 0x005B, 0x005B, 0x005B, 
	0x005B, 0x0059, 0x0054, 0x004D, 0x0044, 0x0039, 0x002E, 0x0022, 0x0018, 
	0x000E, 0x0007, 0x0002, 0xFFFF, 0xFF2F, 0xFF2F, 0xFF2F, 0xFF31, 0xFF36, 
	0xFF3D, 0xFF42, 0xFF44, 0xFF44, 0xFF44, 0xFF44, 0xFF44, 0xFF44, 0xFF44, 
	0xFF44, 0xFF43, 0xFF41, 0xFF3F, 0xFF3C, 0xFF3A, 0xFF37, 0xFF34, 0xFF32, 
	0xFF31, 0xFF2F, 0xC9D7, 0xC9D7, 0xC9D7, 0xC7EB, 0xC355, 0xBDDC, 0xB946, 
	0xB759, 0xB759, 0xB759, 0xB759, 0xB759, 0xB759, 0xB759, 0xB7B6, 0xB8B8, 
	0xBA3D, 0xBC25, 0xBE4E, 0xC098, 0xC2E3, 0xC50C, 0xC6F4, 0xC879, 0xC97A, 
	0xC9D7, 
},
{
	0x0001, 0x0000, 0x001A, 0x0001, 0x0001, 0x001B, 0x0001, 0x001C, 0x0001, 
	0x001D, 0x0001, 0x001E, 0x0001, 0x001F, 0x0001, 0x0020, 0x0001, 0x0021, 
	0x0019, 0x0022, 0x0019, 0x003B, 0x001A, 0x0054, 0x0004, 0x006E, 0x0003, 
	0x0072, 0x001A, 0x0075, 0x0001, 0x008F, 0x0001, 0x0090, 0x0001, 0x0091, 
	0x001A, 0x0092, 0x001A, 0x00AC, 0x001A, 0x00C6, 0x0019, 0x00E0, 0x001A, 
	0x00F9, 0x001A, 0x0113, 0x001A, 0x012D, 0x001A, 0x0147, 0x001A, 0x0161, 
	0x0001, 0x017B, 0x0001, 0x017C, 0x0001, 0x017D, 0x001A, 0x017E, 0x001A, 
	0x0198, 0x001A, 0x01B2, 0x0014, 0x01CC, 0x001A, 0x01E0, 0x001A, 0x01FA, 
	0x001A, 0x0214, 0x001A, 0x022E, 0x001A, 0x0248, 0x0001, 0x0262, 0x0001, 
	0x0263, 0x0001, 0x0264, 0x001A, 0x0265, 0x001A, 0x027F, 0x001A, 0x0299, 
	0x001A, 0x02B3, 0x001A, 0x02CD, 0x001A, 0x02E7, 0x0019, 0x0301, 0x001A, 
	0x031A, 0x001A, 0x0334, 0x0001, 0x034E, 0x0001, 0x034F, 0x0001, 0x0350, 
	0x001A, 0x0351, 0x001A, 0x036B, 0x001A, 0x0385, 0x0007, 0x039F, 0x001A, 
	0x03A6, 0x001A, 0x03C0, 0x001A, 0x03DA, 0x0019, 0x03F4, 0x001A, 0x040D, 	
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_STOP_CRAWLING], 0, 189, 0, 7, 7, {
	0x0000, 0x0081, 0x0080, 0x007D, 0x0078, 0x0073, 0x006E, 0x006A, 0x0069, 
	0xFFDD, 0x0000, 0x3FFF, 0x0000, 0xFDEA, 0xFE08, 0xFE54, 0xFEBC, 0xFF2D, 
	0xFF95, 0xFFE1, 0x0000, 0x0708, 0x06A4, 0x05A3, 0x0444, 0x02C4, 0x0165, 
	0x0064, 0xFFFF, 0x7431, 0x723C, 0x6D33, 0x664F, 0x5ECE, 0x57EA, 0x52E1, 
	0x50ED, 0x08F3, 0x0874, 0x072D, 0x056D, 0x0386, 0x01C6, 0x007F, 0xFFFF, 
	0xF48B, 0xF52E, 0xF6D1, 0xF90D, 0xFB7D, 0xFDBA, 0xFF5D, 0x0000, 0xEA40, 
	0xEC99, 0xF2A7, 0xFAEF, 0x03F5, 0x0C3D, 0x124B, 0x14A4, 0xF72E, 0xF7AB, 
	0xF8ED, 0xFAA6, 0xFC87, 0xFE3F, 0xFF82, 0x0000, 0x03CF, 0x0399, 0x030D, 
	0x024F, 0x0180, 0x00C1, 0x0036, 0x0000, 0xE3F9, 0xE385, 0xE25A, 0xE0C0, 
	0xDF02, 0xDD69, 0xDC3D, 0xDBC9, 0x0001, 0xFFFE, 0xC170, 0x0B54, 0x0EE1, 
	0x1809, 0x248D, 0xB231, 0xBEB6, 0xC7DE, 0xCB6A, 0xE6DF, 0xE5B6, 0xE2B7, 
	0xDE9F, 0xA5D6, 0xA9EE, 0xACED, 0xAE17, 0x9B41, 0x984D, 0x90AE, 0x8642, 
	0xFAE7, 0xF07C, 0xE8DD, 0xE5E8, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xCD91, 0xCD53, 0xCCB1, 0xCBD5, 0xCAE5, 0xCA08, 0xC967, 0xC929, 
	0x18A4, 0x16FB, 0x12B4, 0x0CDA, 0x067A, 0x00A0, 0xFC57, 0xFAAE, 0xF9F4, 
	0xF942, 0xF777, 0xF504, 0xF259, 0xEFE6, 0xEE1B, 0xED69, 0xE38D, 0xE47F, 
	0xE6EF, 0xEA45, 0xEDE7, 0xF13C, 0xF3AC, 0xF49E, 0x0001, 0xFFFE, 0xC170, 
	0xEFE2, 0xED24, 0xE610, 0xDC63, 0x51D9, 0x482C, 0x4118, 0x3E5A, 0x11CD, 
	0x1334, 0x16D3, 0x1BC7, 0x5ED3, 0x59E0, 0x5641, 0x54D9, 0x7D14, 0x7C27, 
	0x79C5, 0x7683, 0xF2F7, 0xEFB5, 0xED53, 0xEC67, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xE1F0, 0xE09E, 0xDD36, 0xD88E, 0xD37B, 
	0xCED3, 0xCB6B, 0xCA19, 0xED56, 0xEE7D, 0xF175, 0xF585, 0xF9F2, 0xFE02, 
	0x00FB, 0x0222, 0xFE52, 0xFF6C, 0x0246, 0x062A, 0x0A67, 0x0E4B, 0x1123, 
	0x123E, 0xEC69, 0xECF1, 0xEE4E, 0xF02B, 0xF234, 0xF411, 0xF56F, 0xF5F6, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xBF5E, 0xFD27, 
	0xFD2C, 0xFD3A, 0xFD4C, 0xFD60, 0xFD73, 0xFD81, 0xFD86, 0xE6A8, 0xE61A, 
	0xE4AB, 0xE2B6, 0xE093, 0xDE9E, 0xDD2F, 0xDCA1, 0x8E9A, 0x8D7D, 0x8A9E, 
	0x86B0, 0x8268, 0x7E7B, 0x7B9B, 0x7A7E, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x4FFE, 0x4FCA, 0x4F44, 0x4E8D, 0x4DC5, 0x4D0E, 0x4C88, 0x4C54, 0xF768, 
	0xF791, 0xF7FB, 0xF88B, 0xF928, 0xF9B9, 0xFA22, 0xFA4B, 0xF776, 0xF7F0, 
	0xF928, 0xFAD2, 0xFCA3, 0xFE4E, 0xFF86, 0x0000, 0xD552, 0xD3DF, 0xD023, 
	0xCB08, 0xC577, 0xC05B, 0xBC9F, 0xBB2C, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0xBF5E, 0xFE93, 0xFEE4, 0xFFB5, 0x00D4, 0x020C, 
	0x032A, 0x03FB, 0x044C, 0x13FB, 0x14CA, 0x16DF, 0x19B9, 0x1CD4, 0x1FAE, 
	0x21C3, 0x2292, 0x9574, 0x93A1, 0x8EED, 0x887D, 0x817B, 0x7B0B, 0x7657, 
	0x7484, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x4C54, 0x4BEC, 
	0x4ADF, 0x4971, 0x47E1, 0x4672, 0x4566, 0x44FE, 0xFFFF, 0x0001, 0x0004, 
	0x0007, 0x000B, 0x000E, 0x0011, 0x0012, 0x03BB, 0x037C, 0x02DA, 0x01FB, 
	0x0109, 0x002B, 0xFF88, 0xFF49, 0xDA83, 0xD963, 0xD67B, 0xD282, 0xCE2E, 
	0xCA35, 0xC74D, 0xC62C, 
},
{
	0x0001, 0x0000, 0x0008, 0x0001, 0x0001, 0x0009, 0x0001, 0x000A, 0x0001, 
	0x000B, 0x0001, 0x000C, 0x0008, 0x000D, 0x0008, 0x0015, 0x0008, 0x001D, 
	0x0008, 0x0025, 0x0008, 0x002D, 0x0008, 0x0035, 0x0008, 0x003D, 0x0008, 
	0x0045, 0x0008, 0x004D, 0x0001, 0x0055, 0x0001, 0x0056, 0x0001, 0x0057, 
	0x0008, 0x0058, 0x0008, 0x0060, 0x0008, 0x0068, 0x0007, 0x0070, 0x0008, 
	0x0077, 0x0008, 0x007F, 0x0008, 0x0087, 0x0008, 0x008F, 0x0008, 0x0097, 
	0x0001, 0x009F, 0x0001, 0x00A0, 0x0001, 0x00A1, 0x0008, 0x00A2, 0x0008, 
	0x00AA, 0x0008, 0x00B2, 0x0008, 0x00BA, 0x0008, 0x00C2, 0x0008, 0x00CA, 
	0x0008, 0x00D2, 0x0008, 0x00DA, 0x0008, 0x00E2, 0x0008, 0x00EA, 0x0008, 
	0x00F2, 0x0001, 0x00FA, 0x0008, 0x00FB, 0x0008, 0x0103, 0x0008, 0x010B, 
	0x0008, 0x0113, 0x0005, 0x011B, 0x0008, 0x0120, 0x0008, 0x0128, 0x0008, 
	0x0130, 0x0008, 0x0138, 0x0008, 0x0140, 0x0008, 0x0148, 0x0001, 0x0150, 
	0x0008, 0x0151, 0x0008, 0x0159, 0x0008, 0x0161, 0x0001, 0x0169, 0x0005, 
	0x016A, 0x0008, 0x016F, 0x0008, 0x0177, 0x0008, 0x017F, 0x0008, 0x0187, 
	
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_START_CRAWLING], 0, 189, 0, 7, 7, {
	0x0000, 0x0069, 0x006A, 0x006E, 0x0073, 0x0078, 0x007D, 0x0080, 0x0081, 
	0xFFDD, 0x0000, 0x3FFF, 0x0000, 0x0000, 0xFFE1, 0xFF95, 0xFF2D, 0xFEBC, 
	0xFE54, 0xFE08, 0xFDEA, 0xFFFF, 0x0064, 0x0165, 0x02C4, 0x0444, 0x05A3, 
	0x06A4, 0x0708, 0x50ED, 0x52E1, 0x57EA, 0x5ECE, 0x664F, 0x6D33, 0x723C, 
	0x7431, 0xFFFF, 0x007F, 0x01C6, 0x0386, 0x056D, 0x072D, 0x0874, 0x08F3, 
	0x0000, 0xFF5D, 0xFDBA, 0xFB7D, 0xF90D, 0xF6D1, 0xF52E, 0xF48B, 0x14A4, 
	0x124B, 0x0C3D, 0x03F5, 0xFAEF, 0xF2A7, 0xEC99, 0xEA40, 0x0000, 0xFF82, 
	0xFE3F, 0xFC87, 0xFAA6, 0xF8ED, 0xF7AB, 0xF72E, 0x0000, 0x0036, 0x00C1, 
	0x0180, 0x024F, 0x030D, 0x0399, 0x03CF, 0xDBC9, 0xDC3D, 0xDD69, 0xDF02, 
	0xE0C0, 0xE25A, 0xE385, 0xE3F9, 0x0001, 0xFFFE, 0xC170, 0xCB6A, 0xC7DE, 
	0xBEB6, 0xB231, 0x248E, 0x1809, 0x0EE1, 0x0B54, 0xAE17, 0xACED, 0xA9EE, 
	0xA5D6, 0xDE9F, 0xE2B7, 0xE5B6, 0xE6DF, 0xE5E8, 0xE8DD, 0xF07C, 0xFAE7, 
	0x8642, 0x90AE, 0x984D, 0x9B41, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xC929, 0xC967, 0xCA08, 0xCAE5, 0xCBD5, 0xCCB1, 0xCD53, 0xCD91, 
	0xFAAE, 0xFC57, 0x00A0, 0x067A, 0x0CDA, 0x12B4, 0x16FB, 0x18A4, 0xED69, 
	0xEE1B, 0xEFE6, 0xF259, 0xF504, 0xF777, 0xF942, 0xF9F4, 0xF49E, 0xF3AC, 
	0xF13C, 0xEDE7, 0xEA45, 0xE6EF, 0xE47F, 0xE38D, 0x0001, 0xFFFE, 0xC170, 
	0x3E5A, 0x4118, 0x482C, 0x51D9, 0xDC63, 0xE610, 0xED24, 0xEFE2, 0x54D9, 
	0x5641, 0x59E0, 0x5ED3, 0x1BC7, 0x16D3, 0x1334, 0x11CD, 0xEC67, 0xED53, 
	0xEFB5, 0xF2F7, 0x7683, 0x79C5, 0x7C27, 0x7D14, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xCA19, 0xCB6B, 
	0xCED3, 0xD37B, 0xD88E, 0xDD36, 0xE09E, 0xE1F0, 0x0222, 0x00FB, 0xFE02, 
	0xF9F2, 0xF585, 0xF175, 0xEE7D, 0xED56, 0x123E, 0x1123, 0x0E4B, 0x0A67, 
	0x062A, 0x0246, 0xFF6C, 0xFE52, 0xF5F6, 0xF56F, 0xF411, 0xF234, 0xF02B, 
	0xEE4E, 0xECF1, 0xEC69, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xBF5E, 
	0xFD86, 0xFD81, 0xFD73, 0xFD60, 0xFD4C, 0xFD3A, 0xFD2C, 0xFD27, 0xDCA1, 
	0xDD2F, 0xDE9E, 0xE093, 0xE2B6, 0xE4AB, 0xE61A, 0xE6A8, 0x7A7E, 0x7B9B, 
	0x7E7B, 0x8268, 0x86B0, 0x8A9E, 0x8D7D, 0x8E9A, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x4C54, 0x4C88, 0x4D0E, 0x4DC5, 0x4E8D, 0x4F44, 0x4FCA, 0x4FFE, 
	0xFA4B, 0xFA22, 0xF9B9, 0xF928, 0xF88B, 0xF7FB, 0xF791, 0xF768, 0x0000, 
	0xFF86, 0xFE4E, 0xFCA3, 0xFAD2, 0xF928, 0xF7F0, 0xF776, 0xBB2C, 0xBC9F, 
	0xC05B, 0xC577, 0xCB08, 0xD023, 0xD3DF, 0xD552, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0xBF5E, 0x044C, 0x03FB, 0x032A, 0x020C, 0x00D4, 0xFFB5, 
	0xFEE4, 0xFE93, 0x2292, 0x21C3, 0x1FAE, 0x1CD4, 0x19B9, 0x16DF, 0x14CA, 
	0x13FB, 0x7484, 0x7657, 0x7B0B, 0x817B, 0x887D, 0x8EED, 0x93A1, 0x9574, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x44FE, 0x4566, 0x4672, 0x47E1, 
	0x4971, 0x4ADF, 0x4BEC, 0x4C54, 0x0012, 0x0011, 0x000E, 0x000B, 0x0007, 
	0x0004, 0x0001, 0xFFFF, 0xFF49, 0xFF88, 0x002B, 0x0109, 0x01FB, 0x02DA, 
	0x037C, 0x03BB, 0xC62C, 0xC74D, 0xCA35, 0xCE2E, 0xD282, 0xD67B, 0xD963, 
	0xDA83, 
},
{
	0x0001, 0x0000, 0x0008, 0x0001, 0x0001, 0x0009, 0x0001, 0x000A, 0x0001, 
	0x000B, 0x0001, 0x000C, 0x0008, 0x000D, 0x0008, 0x0015, 0x0008, 0x001D, 
	0x0008, 0x0025, 0x0008, 0x002D, 0x0008, 0x0035, 0x0008, 0x003D, 0x0008, 
	0x0045, 0x0008, 0x004D, 0x0001, 0x0055, 0x0001, 0x0056, 0x0001, 0x0057, 
	0x0008, 0x0058, 0x0008, 0x0060, 0x0008, 0x0068, 0x0007, 0x0070, 0x0008, 
	0x0077, 0x0008, 0x007F, 0x0008, 0x0087, 0x0008, 0x008F, 0x0008, 0x0097, 
	0x0001, 0x009F, 0x0001, 0x00A0, 0x0001, 0x00A1, 0x0008, 0x00A2, 0x0008, 
	0x00AA, 0x0008, 0x00B2, 0x0007, 0x00BA, 0x0003, 0x00C1, 0x0008, 0x00C4, 
	0x0008, 0x00CC, 0x0008, 0x00D4, 0x0008, 0x00DC, 0x0008, 0x00E4, 0x0006, 
	0x00EC, 0x0001, 0x00F2, 0x0008, 0x00F3, 0x0008, 0x00FB, 0x0008, 0x0103, 
	0x0006, 0x010B, 0x0007, 0x0111, 0x0008, 0x0118, 0x0008, 0x0120, 0x0008, 
	0x0128, 0x0008, 0x0130, 0x0008, 0x0138, 0x0006, 0x0140, 0x0001, 0x0146, 
	0x0008, 0x0147, 0x0008, 0x014F, 0x0008, 0x0157, 0x0006, 0x015F, 0x0008, 
	0x0165, 0x0008, 0x016D, 0x0008, 0x0175, 0x0008, 0x017D, 0x0008, 0x0185, 
	
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_CRAWLING], 0, 189, 0, 0, 91, {
	0x0000, 0x0081, 0xFFDD, 0x0000, 0x3FFF, 0x0000, 0xFDEA, 0xFDEA, 0xFDEA, 
	0xFDEA, 0xFDEC, 0xFDF1, 0xFDF9, 0xFE05, 0xFE13, 0xFE25, 0xFE38, 0xFE4F, 
	0xFE67, 0xFE82, 0xFE9F, 0xFEBD, 0xFEDD, 0xFEFF, 0xFF22, 0xFF46, 0xFF6B, 
	0xFF91, 0xFFB7, 0xFFDE, 0x0006, 0x002D, 0x0055, 0x007C, 0x00A3, 0x00C9, 
	0x00EF, 0x0114, 0x0138, 0x015B, 0x017D, 0x019D, 0x01BB, 0x01D8, 0x01F3, 
	0x020C, 0x0222, 0x0236, 0x0247, 0x0256, 0x0261, 0x026A, 0x026F, 0x0271, 
	0x026F, 0x026A, 0x0261, 0x0256, 0x0247, 0x0236, 0x0222, 0x020C, 0x01F3, 
	0x01D8, 0x01BB, 0x019D, 0x017D, 0x015B, 0x0138, 0x0114, 0x00EF, 0x00C9, 
	0x00A3, 0x007C, 0x0055, 0x002D, 0x0006, 0xFFDE, 0xFFB7, 0xFF91, 0xFF6B, 
	0xFF46, 0xFF22, 0xFEFF, 0xFEDD, 0xFEBD, 0xFE9F, 0xFE82, 0xFE67, 0xFE4F, 
	0xFE38, 0xFE25, 0xFE13, 0xFE05, 0xFDF9, 0xFDF1, 0xFDEC, 0xFDEA, 0x0708, 
	0x0708, 0x0708, 0x0708, 0x0702, 0x06F1, 0x06D4, 0x06AD, 0x067D, 0x0642, 
	0x05FF, 0x05B4, 0x0561, 0x0507, 0x04A7, 0x0440, 0x03D4, 0x0363, 0x02ED, 
	0x0274, 0x01F7, 0x0178, 0x00F6, 0x0073, 0xFFEF, 0xFF6A, 0xFEE5, 0xFE60, 
	0xFDDD, 0xFD5B, 0xFCDC, 0xFC5F, 0xFBE6, 0xFB71, 0xFAFF, 0xFA93, 0xFA2D, 
	0xF9CC, 0xF972, 0xF91F, 0xF8D4, 0xF891, 0xF857, 0xF826, 0xF7FF, 0xF7E2, 
	0xF7D1, 0xF7CB, 0xF7D1, 0xF7E2, 0xF7FF, 0xF826, 0xF857, 0xF891, 0xF8D4, 
	0xF91F, 0xF972, 0xF9CC, 0xFA2D, 0xFA93, 0xFAFF, 0xFB71, 0xFBE6, 0xFC5F, 
	0xFCDC, 0xFD5B, 0xFDDD, 0xFE60, 0xFEE5, 0xFF6A, 0xFFEF, 0x0073, 0x00F6, 
	0x0178, 0x01F7, 0x0274, 0x02ED, 0x0363, 0x03D4, 0x0440, 0x04A7, 0x0507, 
	0x0561, 0x05B4, 0x05FF, 0x0642, 0x067D, 0x06AD, 0x06D4, 0x06F1, 0x0702, 
	0x0708, 0x7431, 0x7431, 0x7431, 0x7431, 0x7431, 0x7431, 0x7431, 0x7431, 
	0x7430, 0x7430, 0x7430, 0x7430, 0x742F, 0x742F, 0x742E, 0x742E, 0x742D, 
	0x742D, 0x742C, 0x742C, 0x742B, 0x742B, 0x742A, 0x742A, 0x7429, 0x7429, 
	0x7428, 0x7427, 0x7427, 0x7426, 0x7426, 0x7425, 0x7425, 0x7424, 0x7424, 
	0x7423, 0x7423, 0x7422, 0x7422, 0x7422, 0x7421, 0x7421, 0x7421, 0x7420, 
	0x7420, 0x7420, 0x7420, 0x7420, 0x7420, 0x7420, 0x7420, 0x7420, 0x7421, 
	0x7421, 0x7421, 0x7422, 0x7422, 0x7422, 0x7423, 0x7423, 0x7424, 0x7424, 
	0x7425, 0x7425, 0x7426, 0x7426, 0x7427, 0x7427, 0x7428, 0x7429, 0x7429, 
	0x742A, 0x742A, 0x742B, 0x742B, 0x742C, 0x742C, 0x742D, 0x742D, 0x742E, 
	0x742E, 0x742F, 0x742F, 0x7430, 0x7430, 0x7430, 0x7430, 0x7431, 0x08F3, 
	0x08EC, 0x08D8, 0x08B7, 0x088A, 0x0852, 0x080E, 0x07C1, 0x076A, 0x070A, 
	0x06A2, 0x0632, 0x05BB, 0x053D, 0x04BA, 0x0431, 0x03A4, 0x0312, 0x027E, 
	0x01E6, 0x014C, 0x00B1, 0x0015, 0xFF77, 0xFEDB, 0xFE40, 0xFDA6, 0xFD0E, 
	0xFC7A, 0xFBE8, 0xFB5B, 0xFAD2, 0xFA4F, 0xF9D1, 0xF95A, 0xF8EA, 0xF882, 
	0xF822, 0xF7CB, 0xF77E, 0xF73A, 0xF702, 0xF6D5, 0xF6B4, 0xF6A0, 0xF699, 
	0xF6A0, 0xF6B3, 0xF6D3, 0xF6FE, 0xF734, 0xF774, 0xF7BF, 0xF812, 0xF86E, 
	0xF8D3, 0xF93F, 0xF9B1, 0xFA2B, 0xFAAA, 0xFB2E, 0xFBB7, 0xFC43, 0xFCD4, 
	0xFD67, 0xFDFD, 0xFE94, 0xFF2C, 0xFFC5, 0x0060, 0x00F8, 0x018F, 0x0225, 
	0x02B8, 0x0348, 0x03D5, 0x045E, 0x04E2, 0x0561, 0x05DB, 0x064D, 0x06B9, 
	0x071E, 0x077A, 0x07CD, 0x0818, 0x0858, 0x088E, 0x08B9, 0x08D9, 0x08EC, 
	0x08F3, 0xF48B, 0xF492, 0xF4A6, 0xF4C6, 0xF4F2, 0xF52A, 0xF56C, 0xF5B8, 
	0xF60E, 0xF66C, 0xF6D2, 0xF741, 0xF7B6, 0xF831, 0xF8B3, 0xF939, 0xF9C4, 
	0xFA53, 0xFAE5, 0xFB7B, 0xFC12, 0xFCAB, 0xFD44, 0xFDDE, 0xFE78, 0xFF11, 
	0xFFA8, 0x003E, 0x00D0, 0x015F, 0x01EA, 0x0271, 0x02F2, 0x036E, 0x03E3, 
	0x0451, 0x04B7, 0x0516, 0x056B, 0x05B7, 0x05F9, 0x0631, 0x065D, 0x067D, 
	0x0691, 0x0698, 0x0691, 0x067E, 0x0660, 0x0635, 0x0600, 0x05C1, 0x0578, 
	0x0525, 0x04CB, 0x0468, 0x03FE, 0x038D, 0x0316, 0x0299, 0x0217, 0x0190, 
	0x0105, 0x0077, 0xFFE6, 0xFF53, 0xFEBE, 0xFE28, 0xFD91, 0xFCFB, 0xFC65, 
	0xFBD0, 0xFB3D, 0xFAAC, 0xFA1E, 0xF993, 0xF90D, 0xF88B, 0xF80E, 0xF797, 
	0xF726, 0xF6BB, 0xF659, 0xF5FE, 0xF5AC, 0xF563, 0xF523, 0xF4EE, 0xF4C4, 
	0xF4A5, 0xF492, 0xF48B, 0xEA40, 0xEA41, 0xEA42, 0xEA44, 0xEA47, 0xEA4A, 
	0xEA4F, 0xEA53, 0xEA59, 0xEA5F, 0xEA65, 0xEA6C, 0xEA74, 0xEA7B, 0xEA84, 
	0xEA8C, 0xEA95, 0xEA9E, 0xEAA7, 0xEAB1, 0xEABA, 0xEAC4, 0xEACE, 0xEAD7, 
	0xEAE1, 0xEAEB, 0xEAF4, 0xEAFE, 0xEB07, 0xEB10, 0xEB19, 0xEB21, 0xEB29, 
	0xEB31, 0xEB39, 0xEB40, 0xEB46, 0xEB4C, 0xEB52, 0xEB56, 0xEB5B, 0xEB5E, 
	0xEB61, 0xEB63, 0xEB64, 0xEB65, 0xEB64, 0xEB63, 0xEB61, 0xEB5E, 0xEB5B, 
	0xEB57, 0xEB52, 0xEB4D, 0xEB47, 0xEB41, 0xEB3A, 0xEB33, 0xEB2C, 0xEB24, 
	0xEB1C, 0xEB13, 0xEB0A, 0xEB01, 0xEAF8, 0xEAEF, 0xEAE5, 0xEADC, 0xEAD2, 
	0xEAC9, 0xEABF, 0xEAB6, 0xEAAD, 0xEAA4, 0xEA9B, 0xEA92, 0xEA89, 0xEA81, 
	0xEA79, 0xEA72, 0xEA6A, 0xEA64, 0xEA5E, 0xEA58, 0xEA53, 0xEA4E, 0xEA4A, 
	0xEA47, 0xEA44, 0xEA42, 0xEA41, 0xEA40, 0xF72E, 0xF732, 0xF73F, 0xF753, 
	0xF76F, 0xF793, 0xF7BD, 0xF7EE, 0xF825, 0xF861, 0xF8A3, 0xF8EA, 0xF936, 
	0xF985, 0xF9D9, 0xFA30, 0xFA8A, 0xFAE7, 0xFB47, 0xFBA8, 0xFC0B, 0xFC6F, 
	0xFCD4, 0xFD3A, 0xFD9F, 0xFE05, 0xFE69, 0xFECC, 0xFF2E, 0xFF8E, 0xFFEB, 
	0x0046, 0x009D, 0x00F0, 0x013F, 0x0189, 0x01CE, 0x020E, 0x0248, 0x027B, 
	0x02A8, 0x02CD, 0x02EB, 0x0301, 0x030F, 0x0313, 0x0310, 0x0305, 0x02F4, 
	0x02DC, 0x02BD, 0x0299, 0x026F, 0x023F, 0x020A, 0x01D1, 0x0192, 0x0150, 
	0x0109, 0x00BE, 0x0070, 0x001E, 0xFFC8, 0xFF71, 0xFF17, 0xFEBA, 0xFE5C, 
	0xFDFC, 0xFD9A, 0xFD38, 0xFCD4, 0xFC70, 0xFC0C, 0xFBA8, 0xFB45, 0xFAE3, 
	0xFA84, 0xFA26, 0xF9CC, 0xF975, 0xF922, 0xF8D4, 0xF88B, 0xF847, 0xF809, 
	0xF7D2, 0xF7A2, 0xF779, 0xF759, 0xF741, 0xF733, 0xF72E, 0x03CF, 0x03CE, 
	0x03CB, 0x03C6, 0x03C0, 0x03B9, 0x03B0, 0x03A6, 0x039B, 0x038F, 0x0382, 
	0x0375, 0x0367, 0x0359, 0x034A, 0x033C, 0x032D, 0x031F, 0x0311, 0x0303, 
	0x02F6, 0x02E9, 0x02DD, 0x02D3, 0x02C9, 0x02C0, 0x02B7, 0x02B0, 0x02A9, 
	0x02A3, 0x029E, 0x0299, 0x0295, 0x0292, 0x028F, 0x028C, 0x028A, 0x0289, 
	0x0287, 0x0286, 0x0285, 0x0285, 0x0284, 0x0284, 0x0284, 0x0284, 0x0284, 
	0x0284, 0x0284, 0x0284, 0x0285, 0x0285, 0x0286, 0x0287, 0x0288, 0x028A, 
	0x028C, 0x028E, 0x0291, 0x0294, 0x0297, 0x029B, 0x02A0, 0x02A5, 0x02AB, 
	0x02B2, 0x02B9, 0x02C1, 0x02CA, 0x02D3, 0x02DD, 0x02E9, 0x02F5, 0x0302, 
	0x0310, 0x031F, 0x032E, 0x033D, 0x034D, 0x035C, 0x036B, 0x0379, 0x0387, 
	0x0394, 0x03A1, 0x03AC, 0x03B6, 0x03BE, 0x03C5, 0x03CA, 0x03CE, 0x03CF, 
	0xE3F9, 0xE3F3, 0xE3E2, 0xE3C8, 0xE3A4, 0xE378, 0xE346, 0xE30E, 0xE2D2, 
	0xE293, 0xE251, 0xE20E, 0xE1CB, 0xE18A, 0xE14A, 0xE10E, 0xE0D6, 0xE0A4, 
	0xE079, 0xE055, 0xE03A, 0xE029, 0xE023, 0xE029, 0xE03A, 0xE055, 0xE079, 
	0xE0A5, 0xE0D7, 0xE110, 0xE14D, 0xE18E, 0xE1D1, 0xE217, 0xE25C, 0xE2A1, 
	0xE2E5, 0xE326, 0xE363, 0xE39B, 0xE3CE, 0xE3FA, 0xE41E, 0xE439, 0xE44A, 
	0xE450, 0xE44B, 0xE43C, 0xE425, 0xE406, 0xE3E1, 0xE3B5, 0xE383, 0xE34D, 
	0xE314, 0xE2D8, 0xE299, 0xE259, 0xE219, 0xE1DA, 0xE19B, 0xE15F, 0xE125, 
	0xE0EF, 0xE0BE, 0xE092, 0xE06C, 0xE04D, 0xE036, 0xE028, 0xE023, 0xE029, 
	0xE03C, 0xE059, 0xE080, 0xE0B0, 0xE0E6, 0xE122, 0xE162, 0xE1A6, 0xE1EB, 
	0xE231, 0xE277, 0xE2BA, 0xE2FB, 0xE337, 0xE36D, 0xE39C, 0xE3C3, 0xE3E0, 
	0xE3F3, 0xE3F9, 0x0001, 0xFFFE, 0xC170, 0x0B54, 0x0B54, 0x0B54, 0x0B54, 
	0x0B58, 0x0B64, 0x0B78, 0x0B93, 0x0BB4, 0x0BDC, 0x0C09, 0x0C3C, 0x0C73, 
	0x0CAF, 0x0CEE, 0x0D30, 0x0D76, 0x0DBD, 0x0E07, 0x0E51, 0x0E9D, 0x0EE9, 
	0x0F35, 0x0F81, 0x0FCB, 0x1014, 0x105B, 0x10A0, 0x10E9, 0x113D, 0x119A, 
	0x11FF, 0x126A, 0x12D8, 0x134A, 0x13BB, 0x142C, 0x149B, 0x1504, 0x1568, 
	0x15C4, 0x1616, 0x165D, 0x1697, 0x16C3, 0x16DE, 0x16E7, 0x16DC, 0x16C3, 
	0x16A4, 0x167E, 0x1651, 0x161F, 0x15E8, 0x15AB, 0x1569, 0x1523, 0x14D9, 
	0x148C, 0x143B, 0x13E6, 0x1390, 0x1337, 0x12DB, 0x127F, 0x1221, 0x11C2, 
	0x1163, 0x1103, 0x10A3, 0x1044, 0x0FE6, 0x0F89, 0x0F2D, 0x0ED4, 0x0E7C, 
	0x0E28, 0x0DD6, 0x0D87, 0x0D3C, 0x0CF5, 0x0CB3, 0x0C75, 0x0C3C, 0x0C08, 
	0x0BDA, 0x0BB3, 0x0B91, 0x0B77, 0x0B64, 0x0B58, 0x0B54, 0xE6DF, 0xE6DF, 
	0xE6DF, 0xE6DF, 0xE6E8, 0xE702, 0xE72B, 0xE763, 0xE7A7, 0xE7F8, 0xE853, 
	0xE8B8, 0xE925, 0xE999, 0xEA13, 0xEA91, 0xEB13, 0xEB96, 0xEC1B, 0xEC9F, 
	0xED21, 0xEDA0, 0xEE1C, 0xEE92, 0xEF01, 0xEF69, 0xEFC8, 0xF01C, 0xF06D, 
	0xF0C1, 0xF118, 0xF170, 0xF1C9, 0xF220, 0xF277, 0xF2CA, 0xF31A, 0xF365, 
	0xF3AA, 0xF3E8, 0xF41F, 0xF44C, 0xF470, 0xF489, 0xF496, 0xF496, 0xF488, 
	0xF46B, 0xF442, 0xF413, 0xF3DC, 0xF3A0, 0xF35D, 0xF316, 0xF2C9, 0xF277, 
	0xF220, 0xF1C6, 0xF168, 0xF107, 0xF0A3, 0xF03D, 0xEFD4, 0xEF69, 0xEEFD, 
	0xEE90, 0xEE23, 0xEDB5, 0xED47, 0xECDA, 0xEC6D, 0xEC02, 0xEB98, 0xEB31, 
	0xEACB, 0xEA68, 0xEA09, 0xE9AD, 0xE954, 0xE900, 0xE8B1, 0xE866, 0xE821, 
	0xE7E1, 0xE7A8, 0xE775, 0xE749, 0xE724, 0xE706, 0xE6F1, 0xE6E4, 0xE6DF, 
	0x9B41, 0x9B41, 0x9B41, 0x9B41, 0x9B2C, 0x9AEF, 0x9A8E, 0x9A0A, 0x9968, 
	0x98AA, 0x97D4, 0x96E8, 0x95E9, 0x94DB, 0x93C1, 0x929D, 0x9173, 0x9045, 
	0x8F17, 0x8DEC, 0x8CC7, 0x8BAB, 0x8A9B, 0x8999, 0x88AA, 0x87D0, 0x870E, 
	0x8667, 0x85D0, 0x853B, 0x84AA, 0x841D, 0x8397, 0x8317, 0x829F, 0x822F, 
	0x81CA, 0x816F, 0x8120, 0x80DD, 0x80A9, 0x8083, 0x806E, 0x8069, 0x8075, 
	0x8095, 0x80C9, 0x8112, 0x816C, 0x81D2, 0x8244, 0x82C1, 0x8349, 0x83DB, 
	0x8475, 0x8519, 0x85C3, 0x8675, 0x872D, 0x87EB, 0x88AE, 0x8975, 0x8A3F, 
	0x8B0D, 0x8BDC, 0x8CAE, 0x8D80, 0x8E52, 0x8F24, 0x8FF4, 0x90C3, 0x918F, 
	0x9257, 0x931C, 0x93DC, 0x9497, 0x954C, 0x95FA, 0x96A1, 0x9740, 0x97D6, 
	0x9862, 0x98E4, 0x995C, 0x99C8, 0x9A28, 0x9A7B, 0x9AC0, 0x9AF8, 0x9B20, 
	0x9B39, 0x9B41, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xCD91, 0xCD91, 0xCD91, 0xCD91, 
	0xCD88, 0xCD6F, 0xCD49, 0xCD1B, 0xCCE9, 0xCCB4, 0xCC82, 0xCC55, 0xCC32, 
	0xCC1B, 0xCC15, 0xCC23, 0xCC3D, 0xCC59, 0xCC7A, 0xCCA2, 0xCCD4, 0xCD11, 
	0xCD5B, 0xCDB6, 0xCE23, 0xCEA5, 0xCF3E, 0xCFF0, 0xD0C3, 0xD1B8, 0xD2CB, 
	0xD3F8, 0xD538, 0xD687, 0xD7E1, 0xD93F, 0xDA9D, 0xDBF6, 0xDD45, 0xDE85, 
	0xDFB1, 0xE0C4, 0xE1B9, 0xE28B, 0xE335, 0xE3B1, 0xE3FC, 0xE410, 0xE3FE, 
	0xE3DC, 0xE3AA, 0xE36A, 0xE31C, 0xE2C1, 0xE25A, 0xE1E7, 0xE16A, 0xE0E2, 
	0xE051, 0xDFB8, 0xDF18, 0xDE70, 0xDDC2, 0xDD10, 0xDC58, 0xDB9D, 0xDADF, 
	0xDA1F, 0xD95E, 0xD89C, 0xD7DA, 0xD71A, 0xD65B, 0xD59E, 0xD4E5, 0xD430, 
	0xD380, 0xD2D6, 0xD232, 0xD196, 0xD101, 0xD075, 0xCFF3, 0xCF7B, 0xCF0F, 
	0xCEAE, 0xCE5A, 0xCE14, 0xCDDC, 0xCDB2, 0xCD99, 0xCD91, 0x18A4, 0x18A4, 
	0x18A4, 0x18A4, 0x1899, 0x187C, 0x184F, 0x1816, 0x17D4, 0x178B, 0x1740, 
	0x16F5, 0x16AE, 0x166E, 0x1637, 0x160D, 0x15EC, 0x15CC, 0x15AE, 0x1592, 
	0x157B, 0x1567, 0x1559, 0x1550, 0x154E, 0x1552, 0x155F, 0x1574, 0x1592, 
	0x15B7, 0x15E3, 0x1615, 0x164C, 0x1687, 0x16C5, 0x1705, 0x1746, 0x1787, 
	0x17C7, 0x1805, 0x1841, 0x1878, 0x18AB, 0x18D8, 0x18EC, 0x18E1, 0x18CB, 
	0x18BF, 0x18BE, 0x18BC, 0x18BB, 0x18BA, 0x18B9, 0x18B8, 0x18B7, 0x18B6, 
	0x18B5, 0x18B4, 0x18B4, 0x18B3, 0x18B2, 0x18B1, 0x18B0, 0x18AF, 0x18AF, 
	0x18AE, 0x18AD, 0x18AC, 0x18AC, 0x18AB, 0x18AA, 0x18AA, 0x18A9, 0x18A9, 
	0x18A8, 0x18A8, 0x18A7, 0x18A7, 0x18A6, 0x18A6, 0x18A6, 0x18A5, 0x18A5, 
	0x18A5, 0x18A4, 0xFA04, 0xFA04, 0xFA04, 0xFA04, 0xFA20, 0xFA6B, 0xFADE, 
	0xFB6D, 0xFC10, 0xFCBD, 0xFD6A, 0xFE0D, 0xFE9D, 0xFF10, 0xFF5C, 0xFF78, 
	0xFF65, 0xFF2D, 0xFED6, 0xFE67, 0xFDE4, 0xFD54, 0xFCBC, 0xFC21, 0xFB8B, 
	0xFAFD, 0xFA7E, 0xFA14, 0xF9B3, 0xF94E, 0xF8E7, 0xF87D, 0xF814, 0xF7AC, 
	0xF748, 0xF6E7, 0xF68D, 0xF63A, 0xF5EF, 0xF5AF, 0xF57A, 0xF553, 0xF53A, 
	0xF532, 0xF5EF, 0xF794, 0xF93F, 0xFA10, 0xFA29, 0xFA3F, 0xFA53, 0xFA65, 
	0xFA75, 0xFA83, 0xFA8F, 0xFA99, 0xFAA1, 0xFAA8, 0xFAAD, 0xFAB1, 0xFAB4, 
	0xFAB5, 0xFAB4, 0xFAB3, 0xFAB1, 0xFAAD, 0xFAA9, 0xFAA4, 0xFA9E, 0xFA98, 
	0xFA90, 0xFA89, 0xFA81, 0xFA78, 0xFA70, 0xFA67, 0xFA5E, 0xFA55, 0xFA4C, 
	0xFA44, 0xFA3B, 0xFA33, 0xFA2B, 0xFA24, 0xFA1D, 0xFA17, 0xFA11, 0xFA0D, 
	0xFA09, 0xFA06, 0xFA05, 0xFA04, 0xE39A, 0xE39A, 0xE39A, 0xE39A, 0xE3D3, 
	0xE46F, 0xE55A, 0xE681, 0xE7D0, 0xE931, 0xEA91, 0xEBDD, 0xECFE, 0xEDE3, 
	0xEE76, 0xEEA3, 0xEE66, 0xEDD3, 0xECF7, 0xEBE4, 0xEAA7, 0xE950, 0xE7EE, 
	0xE690, 0xE545, 0xE41E, 0xE328, 0xE273, 0xE1EB, 0xE171, 0xE104, 0xE0A3, 
	0xE04E, 0xE004, 0xDFC5, 0xDF90, 0xDF64, 0xDF40, 0xDF24, 0xDF10, 0xDF02, 
	0xDEFA, 0xDEF7, 0xDEF8, 0xDF8D, 0xE0D0, 0xE219, 0xE2BD, 0xE2D5, 0xE2EB, 
	0xE300, 0xE314, 0xE326, 0xE337, 0xE346, 0xE354, 0xE362, 0xE36E, 0xE378, 
	0xE382, 0xE38B, 0xE393, 0xE399, 0xE39F, 0xE3A5, 0xE3A9, 0xE3AD, 0xE3AF, 
	0xE3B2, 0xE3B3, 0xE3B4, 0xE3B5, 0xE3B5, 0xE3B5, 0xE3B4, 0xE3B3, 0xE3B2, 
	0xE3B0, 0xE3AE, 0xE3AD, 0xE3AB, 0xE3A8, 0xE3A6, 0xE3A4, 0xE3A2, 0xE3A0, 
	0xE39F, 0xE39D, 0xE39C, 0xE39B, 0xE39A, 0x0001, 0xFFFE, 0xC170, 0xEFE2, 
	0xEFE2, 0xEFE2, 0xEFE2, 0xEFE8, 0xEFF9, 0xF015, 0xF03B, 0xF06C, 0xF0A5, 
	0xF0E7, 0xF131, 0xF183, 0xF1DC, 0xF23B, 0xF2A0, 0xF30B, 0xF37A, 0xF3EE, 
	0xF465, 0xF4E0, 0xF55D, 0xF5DC, 0xF65D, 0xF6DF, 0xF761, 0xF7E4, 0xF865, 
	0xF8E6, 0xF965, 0xF9E1, 0xFA5B, 0xFAD1, 0xFB43, 0xFBB1, 0xFC1A, 0xFC7E, 
	0xFCDB, 0xFD32, 0xFD81, 0xFDC9, 0xFE09, 0xFE3F, 0xFE6D, 0xFE90, 0xFEA9, 
	0xFEB7, 0xFEB9, 0xFE9D, 0xFE52, 0xFDDD, 0xFD44, 0xFC8A, 0xFBB5, 0xFAC8, 
	0xF9CA, 0xF8BD, 0xF7A8, 0xF68F, 0xF577, 0xF464, 0xF35A, 0xF260, 0xF178, 
	0xF0A9, 0xEFF6, 0xEF65, 0xEEFA, 0xEEAC, 0xEE6E, 0xEE3E, 0xEE1C, 0xEE06, 
	0xEDFB, 0xEDFB, 0xEE03, 0xEE14, 0xEE2C, 0xEE49, 0xEE6B, 0xEE91, 0xEEB9, 
	0xEEE2, 0xEF0C, 0xEF35, 0xEF5C, 0xEF81, 0xEFA1, 0xEFBB, 0xEFD0, 0xEFDD, 
	0xEFE2, 0x11CD, 0x11CD, 0x11CD, 0x11CD, 0x11D1, 0x11DC, 0x11EF, 0x1208, 
	0x1228, 0x124E, 0x127A, 0x12AB, 0x12E1, 0x131C, 0x135B, 0x139F, 0x13E5, 
	0x142F, 0x147C, 0x14CB, 0x151D, 0x1570, 0x15C5, 0x161B, 0x1671, 0x16C8, 
	0x171F, 0x1776, 0x17CB, 0x1820, 0x1873, 0x18C5, 0x1914, 0x1961, 0x19AB, 
	0x19F2, 0x1A35, 0x1A74, 0x1AAE, 0x1AE5, 0x1B16, 0x1B41, 0x1B67, 0x1B87, 
	0x1BA0, 0x1BB3, 0x1BBE, 0x1BC2, 0x1BB2, 0x1B85, 0x1B3C, 0x1ADD, 0x1A68, 
	0x19E2, 0x194D, 0x18AC, 0x1803, 0x1753, 0x16A1, 0x15EF, 0x153F, 0x1496, 
	0x13F6, 0x1362, 0x12DC, 0x1269, 0x120A, 0x11C4, 0x118E, 0x1162, 0x113F, 
	0x1123, 0x110F, 0x1101, 0x10FA, 0x10F8, 0x10FB, 0x1102, 0x110D, 0x111A, 
	0x112B, 0x113C, 0x1150, 0x1163, 0x1177, 0x118A, 0x119C, 0x11AC, 0x11B9, 
	0x11C4, 0x11CA, 0x11CD, 0x7D14, 0x7D14, 0x7D14, 0x7D14, 0x7D24, 0x7D51, 
	0x7D9A, 0x7DFE, 0x7E7B, 0x7F11, 0x7FBD, 0x8080, 0x8155, 0x823D, 0x8335, 
	0x843E, 0x8554, 0x8677, 0x87A6, 0x88DF, 0x8A20, 0x8B69, 0x8CB8, 0x8E0A, 
	0x8F60, 0x90B8, 0x9210, 0x9367, 0x94BB, 0x960B, 0x9756, 0x989A, 0x99D6, 
	0x9B08, 0x9C30, 0x9D4B, 0x9E58, 0x9F56, 0xA044, 0xA120, 0xA1E8, 0xA29B, 
	0xA339, 0xA3BF, 0xA42C, 0xA47E, 0xA4B5, 0xA4CF, 0xA49E, 0xA400, 0xA2FD, 
	0xA1A3, 0x9FFA, 0x9E0F, 0x9BEC, 0x999D, 0x972B, 0x94A2, 0x920D, 0x8F77, 
	0x8CEB, 0x8A74, 0x881C, 0x85EF, 0x83F7, 0x823F, 0x80D3, 0x7FBB, 0x7EE4, 
	0x7E29, 0x7D8B, 0x7D07, 0x7C9B, 0x7C45, 0x7C04, 0x7BD6, 0x7BB8, 0x7BAA, 
	0x7BA8, 0x7BB3, 0x7BC6, 0x7BE2, 0x7C04, 0x7C2A, 0x7C52, 0x7C7A, 0x7CA2, 
	0x7CC6, 0x7CE6, 0x7CFE, 0x7D0F, 0x7D14, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xE1F0, 0xE1F0, 
	0xE1F0, 0xE1F0, 0xE1E6, 0xE1C9, 0xE199, 0xE158, 0xE106, 0xE0A4, 0xE034, 
	0xDFB5, 0xDF29, 0xDE90, 0xDDEB, 0xDD3C, 0xDC83, 0xDBC0, 0xDAF6, 0xDA24, 
	0xD94B, 0xD86C, 0xD789, 0xD6A2, 0xD5B7, 0xD4CA, 0xD3DB, 0xD2EC, 0xD1FD, 
	0xD10E, 0xD022, 0xCF38, 0xCE52, 0xCD70, 0xCC93, 0xCBBC, 0xCAED, 0xCA24, 
	0xC965, 0xC8AF, 0xC803, 0xC762, 0xC6CD, 0xC645, 0xC5CB, 0xC55F, 0xC502, 
	0xC4B5, 0xC486, 0xC47F, 0xC49E, 0xC4DE, 0xC53D, 0xC5B7, 0xC64A, 0xC6F3, 
	0xC7AE, 0xC877, 0xC94D, 0xCA2B, 0xCB0F, 0xCBF6, 0xCCDC, 0xCDBE, 0xCE99, 
	0xCF6A, 0xD02D, 0xD0E1, 0xD193, 0xD254, 0xD323, 0xD3FD, 0xD4DF, 0xD5C9, 
	0xD6B8, 0xD7AA, 0xD89C, 0xD98E, 0xDA7D, 0xDB66, 0xDC49, 0xDD22, 0xDDF1, 
	0xDEB2, 0xDF64, 0xE005, 0xE092, 0xE10B, 0xE16C, 0xE1B4, 0xE1E0, 0xE1F0, 
	0xED56, 0xED56, 0xED56, 0xED56, 0xED56, 0xED56, 0xED55, 0xED55, 0xED54, 
	0xED53, 0xED52, 0xED51, 0xED4F, 0xED4E, 0xED4C, 0xED49, 0xED47, 0xED44, 
	0xED41, 0xED3D, 0xED39, 0xED35, 0xED31, 0xED2C, 0xED27, 0xED21, 0xED1B, 
	0xED15, 0xED0E, 0xED06, 0xECFF, 0xECF6, 0xECEE, 0xECE4, 0xECDB, 0xECD0, 
	0xECC6, 0xECBA, 0xECAF, 0xECA2, 0xEC95, 0xEC87, 0xEC79, 0xEC6A, 0xEC5B, 
	0xEC4B, 0xEC3A, 0xEC29, 0xEC0F, 0xEBE9, 0xEBB6, 0xEB7B, 0xEB39, 0xEAF3, 
	0xEAAA, 0xEA62, 0xEA1D, 0xE9DD, 0xE9A4, 0xE975, 0xE94C, 0xE926, 0xE905, 
	0xE8EA, 0xE8D8, 0xE8D1, 0xE8D5, 0xE8E7, 0xE905, 0xE92D, 0xE95C, 0xE992, 
	0xE9CD, 0xEA0B, 0xEA4B, 0xEA8B, 0xEACA, 0xEB06, 0xEB3E, 0xEB71, 0xEBA2, 
	0xEBD6, 0xEC0C, 0xEC43, 0xEC78, 0xECAA, 0xECD9, 0xED02, 0xED25, 0xED3F, 
	0xED50, 0xED56, 0xFE52, 0xFE52, 0xFE52, 0xFE52, 0xFE52, 0xFE4F, 0xFE4B, 
	0xFE45, 0xFE3E, 0xFE35, 0xFE2B, 0xFE1F, 0xFE12, 0xFE04, 0xFDF4, 0xFDE2, 
	0xFDCF, 0xFDBB, 0xFDA6, 0xFD8F, 0xFD77, 0xFD5E, 0xFD43, 0xFD28, 0xFD0B, 
	0xFCED, 0xFCCE, 0xFCAD, 0xFC8C, 0xFC6A, 0xFC47, 0xFC22, 0xFBFD, 0xFBD7, 
	0xFBB0, 0xFB87, 0xFB5E, 0xFB35, 0xFB0A, 0xFADF, 0xFAB2, 0xFA85, 0xFA58, 
	0xFA29, 0xF9FA, 0xF9CB, 0xF99A, 0xF969, 0xF922, 0xF8B4, 0xF828, 0xF788, 
	0xF6DA, 0xF628, 0xF57B, 0xF4DC, 0xF451, 0xF3E6, 0xF3A1, 0xF38C, 0xF3C1, 
	0xF447, 0xF50C, 0xF5FB, 0xF701, 0xF80A, 0xF902, 0xF9D6, 0xFA99, 0xFB6A, 
	0xFC43, 0xFD1F, 0xFDFA, 0xFECE, 0xFF97, 0x004F, 0x00F1, 0x0179, 0x01E2, 
	0x0225, 0x023A, 0x021F, 0x01DD, 0x017D, 0x0107, 0x0084, 0xFFFD, 0xFF7B, 
	0xFF06, 0xFEA8, 0xFE69, 0xFE52, 0xEC69, 0xEC69, 0xEC69, 0xEC69, 0xEC66, 
	0xEC5A, 0xEC48, 0xEC2E, 0xEC0F, 0xEBE9, 0xEBBE, 0xEB8D, 0xEB58, 0xEB1E, 
	0xEAE0, 0xEA9E, 0xEA59, 0xEA11, 0xE9C6, 0xE978, 0xE929, 0xE8D8, 0xE887, 
	0xE834, 0xE7E1, 0xE78D, 0xE73B, 0xE6E8, 0xE697, 0xE647, 0xE5F9, 0xE5AD, 
	0xE564, 0xE51E, 0xE4DB, 0xE49B, 0xE460, 0xE429, 0xE3F6, 0xE3C9, 0xE3A2, 
	0xE380, 0xE364, 0xE34F, 0xE341, 0xE33B, 0xE33C, 0xE345, 0xE37C, 0xE3FE, 
	0xE4C0, 0xE5B6, 0xE6D5, 0xE810, 0xE95E, 0xEAB2, 0xEC01, 0xED3E, 0xEE60, 
	0xEF5A, 0xF04D, 0xF156, 0xF261, 0xF359, 0xF42A, 0xF4C1, 0xF50A, 0xF4EF, 
	0xF475, 0xF3B3, 0xF2B7, 0xF191, 0xF04E, 0xEEFB, 0xEDA8, 0xEC63, 0xEB39, 
	0xEA38, 0xE970, 0xE8ED, 0xE8B2, 0xE8B1, 0xE8DF, 0xE933, 0xE9A2, 0xEA23, 
	0xEAAB, 0xEB31, 0xEBAB, 0xEC0E, 0xEC51, 0xEC69, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xBF5E, 0xFCEE, 
	0xFCEE, 0xFCEE, 0xFCEE, 0xFCEC, 0xFCE7, 0xFCE0, 0xFCD6, 0xFCC9, 0xFCBA, 
	0xFCA8, 0xFC94, 0xFC7F, 0xFC67, 0xFC4E, 0xFC33, 0xFC17, 0xFBF9, 0xFBDA, 
	0xFBBA, 0xFB9A, 0xFB78, 0xFB56, 0xFB34, 0xFB11, 0xFAEF, 0xFACC, 0xFAA9, 
	0xFA87, 0xFA65, 0xFA43, 0xFA23, 0xFA03, 0xF9E4, 0xF9C7, 0xF9AA, 0xF98F, 
	0xF976, 0xF95E, 0xF949, 0xF935, 0xF924, 0xF914, 0xF907, 0xF8FD, 0xF8F6, 
	0xF8F1, 0xF8F0, 0xF8F1, 0xF8F6, 0xF8FD, 0xF907, 0xF914, 0xF924, 0xF935, 
	0xF949, 0xF95E, 0xF976, 0xF98F, 0xF9AA, 0xF9C7, 0xF9E4, 0xFA03, 0xFA23, 
	0xFA43, 0xFA65, 0xFA87, 0xFAA9, 0xFACC, 0xFAEF, 0xFB11, 0xFB34, 0xFB56, 
	0xFB78, 0xFB9A, 0xFBBA, 0xFBDA, 0xFBF9, 0xFC17, 0xFC33, 0xFC4E, 0xFC67, 
	0xFC7F, 0xFC94, 0xFCA8, 0xFCBA, 0xFCC9, 0xFCD6, 0xFCE0, 0xFCE7, 0xFCEC, 
	0xFCEE, 0xE6A8, 0xE6A8, 0xE6A8, 0xE6A8, 0xE6A8, 0xE6A9, 0xE6AB, 0xE6AC, 
	0xE6AF, 0xE6B1, 0xE6B4, 0xE6B8, 0xE6BC, 0xE6C0, 0xE6C5, 0xE6C9, 0xE6CE, 
	0xE6D4, 0xE6D9, 0xE6DF, 0xE6E5, 0xE6EA, 0xE6F0, 0xE6F7, 0xE6FD, 0xE703, 
	0xE709, 0xE70F, 0xE715, 0xE71B, 0xE721, 0xE727, 0xE72D, 0xE732, 0xE738, 
	0xE73D, 0xE741, 0xE746, 0xE74A, 0xE74E, 0xE751, 0xE755, 0xE757, 0xE75A, 
	0xE75B, 0xE75D, 0xE75D, 0xE75E, 0xE75D, 0xE75D, 0xE75B, 0xE75A, 0xE757, 
	0xE755, 0xE751, 0xE74E, 0xE74A, 0xE746, 0xE741, 0xE73D, 0xE738, 0xE732, 
	0xE72D, 0xE727, 0xE721, 0xE71B, 0xE715, 0xE70F, 0xE709, 0xE703, 0xE6FD, 
	0xE6F7, 0xE6F0, 0xE6EA, 0xE6E5, 0xE6DF, 0xE6D9, 0xE6D4, 0xE6CE, 0xE6C9, 
	0xE6C5, 0xE6C0, 0xE6BC, 0xE6B8, 0xE6B4, 0xE6B1, 0xE6AF, 0xE6AC, 0xE6AB, 
	0xE6A9, 0xE6A8, 0x8E9A, 0x8E9A, 0x8E9A, 0x8E9A, 0x8E9D, 0x8EA5, 0x8EB2, 
	0x8EC4, 0x8EDA, 0x8EF4, 0x8F13, 0x8F35, 0x8F5A, 0x8F83, 0x8FAF, 0x8FDE, 
	0x900F, 0x9042, 0x9078, 0x90AF, 0x90E8, 0x9121, 0x915C, 0x9198, 0x91D4, 
	0x9211, 0x924D, 0x9289, 0x92C5, 0x9300, 0x9339, 0x9372, 0x93A9, 0x93DF, 
	0x9412, 0x9443, 0x9472, 0x949E, 0x94C7, 0x94EC, 0x950E, 0x952D, 0x9547, 
	0x955D, 0x956F, 0x957C, 0x9584, 0x9587, 0x9584, 0x957C, 0x956F, 0x955D, 
	0x9547, 0x952D, 0x950E, 0x94EC, 0x94C7, 0x949E, 0x9472, 0x9443, 0x9412, 
	0x93DF, 0x93A9, 0x9372, 0x9339, 0x9300, 0x92C5, 0x9289, 0x924D, 0x9211, 
	0x91D4, 0x9198, 0x915C, 0x9121, 0x90E8, 0x90AF, 0x9078, 0x9042, 0x900F, 
	0x8FDE, 0x8FAF, 0x8F83, 0x8F5A, 0x8F35, 0x8F13, 0x8EF4, 0x8EDA, 0x8EC4, 
	0x8EB2, 0x8EA5, 0x8E9D, 0x8E9A, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x4FFE, 0x4FFE, 0x4FFE, 0x4FFE, 
	0x4FFC, 0x4FF6, 0x4FEC, 0x4FDF, 0x4FCE, 0x4FB9, 0x4FA2, 0x4F88, 0x4F6B, 
	0x4F4C, 0x4F2A, 0x4F07, 0x4EE1, 0x4EBA, 0x4E91, 0x4E67, 0x4E3B, 0x4E0F, 
	0x4DE2, 0x4DB4, 0x4D86, 0x4D58, 0x4D2A, 0x4CFC, 0x4CCE, 0x4CA1, 0x4C75, 
	0x4C4A, 0x4C20, 0x4BF7, 0x4BCF, 0x4BAA, 0x4B86, 0x4B65, 0x4B45, 0x4B28, 
	0x4B0E, 0x4AF7, 0x4AE3, 0x4AD2, 0x4AC4, 0x4ABA, 0x4AB4, 0x4AB2, 0x4AB4, 
	0x4ABA, 0x4AC4, 0x4AD2, 0x4AE3, 0x4AF7, 0x4B0E, 0x4B28, 0x4B45, 0x4B65, 
	0x4B86, 0x4BAA, 0x4BCF, 0x4BF7, 0x4C20, 0x4C4A, 0x4C75, 0x4CA1, 0x4CCE, 
	0x4CFC, 0x4D2A, 0x4D58, 0x4D86, 0x4DB4, 0x4DE2, 0x4E0F, 0x4E3B, 0x4E67, 
	0x4E91, 0x4EBA, 0x4EE1, 0x4F07, 0x4F2A, 0x4F4C, 0x4F6B, 0x4F88, 0x4FA2, 
	0x4FB9, 0x4FCE, 0x4FDF, 0x4FEC, 0x4FF6, 0x4FFC, 0x4FFE, 0xF768, 0xF768, 
	0xF768, 0xF768, 0xF770, 0xF784, 0xF7A4, 0xF7CF, 0xF803, 0xF83E, 0xF87F, 
	0xF8C4, 0xF90C, 0xF956, 0xF9A0, 0xF9E8, 0xFA2E, 0xFA6F, 0xFAAA, 0xFADD, 
	0xFB08, 0xFB28, 0xFB3D, 0xFB44, 0xFB40, 0xFB33, 0xFB1E, 0xFB03, 0xFAE1, 
	0xFABA, 0xFA8E, 0xFA5E, 0xFA2A, 0xF9F4, 0xF9BC, 0xF982, 0xF948, 0xF90D, 
	0xF8D4, 0xF89C, 0xF867, 0xF834, 0xF805, 0xF7DA, 0xF7B4, 0xF794, 0xF77B, 
	0xF768, 0xF75B, 0xF74E, 0xF743, 0xF738, 0xF72F, 0xF727, 0xF721, 0xF71B, 
	0xF716, 0xF712, 0xF70F, 0xF70C, 0xF70B, 0xF70A, 0xF70A, 0xF70A, 0xF70B, 
	0xF70D, 0xF70F, 0xF712, 0xF715, 0xF719, 0xF71C, 0xF720, 0xF725, 0xF729, 
	0xF72E, 0xF733, 0xF738, 0xF73C, 0xF741, 0xF746, 0xF74A, 0xF74F, 0xF753, 
	0xF757, 0xF75B, 0xF75E, 0xF761, 0xF764, 0xF766, 0xF767, 0xF768, 0xF7BA, 
	0xF7BA, 0xF7BA, 0xF7BA, 0xF7B4, 0xF7A2, 0xF786, 0xF761, 0xF734, 0xF701, 
	0xF6C9, 0xF68C, 0xF64E, 0xF60D, 0xF5CD, 0xF58E, 0xF552, 0xF51A, 0xF4E6, 
	0xF4BA, 0xF495, 0xF478, 0xF467, 0xF460, 0xF464, 0xF46F, 0xF481, 0xF499, 
	0xF4B6, 0xF4D8, 0xF4FF, 0xF528, 0xF555, 0xF584, 0xF5B5, 0xF5E8, 0xF61A, 
	0xF64D, 0xF67F, 0xF6AF, 0xF6DE, 0xF70A, 0xF733, 0xF758, 0xF779, 0xF794, 
	0xF7AB, 0xF7BA, 0xF7C6, 0xF7D1, 0xF7DB, 0xF7E4, 0xF7EC, 0xF7F3, 0xF7F9, 
	0xF7FE, 0xF802, 0xF806, 0xF809, 0xF80B, 0xF80C, 0xF80D, 0xF80D, 0xF80C, 
	0xF80B, 0xF80A, 0xF808, 0xF806, 0xF803, 0xF800, 0xF7FD, 0xF7F9, 0xF7F5, 
	0xF7F1, 0xF7ED, 0xF7E9, 0xF7E5, 0xF7E1, 0xF7DD, 0xF7D8, 0xF7D4, 0xF7D1, 
	0xF7CD, 0xF7C9, 0xF7C6, 0xF7C3, 0xF7C1, 0xF7BF, 0xF7BD, 0xF7BC, 0xF7BB, 
	0xF7BA, 0xD552, 0xD552, 0xD552, 0xD552, 0xD538, 0xD4EE, 0xD478, 0xD3DD, 
	0xD321, 0xD24B, 0xD15F, 0xD062, 0xCF5B, 0xCE4F, 0xCD43, 0xCC3C, 0xCB3F, 
	0xCA53, 0xC97D, 0xC8C1, 0xC826, 0xC7B0, 0xC766, 0xC74C, 0xC75C, 0xC78A, 
	0xC7D5, 0xC838, 0xC8B3, 0xC941, 0xC9E1, 0xCA91, 0xCB4C, 0xCC12, 0xCCDF, 
	0xCDB1, 0xCE84, 0xCF58, 0xD029, 0xD0F4, 0xD1B7, 0xD26F, 0xD31A, 0xD3B6, 
	0xD43F, 0xD4B3, 0xD510, 0xD552, 0xD585, 0xD5B2, 0xD5DC, 0xD601, 0xD622, 
	0xD63F, 0xD658, 0xD66D, 0xD67F, 0xD68E, 0xD699, 0xD6A1, 0xD6A7, 0xD6AA, 
	0xD6AA, 0xD6A8, 0xD6A4, 0xD69E, 0xD696, 0xD68C, 0xD681, 0xD675, 0xD667, 
	0xD658, 0xD648, 0xD638, 0xD627, 0xD616, 0xD604, 0xD5F3, 0xD5E1, 0xD5D0, 
	0xD5BF, 0xD5AF, 0xD5A0, 0xD591, 0xD584, 0xD578, 0xD56D, 0xD564, 0xD55C, 
	0xD557, 0xD553, 0xD552, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xBF5E, 0xFF1C, 0xFF1C, 0xFF1C, 0xFF1C, 
	0xFF1A, 0xFF15, 0xFF0C, 0xFF00, 0xFEF1, 0xFEDF, 0xFECB, 0xFEB4, 0xFE9A, 
	0xFE7F, 0xFE62, 0xFE43, 0xFE22, 0xFE00, 0xFDDC, 0xFDB8, 0xFD92, 0xFD6C, 
	0xFD46, 0xFD1F, 0xFCF7, 0xFCD0, 0xFCA9, 0xFC82, 0xFC5C, 0xFC37, 0xFC12, 
	0xFBEF, 0xFBCC, 0xFBAB, 0xFB8C, 0xFB6E, 0xFB53, 0xFB39, 0xFB22, 0xFB0D, 
	0xFAFB, 0xFAEC, 0xFADF, 0xFAD6, 0xFAD0, 0xFACE, 0xFAD0, 0xFAD5, 0xFAE6, 
	0xFB08, 0xFB3A, 0xFB7A, 0xFBC6, 0xFC1D, 0xFC7B, 0xFCE0, 0xFD4A, 0xFDB7, 
	0xFE24, 0xFE90, 0xFEFA, 0xFF5F, 0xFFBD, 0x0013, 0x005E, 0x009D, 0x00CF, 
	0x00F0, 0x0105, 0x0111, 0x0115, 0x0113, 0x010A, 0x00FB, 0x00E7, 0x00CF, 
	0x00B3, 0x0095, 0x0074, 0x0051, 0x002D, 0x0009, 0xFFE5, 0xFFC2, 0xFFA0, 
	0xFF81, 0xFF65, 0xFF4C, 0xFF38, 0xFF29, 0xFF1F, 0xFF1C, 0x13FB, 0x13FB, 
	0x13FB, 0x13FB, 0x13FA, 0x13F9, 0x13F7, 0x13F4, 0x13F1, 0x13ED, 0x13E9, 
	0x13E4, 0x13DF, 0x13D9, 0x13D3, 0x13CC, 0x13C5, 0x13BE, 0x13B7, 0x13B0, 
	0x13A8, 0x13A1, 0x1399, 0x1391, 0x138A, 0x1383, 0x137C, 0x1375, 0x136E, 
	0x1368, 0x1362, 0x135C, 0x1357, 0x1353, 0x134E, 0x134B, 0x1348, 0x1346, 
	0x1344, 0x1344, 0x1344, 0x1345, 0x1347, 0x1349, 0x134D, 0x1352, 0x1358, 
	0x135F, 0x136A, 0x137D, 0x1395, 0x13B3, 0x13D6, 0x13FC, 0x1425, 0x1451, 
	0x147E, 0x14AB, 0x14D9, 0x1505, 0x152F, 0x1557, 0x157C, 0x159C, 0x15B7, 
	0x15CD, 0x15DC, 0x15E3, 0x15E4, 0x15DF, 0x15D6, 0x15C9, 0x15B7, 0x15A3, 
	0x158B, 0x1571, 0x1555, 0x1537, 0x1519, 0x14F9, 0x14DA, 0x14BB, 0x149D, 
	0x147F, 0x1464, 0x144B, 0x1434, 0x1421, 0x1411, 0x1405, 0x13FD, 0x13FB, 
	0x9574, 0x9574, 0x9574, 0x9574, 0x9570, 0x9565, 0x9552, 0x9539, 0x951A, 
	0x94F4, 0x94C9, 0x9498, 0x9463, 0x9429, 0x93EB, 0x93A9, 0x9364, 0x931C, 
	0x92D1, 0x9284, 0x9235, 0x91E4, 0x9192, 0x913F, 0x90EC, 0x9099, 0x9046, 
	0x8FF3, 0x8FA2, 0x8F52, 0x8F04, 0x8EB8, 0x8E6E, 0x8E27, 0x8DE4, 0x8DA4, 
	0x8D68, 0x8D31, 0x8CFE, 0x8CD0, 0x8CA8, 0x8C86, 0x8C69, 0x8C54, 0x8C45, 
	0x8C3E, 0x8C3E, 0x8C46, 0x8C66, 0x8CA9, 0x8D0C, 0x8D8B, 0x8E23, 0x8ECF, 
	0x8F8D, 0x9057, 0x912C, 0x9206, 0x92E2, 0x93BC, 0x9491, 0x955D, 0x961C, 
	0x96CA, 0x9764, 0x97E5, 0x984B, 0x9892, 0x98BF, 0x98DC, 0x98EA, 0x98EB, 
	0x98E0, 0x98C9, 0x98A9, 0x9881, 0x9851, 0x981C, 0x97E1, 0x97A3, 0x9763, 
	0x9722, 0x96E1, 0x96A2, 0x9665, 0x962D, 0x95FA, 0x95CD, 0x95A8, 0x958C, 
	0x957A, 0x9574, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x4C54, 0x4C54, 0x4C54, 0x4C54, 
	0x4C56, 0x4C5C, 0x4C67, 0x4C76, 0x4C88, 0x4C9E, 0x4CB7, 0x4CD3, 0x4CF2, 
	0x4D14, 0x4D39, 0x4D60, 0x4D89, 0x4DB4, 0x4DE0, 0x4E0E, 0x4E3E, 0x4E6F, 
	0x4EA0, 0x4ED3, 0x4F06, 0x4F39, 0x4F6D, 0x4FA0, 0x4FD4, 0x5006, 0x5039, 
	0x506A, 0x509B, 0x50CA, 0x50F7, 0x5124, 0x514E, 0x5176, 0x519C, 0x51C0, 
	0x51E1, 0x5200, 0x521B, 0x5233, 0x5248, 0x5259, 0x5267, 0x5270, 0x5270, 
	0x5264, 0x524B, 0x5228, 0x51FB, 0x51C6, 0x518A, 0x5149, 0x5102, 0x50B9, 
	0x506D, 0x5020, 0x4FD4, 0x4F89, 0x4F41, 0x4EFC, 0x4EBD, 0x4E84, 0x4E53, 
	0x4E2B, 0x4E08, 0x4DE6, 0x4DC5, 0x4DA5, 0x4D87, 0x4D69, 0x4D4D, 0x4D32, 
	0x4D19, 0x4D01, 0x4CEA, 0x4CD5, 0x4CC1, 0x4CAE, 0x4C9E, 0x4C8F, 0x4C81, 
	0x4C75, 0x4C6B, 0x4C63, 0x4C5C, 0x4C57, 0x4C54, 0xFFAC, 0xFFAC, 0xFFAC, 
	0xFFAC, 0xFFAD, 0xFFAD, 0xFFAF, 0xFFB0, 0xFFB2, 0xFFB5, 0xFFB8, 0xFFBB, 
	0xFFBE, 0xFFC1, 0xFFC5, 0xFFC9, 0xFFCD, 0xFFD1, 0xFFD5, 0xFFD9, 0xFFDD, 
	0xFFE0, 0xFFE4, 0xFFE8, 0xFFEB, 0xFFEE, 0xFFF1, 0xFFF4, 0xFFF6, 0xFFF8, 
	0xFFF9, 0xFFFA, 0xFFFA, 0xFFFA, 0xFFFA, 0xFFF8, 0xFFF6, 0xFFF4, 0xFFF0, 
	0xFFEC, 0xFFE8, 0xFFE2, 0xFFDB, 0xFFD4, 0xFFCC, 0xFFC2, 0xFFB8, 0xFFAC, 
	0xFF9C, 0xFF84, 0xFF64, 0xFF3E, 0xFF13, 0xFEE4, 0xFEB1, 0xFE7D, 0xFE46, 
	0xFE10, 0xFDDA, 0xFDA5, 0xFD74, 0xFD45, 0xFD1B, 0xFCF7, 0xFCD9, 0xFCC2, 
	0xFCB4, 0xFCAF, 0xFCB3, 0xFCBE, 0xFCD0, 0xFCE8, 0xFD05, 0xFD27, 0xFD4C, 
	0xFD75, 0xFDA1, 0xFDCF, 0xFDFE, 0xFE2E, 0xFE5D, 0xFE8C, 0xFEBA, 0xFEE6, 
	0xFF0F, 0xFF35, 0xFF57, 0xFF74, 0xFF8B, 0xFF9D, 0xFFA8, 0xFFAC, 0x03BB, 
	0x03BB, 0x03BB, 0x03BB, 0x03BB, 0x03BA, 0x03B9, 0x03B7, 0x03B5, 0x03B2, 
	0x03AF, 0x03AB, 0x03A8, 0x03A4, 0x03A0, 0x039C, 0x0397, 0x0393, 0x038E, 
	0x038A, 0x0386, 0x0381, 0x037D, 0x0379, 0x0375, 0x0372, 0x036F, 0x036C, 
	0x0369, 0x0367, 0x0366, 0x0365, 0x0364, 0x0364, 0x0365, 0x0367, 0x0369, 
	0x036C, 0x036F, 0x0374, 0x0379, 0x0380, 0x0387, 0x038F, 0x0399, 0x03A3, 
	0x03AF, 0x03BB, 0x03CE, 0x03E9, 0x040C, 0x0436, 0x0467, 0x049B, 0x04D4, 
	0x050F, 0x054B, 0x0588, 0x05C5, 0x05FF, 0x0637, 0x066B, 0x0699, 0x06C2, 
	0x06E4, 0x06FD, 0x070D, 0x0712, 0x070E, 0x0702, 0x06EE, 0x06D3, 0x06B2, 
	0x068D, 0x0663, 0x0635, 0x0604, 0x05D1, 0x059C, 0x0567, 0x0532, 0x04FD, 
	0x04CA, 0x0499, 0x046B, 0x0441, 0x041B, 0x03FB, 0x03E0, 0x03CC, 0x03C0, 
	0x03BB, 0xDA83, 0xDA83, 0xDA83, 0xDA83, 0xDA85, 0xDA8A, 0xDA92, 0xDA9C, 
	0xDAAA, 0xDAB9, 0xDACB, 0xDADE, 0xDAF3, 0xDB09, 0xDB21, 0xDB39, 0xDB52, 
	0xDB6B, 0xDB84, 0xDB9E, 0xDBB7, 0xDBCF, 0xDBE7, 0xDBFE, 0xDC13, 0xDC27, 
	0xDC39, 0xDC49, 0xDC57, 0xDC63, 0xDC6C, 0xDC72, 0xDC75, 0xDC74, 0xDC70, 
	0xDC68, 0xDC5B, 0xDC4B, 0xDC36, 0xDC1C, 0xDBFD, 0xDBD9, 0xDBAF, 0xDB7F, 
	0xDB4A, 0xDB0E, 0xDACC, 0xDA83, 0xDA1B, 0xD97F, 0xD8B5, 0xD7C4, 0xD6B1, 
	0xD583, 0xD441, 0xD2EF, 0xD196, 0xD039, 0xCEE1, 0xCD92, 0xCC54, 0xCB2C, 
	0xCA21, 0xC938, 0xC879, 0xC7E8, 0xC78D, 0xC76D, 0xC786, 0xC7CD, 0xC83F, 
	0xC8D7, 0xC991, 0xCA69, 0xCB5A, 0xCC60, 0xCD77, 0xCE9B, 0xCFC7, 0xD0F8, 
	0xD229, 0xD355, 0xD479, 0xD590, 0xD697, 0xD788, 0xD85F, 0xD919, 0xD9B1, 
	0xDA23, 0xDA6A, 0xDA83, 
},
{
	0x0001, 0x0000, 0x0001, 0x0001, 0x0001, 0x0002, 0x0001, 0x0003, 0x0001, 
	0x0004, 0x0001, 0x0005, 0x005C, 0x0006, 0x005C, 0x0062, 0x0058, 0x00BE, 
	0x005C, 0x0116, 0x005C, 0x0172, 0x005C, 0x01CE, 0x005C, 0x022A, 0x005C, 
	0x0286, 0x005C, 0x02E2, 0x0001, 0x033E, 0x0001, 0x033F, 0x0001, 0x0340, 
	0x005C, 0x0341, 0x005C, 0x039D, 0x005C, 0x03F9, 0x005C, 0x0455, 0x005B, 
	0x04B1, 0x005C, 0x050C, 0x0055, 0x0568, 0x005C, 0x05BD, 0x005B, 0x0619, 
	0x0001, 0x0674, 0x0001, 0x0675, 0x0001, 0x0676, 0x005C, 0x0677, 0x005C, 
	0x06D3, 0x005C, 0x072F, 0x005A, 0x078B, 0x0053, 0x07E5, 0x005C, 0x0838, 
	0x005C, 0x0894, 0x005C, 0x08F0, 0x005C, 0x094C, 0x0059, 0x09A8, 0x005C, 
	0x0A01, 0x0001, 0x0A5D, 0x005C, 0x0A5E, 0x005B, 0x0ABA, 0x005C, 0x0B15, 
	0x0059, 0x0B71, 0x005C, 0x0BCA, 0x005C, 0x0C26, 0x005B, 0x0C82, 0x005C, 
	0x0CDD, 0x005C, 0x0D39, 0x0059, 0x0D95, 0x005C, 0x0DEE, 0x0001, 0x0E4A, 
	0x005C, 0x0E4B, 0x005C, 0x0EA7, 0x005C, 0x0F03, 0x005B, 0x0F5F, 0x005C, 
	0x0FBA, 0x005B, 0x1016, 0x005C, 0x1071, 0x005C, 0x10CD, 0x005C, 0x1129, 
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_TAKE_CAP_OFF_THEN_ON], 0, 189, 0, 90, 90, {
	0x0000, 0x00AA, 0x00AA, 0x00AA, 0x00AA, 0x00AA, 0x00AA, 0x00AA, 0x00AA, 
	0x00AA, 0x00AA, 0x00AA, 0x00AA, 0x00AA, 0x00AA, 0x00AA, 0x00AA, 0x00AA, 
	0x00AA, 0x00AA, 0x00AA, 0x00AA, 0x00AA, 0x00AB, 0x00AC, 0x00AD, 0x00AE, 
	0x00B0, 0x00B1, 0x00B3, 0x00B4, 0x00B6, 0x00B7, 0x00B8, 0x00B9, 0x00BA, 
	0x00BA, 0x00BA, 0x00BA, 0x00B9, 0x00B8, 0x00B7, 0x00B7, 0x00B5, 0x00B4, 
	0x00B3, 0x00B2, 0x00B1, 0x00B0, 0x00AE, 0x00AD, 0x00AC, 0x00AC, 0x00AB, 
	0x00AA, 0x0000, 0x0000, 0x0001, 0x0002, 0x0003, 0x0005, 0x0006, 0x0008, 
	0x000A, 0x000C, 0x000D, 0x000F, 0x0010, 0x0011, 0x0012, 0x0012, 0x0012, 
	0x0012, 0x0011, 0x0011, 0x0011, 0x0010, 0x0010, 0x000F, 0x000F, 0x000E, 
	0x000E, 0x000D, 0x000D, 0x000D, 0x000C, 0x000C, 0x000C, 0x000B, 0x000B, 
	0x000B, 0x000B, 0x000B, 0x000C, 0x000C, 0x000C, 0x000C, 0x000D, 0x000D, 
	0x000E, 0x000E, 0x000E, 0x000F, 0x000F, 0x000F, 0x0010, 0x0010, 0x0010, 
	0x0010, 0x0010, 0x0011, 0x0010, 0x0010, 0x0010, 0x0010, 0x0010, 0x000F, 
	0x000F, 0x000E, 0x000E, 0x000D, 0x000D, 0x000C, 0x000B, 0x000B, 0x000A, 
	0x0009, 0x0009, 0x0008, 0x0007, 0x0006, 0x0006, 0x0005, 0x0004, 0x0004, 
	0x0003, 0x0003, 0x0002, 0x0002, 0x0001, 0x0001, 0x0001, 0x0000, 0x0000, 
	0x3FFF, 0x0000, 0xFFFF, 0x0014, 0x004C, 0x00A4, 0x0114, 0x0198, 0x022A, 
	0x02C4, 0x0361, 0x03FB, 0x048D, 0x0511, 0x0581, 0x05D8, 0x0611, 0x0625, 
	0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 
	0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 
	0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 
	0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 
	0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 
	0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 0x0625, 0x061C, 0x0603, 
	0x05DC, 0x05A7, 0x0566, 0x051C, 0x04C8, 0x046E, 0x040F, 0x03AB, 0x0346, 
	0x02DF, 0x0279, 0x0216, 0x01B6, 0x015C, 0x0109, 0x00BF, 0x007E, 0x0049, 
	0x0022, 0x0009, 0xFFFF, 0xFFFF, 0xFFFB, 0xFFF0, 0xFFDE, 0xFFC8, 0xFFAE, 
	0xFF91, 0xFF72, 0xFF53, 0xFF34, 0xFF17, 0xFEFD, 0xFEE6, 0xFED5, 0xFECA, 
	0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 
	0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 
	0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 
	0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 
	0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 
	0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC6, 0xFEC7, 
	0xFECC, 0xFED4, 0xFEDF, 0xFEEC, 0xFEFA, 0xFF0B, 0xFF1D, 0xFF30, 0xFF44, 
	0xFF58, 0xFF6C, 0xFF81, 0xFF95, 0xFFA8, 0xFFBA, 0xFFCA, 0xFFD9, 0xFFE6, 
	0xFFF0, 0xFFF8, 0xFFFD, 0xFFFF, 0x40A1, 0x40B9, 0x40FC, 0x4164, 0x41EA, 
	0x4287, 0x4335, 0x43ED, 0x44A8, 0x4560, 0x460E, 0x46AB, 0x4731, 0x4799, 
	0x47DC, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 
	0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 
	0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 
	0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 
	0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 
	0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 0x47F4, 
	0x47EA, 0x47CC, 0x479D, 0x475E, 0x4711, 0x46B8, 0x4655, 0x45E9, 0x4577, 
	0x4501, 0x4488, 0x440D, 0x4394, 0x431D, 0x42AC, 0x4240, 0x41DD, 0x4184, 
	0x4137, 0x40F8, 0x40C9, 0x40AB, 0x40A1, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x004A, 0x00FB, 0x01CF, 0x0280, 0x02CA, 0x02B3, 
	0x0271, 0x020C, 0x018D, 0x00FA, 0x005C, 0xFFB9, 0xFF1A, 0xFE88, 0xFE08, 
	0xFDA4, 0xFD62, 0xFD4A, 0xFD4B, 0xFD4F, 0xFD56, 0xFD61, 0xFD6F, 0xFD81, 
	0xFD97, 0xFDB2, 0xFDCF, 0xFDEE, 0xFE0D, 0xFE2A, 0xFE43, 0xFE57, 0xFE64, 
	0xFE69, 0xFDE6, 0xFC9E, 0xFAF4, 0xF94A, 0xF802, 0xF77F, 0xF796, 0xF7C9, 
	0xF7FC, 0xF813, 0xF811, 0xF80C, 0xF804, 0xF7FA, 0xF7EF, 0xF7E4, 0xF7D9, 
	0xF7D0, 0xF7C8, 0xF7C3, 0xF7C1, 0xF7FC, 0xF89C, 0xF989, 0xFAA8, 0xFBE0, 
	0xFD18, 0xFE37, 0xFF24, 0xFFC4, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFC2, 0xFF1E, 
	0xFE2C, 0xFD06, 0xFBC6, 0xFA86, 0xF960, 0xF86E, 0xF7C9, 0xF78D, 0xF86E, 
	0xFA86, 0xFD06, 0xFF1E, 0xFFFF, 0xFFF6, 0xFFE2, 0xFFC9, 0xFFB5, 0xFFAC, 
	0x002B, 0x0188, 0x039B, 0x063E, 0x0945, 0x0C8A, 0x0FE3, 0x1328, 0x1630, 
	0x18D2, 0x1AE6, 0x1C43, 0x1CC0, 0x1C29, 0x1A79, 0x17D4, 0x145D, 0x1036, 
	0x0B83, 0x0667, 0x0106, 0xFB90, 0xF635, 0xF127, 0xEC97, 0xE8B5, 0xE5B2, 
	0xE3C0, 0xE30F, 0xE3BC, 0xE5A0, 0xE882, 0xEC2A, 0xF05F, 0xF4EA, 0xF980, 
	0xFD91, 0x007A, 0x0196, 0x0196, 0x0195, 0x0194, 0x0191, 0x018B, 0x0184, 
	0x0179, 0x016B, 0x0159, 0x0143, 0x0127, 0x00CA, 0x0001, 0xFEE7, 0xFD9A, 
	0xFC34, 0xFAD1, 0xF98C, 0xF883, 0xF7CF, 0xF78D, 0xF7C9, 0xF86E, 0xF960, 
	0xFA86, 0xFBC6, 0xFD06, 0xFE2C, 0xFF1E, 0xFFC2, 0xFFFF, 0x0884, 0x0892, 
	0x08BA, 0x08F9, 0x094A, 0x09AB, 0x0A17, 0x0A8B, 0x0B04, 0x0B7D, 0x0BF4, 
	0x0C6A, 0x0CF3, 0x0DAA, 0x0EA9, 0x1008, 0x11D1, 0x13C3, 0x158D, 0x16DB, 
	0x175D, 0x16BD, 0x14FA, 0x123D, 0x0EB1, 0x0A7F, 0x05D3, 0x00D6, 0xFBB2, 
	0xF692, 0xF1A0, 0xED06, 0xE8EE, 0xE582, 0xE2E0, 0xE0F8, 0xDFAB, 0xDEDB, 
	0xDE6B, 0xDE3E, 0xDE35, 0xDE50, 0xDEA2, 0xDF30, 0xDFFF, 0xE114, 0xE272, 
	0xE41F, 0xE61F, 0xE876, 0xEB2D, 0xEE54, 0xF200, 0xF647, 0xFB3C, 0x00F6, 
	0x0752, 0x0D55, 0x11CF, 0x1391, 0x1350, 0x129E, 0x1193, 0x104A, 0x0EDB, 
	0x0D5F, 0x0BF0, 0x0AA6, 0x099C, 0x08E9, 0x08A8, 0x08C0, 0x0900, 0x095F, 
	0x09D1, 0x0A4E, 0x0ACB, 0x0B3E, 0x0B9D, 0x0BDD, 0x0BF4, 0x0BDC, 0x0B99, 
	0x0B36, 0x0ABE, 0x0A3C, 0x09BA, 0x0942, 0x08E0, 0x089D, 0x0884, 0xFFFF, 
	0xFFF6, 0xFFDB, 0xFFB2, 0xFF7D, 0xFF3F, 0xFEFA, 0xFEB1, 0xFE66, 0xFE1C, 
	0xFDD6, 0xFD96, 0xFD5F, 0xFD34, 0xFD18, 0xFD0D, 0xFD2C, 0xFD7D, 0xFDF2, 
	0xFE7B, 0xFF09, 0xFF8F, 0x000A, 0x0076, 0x00D3, 0x011E, 0x0156, 0x0178, 
	0x0184, 0x00D0, 0xFEE6, 0xFC16, 0xF8AB, 0xF4F3, 0xF13B, 0xEDD0, 0xEAFF, 
	0xE916, 0xE862, 0xE86E, 0xE89C, 0xE8F6, 0xE989, 0xEA62, 0xEB8C, 0xED14, 
	0xEF05, 0xF16C, 0xF44C, 0xF787, 0xFAF4, 0xFE6D, 0x01CB, 0x04E4, 0x0791, 
	0x09AC, 0x0B0C, 0x0B8A, 0x0A43, 0x076F, 0x0491, 0x032D, 0x030E, 0x02FA, 
	0x02EE, 0x02E9, 0x02E8, 0x02E8, 0x02E7, 0x02E1, 0x02D6, 0x02C2, 0x02A3, 
	0x0251, 0x01B8, 0x00F2, 0x0017, 0xFF40, 0xFE88, 0xFE07, 0xFDD6, 0xFDE6, 
	0xFE10, 0xFE4D, 0xFE99, 0xFEEB, 0xFF3C, 0xFF88, 0xFFC5, 0xFFF0, 0xFFFF, 
	0xFFFF, 0x003D, 0x00E2, 0x01D6, 0x02FE, 0x043F, 0x0581, 0x06A9, 0x079D, 
	0x0842, 0x087F, 0x07F4, 0x0699, 0x04D6, 0x0313, 0x01B8, 0x010B, 0x00CC, 
	0x0098, 0x000C, 0xFEC4, 0xFC33, 0xF85F, 0xF3C5, 0xEEE6, 0xEA3F, 0xE650, 
	0xE396, 0xE292, 0xE2BF, 0xE342, 0xE418, 0xE53A, 0xE6A5, 0xE854, 0xEA43, 
	0xEC6B, 0xEEC9, 0xF159, 0xF411, 0xF6DA, 0xF99B, 0xFC38, 0xFE97, 0x009F, 
	0x0232, 0x0338, 0x0395, 0x033A, 0x0244, 0x00DA, 0xFF21, 0xFD42, 0xFB63, 
	0xF9AB, 0xF841, 0xF74B, 0xF6F0, 0xF8AB, 0xFC7E, 0x005C, 0x0238, 0x025C, 
	0x0273, 0x0280, 0x0286, 0x0287, 0x0287, 0x0289, 0x028F, 0x029C, 0x02B3, 
	0x02D7, 0x0336, 0x03EA, 0x04D4, 0x05D6, 0x06D3, 0x07AD, 0x0845, 0x087F, 
	0x0842, 0x079D, 0x06A9, 0x0581, 0x043F, 0x02FE, 0x01D6, 0x00E2, 0x003D, 
	0xFFFF, 0xFC61, 0xFC53, 0xFC2C, 0xFBEE, 0xFB9B, 0xFB36, 0xFAC3, 0xFA43, 
	0xF9BA, 0xF929, 0xF894, 0xF7FF, 0xF775, 0xF703, 0xF6B5, 0xF698, 0xF6B1, 
	0xF707, 0xF7A9, 0xF8A6, 0xFA0F, 0xFBE9, 0xFE11, 0x005D, 0x02A0, 0x04AE, 
	0x065C, 0x077E, 0x07E9, 0x077C, 0x0648, 0x0469, 0x01FB, 0xFF19, 0xFBE1, 
	0xF86F, 0xF4DF, 0xF14C, 0xEDD3, 0xEA8C, 0xE785, 0xE4C7, 0xE25A, 0xE04A, 
	0xDE9E, 0xDD61, 0xDC9C, 0xDC58, 0xDC5B, 0xDC6E, 0xDCA1, 0xDD06, 0xDDAC, 
	0xDEA3, 0xDFFD, 0xE1C9, 0xE417, 0xE6F8, 0xEC70, 0xF454, 0xFB6C, 0xFE80, 
	0xFE4C, 0xFDBE, 0xFCEA, 0xFBE3, 0xFABE, 0xF990, 0xF86B, 0xF765, 0xF690, 
	0xF602, 0xF5CE, 0xF5DE, 0xF609, 0xF64D, 0xF6A6, 0xF711, 0xF789, 0xF80B, 
	0xF894, 0xF920, 0xF9AB, 0xFA32, 0xFAB2, 0xFB28, 0xFB90, 0xFBE6, 0xFC28, 
	0xFC52, 0xFC61, 0x0001, 0xFFFE, 0xC170, 0xFB1C, 0xFA11, 0xF73D, 0xF312, 
	0xEE02, 0xE880, 0xE2FE, 0xDDEE, 0xD9C3, 0xD6EF, 0xD5E4, 0xD739, 0xDAD7, 
	0xE02B, 0xE6A4, 0xEDB0, 0xF4BB, 0xFB34, 0x0089, 0x0427, 0x057C, 0x0572, 
	0x0551, 0x0514, 0x04B7, 0x0438, 0x0391, 0x02BE, 0x01BC, 0x008B, 0xFF40, 
	0xFDF7, 0xFCCA, 0xFBD2, 0xFB2A, 0xFAEC, 0xFAEE, 0xFAFC, 0xFB22, 0xFB6C, 
	0xFBE7, 0xFC9E, 0xFD9D, 0xFEF1, 0x00A6, 0x02C7, 0x0561, 0x087F, 0x0C2E, 
	0x107A, 0x156F, 0x1B4F, 0x220C, 0x2937, 0xB064, 0xB723, 0xBD18, 0xC21F, 
	0xC628, 0xC91F, 0xCAF4, 0xCB95, 0xCB4D, 0xCA7C, 0xC92D, 0xC769, 0xC53B, 
	0xC2AC, 0xBFC7, 0xBC97, 0xB924, 0xB57A, 0xB1A2, 0xADA6, 0x2992, 0x256E, 
	0x2145, 0x1D21, 0x190C, 0x1510, 0x1138, 0x0D8E, 0x0A1B, 0x06EA, 0x0406, 
	0x0177, 0xFF48, 0xFD84, 0xFC34, 0xFB64, 0xFB1C, 0xD2DB, 0xD27C, 0xD178, 
	0xCFFA, 0xCE2A, 0xCC30, 0xCA37, 0xC867, 0xC6E9, 0xC5E5, 0xC586, 0xC588, 
	0xC596, 0xC5BF, 0xC60D, 0xC68F, 0xC750, 0xC85D, 0xC9C4, 0xCB90, 0xCDCF, 
	0xD0E9, 0xD4F8, 0xD98F, 0xDE42, 0xE2A5, 0xE64D, 0xE8CE, 0xE9BC, 0xE950, 
	0xE827, 0xE662, 0xE425, 0xE194, 0xDED2, 0xDC02, 0xD944, 0xD69F, 0xD417, 
	0xD1AF, 0xCF6A, 0xCD4D, 0xCB5B, 0xC996, 0xC803, 0xC6A4, 0xC57E, 0xC493, 
	0xC3E6, 0xC37D, 0xC359, 0xC4B4, 0xC7EF, 0xCBCB, 0xB0F9, 0xAF9E, 0xAFDB, 
	0xB074, 0xB13B, 0xB202, 0xB29C, 0xB2D9, 0xB2D4, 0xB2C5, 0xB2AD, 0xB28D, 
	0xB266, 0xB237, 0xB203, 0xB1C9, 0xB18A, 0xB147, 0xB102, 0xB0B9, 0xCF8F, 
	0xCFDB, 0xD026, 0xD071, 0xD0BC, 0xD104, 0xD14A, 0xD18C, 0xD1CB, 0xD205, 
	0xD239, 0xD268, 0xD28F, 0xD2AF, 0xD2C7, 0xD2D6, 0xD2DB, 0xD4B3, 0xD59B, 
	0xD80F, 0xDBAE, 0xE012, 0xE4DA, 0xE9A2, 0xEE07, 0xF1A5, 0xF41A, 0xF501, 
	0xF38E, 0xEF9E, 0xE9D1, 0xE2C5, 0xDB1A, 0xD36F, 0xCC64, 0xC696, 0xC2A6, 
	0xC133, 0xC147, 0xC184, 0xC1ED, 0xC285, 0xC34D, 0xC449, 0xC57A, 0xC6E4, 
	0xC883, 0xCA3B, 0xCBED, 0xCD78, 0xCEBA, 0xCF93, 0xCFE3, 0xCFE1, 0xCFD3, 
	0xCFAC, 0xCF62, 0xCEE6, 0xCE2E, 0xCD2E, 0xCBD8, 0xCA22, 0xC7FF, 0xC562, 
	0xC240, 0xBE8C, 0xBA3B, 0xB541, 0xAF60, 0xA8A4, 0xA16D, 0x1A1C, 0x130F, 
	0x0C9E, 0x06FB, 0x0251, 0xFEC7, 0xFC8A, 0xFBC1, 0xFC11, 0xFCF7, 0xFE6A, 
	0x005E, 0x02C7, 0x059B, 0x08CE, 0x0C55, 0x1024, 0x1431, 0x1871, 0x1CD8, 
	0xA15A, 0xA5EE, 0xAA87, 0xAF1B, 0xB39E, 0xB804, 0xBC44, 0xC051, 0xC421, 
	0xC7A8, 0xCADA, 0xCDAE, 0xD017, 0xD20B, 0xD37D, 0xD464, 0xD4B3, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xCA4E, 0xCA4E, 
	0xCA4E, 0xCA4E, 0xCA4E, 0xCA4E, 0xCA4E, 0xCA4E, 0xCA4E, 0xCA4E, 0xCA4E, 
	0xCA4E, 0xCA4E, 0xCA4E, 0xCA4E, 0xCA4E, 0xCA4E, 0xCA4E, 0xCA4E, 0xCA4E, 
	0xCA4E, 0xCAB6, 0xCBD9, 0xCD9C, 0xCFE3, 0xD292, 0xD58D, 0xD8B7, 0xDBF5, 
	0xDF2B, 0xE23C, 0xE50D, 0xE781, 0xE97D, 0xEAE4, 0xEB9A, 0xEBE9, 0xEC2D, 
	0xEC68, 0xEC99, 0xECC3, 0xECE5, 0xED00, 0xED15, 0xED25, 0xED30, 0xED38, 
	0xED3D, 0xED3F, 0xED40, 0xED40, 0xEC3B, 0xE9AE, 0xE65D, 0xE30D, 0xE082, 
	0xDEA9, 0xDCEB, 0xDB46, 0xD9BC, 0xD84A, 0xD6F0, 0xD5AC, 0xD480, 0xD368, 
	0xD266, 0xD177, 0xD09B, 0xCFD2, 0xCF1A, 0xCE73, 0xCDDC, 0xCD53, 0xCCDA, 
	0xCC6D, 0xCC0E, 0xCBBA, 0xCB71, 0xCB33, 0xCAFF, 0xCAD3, 0xCAAF, 0xCA92, 
	0xCA7C, 0xCA6B, 0xCA5F, 0xCA57, 0xCA52, 0xCA4F, 0xCA4E, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xF97B, 0xED8B, 0x0001, 0xFFFE, 
	0xC170, 0x054B, 0x054B, 0x054D, 0x0553, 0x055D, 0x056F, 0x0589, 0x05AD, 
	0x05DE, 0x061C, 0x066A, 0x0702, 0x0817, 0x099C, 0x0B83, 0x0DBF, 0x1044, 
	0x1305, 0x15F4, 0x1905, 0x1C2B, 0x1F5A, 0x2288, 0x25AD, 0x28C2, 0x2BBD, 
	0x2E96, 0x3146, 0x33C4, 0x3608, 0x3809, 0x39C0, 0x3B23, 0x3C2B, 0x3CCF, 
	0x3D08, 0x3CC9, 0x3C07, 0x3ABA, 0x38DC, 0x3665, 0x334F, 0x2F91, 0x2B24, 
	0x2602, 0x2023, 0x1980, 0x1211, 0x09D0, 0x00B5, 0xF6B8, 0xEBFB, 0xE137, 
	0xD74E, 0x4F23, 0x4996, 0x478B, 0x4793, 0x47AC, 0x47DB, 0x4820, 0x487F, 
	0x48FA, 0x4994, 0x4A4F, 0x4B2F, 0x4C35, 0x4D65, 0x4EC1, 0x504C, 0x5208, 
	0x53F8, 0xD61E, 0xD87E, 0xDB1A, 0xDDF5, 0xE10D, 0xE458, 0xE7C4, 0xEB43, 
	0xEEC6, 0xF23C, 0xF597, 0xF8C7, 0xFBBC, 0xFE67, 0x00B9, 0x02A2, 0x0412, 
	0x04FA, 0x054B, 0x2BD6, 0x2BF1, 0x2C39, 0x2CA4, 0x2D26, 0x2DB3, 0x2E40, 
	0x2EC2, 0x2F2D, 0x2F76, 0x2F91, 0x2F4A, 0x2E8B, 0x2D71, 0x2C1B, 0x2AA7, 
	0x2933, 0x27DC, 0x26C3, 0x2603, 0x25BD, 0x25CF, 0x2602, 0x2650, 0x26B5, 
	0x272C, 0x27AF, 0x283A, 0x28C8, 0x2952, 0x29D6, 0x2A4C, 0x2AB1, 0x2B00, 
	0x2B33, 0x2B45, 0x2B43, 0x2B3E, 0x2B37, 0x2B2D, 0x2B21, 0x2B15, 0x2B07, 
	0x2AFA, 0x2AED, 0x2AE0, 0x2AD5, 0x2ACB, 0x2AC3, 0x2ABE, 0x2ABD, 0x2B70, 
	0x2D30, 0x2F77, 0x4E42, 0x4C82, 0x4BCF, 0x4BDD, 0x4C05, 0x4C45, 0x4C9A, 
	0x4D00, 0x4D74, 0x4DF5, 0x4E7F, 0x4F0F, 0x4FA2, 0x5035, 0x50C6, 0x5151, 
	0x51D4, 0x524C, 0x2D4A, 0x2CF1, 0x2CAD, 0x2C7E, 0x2C5F, 0x2C44, 0x2C2C, 
	0x2C18, 0x2C08, 0x2BFA, 0x2BEF, 0x2BE7, 0x2BE1, 0x2BDC, 0x2BD9, 0x2BD7, 
	0x2BD6, 0xCCF5, 0xCCF6, 0xCCF8, 0xCCFE, 0xCD0A, 0xCD1D, 0xCD3A, 0xCD62, 
	0xCD98, 0xCDDD, 0xCE33, 0xCEB9, 0xCF89, 0xD0A2, 0xD202, 0xD3A6, 0xD58C, 
	0xD7B2, 0xDA16, 0xDCB6, 0xDF90, 0xE29F, 0xE5D7, 0xE92A, 0xEC8B, 0xEFEA, 
	0xF33A, 0xF66D, 0xF975, 0xFC42, 0xFEC9, 0x00FA, 0x02C6, 0x0421, 0x04FB, 
	0x0547, 0x050F, 0x0461, 0x0331, 0x0174, 0xFF1F, 0xFC28, 0xF884, 0xF427, 
	0xEF07, 0xE918, 0xE250, 0xDAA3, 0xD207, 0xC871, 0xBDD4, 0xB253, 0xA6BB, 
	0x9C05, 0x132A, 0x0D23, 0x0AE9, 0x0AF1, 0x0B0B, 0x0B3A, 0x0B82, 0x0BE4, 
	0x0C64, 0x0D04, 0x0DC9, 0x0EB4, 0x0FC8, 0x1109, 0x127A, 0x141C, 0x15F4, 
	0x1804, 0x9A4F, 0x9CD8, 0x9FA2, 0xA2B0, 0xA601, 0xA988, 0xAD35, 0xB0F7, 
	0xB4BC, 0xB875, 0xBC10, 0xBF7E, 0xC2AC, 0xC58B, 0xC80A, 0xCA18, 0xCBA4, 
	0xCC9E, 0xCCF5, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xC7DC, 
	0xC83F, 0xC949, 0xCAD3, 0xCCB0, 0xCEB8, 0xD0C0, 0xD29E, 0xD427, 0xD532, 
	0xD594, 0xD56A, 0xD4F4, 0xD43E, 0xD351, 0xD239, 0xD102, 0xCFB7, 0xCE63, 
	0xCD10, 0xCBCB, 0xCA9B, 0xC984, 0xC884, 0xC79B, 0xC6C9, 0xC60D, 0xC566, 
	0xC4D5, 0xC458, 0xC3F0, 0xC39B, 0xC35B, 0xC32D, 0xC312, 0xC309, 0xC3A8, 
	0xC567, 0xC81A, 0xCB95, 0xCFAB, 0xD430, 0xD8F8, 0xDDD6, 0xE29D, 0xE722, 
	0xEB38, 0xEEB3, 0xF167, 0xF326, 0xF3C5, 0xF320, 0xF15C, 0xEEB9, 0xEB77, 
	0xE7D4, 0xE411, 0xE06E, 0xDD2A, 0xDA84, 0xD8BD, 0xD815, 0xD811, 0xD80F, 
	0xD80D, 0xD80C, 0xD80B, 0xD80B, 0xD80B, 0xD80B, 0xD80B, 0xD80A, 0xD809, 
	0xD807, 0xD805, 0xD801, 0xD7C9, 0xD732, 0xD64B, 0xD523, 0xD3C8, 0xD249, 
	0xD0B5, 0xCF19, 0xCD85, 0xCC07, 0xCAAE, 0xC988, 0xC8A4, 0xC811, 0xC7DC, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xF548, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xBF5E, 0xD649, 0xD65A, 0xD68B, 0xD6D5, 0xD736, 0xD7A7, 
	0xD824, 0xD8A8, 0xD92E, 0xD9B3, 0xDA30, 0xDAA1, 0xDB01, 0xDB4C, 0xDB7C, 
	0xDB8D, 0xDB8D, 0xDB8D, 0xDB8D, 0xDB8D, 0xDB8D, 0xDB89, 0xDB7C, 0xDB69, 
	0xDB51, 0xDB34, 0xDB15, 0xDAF3, 0xDAD1, 0xDAAF, 0xDA8F, 0xDA73, 0xDA5A, 
	0xDA47, 0xDA3B, 0xDA37, 0xDA39, 0xDA40, 0xDA4B, 0xDA5A, 0xDA6C, 0xDA81, 
	0xDA97, 0xDAAF, 0xDAC8, 0xDAE2, 0xDAFB, 0xDB15, 0xDB2D, 0xDB43, 0xDB58, 
	0xDB69, 0xDB78, 0xDB84, 0xDB8B, 0xDB8D, 0xDB8D, 0xDB8D, 0xDB8D, 0xDB8D, 
	0xDB8D, 0xDB8D, 0xDB8D, 0xDB8D, 0xDB8D, 0xDB8D, 0xDB8D, 0xDB8D, 0xDB86, 
	0xDB70, 0xDB4E, 0xDB21, 0xDAEA, 0xDAAA, 0xDA63, 0xDA15, 0xD9C3, 0xD96E, 
	0xD917, 0xD8BF, 0xD868, 0xD813, 0xD7C1, 0xD774, 0xD72C, 0xD6ED, 0xD6B5, 
	0xD688, 0xD666, 0xD651, 0xD649, 0xEC40, 0xEC4C, 0xEC6F, 0xECA4, 0xECE8, 
	0xED38, 0xED91, 0xEDEF, 0xEE4F, 0xEEAD, 0xEF05, 0xEF56, 0xEF9A, 0xEFCF, 
	0xEFF1, 0xEFFE, 0xEFFE, 0xEFFE, 0xEFFE, 0xEFFE, 0xEFFE, 0xF00E, 0xF03D, 
	0xF086, 0xF0E3, 0xF151, 0xF1CB, 0xF24B, 0xF2CE, 0xF34E, 0xF3C8, 0xF436, 
	0xF493, 0xF4DC, 0xF50B, 0xF51C, 0xF512, 0xF4F7, 0xF4CC, 0xF493, 0xF44F, 
	0xF401, 0xF3AB, 0xF34E, 0xF2EF, 0xF28D, 0xF22B, 0xF1CB, 0xF16F, 0xF119, 
	0xF0CA, 0xF086, 0xF04D, 0xF022, 0xF007, 0xEFFE, 0xEFFE, 0xEFFE, 0xEFFE, 
	0xEFFE, 0xEFFE, 0xEFFE, 0xEFFE, 0xEFFE, 0xEFFE, 0xEFFE, 0xEFFE, 0xEFFE, 
	0xEFF8, 0xEFE9, 0xEFD1, 0xEFB1, 0xEF89, 0xEF5C, 0xEF29, 0xEEF3, 0xEEB8, 
	0xEE7C, 0xEE3E, 0xEE00, 0xEDC2, 0xED85, 0xED4B, 0xED14, 0xECE2, 0xECB4, 
	0xEC8D, 0xEC6D, 0xEC55, 0xEC45, 0xEC40, 0xB59D, 0xB57E, 0xB527, 0xB4A1, 
	0xB3F4, 0xB329, 0xB248, 0xB15A, 0xB068, 0xAF7A, 0xAE99, 0xADCE, 0xAD21, 
	0xAC9B, 0xAC44, 0xAC25, 0xAC25, 0xAC25, 0xAC25, 0xAC25, 0xAC25, 0xAC33, 
	0xAC5A, 0xAC97, 0xACE5, 0xAD41, 0xADA7, 0xAE12, 0xAE80, 0xAEEB, 0xAF51, 
	0xAFAD, 0xAFFB, 0xB038, 0xB05F, 0xB06D, 0xB065, 0xB04F, 0xB02B, 0xAFFB, 
	0xAFC2, 0xAF81, 0xAF38, 0xAEEB, 0xAE9B, 0xAE49, 0xADF7, 0xADA7, 0xAD5A, 
	0xAD12, 0xACD0, 0xAC97, 0xAC67, 0xAC43, 0xAC2D, 0xAC25, 0xAC25, 0xAC25, 
	0xAC25, 0xAC25, 0xAC25, 0xAC25, 0xAC25, 0xAC25, 0xAC25, 0xAC25, 0xAC25, 
	0xAC25, 0xAC32, 0xAC59, 0xAC96, 0xACE7, 0xAD4B, 0xADBE, 0xAE3E, 0xAEC9, 
	0xAF5C, 0xAFF5, 0xB092, 0xB130, 0xB1CD, 0xB266, 0xB2F9, 0xB384, 0xB404, 
	0xB477, 0xB4DB, 0xB52C, 0xB569, 0xB590, 0xB59D, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x2537, 0x2549, 0x257A, 0x25C7, 
	0x262A, 0x269F, 0x271F, 0x27A7, 0x2832, 0x28BA, 0x293B, 0x29AF, 0x2A12, 
	0x2A5F, 0x2A91, 0x2AA3, 0x2AA3, 0x2AA3, 0x2AA3, 0x2AA3, 0x2AA3, 0x2A6D, 
	0x29D7, 0x28F0, 0x27C5, 0x2666, 0x24E3, 0x2348, 0x21A7, 0x200D, 0x1E89, 
	0x1D2A, 0x1C00, 0x1B18, 0x1A82, 0x1A4D, 0x1A6B, 0x1AC2, 0x1B4B, 0x1C00, 
	0x1CDA, 0x1DD4, 0x1EE7, 0x200D, 0x213F, 0x2278, 0x23B0, 0x24E3, 0x2608, 
	0x271B, 0x2815, 0x28F0, 0x29A5, 0x2A2D, 0x2A84, 0x2AA3, 0x2AA3, 0x2AA3, 
	0x2AA3, 0x2AA3, 0x2AA3, 0x2AA3, 0x2AA3, 0x2AA3, 0x2AA3, 0x2AA3, 0x2AA3, 
	0x2AA3, 0x2A9B, 0x2A85, 0x2A62, 0x2A33, 0x29FA, 0x29B9, 0x296F, 0x2920, 
	0x28CB, 0x2874, 0x281A, 0x27BF, 0x2766, 0x270E, 0x26BA, 0x266A, 0x2621, 
	0x25DF, 0x25A6, 0x2578, 0x2555, 0x253E, 0x2537, 0xFFFF, 0xFFFC, 0xFFF3, 
	0xFFE4, 0xFFD2, 0xFFBC, 0xFFA5, 0xFF8B, 0xFF72, 0xFF59, 0xFF41, 0xFF2B, 
	0xFF19, 0xFF0B, 0xFF02, 0xFEFE, 0xFEFE, 0xFEFE, 0xFEFE, 0xFEFE, 0xFEFE, 
	0xFEFC, 0xFEF7, 0xFEF0, 0xFEE5, 0xFEDA, 0xFECC, 0xFEBE, 0xFEB0, 0xFEA2, 
	0xFE95, 0xFE89, 0xFE7F, 0xFE77, 0xFE72, 0xFE71, 0xFE72, 0xFE75, 0xFE79, 
	0xFE7F, 0xFE87, 0xFE8F, 0xFE99, 0xFEA2, 0xFEAD, 0xFEB7, 0xFEC2, 0xFECC, 
	0xFED6, 0xFEE0, 0xFEE8, 0xFEF0, 0xFEF6, 0xFEFA, 0xFEFD, 0xFEFE, 0xFEFE, 
	0xFEFE, 0xFEFE, 0xFEFE, 0xFEFE, 0xFEFE, 0xFEFE, 0xFEFE, 0xFEFE, 0xFEFE, 
	0xFEFE, 0xFEFE, 0xFF00, 0xFF04, 0xFF0A, 0xFF13, 0xFF1D, 0xFF2A, 0xFF37, 
	0xFF46, 0xFF55, 0xFF66, 0xFF76, 0xFF87, 0xFF98, 0xFFA8, 0xFFB7, 0xFFC6, 
	0xFFD4, 0xFFE0, 0xFFEA, 0xFFF3, 0xFFFA, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFF8, 
	0xFFE3, 0xFFC3, 0xFF99, 0xFF68, 0xFF32, 0xFEF9, 0xFEBF, 0xFE86, 0xFE51, 
	0xFE20, 0xFDF6, 0xFDD6, 0xFDC1, 0xFDBA, 0xFDBA, 0xFDBA, 0xFDBA, 0xFDBA, 
	0xFDBA, 0xFDBB, 0xFDBE, 0xFDC3, 0xFDC9, 0xFDD0, 0xFDD8, 0xFDE1, 0xFDE9, 
	0xFDF2, 0xFDFA, 0xFE01, 0xFE07, 0xFE0C, 0xFE0F, 0xFE10, 0xFE0F, 0xFE0E, 
	0xFE0B, 0xFE07, 0xFE03, 0xFDFD, 0xFDF8, 0xFDF2, 0xFDEB, 0xFDE5, 0xFDDF, 
	0xFDD8, 0xFDD2, 0xFDCD, 0xFDC7, 0xFDC3, 0xFDBF, 0xFDBC, 0xFDBB, 0xFDBA, 
	0xFDBA, 0xFDBA, 0xFDBA, 0xFDBA, 0xFDBA, 0xFDBA, 0xFDBA, 0xFDBA, 0xFDBA, 
	0xFDBA, 0xFDBA, 0xFDBA, 0xFDBD, 0xFDC6, 0xFDD5, 0xFDE8, 0xFE00, 0xFE1C, 
	0xFE3B, 0xFE5C, 0xFE7F, 0xFEA4, 0xFECA, 0xFEEF, 0xFF15, 0xFF3A, 0xFF5D, 
	0xFF7E, 0xFF9D, 0xFFB9, 0xFFD0, 0xFFE4, 0xFFF3, 0xFFFC, 0xFFFF, 0xBF3F, 
	0xBF2B, 0xBEF2, 0xBE99, 0xBE27, 0xBDA1, 0xBD0C, 0xBC6F, 0xBBD0, 0xBB33, 
	0xBA9E, 0xBA18, 0xB9A6, 0xB94D, 0xB914, 0xB900, 0xB900, 0xB900, 0xB900, 
	0xB900, 0xB900, 0xB922, 0xB984, 0xBA1C, 0xBADF, 0xBBC4, 0xBCC1, 0xBDCD, 
	0xBEDE, 0xBFEA, 0xC0E7, 0xC1CC, 0xC28F, 0xC327, 0xC389, 0xC3AB, 0xC398, 
	0xC35F, 0xC305, 0xC28F, 0xC201, 0xC15D, 0xC0AA, 0xBFEA, 0xBF22, 0xBE56, 
	0xBD89, 0xBCC1, 0xBC01, 0xBB4E, 0xBAAA, 0xBA1C, 0xB9A6, 0xB94C, 0xB913, 
	0xB900, 0xB900, 0xB900, 0xB900, 0xB900, 0xB900, 0xB900, 0xB900, 0xB900, 
	0xB900, 0xB900, 0xB900, 0xB900, 0xB908, 0xB922, 0xB94A, 0xB980, 0xB9C2, 
	0xBA0D, 0xBA62, 0xBABE, 0xBB1F, 0xBB84, 0xBBEB, 0xBC54, 0xBCBB, 0xBD20, 
	0xBD81, 0xBDDD, 0xBE31, 0xBE7D, 0xBEBF, 0xBEF5, 0xBF1D, 0xBF36, 0xBF3F, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xBF5E, 0x1B09, 0x1AFB, 0x1A9A, 0x1994, 0x1742, 0x139E, 0x0F45, 
	0x0AD3, 0x06E4, 0x0416, 0x0304, 0x0427, 0x06DE, 0x0A1C, 0x0CD3, 0x0DF7, 
	0x0DF7, 0x0DF7, 0x0DF7, 0x0DF7, 0x0DF7, 0x0E02, 0x0E22, 0x0E53, 0x0E93, 
	0x0EDE, 0x0F31, 0x0F89, 0x0FE2, 0x103A, 0x108C, 0x10D7, 0x1117, 0x1149, 
	0x1169, 0x1174, 0x116E, 0x115B, 0x113E, 0x1117, 0x10E8, 0x10B3, 0x1078, 
	0x103A, 0x0FF8, 0x0FB5, 0x0F73, 0x0F31, 0x0EF2, 0x0EB8, 0x0E82, 0x0E53, 
	0x0E2D, 0x0E10, 0x0DFD, 0x0DF7, 0x0DF7, 0x0DF7, 0x0DF7, 0x0DF7, 0x0DF7, 
	0x0DF7, 0x0DF7, 0x0DF7, 0x0DF7, 0x0DF7, 0x0DF7, 0x0DF7, 0x0DC7, 0x0D44, 
	0x0C7C, 0x0B7E, 0x0A5A, 0x091E, 0x07DC, 0x06A0, 0x057C, 0x047E, 0x03B6, 
	0x0333, 0x0304, 0x03B0, 0x0583, 0x0834, 0x0B78, 0x0F06, 0x1294, 0x15D9, 
	0x1889, 0x1A5D, 0x1B09, 0x1144, 0x1144, 0x1147, 0x114E, 0x11CD, 0x1305, 
	0x14AB, 0x1675, 0x1818, 0x194A, 0x19C1, 0x1882, 0x158A, 0x11FF, 0x0F07, 
	0x0DC8, 0x0DC8, 0x0DC8, 0x0DC8, 0x0DC8, 0x0DC8, 0x0DB8, 0x0D8A, 0x0D43, 
	0x0CE8, 0x0C7E, 0x0C07, 0x0B8B, 0x0B0B, 0x0A8E, 0x0A18, 0x09AD, 0x0952, 
	0x090C, 0x08DE, 0x08CE, 0x08D7, 0x08F2, 0x091B, 0x0952, 0x0995, 0x09E1, 
	0x0A35, 0x0A8E, 0x0AEC, 0x0B4B, 0x0BAA, 0x0C07, 0x0C61, 0x0CB5, 0x0D01, 
	0x0D43, 0x0D7A, 0x0DA4, 0x0DBF, 0x0DC8, 0x0DC8, 0x0DC8, 0x0DC8, 0x0DC8, 
	0x0DC8, 0x0DC8, 0x0DC8, 0x0DC8, 0x0DC8, 0x0DC8, 0x0DC8, 0x0DC8, 0x0DFB, 
	0x0E8B, 0x0F66, 0x107C, 0x11BB, 0x1314, 0x1475, 0x15CD, 0x170D, 0x1822, 
	0x18FD, 0x198D, 0x19C1, 0x1984, 0x18DF, 0x17EB, 0x16C4, 0x1582, 0x1441, 
	0x1319, 0x1226, 0x1181, 0x1144, 0xAC43, 0xAC30, 0xABAC, 0xAA43, 0xA67E, 
	0x9FFB, 0x97F1, 0x8F96, 0x881E, 0x82C0, 0x80B1, 0x834B, 0x897E, 0x90E4, 
	0x9718, 0x99B1, 0x99B1, 0x99B1, 0x99B1, 0x99B1, 0x99B1, 0x99DA, 0x9A4E, 
	0x9B02, 0x9BE9, 0x9CF8, 0x9E24, 0x9F61, 0xA0A4, 0xA1E2, 0xA30E, 0xA41D, 
	0xA504, 0xA5B7, 0xA62B, 0xA654, 0xA63D, 0xA5FA, 0xA590, 0xA504, 0xA45B, 
	0xA39A, 0xA2C5, 0xA1E2, 0xA0F5, 0xA003, 0x9F11, 0x9E24, 0x9D41, 0x9C6C, 
	0x9BAB, 0x9B02, 0x9A76, 0x9A0C, 0x99C9, 0x99B1, 0x99B1, 0x99B1, 0x99B1, 
	0x99B1, 0x99B1, 0x99B1, 0x99B1, 0x99B1, 0x99B1, 0x99B1, 0x99B1, 0x99B1, 
	0x9945, 0x9819, 0x9650, 0x940C, 0x9171, 0x8EA2, 0x8BC1, 0x88F1, 0x8656, 
	0x8412, 0x8249, 0x811D, 0x80B1, 0x81E9, 0x8539, 0x8A1A, 0x9007, 0x967A, 
	0x9CED, 0xA2DA, 0xA7BB, 0xAB0B, 0xAC43, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0x1E4A, 0x1EB8, 0x1FE4, 0x219E, 0x23B7, 0x25FF, 0x2847, 0x2A60, 0x2C1A, 
	0x2D46, 0x2DB5, 0x2BFB, 0x27DE, 0x22F4, 0x1ED7, 0x1D1D, 0x1D1D, 0x1D1D, 
	0x1D1D, 0x1D1D, 0x1D1D, 0x1CBF, 0x1BB5, 0x1A1B, 0x1809, 0x159C, 0x12ED, 
	0x1016, 0x0D32, 0x0A5B, 0x07AB, 0x053E, 0x032D, 0x0192, 0x0088, 0x002A, 
	0x005F, 0x00F9, 0x01EC, 0x032D, 0x04B0, 0x066B, 0x0852, 0x0A5B, 0x0C7A, 
	0x0EA4, 0x10CE, 0x12ED, 0x14F5, 0x16DD, 0x1897, 0x1A1B, 0x1B5B, 0x1C4E, 
	0x1CE8, 0x1D1D, 0x1D1D, 0x1D1D, 0x1D1D, 0x1D1D, 0x1D1D, 0x1D1D, 0x1D1D, 
	0x1D1D, 0x1D1D, 0x1D1D, 0x1D1D, 0x1D1D, 0x1D65, 0x1E2C, 0x1F5C, 0x20DC, 
	0x2297, 0x2474, 0x265E, 0x283B, 0x29F6, 0x2B76, 0x2CA6, 0x2D6D, 0x2DB5, 
	0x2D46, 0x2C1A, 0x2A60, 0x2847, 0x25FF, 0x23B7, 0x219E, 0x1FE4, 0x1EB8, 
	0x1E4A, 0xFFFF, 0x0004, 0x001B, 0x0052, 0x00B4, 0x0134, 0x01C4, 0x0253, 
	0x02D0, 0x032C, 0x0355, 0x035F, 0x0365, 0x0368, 0x0369, 0x0369, 0x0369, 
	0x0369, 0x0369, 0x0369, 0x0369, 0x036B, 0x0373, 0x037E, 0x038C, 0x039D, 
	0x03B0, 0x03C4, 0x03D8, 0x03EC, 0x03FF, 0x0410, 0x041F, 0x042A, 0x0431, 
	0x0434, 0x0432, 0x042E, 0x0427, 0x041F, 0x0414, 0x0408, 0x03FB, 0x03EC, 
	0x03DD, 0x03CE, 0x03BF, 0x03B0, 0x03A2, 0x0395, 0x0389, 0x037E, 0x0375, 
	0x036F, 0x036A, 0x0369, 0x0369, 0x0369, 0x0369, 0x0369, 0x0369, 0x0369, 
	0x0369, 0x0369, 0x0369, 0x0369, 0x0369, 0x0369, 0x0369, 0x0369, 0x0369, 
	0x0368, 0x0368, 0x0367, 0x0366, 0x0364, 0x0362, 0x0360, 0x035D, 0x035A, 
	0x0355, 0x033A, 0x02F7, 0x0297, 0x0223, 0x01A5, 0x0128, 0x00B6, 0x0057, 
	0x0017, 0xFFFF, 0xFF2F, 0xFF38, 0xFF4C, 0xFF61, 0xFF6F, 0xFF7E, 0xFF98, 
	0xFFC7, 0x0018, 0x0093, 0x0143, 0x027E, 0x0443, 0x061B, 0x078E, 0x0824, 
	0x0824, 0x0824, 0x0824, 0x0824, 0x0824, 0x081F, 0x0812, 0x07FE, 0x07E4, 
	0x07C5, 0x07A3, 0x077F, 0x075A, 0x0736, 0x0714, 0x06F5, 0x06DB, 0x06C7, 
	0x06BA, 0x06B5, 0x06B8, 0x06BF, 0x06CB, 0x06DB, 0x06EE, 0x0704, 0x071C, 
	0x0736, 0x0751, 0x076D, 0x0788, 0x07A3, 0x07BD, 0x07D5, 0x07EB, 0x07FE, 
	0x080E, 0x081A, 0x0821, 0x0824, 0x0824, 0x0824, 0x0824, 0x0824, 0x0824, 
	0x0824, 0x0824, 0x0824, 0x0824, 0x0824, 0x0824, 0x0824, 0x0810, 0x07D7, 
	0x077D, 0x0708, 0x067D, 0x05E0, 0x0536, 0x0485, 0x03D0, 0x031E, 0x0272, 
	0x01D2, 0x0143, 0x00C8, 0x0061, 0x000C, 0xFFC7, 0xFF92, 0xFF6A, 0xFF4E, 
	0xFF3C, 0xFF32, 0xFF2F, 0xC9D7, 0xC9C5, 0xC9A4, 0xC992, 0xCB8F, 0xD0B1, 
	0xD7B6, 0xDF5B, 0xE660, 0xEB82, 0xED80, 0xEAD6, 0xE47B, 0xDCE6, 0xD68B, 
	0xD3E1, 0xD3E1, 0xD3E1, 0xD3E1, 0xD3E1, 0xD3E1, 0xD413, 0xD49E, 0xD575, 
	0xD68B, 0xD7D1, 0xD939, 0xDAB7, 0xDC3B, 0xDDB8, 0xDF20, 0xE066, 0xE17C, 
	0xE253, 0xE2DE, 0xE310, 0xE2F4, 0xE2A3, 0xE224, 0xE17C, 0xE0B1, 0xDFC8, 
	0xDEC9, 0xDDB8, 0xDC9B, 0xDB79, 0xDA56, 0xD939, 0xD828, 0xD729, 0xD640, 
	0xD575, 0xD4CD, 0xD44E, 0xD3FD, 0xD3E1, 0xD3E1, 0xD3E1, 0xD3E1, 0xD3E1, 
	0xD3E1, 0xD3E1, 0xD3E1, 0xD3E1, 0xD3E1, 0xD3E1, 0xD3E1, 0xD3E1, 0xD450, 
	0xD583, 0xD758, 0xD9AA, 0xDC55, 0xDF37, 0xE22A, 0xE50B, 0xE7B7, 0xEA09, 
	0xEBDE, 0xED11, 0xED80, 0xEC80, 0xE9CA, 0xE5CC, 0xE0F2, 0xDBAB, 0xD664, 
	0xD18B, 0xCD8D, 0xCAD7, 0xC9D7, 
},
{
	0x0001, 0x0000, 0x0036, 0x0001, 0x0058, 0x0037, 0x0001, 0x008F, 0x0001, 
	0x0090, 0x0001, 0x0091, 0x005B, 0x0092, 0x005B, 0x00ED, 0x005B, 0x0148, 
	0x005B, 0x01A3, 0x005B, 0x01FE, 0x005B, 0x0259, 0x005B, 0x02B4, 0x005B, 
	0x030F, 0x005B, 0x036A, 0x0001, 0x03C5, 0x0001, 0x03C6, 0x0001, 0x03C7, 
	0x005B, 0x03C8, 0x005B, 0x0423, 0x005B, 0x047E, 0x002B, 0x04D9, 0x005B, 
	0x0504, 0x005A, 0x055F, 0x0058, 0x05B9, 0x0001, 0x0611, 0x0001, 0x0612, 
	0x0001, 0x0613, 0x0001, 0x0614, 0x0001, 0x0615, 0x005B, 0x0616, 0x0059, 
	0x0671, 0x005B, 0x06CA, 0x005B, 0x0725, 0x0032, 0x0780, 0x005B, 0x07B2, 
	0x005A, 0x080D, 0x005A, 0x0867, 0x0001, 0x08C1, 0x005B, 0x08C2, 0x005A, 
	0x091D, 0x0001, 0x0977, 0x005B, 0x0978, 0x005B, 0x09D3, 0x005B, 0x0A2E, 
	0x005B, 0x0A89, 0x0010, 0x0AE4, 0x005B, 0x0AF4, 0x005B, 0x0B4F, 0x005B, 
	0x0BAA, 0x005B, 0x0C05, 0x005B, 0x0C60, 0x005A, 0x0CBB, 0x0001, 0x0D15, 
	0x005B, 0x0D16, 0x005B, 0x0D71, 0x005B, 0x0DCC, 0x0059, 0x0E27, 0x0056, 
	0x0E80, 0x005B, 0x0ED6, 0x005B, 0x0F31, 0x005B, 0x0F8C, 0x005B, 0x0FE7, 
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_CROUCHING], 0, 189, 0, 0, 60, {
	0x0000, 0x0069, 0x0069, 0x0069, 0x0069, 0x0069, 0x0069, 0x006A, 0x006A, 
	0x006A, 0x006B, 0x006B, 0x006B, 0x006B, 0x006B, 0x006B, 0x006B, 0x006B, 
	0x006B, 0x006B, 0x006B, 0x006A, 0x006A, 0x006A, 0x006A, 0x0069, 0x0069, 
	0x0069, 0x0069, 0x0069, 0x0069, 0x0069, 0x0069, 0x0069, 0x0069, 0x0069, 
	0x006A, 0x006A, 0x006A, 0x006A, 0x006B, 0x006B, 0x006B, 0x006B, 0x006B, 
	0x006B, 0x006B, 0x006B, 0x006B, 0x006B, 0x006B, 0x006A, 0x006A, 0x006A, 
	0x006A, 0x0069, 0xFFDD, 0x0000, 0x3FFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x50ED, 0x50E7, 
	0x50D6, 0x50BC, 0x509A, 0x5073, 0x5049, 0x501C, 0x4FF0, 0x4FC5, 0x4F9F, 
	0x4F7D, 0x4F63, 0x4F52, 0x4F4C, 0x4F51, 0x4F60, 0x4F77, 0x4F95, 0x4FB8, 
	0x4FDF, 0x5008, 0x5031, 0x505A, 0x5081, 0x50A4, 0x50C2, 0x50D9, 0x50E8, 
	0x50ED, 0x50E8, 0x50D9, 0x50C2, 0x50A4, 0x5081, 0x505A, 0x5031, 0x5008, 
	0x4FDF, 0x4FB8, 0x4F95, 0x4F77, 0x4F60, 0x4F51, 0x4F4C, 0x4F51, 0x4F60, 
	0x4F77, 0x4F95, 0x4FB8, 0x4FDF, 0x5008, 0x5031, 0x505A, 0x5081, 0x50A4, 
	0x50C2, 0x50D9, 0x50E8, 0x50ED, 0x50E8, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x14A4, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xDBC9, 0xDBC4, 
	0xDBB7, 0xDBA2, 0xDB86, 0xDB64, 0xDB3D, 0xDB12, 0xDAE5, 0xDAB5, 0xDA85, 
	0xDA54, 0xDA25, 0xD9F7, 0xD9CD, 0xD9A6, 0xD984, 0xD968, 0xD953, 0xD945, 
	0xD940, 0xD94A, 0xD966, 0xD992, 0xD9CD, 0xDA16, 0xDA6A, 0xDAC8, 0xDB30, 
	0xDB9E, 0xDC12, 0xDC89, 0xDD03, 0xDD7E, 0xDDF8, 0xDE70, 0xDEE4, 0xDF52, 
	0xDFB9, 0xE018, 0xE06C, 0xE0B5, 0xE0F0, 0xE11C, 0xE138, 0xE141, 0xE12F, 
	0xE0FD, 0xE0B0, 0xE04C, 0xDFD6, 0xDF54, 0xDECB, 0xDE3F, 0xDDB6, 0xDD34, 
	0xDCBF, 0xDC5B, 0xDC0D, 0xDBDB, 0xDBC9, 0x0001, 0xFFFE, 0xC170, 0xCB6A, 
	0xCB72, 0xCB87, 0xCBA8, 0xCBD3, 0xCC05, 0xCC3C, 0xCC76, 0xCCB1, 0xCCEC, 
	0xCD23, 0xCD55, 0xCD7F, 0xCDA0, 0xCDB6, 0xCDBD, 0xCDB6, 0xCDA0, 0xCD7F, 
	0xCD55, 0xCD23, 0xCCEC, 0xCCB1, 0xCC76, 0xCC3C, 0xCC05, 0xCBD3, 0xCBA8, 
	0xCB87, 0xCB72, 0xCB6A, 0xCB72, 0xCB87, 0xCBA8, 0xCBD3, 0xCC05, 0xCC3C, 
	0xCC76, 0xCCB1, 0xCCEC, 0xCD23, 0xCD55, 0xCD7F, 0xCDA0, 0xCDB6, 0xCDBD, 
	0xCDB6, 0xCDA0, 0xCD7F, 0xCD55, 0xCD23, 0xCCEC, 0xCCB1, 0xCC76, 0xCC3C, 
	0xCC05, 0xCBD3, 0xCBA8, 0xCB87, 0xCB72, 0xCB6A, 0xAE17, 0xE5E8, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xC929, 0xFAAE, 0xED69, 0xF45E, 0x0001, 0xFFFE, 0xC170, 
	0x3E5A, 0x3E4D, 0x3E28, 0x3DEF, 0x3DA6, 0x3D51, 0x3CF2, 0x3C8E, 0x3C28, 
	0x3BC3, 0x3B65, 0x3B0F, 0x3AC6, 0x3A8D, 0x3A69, 0x3A5B, 0x3A69, 0x3A8D, 
	0x3AC6, 0x3B0F, 0x3B65, 0x3BC3, 0x3C28, 0x3C8E, 0x3CF2, 0x3D51, 0x3DA6, 
	0x3DEF, 0x3E28, 0x3E4D, 0x3E5A, 0x3E4D, 0x3E28, 0x3DEF, 0x3DA6, 0x3D51, 
	0x3CF2, 0x3C8E, 0x3C28, 0x3BC3, 0x3B65, 0x3B0F, 0x3AC6, 0x3A8D, 0x3A69, 
	0x3A5B, 0x3A69, 0x3A8D, 0x3AC6, 0x3B0F, 0x3B65, 0x3BC3, 0x3C28, 0x3C8E, 
	0x3CF2, 0x3D51, 0x3DA6, 0x3DEF, 0x3E28, 0x3E4D, 0x3E5A, 0x54D9, 0xEC67, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0xCA19, 0x021D, 0x123E, 0xF5F6, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xBF5E, 0xFD86, 0xDCA1, 0x7A7E, 
	0x7A85, 0x7A97, 0x7AB4, 0x7AD9, 0x7B05, 0x7B35, 0x7B68, 0x7B9C, 0x7BCF, 
	0x7BFF, 0x7C2A, 0x7C50, 0x7C6C, 0x7C7F, 0x7C86, 0x7C7F, 0x7C6C, 0x7C50, 
	0x7C2A, 0x7BFF, 0x7BCF, 0x7B9C, 0x7B68, 0x7B35, 0x7B05, 0x7AD9, 0x7AB4, 
	0x7A97, 0x7A85, 0x7A7E, 0x7A85, 0x7A97, 0x7AB4, 0x7AD9, 0x7B05, 0x7B35, 
	0x7B68, 0x7B9C, 0x7BCF, 0x7BFF, 0x7C2A, 0x7C50, 0x7C6C, 0x7C7F, 0x7C86, 
	0x7C7F, 0x7C6C, 0x7C50, 0x7C2A, 0x7BFF, 0x7BCF, 0x7B9C, 0x7B68, 0x7B35, 
	0x7B05, 0x7AD9, 0x7AB4, 0x7A97, 0x7A85, 0x7A7E, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x4C54, 
	0xFA4B, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xBB2C, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xBF5E, 0x044C, 0x2292, 0x7484, 0x748A, 0x749D, 0x74BA, 0x74DF, 0x750A, 
	0x753B, 0x756D, 0x75A1, 0x75D4, 0x7604, 0x7630, 0x7655, 0x7672, 0x7685, 
	0x768B, 0x7685, 0x7672, 0x7655, 0x7630, 0x7604, 0x75D4, 0x75A1, 0x756D, 
	0x753B, 0x750A, 0x74DF, 0x74BA, 0x749D, 0x748A, 0x7484, 0x748A, 0x749D, 
	0x74BA, 0x74DF, 0x750A, 0x753B, 0x756D, 0x75A1, 0x75D4, 0x7604, 0x7630, 
	0x7655, 0x7672, 0x7685, 0x768B, 0x7685, 0x7672, 0x7655, 0x7630, 0x7604, 
	0x75D4, 0x75A1, 0x756D, 0x753B, 0x750A, 0x74DF, 0x74BA, 0x749D, 0x748A, 
	0x7484, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x44FE, 0x0012, 0x000C, 0xFFFB, 0xFFE1, 0xFFBF, 0xFF99, 0xFF6E, 0xFF42, 
	0xFF15, 0xFEEB, 0xFEC4, 0xFEA2, 0xFE88, 0xFE77, 0xFE71, 0xFE76, 0xFE85, 
	0xFE9C, 0xFEBA, 0xFEDD, 0xFF04, 0xFF2D, 0xFF56, 0xFF7F, 0xFFA6, 0xFFC9, 
	0xFFE7, 0xFFFE, 0x000D, 0x0012, 0x000D, 0xFFFE, 0xFFE7, 0xFFC9, 0xFFA6, 
	0xFF7F, 0xFF56, 0xFF2D, 0xFF04, 0xFEDD, 0xFEBA, 0xFE9C, 0xFE85, 0xFE76, 
	0xFE71, 0xFE76, 0xFE85, 0xFE9C, 0xFEBA, 0xFEDD, 0xFF04, 0xFF2D, 0xFF56, 
	0xFF7F, 0xFFA6, 0xFFC9, 0xFFE7, 0xFFFE, 0x000D, 0x0012, 0x000D, 0xFF30, 
	0xC62C, 
},
{
	0x0001, 0x0000, 0x0037, 0x0001, 0x0001, 0x0038, 0x0001, 0x0039, 0x0001, 
	0x003A, 0x0001, 0x003B, 0x0036, 0x003C, 0x0001, 0x0072, 0x003D, 0x0073, 
	0x003D, 0x00B0, 0x003D, 0x00ED, 0x0001, 0x012A, 0x003D, 0x012B, 0x003D, 
	0x0168, 0x003D, 0x01A5, 0x0001, 0x01E2, 0x0001, 0x01E3, 0x0001, 0x01E4, 
	0x003D, 0x01E5, 0x0001, 0x0222, 0x0001, 0x0223, 0x003B, 0x0224, 0x003D, 
	0x025F, 0x0001, 0x029C, 0x0001, 0x029D, 0x0001, 0x029E, 0x0001, 0x029F, 
	0x0001, 0x02A0, 0x0001, 0x02A1, 0x0001, 0x02A2, 0x003D, 0x02A3, 0x0001, 
	0x02E0, 0x0001, 0x02E1, 0x003B, 0x02E2, 0x0032, 0x031D, 0x0001, 0x034F, 
	0x0001, 0x0350, 0x0001, 0x0351, 0x0001, 0x0352, 0x003A, 0x0353, 0x003B, 
	0x038D, 0x0001, 0x03C8, 0x0001, 0x03C9, 0x0001, 0x03CA, 0x003D, 0x03CB, 
	0x003C, 0x0408, 0x003B, 0x0444, 0x0001, 0x047F, 0x0001, 0x0480, 0x003D, 
	0x0481, 0x0001, 0x04BE, 0x003A, 0x04BF, 0x003B, 0x04F9, 0x0001, 0x0534, 
	0x0001, 0x0535, 0x0001, 0x0536, 0x003D, 0x0537, 0x003D, 0x0574, 0x0037, 
	0x05B1, 0x0001, 0x05E8, 0x003D, 0x05E9, 0x0001, 0x0626, 0x0001, 0x0627, 
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_START_CROUCHING], 0, 189, 0, 5, 5, {
	0x0000, 0x00AA, 0x00A3, 0x008C, 0x0078, 0x006D, 0x0069, 0x0000, 0xFFF9, 
	0xFFED, 0xFFE4, 0xFFDF, 0xFFDD, 0x0000, 0x3FFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x40A1, 0x4253, 0x4967, 0x4E82, 0x508D, 0x50ED, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0884, 0x0B65, 0x1662, 0x15EE, 0x1518, 0x14A4, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFC61, 0xF8FD, 0xEAD5, 0xE09E, 
	0xDC88, 0xDBC9, 0x0001, 0xFFFE, 0xC170, 0xFB1C, 0xFB7B, 0x0BFD, 0xCB6A, 
	0xD2DB, 0xD24B, 0xCC95, 0xAE17, 0xD4B3, 0xD163, 0xA3CD, 0xEB34, 0xE5E8, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xCA4E, 0xD5F0, 0xCF7D, 0xC929, 0x0000, 0xFFFF, 0x0479, 0xFAAE, 0xF97B, 
	0xF97B, 0xFABF, 0xED69, 0xED8B, 0xED8B, 0xED31, 0xF45E, 0x0001, 0xFFFE, 
	0xC170, 0x054B, 0x077B, 0x14E1, 0x3E59, 0x3E5A, 0x2BD6, 0x2B68, 0x383C, 
	0x54DA, 0x54D9, 0xCCF5, 0xCBB2, 0xC7C9, 0xF1B2, 0xEC67, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xC7DC, 0xD400, 0xCBAF, 0xCA19, 0xFFFF, 0xFFFF, 0xFBFC, 0x021D, 
	0xFFFF, 0x0000, 0xFE46, 0x123E, 0xF548, 0xF548, 0xF4ED, 0xF5F6, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xBF5E, 0xD649, 0xDC90, 0xE0D8, 0xF449, 0xFD86, 0xEC40, 0xEB68, 0xE124, 
	0xDE10, 0xDCA1, 0xB59D, 0xAC47, 0x9D01, 0x86BE, 0x7A7E, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x2537, 0x2C2E, 0x3D93, 0x4C54, 0xFFFF, 0x0255, 0x040D, 0xFA55, 0xFA4B, 
	0xFFFF, 0x001F, 0x00A7, 0xFF55, 0xFFFF, 0x0000, 0xBF3F, 0xBD85, 0xB754, 
	0xB676, 0xBB2C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xBF5E, 0x1B09, 0x187C, 0x1420, 0x0D43, 0x044C, 
	0x1144, 0x11AF, 0x1AE6, 0x20C1, 0x2292, 0xAC43, 0xA658, 0x9166, 0x80A9, 
	0x7484, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x1E4A, 0x2250, 0x32D0, 0x44FE, 0xFFFF, 0xFF01, 0xFDFF, 
	0x002A, 0x0012, 0xFF2F, 0xFF23, 0xFF21, 0xFF34, 0xFF30, 0xC9D7, 0xC8C5, 
	0xC825, 0xC159, 0xC62C, 
},
{
	0x0001, 0x0000, 0x0006, 0x0001, 0x0006, 0x0007, 0x0001, 0x000D, 0x0001, 
	0x000E, 0x0001, 0x000F, 0x0001, 0x0010, 0x0003, 0x0011, 0x0006, 0x0014, 
	0x0005, 0x001A, 0x0005, 0x001F, 0x0006, 0x0024, 0x0006, 0x002A, 0x0002, 
	0x0030, 0x0006, 0x0032, 0x0001, 0x0038, 0x0001, 0x0039, 0x0001, 0x003A, 
	0x0004, 0x003B, 0x0004, 0x003F, 0x0005, 0x0043, 0x0006, 0x0048, 0x0003, 
	0x004E, 0x0004, 0x0051, 0x0004, 0x0055, 0x0004, 0x0059, 0x0004, 0x005D, 
	0x0001, 0x0061, 0x0001, 0x0062, 0x0001, 0x0063, 0x0005, 0x0064, 0x0005, 
	0x0069, 0x0005, 0x006E, 0x0006, 0x0073, 0x0006, 0x0079, 0x0004, 0x007F, 
	0x0004, 0x0083, 0x0004, 0x0087, 0x0004, 0x008B, 0x0006, 0x008F, 0x0004, 
	0x0095, 0x0001, 0x0099, 0x0005, 0x009A, 0x0005, 0x009F, 0x0005, 0x00A4, 
	0x0005, 0x00A9, 0x0006, 0x00AE, 0x0004, 0x00B4, 0x0005, 0x00B8, 0x0006, 
	0x00BD, 0x0005, 0x00C3, 0x0006, 0x00C8, 0x0004, 0x00CE, 0x0001, 0x00D2, 
	0x0005, 0x00D3, 0x0005, 0x00D8, 0x0005, 0x00DD, 0x0006, 0x00E2, 0x0004, 
	0x00E8, 0x0004, 0x00EC, 0x0005, 0x00F0, 0x0005, 0x00F5, 0x0005, 0x00FA, 
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_STOP_CROUCHING], 0, 189, 0, 9, 9, {
	0x0000, 0x0069, 0x006B, 0x006F, 0x0076, 0x0080, 0x008C, 0x0099, 0x00A3, 
	0x00A8, 0x00AA, 0xFFDD, 0xFFDE, 0xFFE0, 0xFFE3, 0xFFE8, 0xFFED, 0xFFF3, 
	0xFFF9, 0xFFFE, 0x0000, 0x0000, 0x3FFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x50ED, 0x50E8, 
	0x50C5, 0x5067, 0x4FB0, 0x4E82, 0x4575, 0x4253, 0x40D8, 0x40A1, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x14A4, 
	0x130B, 0x0F3D, 0x0AB1, 0x06E3, 0x054A, 0x0B93, 0x0B65, 0x08E2, 0x0884, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0xDBC9, 0xDCE7, 0xDFE6, 0xE43C, 0xE961, 0xEECA, 
	0xF3EE, 0xF844, 0xFB43, 0xFC61, 0x0001, 0xFFFE, 0xC170, 0xCB6A, 0xCB6A, 
	0xCB69, 0xCBCA, 0xACAE, 0xF990, 0x0119, 0xFB7B, 0xFB28, 0xFB1C, 0xAE17, 
	0xAE17, 0xAE17, 0xAE17, 0xB0CB, 0xD550, 0xD163, 0xD24B, 0xD2C9, 0xD2DB, 
	0xE5E8, 0xE896, 0xF299, 0xF932, 0x1A12, 0xC6F1, 0xC8B8, 0xD163, 0xD446, 
	0xD4B3, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xC929, 0xC929, 0xC929, 0xC929, 0xC929, 0xC929, 0xCF6B, 0xD5F0, 
	0xD0ED, 0xCA4E, 0xFAAE, 0xFCE9, 0x010D, 0x0347, 0x024B, 0x014F, 0x01EA, 
	0xFFFF, 0x0000, 0xED69, 0xEC7E, 0xEAC9, 0xE9DD, 0xEC63, 0xFE09, 0xFA06, 
	0xF97B, 0xF45E, 0xF43D, 0xF401, 0xF3E0, 0xF444, 0xF6FB, 0xED64, 0xED8B, 
	0x0001, 0xFFFE, 0xC170, 0x3E5A, 0x3E5A, 0x37AC, 0x3E58, 0xDD1E, 0xFE95, 
	0x064A, 0x077B, 0x0593, 0x054B, 0x54D9, 0x54DA, 0x54DA, 0x54DA, 0x2F2E, 
	0x2B84, 0x2A69, 0x2B68, 0x2BC8, 0x2BD6, 0xEC67, 0xEF14, 0xF1D2, 0xFFAD, 
	0x9E37, 0xBF69, 0xC643, 0xCBB2, 0xCCCC, 0xCCF5, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xCA19, 0xCA19, 0xCA19, 
	0xCA19, 0xCA19, 0xCA19, 0xCD31, 0xD400, 0xCEC0, 0xC7DC, 0x021D, 0xFFCE, 
	0xFB86, 0xF938, 0xF9A3, 0xFC90, 0xFE47, 0xFFFF, 0x0000, 0xFFFF, 0x123E, 
	0x1226, 0x1183, 0x0FC8, 0x07ED, 0x014C, 0xFF42, 0x0000, 0xFFFF, 0xF5F6, 
	0xF57A, 0xF493, 0xF417, 0xF488, 0xF511, 0xF521, 0xF548, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xBF5E, 0xFD86, 0xFCBC, 0xFADB, 0xF89D, 
	0xF6BC, 0xF5F2, 0xE29C, 0xDC90, 0xD82D, 0xD649, 0xDCA1, 0xDE13, 0xE184, 
	0xE5A0, 0xE911, 0xEA83, 0xE920, 0xEB68, 0xEC1F, 0xEC40, 0x7A7E, 0x7AA8, 
	0x7BCB, 0x7EE3, 0x84E9, 0x8ED8, 0xA2A8, 0xAC47, 0xB2DB, 0xB59D, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x4C54, 0x4C3B, 0x4B8E, 0x49B7, 
	0x4623, 0x403C, 0x347E, 0x2C2E, 0x272C, 0x2537, 0xFA4B, 0xFA4C, 0xFA4E, 
	0xFA51, 0xFA54, 0xFA55, 0x03CF, 0x0255, 0x00E9, 0x0000, 0x0000, 0xFFED, 
	0xFFC3, 0xFF91, 0xFF67, 0xFF55, 0x0072, 0x001F, 0x0005, 0xFFFF, 0xBB2C, 
	0xBAAF, 0xB984, 0xB81F, 0xB6F3, 0xB676, 0xBA41, 0xBD85, 0xBEE1, 0xBF3F, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xBF5E, 0x044C, 0x046F, 
	0x0517, 0x06A4, 0x0972, 0x0DE1, 0x13B6, 0x187C, 0x1A92, 0x1B09, 0x2292, 
	0x221B, 0x20B4, 0x1E57, 0x1B00, 0x16A8, 0x1278, 0x11AF, 0x1158, 0x1144, 
	0x7484, 0x74AF, 0x75E2, 0x7922, 0x7F75, 0x89E4, 0x9B45, 0xA658, 0xAB30, 
	0xAC43, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x44FE, 0x44E4, 0x4433, 0x4252, 0x3EAA, 0x38A2, 0x29D9, 0x2250, 
	0x1F04, 0x1E4A, 0x0012, 0x0012, 0x0014, 0x0017, 0x001E, 0x002A, 0xFE57, 
	0xFF01, 0xFFA0, 0xFFFF, 0xFF30, 0xFF30, 0xFF31, 0xFF32, 0xFF33, 0xFF34, 
	0xFF20, 0xFF23, 0xFF2A, 0xFF2F, 0xC62C, 0xC5AC, 0xC479, 0xC30C, 0xC1D9, 
	0xC159, 0xC873, 0xC8C5, 0xC969, 0xC9D7, 
},
{
	0x0001, 0x0000, 0x000A, 0x0001, 0x000A, 0x000B, 0x0001, 0x0015, 0x0001, 
	0x0016, 0x0001, 0x0017, 0x000A, 0x0018, 0x0009, 0x0022, 0x000A, 0x002B, 
	0x0003, 0x0035, 0x0006, 0x0038, 0x000A, 0x003E, 0x0002, 0x0048, 0x000A, 
	0x004A, 0x000A, 0x0054, 0x0001, 0x005E, 0x0001, 0x005F, 0x0001, 0x0060, 
	0x000A, 0x0061, 0x000A, 0x006B, 0x000A, 0x0075, 0x0008, 0x007F, 0x000A, 
	0x0087, 0x000A, 0x0091, 0x0009, 0x009B, 0x0008, 0x00A4, 0x0008, 0x00AC, 
	0x0001, 0x00B4, 0x0001, 0x00B5, 0x0001, 0x00B6, 0x000A, 0x00B7, 0x000A, 
	0x00C1, 0x000A, 0x00CB, 0x0008, 0x00D5, 0x000A, 0x00DD, 0x000A, 0x00E7, 
	0x000A, 0x00F1, 0x0009, 0x00FB, 0x0008, 0x0104, 0x0005, 0x010C, 0x000A, 
	0x0111, 0x0001, 0x011B, 0x000A, 0x011C, 0x000A, 0x0126, 0x000A, 0x0130, 
	0x0009, 0x013A, 0x0006, 0x0143, 0x000A, 0x0149, 0x000A, 0x0153, 0x000A, 
	0x015D, 0x000A, 0x0167, 0x0005, 0x0171, 0x000A, 0x0176, 0x0001, 0x0180, 
	0x000A, 0x0181, 0x000A, 0x018B, 0x000A, 0x0195, 0x0008, 0x019F, 0x000A, 
	0x01A7, 0x000A, 0x01B1, 0x000A, 0x01BB, 0x000A, 0x01C5, 0x000A, 0x01CF, 
	
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_IDLE_ON_LEDGE], 0, 189, 0, 0, 49, {
	0x0007, 0x0008, 0x0008, 0x0009, 0x000B, 0x000C, 0x000D, 0x000E, 0x000F, 
	0x0010, 0x0010, 0x0010, 0x0010, 0x0010, 0x0010, 0x000F, 0x000F, 0x000E, 
	0x000E, 0x000D, 0x000D, 0x000C, 0x000C, 0x000B, 0x000B, 0x000A, 0x0009, 
	0x0009, 0x0008, 0x0008, 0x0007, 0x0007, 0x0007, 0x0006, 0x0006, 0x0006, 
	0x0006, 0x0006, 0x0006, 0x0006, 0x0006, 0x0006, 0x0006, 0x0006, 0x0007, 
	0xFE6E, 0xFF8C, 0x0000, 0x3FFF, 0x0000, 0xFF93, 0xFF93, 0xFF93, 0xFF92, 
	0xFF92, 0xFF91, 0xFF90, 0xFF8F, 0xFF8F, 0xFF8E, 0xFF8E, 0xFF8E, 0xFF8E, 
	0xFF8E, 0xFF8F, 0xFF8F, 0xFF8F, 0xFF8F, 0xFF90, 0xFF90, 0xFF90, 0xFF91, 
	0xFF91, 0xFF91, 0xFF92, 0xFF92, 0xFF92, 0xFF93, 0xFF93, 0xFF93, 0xFF94, 
	0xFF94, 0xFF94, 0xFF94, 0xFF94, 0xFF94, 0xFF95, 0xFF95, 0xFF95, 0xFF94, 
	0xFF94, 0xFF94, 0xFF94, 0xFF94, 0xFF94, 0xFF94, 0xFF94, 0xFF94, 0xFF94, 
	0xFF93, 0x0580, 0x05BF, 0x0667, 0x075D, 0x0887, 0x09C8, 0x0B05, 0x0C21, 
	0x0D03, 0x0D8E, 0x0DA6, 0x0D70, 0x0D23, 0x0CC0, 0x0C4B, 0x0BC5, 0x0B30, 
	0x0A8E, 0x09E1, 0x092C, 0x0870, 0x07AF, 0x06EC, 0x0628, 0x0566, 0x04A8, 
	0x03EF, 0x033E, 0x0297, 0x01FC, 0x016E, 0x00F1, 0x0085, 0x002E, 0xFFED, 
	0xFFD0, 0xFFE2, 0x001A, 0x0074, 0x00E8, 0x0170, 0x0205, 0x02A1, 0x033D, 
	0x03D3, 0x045C, 0x04D2, 0x052F, 0x056B, 0x0580, 0x3F76, 0x3F75, 0x3F73, 
	0x3F70, 0x3F6D, 0x3F6A, 0x3F66, 0x3F63, 0x3F61, 0x3F5F, 0x3F5F, 0x3F5F, 
	0x3F60, 0x3F61, 0x3F63, 0x3F64, 0x3F66, 0x3F67, 0x3F69, 0x3F6B, 0x3F6D, 
	0x3F6F, 0x3F71, 0x3F73, 0x3F75, 0x3F77, 0x3F79, 0x3F7B, 0x3F7D, 0x3F7F, 
	0x3F80, 0x3F82, 0x3F83, 0x3F84, 0x3F84, 0x3F85, 0x3F85, 0x3F84, 0x3F83, 
	0x3F82, 0x3F80, 0x3F7F, 0x3F7D, 0x3F7C, 0x3F7A, 0x3F79, 0x3F77, 0x3F77, 
	0x3F76, 0xFFDA, 0xFFDA, 0xFFDA, 0xFFDA, 0xFFDA, 0xFFD9, 0xFFD9, 0xFFD9, 
	0xFFD9, 0xFFD8, 0xFFD8, 0xFFD8, 0xFFD8, 0xFFD8, 0xFFD8, 0xFFD8, 0xFFD9, 
	0xFFD9, 0xFFD9, 0xFFD9, 0xFFD9, 0xFFD9, 0xFFD9, 0xFFD9, 0xFFDA, 0xFFDA, 
	0xFFDA, 0xFFDA, 0xFFDA, 0xFFDA, 0xFFDA, 0xFFDA, 0xFFDB, 0xFFDB, 0xFFDB, 
	0xFFDB, 0xFFDB, 0xFFDB, 0xFFDB, 0xFFDB, 0xFFDB, 0xFFDA, 0xFC2F, 0xFBF0, 
	0xFB42, 0xFA40, 0xF902, 0xF7A1, 0xF636, 0xF4DB, 0xF3A8, 0xF2B8, 0xF222, 
	0xF1FF, 0xF230, 0xF27F, 0xF2E9, 0xF36C, 0xF406, 0xF4B2, 0xF56E, 0xF637, 
	0xF70B, 0xF7E6, 0xF8C5, 0xF9A7, 0xFA87, 0xFB63, 0xFC38, 0xFD03, 0xFDC1, 
	0xFE70, 0xFF0C, 0xFF93, 0x0001, 0x0054, 0x0084, 0x0090, 0x007A, 0x0049, 
	0xFFFF, 0xFFA5, 0xFF3C, 0xFECB, 0xFE55, 0xFDDF, 0xFD6F, 0xFD08, 0xFCB0, 
	0xFC6C, 0xFC3F, 0xFC2F, 0xFC1B, 0xFC1B, 0xFC1B, 0xFC1C, 0xFC1E, 0xFC1F, 
	0xFC20, 0xFC22, 0xFC23, 0xFC24, 0xFC24, 0xFC24, 0xFC24, 0xFC24, 0xFC23, 
	0xFC23, 0xFC22, 0xFC22, 0xFC21, 0xFC20, 0xFC20, 0xFC1F, 0xFC1E, 0xFC1D, 
	0xFC1C, 0xFC1B, 0xFC1B, 0xFC1A, 0xFC19, 0xFC19, 0xFC18, 0xFC17, 0xFC17, 
	0xFC17, 0xFC17, 0xFC17, 0xFC17, 0xFC17, 0xFC17, 0xFC17, 0xFC18, 0xFC18, 
	0xFC19, 0xFC19, 0xFC19, 0xFC1A, 0xFC1A, 0xFC1A, 0xFC1A, 0xFC1B, 0x0215, 
	0x021E, 0x0238, 0x0260, 0x0295, 0x02D6, 0x031F, 0x0370, 0x03C7, 0x0421, 
	0x047D, 0x04D9, 0x0533, 0x058A, 0x05DA, 0x0624, 0x0664, 0x069A, 0x06C2, 
	0x06DB, 0x06E4, 0x06CF, 0x0693, 0x0635, 0x05BA, 0x0527, 0x0480, 0x03CA, 
	0x030B, 0x0247, 0x0183, 0x00C4, 0x000E, 0xFF67, 0xFED3, 0xFE58, 0xFDFA, 
	0xFDBE, 0xFDA9, 0xFDC3, 0xFE0C, 0xFE77, 0xFEFD, 0xFF92, 0x002C, 0x00C1, 
	0x0147, 0x01B3, 0x01FB, 0x0215, 0xFF8D, 0xE0FA, 0xFFFE, 0x0001, 0xC170, 
	0x343C, 0x343E, 0x3444, 0x344E, 0x345B, 0x3469, 0x3478, 0x3488, 0x3498, 
	0x34A6, 0x34B2, 0x34BC, 0x34C3, 0x34C5, 0x34C5, 0x34C4, 0x34C2, 0x34C0, 
	0x34BE, 0x34BB, 0x34B7, 0x34B4, 0x34B0, 0x34AB, 0x34A6, 0x34A1, 0x349C, 
	0x3497, 0x3491, 0x348C, 0x3486, 0x3480, 0x347B, 0x3475, 0x346F, 0x346A, 
	0x3464, 0x345F, 0x345A, 0x3456, 0x3451, 0x344D, 0x3449, 0x3446, 0x3443, 
	0x3440, 0x343E, 0x343D, 0x343C, 0xE4A6, 0xE4B1, 0xE4CF, 0xE4FC, 0xE535, 
	0xE578, 0xE5BF, 0xE608, 0xE650, 0xE692, 0xE6CB, 0xE6F9, 0xE717, 0xE721, 
	0xE720, 0xE71C, 0xE715, 0xE70B, 0xE700, 0xE6F2, 0xE6E3, 0xE6D1, 0xE6BE, 
	0xE6A9, 0xE694, 0xE67D, 0xE665, 0xE64C, 0xE632, 0xE618, 0xE5FE, 0xE5E4, 
	0xE5C9, 0xE5AF, 0xE595, 0xE57C, 0xE563, 0xE54B, 0xE534, 0xE51E, 0xE509, 
	0xE4F6, 0xE4E5, 0xE4D5, 0xE4C7, 0xE4BC, 0xE4B3, 0xE4AC, 0xE4A8, 0xE4A6, 
	0x505B, 0x5057, 0x504C, 0x503C, 0x5027, 0x500F, 0x4FF5, 0x4FDB, 0x4FC1, 
	0x4FA9, 0x4F94, 0x4F84, 0x4F79, 0x4F75, 0x4F75, 0x4F77, 0x4F79, 0x4F7D, 
	0x4F81, 0x4F86, 0x4F8C, 0x4F92, 0x4F99, 0x4FA0, 0x4FA8, 0x4FB0, 0x4FB9, 
	0x4FC2, 0x4FCB, 0x4FD5, 0x4FDE, 0x4FE8, 0x4FF1, 0x4FFB, 0x5004, 0x500D, 
	0x5016, 0x501F, 0x5027, 0x502F, 0x5037, 0x503E, 0x5044, 0x504A, 0x504F, 
	0x5053, 0x5056, 0x5059, 0x505A, 0x505B, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xF502, 0x17FE, 0x17FD, 0x17FA, 0x17F6, 0x17F0, 0x17E8, 0x17DF, 
	0x17D5, 0x17C9, 0x17BD, 0x17B0, 0x17A1, 0x1792, 0x1783, 0x1773, 0x1762, 
	0x1752, 0x1741, 0x1730, 0x171F, 0x170F, 0x16FE, 0x16EE, 0x16DF, 0x16D0, 
	0x16C1, 0x16B4, 0x16A8, 0x169C, 0x1692, 0x1689, 0x1682, 0x167B, 0x1677, 
	0x1674, 0x1673, 0x1679, 0x1689, 0x16A2, 0x16C1, 0x16E6, 0x170F, 0x1739, 
	0x1762, 0x178B, 0x17B0, 0x17CF, 0x17E8, 0x17F8, 0x17FE, 0xFF32, 0xFF35, 
	0xFF3E, 0xFF4C, 0xFF60, 0xFF78, 0xFF95, 0xFFB5, 0xFFD9, 0x0001, 0x002C, 
	0x0059, 0x0089, 0x00BA, 0x00ED, 0x0122, 0x0157, 0x018D, 0x01C3, 0x01F9, 
	0x022E, 0x0262, 0x0295, 0x02C7, 0x02F6, 0x0324, 0x034E, 0x0376, 0x039A, 
	0x03BB, 0x03D8, 0x03F0, 0x0403, 0x0412, 0x041A, 0x041D, 0x040B, 0x03D8, 
	0x0389, 0x0324, 0x02AE, 0x022E, 0x01A8, 0x0122, 0x00A1, 0x002C, 0xFFC7, 
	0xFF78, 0xFF45, 0xFF32, 0xF1E4, 0xF1E2, 0xF1DA, 0xF1CE, 0xF1BE, 0xF1AA, 
	0xF193, 0xF178, 0xF15A, 0xF139, 0xF115, 0xF0F0, 0xF0C9, 0xF0A0, 0xF075, 
	0xF04A, 0xF01E, 0xEFF1, 0xEFC5, 0xEF98, 0xEF6C, 0xEF41, 0xEF16, 0xEEED, 
	0xEEC6, 0xEEA0, 0xEE7D, 0xEE5C, 0xEE3E, 0xEE23, 0xEE0C, 0xEDF8, 0xEDE8, 
	0xEDDC, 0xEDD4, 0xEDD2, 0xEDE1, 0xEE0C, 0xEE4D, 0xEEA0, 0xEF02, 0xEF6C, 
	0xEFDB, 0xF04A, 0xF0B4, 0xF115, 0xF169, 0xF1AA, 0xF1D5, 0xF1E4, 0xFFFE, 
	0x0001, 0xC170, 0xBDC5, 0xBDC5, 0xBDC5, 0xBDC5, 0xBDC5, 0xBDC5, 0xBDC5, 
	0xBDC4, 0xBDC1, 0xBDBD, 0xBDB9, 0xBDB6, 0xBDB3, 0xBDB2, 0xBDB2, 0xBDB2, 
	0xBDB3, 0xBDB3, 0xBDB3, 0xBDB4, 0xBDB4, 0xBDB5, 0xBDB5, 0xBDB6, 0xBDB6, 
	0xBDB7, 0xBDB8, 0xBDB8, 0xBDB9, 0xBDBA, 0xBDBB, 0xBDBB, 0xBDBC, 0xBDBD, 
	0xBDBE, 0xBDBE, 0xBDBF, 0xBDC0, 0xBDC1, 0xBDC1, 0xBDC2, 0xBDC2, 0xBDC3, 
	0xBDC3, 0xBDC4, 0xBDC4, 0xBDC4, 0xBDC4, 0xBDC5, 0x10EA, 0x10EA, 0x10EA, 
	0x10EA, 0x10EA, 0x10EA, 0x10EA, 0x1110, 0x1172, 0x11F8, 0x1289, 0x130F, 
	0x1371, 0x1397, 0x1396, 0x1391, 0x138A, 0x1380, 0x1373, 0x1365, 0x1354, 
	0x1341, 0x132C, 0x1316, 0x12FE, 0x12E6, 0x12CC, 0x12B1, 0x1295, 0x1279, 
	0x125D, 0x1240, 0x1224, 0x1208, 0x11EC, 0x11D0, 0x11B5, 0x119B, 0x1183, 
	0x116B, 0x1155, 0x1140, 0x112D, 0x111C, 0x110E, 0x1101, 0x10F7, 0x10F0, 
	0x10EB, 0x10EA, 0x4EB0, 0x4EB0, 0x4EB0, 0x4EB0, 0x4EB0, 0x4EB0, 0x4EB0, 
	0x4EAD, 0x4EA7, 0x4E9F, 0x4E96, 0x4E8E, 0x4E88, 0x4E85, 0x4E86, 0x4E86, 
	0x4E86, 0x4E87, 0x4E88, 0x4E89, 0x4E8A, 0x4E8B, 0x4E8C, 0x4E8D, 0x4E8F, 
	0x4E90, 0x4E92, 0x4E94, 0x4E95, 0x4E97, 0x4E99, 0x4E9B, 0x4E9C, 0x4E9E, 
	0x4EA0, 0x4EA2, 0x4EA3, 0x4EA5, 0x4EA6, 0x4EA8, 0x4EA9, 0x4EAA, 0x4EAC, 
	0x4EAD, 0x4EAE, 0x4EAE, 0x4EAF, 0x4EAF, 0x4EB0, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xF8AA, 0xF32B, 
	0x066E, 0xF3C6, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xBF5E, 0xE71D, 0xE71C, 0xE719, 0xE715, 0xE70F, 0xE707, 0xE6FE, 
	0xE6F4, 0xE6E9, 0xE6DC, 0xE6CF, 0xE6C0, 0xE6B1, 0xE6A1, 0xE691, 0xE680, 
	0xE66F, 0xE65D, 0xE64C, 0xE63A, 0xE628, 0xE617, 0xE605, 0xE5F5, 0xE5E4, 
	0xE5D4, 0xE5C5, 0xE5B7, 0xE5A9, 0xE59D, 0xE591, 0xE587, 0xE57E, 0xE577, 
	0xE570, 0xE56C, 0xE569, 0xE568, 0xE571, 0xE589, 0xE5AD, 0xE5DA, 0xE60D, 
	0xE643, 0xE679, 0xE6AC, 0xE6D9, 0xE6FD, 0xE714, 0xE71D, 0xE79B, 0xE79C, 
	0xE79F, 0xE7A4, 0xE7AB, 0xE7B3, 0xE7BD, 0xE7C9, 0xE7D6, 0xE7E4, 0xE7F3, 
	0xE803, 0xE814, 0xE826, 0xE839, 0xE84C, 0xE85F, 0xE873, 0xE887, 0xE89B, 
	0xE8AF, 0xE8C3, 0xE8D6, 0xE8E9, 0xE8FC, 0xE90E, 0xE91F, 0xE92F, 0xE93E, 
	0xE94C, 0xE959, 0xE965, 0xE96F, 0xE977, 0xE97E, 0xE983, 0xE986, 0xE988, 
	0xE97E, 0xE963, 0xE93A, 0xE908, 0xE8CE, 0xE891, 0xE854, 0xE81A, 0xE7E8, 
	0xE7BF, 0xE7A4, 0xE79B, 0x9BA3, 0x9BA5, 0x9BAA, 0x9BB2, 0x9BBD, 0x9BCB, 
	0x9BDC, 0x9BEF, 0x9C04, 0x9C1B, 0x9C34, 0x9C4E, 0x9C6A, 0x9C87, 0x9CA5, 
	0x9CC4, 0x9CE4, 0x9D04, 0x9D24, 0x9D45, 0x9D65, 0x9D85, 0x9DA5, 0x9DC4, 
	0x9DE2, 0x9DFF, 0x9E1B, 0x9E36, 0x9E4E, 0x9E65, 0x9E7B, 0x9E8D, 0x9E9E, 
	0x9EAC, 0x9EB7, 0x9EBF, 0x9EC4, 0x9EC6, 0x9EB6, 0x9E8A, 0x9E48, 0x9DF6, 
	0x9D98, 0x9D35, 0x9CD1, 0x9C73, 0x9C21, 0x9BDF, 0x9BB3, 0x9BA3, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x4A2F, 0x4A17, 
	0x49D5, 0x4972, 0x48F4, 0x4866, 0x47CE, 0x4734, 0x46A2, 0x461F, 0x45B4, 
	0x4553, 0x44EC, 0x4480, 0x440F, 0x439A, 0x4322, 0x42A8, 0x422D, 0x41B2, 
	0x4137, 0x40BE, 0x4047, 0x3FD4, 0x3F64, 0x3EF9, 0x3E95, 0x3E37, 0x3DE0, 
	0x3D92, 0x3D4E, 0x3D13, 0x3CE4, 0x3CC1, 0x3CAB, 0x3CA2, 0x3CA8, 0x3CBD, 
	0x3D1A, 0x3DE5, 0x3F09, 0x406E, 0x41FE, 0x43A2, 0x4544, 0x46CD, 0x4826, 
	0x4938, 0x49EE, 0x4A2F, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xBA4C, 
	0xBA4C, 0xBA4D, 0xBA50, 0xBA54, 0xBA5B, 0xBA64, 0xBA71, 0xBA81, 0xBA95, 
	0xBAAE, 0xBACC, 0xBAF0, 0xBB19, 0xBB48, 0xBB7F, 0xBBBD, 0xBC02, 0xBC50, 
	0xBCA6, 0xBD05, 0xBD6E, 0xBDE1, 0xBE5F, 0xBF0A, 0xBFFB, 0xC126, 0xC27C, 
	0xC3EF, 0xC571, 0xC6F6, 0xC86E, 0xC9CB, 0xCB01, 0xCC02, 0xCCBE, 0xCD2A, 
	0xCD36, 0xCCB5, 0xCB98, 0xC9FE, 0xC807, 0xC5D4, 0xC385, 0xC139, 0xBF10, 
	0xBD2A, 0xBBA7, 0xBAA8, 0xBA4C, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xBF5E, 0x2333, 0x170B, 0xAA09, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x2741, 0x274B, 0x276A, 0x279B, 0x27DC, 0x282A, 0x2885, 0x28EA, 
	0x2957, 0x29CA, 0x2A41, 0x2ABA, 0x2B34, 0x2BAB, 0x2C1F, 0x2C8D, 0x2D36, 
	0x2E32, 0x2F3B, 0x300C, 0x3061, 0x2FF6, 0x2EDD, 0x2D63, 0x2BA0, 0x29A7, 
	0x2790, 0x256F, 0x235B, 0x2169, 0x1FAE, 0x1E40, 0x1D34, 0x1CA1, 0x1C7A, 
	0x1C9C, 0x1CFF, 0x1D97, 0x1E5C, 0x1F43, 0x2043, 0x2152, 0x2265, 0x2374, 
	0x2474, 0x255C, 0x2621, 0x26BA, 0x271E, 0x2741, 0xFFE9, 0xFFE8, 0xFFE6, 
	0xFFE3, 0xFFE0, 0xFFDC, 0xFFD8, 0xFFD4, 0xFFD1, 0xFFCE, 0xFFCC, 0xFFCB, 
	0xFFC9, 0xFFC8, 0xFFC7, 0xFFC6, 0xFFC5, 0xFFC4, 0xFFC3, 0xFFC2, 0xFFC1, 
	0xFFC0, 0xFFC0, 0xFFBF, 0xFFBF, 0xFFBE, 0xFFBE, 0xFFBE, 0xFFBE, 0xFFBE, 
	0xFFBE, 0xFFBF, 0xFFBF, 0xFFC0, 0xFFC1, 0xFFC3, 0xFFC5, 0xFFC8, 0xFFCB, 
	0xFFCE, 0xFFD2, 0xFFD6, 0xFFD9, 0xFFDD, 0xFFE0, 0xFFE3, 0xFFE5, 0xFFE7, 
	0xFFE8, 0xFFE9, 0xFF2F, 0xFF2F, 0xFF2F, 0xFF30, 0xFF31, 0xFF31, 0xFF32, 
	0xFF33, 0xFF33, 0xFF34, 0xFF34, 0xFF34, 0xFF35, 0xFF35, 0xFF35, 0xFF36, 
	0xFF36, 0xFF36, 0xFF36, 0xFF37, 0xFF37, 0xFF37, 0xFF37, 0xFF38, 0xFF38, 
	0xFF38, 0xFF38, 0xFF38, 0xFF38, 0xFF38, 0xFF38, 0xFF38, 0xFF38, 0xFF38, 
	0xFF38, 0xFF38, 0xFF37, 0xFF36, 0xFF36, 0xFF35, 0xFF34, 0xFF33, 0xFF33, 
	0xFF32, 0xFF31, 0xFF30, 0xFF30, 0xFF2F, 0xCE0A, 0xCE2D, 0xCE8D, 0xCF1D, 
	0xCFCF, 0xD094, 0xD160, 0xD225, 0xD2D5, 0xD362, 0xD3BE, 0xD3FD, 0xD43C, 
	0xD479, 0xD4B5, 0xD4EE, 0xD526, 0xD55B, 0xD58D, 0xD5BC, 0xD5E7, 0xD60F, 
	0xD632, 0xD650, 0xD66A, 0xD67F, 0xD68E, 0xD697, 0xD699, 0xD696, 0xD68B, 
	0xD679, 0xD660, 0xD63E, 0xD606, 0xD5AB, 0xD532, 0xD4A2, 0xD3FE, 0xD34E, 
	0xD295, 0xD1D9, 0xD11F, 0xD06E, 0xCFC9, 0xCF36, 0xCEBA, 0xCE5C, 0xCE1F, 
	0xCE0A, 
},
{
	0x002D, 0x0000, 0x0001, 0x002D, 0x0001, 0x002E, 0x0001, 0x002F, 0x0001, 
	0x0030, 0x0001, 0x0031, 0x0032, 0x0032, 0x0032, 0x0064, 0x0031, 0x0096, 
	0x002A, 0x00C7, 0x0032, 0x00F1, 0x0032, 0x0123, 0x0032, 0x0155, 0x0001, 
	0x0187, 0x0001, 0x0188, 0x0001, 0x0189, 0x0001, 0x018A, 0x0001, 0x018B, 
	0x0031, 0x018C, 0x0032, 0x01BD, 0x0032, 0x01EF, 0x002F, 0x0221, 0x0030, 
	0x0250, 0x0001, 0x0280, 0x0032, 0x0281, 0x0032, 0x02B3, 0x0032, 0x02E5, 
	0x0001, 0x0317, 0x0001, 0x0318, 0x0001, 0x0319, 0x0031, 0x031A, 0x0032, 
	0x034B, 0x0031, 0x037D, 0x0029, 0x03AE, 0x0032, 0x03D7, 0x0001, 0x0409, 
	0x0001, 0x040A, 0x0001, 0x040B, 0x0001, 0x040C, 0x0032, 0x040D, 0x0030, 
	0x043F, 0x0001, 0x046F, 0x0032, 0x0470, 0x0032, 0x04A2, 0x0032, 0x04D4, 
	0x0030, 0x0506, 0x0032, 0x0536, 0x0032, 0x0568, 0x002E, 0x059A, 0x0031, 
	0x05C8, 0x0032, 0x05F9, 0x0032, 0x062B, 0x0030, 0x065D, 0x0001, 0x068D, 
	0x0001, 0x068E, 0x0001, 0x068F, 0x0001, 0x0690, 0x0031, 0x0691, 0x002C, 
	0x06C2, 0x0032, 0x06EE, 0x0032, 0x0720, 0x0030, 0x0752, 0x0032, 0x0782, 
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_FAST_LEDGE_GRAB], 0, 189, 0, 15, 15, {
	0x0007, 0x0007, 0x0007, 0x0007, 0x0006, 0x0005, 0x0004, 0x0003, 0x0002, 
	0x0000, 0xFE6E, 0xFF09, 0xFFA5, 0x0058, 0x00A7, 0x00D2, 0x00CD, 0x00C0, 
	0x00B0, 0x0090, 0x0088, 0x0096, 0x009E, 0x00A4, 0x00AA, 0xFF8C, 0xFF4D, 
	0xFF60, 0xFF86, 0xFFA8, 0xFFCC, 0xFFF9, 0x0028, 0x004E, 0x0042, 0x003F, 
	0x003F, 0x003E, 0x003E, 0x003E, 0x003A, 0x0000, 0x3FFF, 0x0000, 0xFF93, 
	0xFF76, 0xFFC6, 0x0255, 0x024C, 0x022E, 0x01FE, 0x01C1, 0x017B, 0x0130, 
	0x00E5, 0x009E, 0x005F, 0x002D, 0x000C, 0xFFFF, 0x0580, 0x058F, 0x0589, 
	0x0501, 0x048F, 0x040F, 0x0386, 0x02F9, 0x026B, 0x01E1, 0x0161, 0x00EE, 
	0x008C, 0x0041, 0x0011, 0xFFFF, 0x3F76, 0x3EAD, 0x412A, 0x5469, 0x53FD, 
	0x52E4, 0x5141, 0x4F36, 0x4CE7, 0x4A76, 0x4805, 0x45B9, 0x43B3, 0x4215, 
	0x4104, 0x40A1, 0xFFDA, 0xFF4C, 0xFE1E, 0xFD08, 0xFC80, 0xFD40, 0xFE32, 
	0xFF2B, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFC2F, 0xFC72, 0xFD05, 0xFD97, 0xFE27, 0xFEA4, 0xFF21, 0xFF98, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFC1B, 0x02D1, 
	0x113F, 0x1ED1, 0x274D, 0x22E4, 0x1C89, 0x15CD, 0x1041, 0x1128, 0x1097, 
	0x0F03, 0x0CEB, 0x0ACD, 0x092B, 0x0884, 0x0215, 0x01CA, 0x0192, 0x0153, 
	0x0112, 0x00CB, 0x0083, 0x003D, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0xFF8D, 0xFECB, 0xFE71, 0xFE53, 0xFE89, 0xFEDF, 0xFF45, 
	0xFFAA, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xE0FA, 0xF017, 0xF78B, 
	0xFD0D, 0xFEF9, 0xFFD1, 0x0027, 0x008D, 0x0197, 0x065B, 0x051A, 0x031B, 
	0x00CF, 0xFEA2, 0xFD03, 0xFC61, 0xFFFE, 0x0001, 0xC170, 0x343C, 0x1474, 
	0x0F7F, 0x1200, 0x27EB, 0x1019, 0xB494, 0xE751, 0x9A4E, 0xC9E4, 0xE756, 
	0xF523, 0xFB82, 0xFCF5, 0xFBFD, 0xFB1C, 0xE4A6, 0xE00F, 0xE041, 0xF4E0, 
	0xF20A, 0xDCE4, 0xA768, 0xAB43, 0xD2C7, 0xDAD3, 0xE00D, 0xDFF3, 0xDCD6, 
	0xD874, 0xD48C, 0xD2DB, 0x505B, 0x8B1D, 0x9718, 0x8EDD, 0x79A6, 0x9C81, 
	0x00FD, 0xD7AE, 0x2BEB, 0xF798, 0xE84C, 0xDB54, 0xD51A, 0xD366, 0xD401, 
	0xD4B3, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xF502, 0xD1C2, 0xD262, 0xEA02, 0xF2F1, 0xD285, 0xC8CD, 0xC1C8, 
	0xBD5D, 0xBB76, 0xCF24, 0xD038, 0xCF38, 0xCD32, 0xCB34, 0xCA4E, 0x17FE, 
	0x0206, 0x0C2C, 0x1C2F, 0x0343, 0xF068, 0xF4D6, 0xFA64, 0xFF81, 0x029B, 
	0x0381, 0x0354, 0x027C, 0x0160, 0x0069, 0xFFFF, 0xFF32, 0xFE3C, 0xFD04, 
	0xEA86, 0x0173, 0x06EC, 0x02CA, 0xFE4B, 0xFA56, 0xF7D4, 0xF6EC, 0xF6F1, 
	0xF78B, 0xF865, 0xF927, 0xF97B, 0xF1E4, 0xE9BC, 0xE45D, 0xDA84, 0xF20E, 
	0xF505, 0xF275, 0xEFB2, 0xED4B, 0xEBCF, 0xEB59, 0xEB82, 0xEC0A, 0xECB7, 
	0xED4C, 0xED8B, 0xFFFE, 0x0001, 0xC170, 0xBDC5, 0x420C, 0x3A54, 0x407B, 
	0x38AC, 0x3F16, 0x4869, 0x5023, 0x51C0, 0x29F0, 0x1FA4, 0x16BB, 0x0F6D, 
	0x09F1, 0x067E, 0x054B, 0x10EA, 0x56FD, 0x5771, 0x65A2, 0x6A93, 0x5CD2, 
	0x4C51, 0x3B10, 0x2B0C, 0x20EF, 0x21D1, 0x23DC, 0x2678, 0x290F, 0x2B0B, 
	0x2BD6, 0x4EB0, 0xF040, 0xF402, 0xFEFC, 0xF598, 0xFDF9, 0x09B8, 0x142F, 
	0x18B6, 0xF5A5, 0xEB1E, 0xE17A, 0xD92F, 0xD2B2, 0xCE78, 0xCCF5, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0xF8AA, 0xCC1F, 0xCF52, 0xEDAA, 0xE6DD, 0xDC31, 0xCF81, 
	0xC2A7, 0xB77F, 0xAFE4, 0xC925, 0xCB91, 0xCB92, 0xCA3B, 0xC8A2, 0xC7DC, 
	0xF32B, 0xFEA4, 0x0633, 0x140A, 0x0EA9, 0x0B9D, 0x08A4, 0x05EA, 0x039D, 
	0x01EB, 0x00D9, 0x003C, 0xFFF5, 0xFFE7, 0xFFF5, 0x0000, 0x066E, 0x17A0, 
	0x22F5, 0x37B4, 0x0D26, 0x070E, 0x04B4, 0x0492, 0x0521, 0x04DC, 0x03AB, 
	0x0289, 0x0188, 0x00BA, 0x0031, 0x0000, 0xF3C6, 0xF5FB, 0xF76F, 0xFA1A, 
	0xEEFD, 0xEF21, 0xF08F, 0xF298, 0xF48B, 0xF5BA, 0xF617, 0xF61F, 0xF5EF, 
	0xF5A7, 0xF565, 0xF548, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xBF5E, 0xE71D, 
	0xE953, 0xEA46, 0xDF0B, 0xE192, 0xE676, 0xE86B, 0xE16D, 0xD8AC, 0xDA03, 
	0xDC73, 0xD980, 0xD84E, 0xD747, 0xD68F, 0xD649, 0xE79B, 0xF0F1, 0xFCD3, 
	0xF7E4, 0xF287, 0xECD6, 0xE8C1, 0xE926, 0xEAB0, 0xE7B5, 0xE2CE, 0xE6BE, 
	0xE8AA, 0xEA71, 0xEBBE, 0xEC40, 0x9BA3, 0x98E6, 0x9949, 0xAFA9, 0xB088, 
	0xADC3, 0xAC10, 0xAEBE, 0xB1BD, 0xAF38, 0xAB2C, 0xAFEB, 0xB1FB, 0xB3CF, 
	0xB51E, 0xB59D, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x4A2F, 0x3AFB, 0x24F6, 0x1E97, 0x29BE, 0x3848, 
	0x40DA, 0x36AA, 0x2AEA, 0x3EE1, 0x41F7, 0x3A9A, 0x3407, 0x2D08, 0x277A, 
	0x2537, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFDD, 0xFFB4, 0xFF9E, 0xFFB8, 
	0xFFEA, 0xFB70, 0xFAB6, 0xFA4C, 0xFD1E, 0xFFFF, 0xFFF1, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x002C, 0x0065, 0x00A3, 0x00F4, 0x0138, 0x0062, 
	0xFFC2, 0x0021, 0x0015, 0xFFF6, 0xFFEC, 0xFFFF, 0xBA4C, 0xBFCC, 0xCB69, 
	0xE169, 0xD814, 0xC8D8, 0xBD19, 0xBCFC, 0xBF11, 0xA94A, 0xAC42, 0xAF55, 
	0xB4C7, 0xBA52, 0xBE04, 0xBF3F, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xBF5E, 
	0x2333, 0x14EB, 0x06FE, 0x2575, 0x255B, 0x1FEB, 0x1B46, 0x1ADC, 0x1A65, 
	0x1458, 0x12F6, 0x1623, 0x17CF, 0x1965, 0x1A92, 0x1B09, 0x170B, 0x100E, 
	0x0845, 0x11F7, 0x165C, 0x19F4, 0x1B78, 0x1710, 0x1234, 0x18E4, 0x19D2, 
	0x16D5, 0x1500, 0x1331, 0x11D1, 0x1144, 0xAA09, 0xA48F, 0x9FCF, 0xAEB5, 
	0xAC1C, 0xA66B, 0xA2D6, 0xA6EC, 0xAABE, 0x9EDA, 0x9C8B, 0xA277, 0xA5C3, 
	0xA8EF, 0xAB52, 0xAC43, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x2741, 0x27B2, 0x2619, 0x1A37, 0x2708, 0x3883, 0x42BF, 
	0x3614, 0x2769, 0x3EA2, 0x449D, 0x37E1, 0x2F92, 0x2740, 0x20D9, 0x1E4A, 
	0xFFE9, 0xFFED, 0xFFDE, 0xFF73, 0xFF7D, 0xFFA7, 0x004A, 0x0296, 0x0464, 
	0x048F, 0x02C7, 0x02CF, 0x020F, 0x0120, 0x0055, 0xFFFF, 0xFF2F, 0xFF2A, 
	0xFF2D, 0xFF64, 0xFF69, 0xFF65, 0xFF5F, 0xFF58, 0xFF4C, 0xFF8F, 0xFFC2, 
	0xFF4E, 0xFF39, 0xFF30, 0xFF2E, 0xFF2F, 0xCE0A, 0xCD14, 0xD021, 0xE7B5, 
	0xDAFC, 0xC752, 0xB80F, 0xB61B, 0xB94D, 0xAF20, 0xAD11, 0xB5F7, 0xBC4E, 
	0xC2C7, 0xC7D0, 0xC9D7, 
},
{
	0x000A, 0x0000, 0x000F, 0x000A, 0x0010, 0x0019, 0x0001, 0x0029, 0x0001, 
	0x002A, 0x0001, 0x002B, 0x0010, 0x002C, 0x0010, 0x003C, 0x0010, 0x004C, 
	0x0010, 0x005C, 0x0010, 0x006C, 0x0010, 0x007C, 0x000F, 0x008C, 0x000D, 
	0x009B, 0x0010, 0x00A8, 0x0001, 0x00B8, 0x0001, 0x00B9, 0x0001, 0x00BA, 
	0x0010, 0x00BB, 0x0010, 0x00CB, 0x0010, 0x00DB, 0x000E, 0x00EB, 0x000D, 
	0x00F9, 0x0010, 0x0106, 0x0010, 0x0116, 0x0010, 0x0126, 0x0010, 0x0136, 
	0x0001, 0x0146, 0x0001, 0x0147, 0x0001, 0x0148, 0x0010, 0x0149, 0x0010, 
	0x0159, 0x0010, 0x0169, 0x000E, 0x0179, 0x0010, 0x0187, 0x0010, 0x0197, 
	0x0010, 0x01A7, 0x0010, 0x01B7, 0x0010, 0x01C7, 0x0010, 0x01D7, 0x000F, 
	0x01E7, 0x0001, 0x01F6, 0x0010, 0x01F7, 0x0010, 0x0207, 0x0010, 0x0217, 
	0x000C, 0x0227, 0x0010, 0x0233, 0x0010, 0x0243, 0x0010, 0x0253, 0x0010, 
	0x0263, 0x0010, 0x0273, 0x0010, 0x0283, 0x000F, 0x0293, 0x0001, 0x02A2, 
	0x0010, 0x02A3, 0x0010, 0x02B3, 0x0010, 0x02C3, 0x000C, 0x02D3, 0x000E, 
	0x02DF, 0x0010, 0x02ED, 0x0010, 0x02FD, 0x0010, 0x030D, 0x0010, 0x031D, 
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_SLOW_LEDGE_GRAB], 0, 189, 0, 33, 33, {
	0x0007, 0x0007, 0x0007, 0x0007, 0x0007, 0x0007, 0x0007, 0xFFFE, 0xFFEE, 
	0xFFDE, 0xFFCC, 0xFFBC, 0xFFAD, 0xFFA2, 0xFF9A, 0xFF97, 0xFF99, 0xFFA0, 
	0xFFAA, 0xFFB7, 0xFFC7, 0xFFD9, 0xFFED, 0xFFFF, 0x0004, 0xFFF9, 0xFFEC, 
	0xFFE7, 0xFFE8, 0xFFF5, 0x0000, 0x0002, 0x0001, 0x0000, 0xFE61, 0xFE61, 
	0xFE61, 0xFE61, 0xFE61, 0xFE61, 0xFE61, 0xFE73, 0xFE89, 0xFE9A, 0xFEA7, 
	0xFEB0, 0xFEBA, 0xFEC6, 0xFEDB, 0xFEFD, 0xFF2F, 0xFF6D, 0xFFB1, 0xFFF4, 
	0x0031, 0x0061, 0x007E, 0x008A, 0x009C, 0x00AF, 0x00B6, 0x00B8, 0x00B7, 
	0x00B0, 0x00AA, 0x00A9, 0x00A9, 0x00AA, 0xFF95, 0xFF95, 0xFF95, 0xFF95, 
	0xFF95, 0xFF95, 0xFF95, 0xFF95, 0xFF95, 0xFF95, 0xFF95, 0xFF95, 0xFF95, 
	0xFF96, 0xFF96, 0xFF96, 0xFF83, 0xFF70, 0xFF7F, 0xFFA5, 0xFFD4, 0xFFFD, 
	0x0013, 0x0017, 0x0040, 0x0042, 0x0030, 0x002F, 0x0036, 0x0000, 0x3FFF, 
	0x0000, 0xFF93, 0xFF8D, 0xFF8B, 0xFFA8, 0xFFFF, 0xFF35, 0xFD33, 0xFBFB, 
	0xFD90, 0x03F6, 0x101E, 0x2072, 0x3325, 0x466A, 0x5874, 0xE775, 0xF1A3, 
	0xEDFD, 0x5D1C, 0x4B98, 0x3CAA, 0x2CA3, 0x1DBC, 0x122E, 0x0B13, 0x0711, 
	0x04B0, 0x027D, 0x00B0, 0x0011, 0x0000, 0x0580, 0x05D5, 0x05ED, 0x046E, 
	0xFFFF, 0xF75E, 0xEBA9, 0xDF1A, 0xD3EA, 0xCC54, 0xC82D, 0xC595, 0xC42F, 
	0xC3A0, 0xC38D, 0xBC64, 0xBC93, 0xBD3A, 0xC370, 0xC823, 0xD283, 0xE03E, 
	0xEE0F, 0xF8B3, 0xFF58, 0x03BA, 0x0660, 0x07D6, 0x0644, 0x0243, 0xFFFF, 
	0x3F76, 0x3F10, 0x3E17, 0x3CE2, 0x3BC4, 0x3C2D, 0x3DF1, 0x3F04, 0x3D57, 
	0x36DB, 0x2A93, 0x1A19, 0x0741, 0xF3E2, 0xE1D1, 0x52E4, 0x48F0, 0x4C7D, 
	0xDDCD, 0xF24C, 0x0898, 0x2296, 0x3A90, 0x4AD4, 0x5055, 0x4EA1, 0x49E9, 
	0x4660, 0x4409, 0x414E, 0x3FFF, 0xFFDA, 0xFFD8, 0xFFD7, 0xFFE1, 0x0000, 
	0x0035, 0x007B, 0x00C9, 0x0117, 0x015E, 0x0175, 0x0153, 0x0122, 0x010C, 
	0x013B, 0x01D8, 0x030D, 0x07D9, 0x0EB3, 0x10F6, 0x096D, 0xFD4E, 0xF590, 
	0xF47C, 0xF5AF, 0xF81C, 0xFAB7, 0xFC73, 0xFD5F, 0xFE36, 0xFEEF, 0xFF80, 
	0xFFDE, 0x0000, 0xFC2F, 0xFBF4, 0xFBE4, 0xFCED, 0xFFFF, 0x0618, 0x0E70, 
	0x1751, 0x1F03, 0x23D1, 0x25CD, 0x266A, 0x2605, 0x24F8, 0x239E, 0x2253, 
	0x2171, 0x20B6, 0x1FA5, 0x1E3B, 0x1C5B, 0x1A23, 0x17EB, 0x15D4, 0x13BF, 
	0x11A9, 0x0F8E, 0x0D67, 0x0AE7, 0x07FF, 0x0512, 0x0282, 0x00B0, 0xFFFF, 
	0xFC1B, 0xFC48, 0xFCBB, 0xFD52, 0xFDED, 0xFE79, 0xFF02, 0xFF9B, 0x0056, 
	0x0144, 0x023B, 0x031B, 0x0404, 0x0517, 0x0675, 0x083F, 0x0A94, 0x0F36, 
	0x15E6, 0x1BC3, 0x2028, 0x23BB, 0x258A, 0x25D9, 0x2588, 0x2493, 0x22F5, 
	0x20AA, 0x1D0B, 0x180F, 0x129C, 0x0D9A, 0x09F0, 0x0884, 0x0215, 0x0215, 
	0x0215, 0x0215, 0x0215, 0x0215, 0xF87A, 0xF461, 0xF099, 0xEE55, 0xED52, 
	0xECBC, 0xEC9C, 0xECFC, 0xEDE4, 0xEF5F, 0xF175, 0xF499, 0xF8EA, 0xFDF0, 
	0x0337, 0x0849, 0x0CAF, 0x0FF3, 0x0D40, 0x0865, 0x08B9, 0x08E2, 0x0449, 
	0x0000, 0xFF2A, 0xFF42, 0xFFB8, 0xFFFF, 0xFF8D, 0xFF8D, 0xFF8D, 0xFF8D, 
	0xFF8D, 0xFF8D, 0x02FF, 0x05FF, 0x080B, 0x0972, 0x0A46, 0x0AE2, 0x0B4B, 
	0x0B85, 0x0B96, 0x0B83, 0x0B4F, 0x0AD3, 0x09FE, 0x08F7, 0x07E2, 0x06E5, 
	0x0627, 0x05CD, 0x08B7, 0x0A5A, 0x02B9, 0xFB23, 0xFCB8, 0xFFFF, 0x0074, 
	0x0067, 0x0026, 0x0000, 0xE0FA, 0xE0FA, 0xE0FA, 0xE0FA, 0xE0FA, 0xE0FA, 
	0xE18C, 0xE33B, 0xE198, 0xE11A, 0xE1B7, 0xE2EA, 0xE48E, 0xE67E, 0xE896, 
	0xEAB1, 0xECAA, 0xEEF5, 0xF1D9, 0xF4F0, 0xF7D0, 0xFA12, 0xFB50, 0xFB21, 
	0xF06B, 0xE360, 0xE1CB, 0xE459, 0xE8AC, 0xEDB6, 0xF241, 0xF70C, 0xFAD6, 
	0xFC61, 0xFFFE, 0x0001, 0xC170, 0x343C, 0x343C, 0x343C, 0x343C, 0x343C, 
	0x3DA2, 0x3D61, 0x3BF1, 0x3A2A, 0x393E, 0x38AE, 0x37A3, 0x366A, 0x34DB, 
	0x335D, 0x3965, 0x3584, 0x2DD6, 0x41B4, 0xD709, 0xE760, 0xA028, 0xAF5D, 
	0xF6CA, 0xE7AC, 0x0294, 0x01CF, 0xFE7C, 0xFC0D, 0xFB1C, 0xE4A6, 0xE4A6, 
	0xE4A6, 0xE4A6, 0xE4A6, 0xEB1C, 0xEF3F, 0xF3BE, 0xF802, 0xFAFF, 0xFCB7, 
	0xFE18, 0xFEDB, 0xFFFA, 0x021E, 0x01EB, 0xF4EE, 0xE0F6, 0xD94D, 0xB3F7, 
	0xB81F, 0xC83F, 0xBC92, 0xC719, 0xD388, 0xDF8B, 0xD7EE, 0xD55C, 0xD38B, 
	0xD2DB, 0x505B, 0x505B, 0x505B, 0x505B, 0x505B, 0x4F67, 0x4C58, 0x4AD0, 
	0x4BC0, 0x4D53, 0x4D72, 0x4CB2, 0x4B78, 0x481A, 0x4416, 0x41A6, 0x43CE, 
	0x454E, 0x43FD, 0xB790, 0xB003, 0x00C3, 0xF559, 0xAC8F, 0xBA9B, 0xB9C7, 
	0xC1D2, 0xCB4B, 0xD217, 0xD4B3, 0x0000, 0x000D, 0x0033, 0x006E, 0x00BB, 
	0x0116, 0x017B, 0x01E7, 0x0257, 0x02C6, 0x0332, 0x0398, 0x03F2, 0x043F, 
	0x047A, 0x04A0, 0x04AD, 0x0307, 0x0310, 0x034D, 0x03F3, 0x0537, 0x074D, 
	0x0936, 0xFFFF, 0x001A, 0x0065, 0x00DA, 0x0170, 0x0223, 0x02EA, 0x03BF, 
	0x049A, 0x0576, 0x064B, 0x0712, 0x07C5, 0x085B, 0x08D0, 0x091A, 0x0935, 
	0x078E, 0x058D, 0x03F2, 0x0270, 0x00BB, 0xFE83, 0xFCAA, 0xF502, 0xF46D, 
	0xF3CE, 0xF343, 0xF2E6, 0xF2BF, 0xF2BA, 0xF2C9, 0xF2DC, 0xF2E6, 0xF381, 
	0xF4EA, 0xF688, 0xF7BE, 0xF7F2, 0xF688, 0xEB4B, 0xD64B, 0xD166, 0xC171, 
	0xBB8D, 0xC342, 0xE7A7, 0xEEEA, 0xEB06, 0xE261, 0xD99C, 0xD1E4, 0xCC66, 
	0xCA4E, 0x17FE, 0x155E, 0x1294, 0x101F, 0x0E7D, 0x0DD0, 0x0DBA, 0x0DFB, 
	0x0E52, 0x0E7D, 0x0E8C, 0x0EAF, 0x0ED7, 0x0EF5, 0x0EFA, 0x0ED7, 0x0E7D, 
	0x0D6C, 0x0D42, 0x0BC1, 0x1150, 0x153A, 0x1168, 0x091A, 0x114B, 0x1184, 
	0x0C81, 0x069A, 0x01E9, 0xFFFF, 0x0000, 0xFF32, 0xFED0, 0xFE67, 0xFE0B, 
	0xFDCD, 0xFDB4, 0xFDB1, 0xFDBA, 0xFDC7, 0xFDCD, 0xFDD2, 0xFDDC, 0xFDE8, 
	0xFDF1, 0xFDF3, 0xFDE8, 0xFDCD, 0x04DC, 0x055B, 0x0D91, 0x1236, 0x06DC, 
	0xF862, 0xE8ED, 0xF21D, 0xDE39, 0xF93F, 0xF9B8, 0xF9A0, 0xF97B, 0xF1E4, 
	0xF26D, 0xF2FE, 0xF37F, 0xF3D4, 0xF3F7, 0xF3FB, 0xF3EE, 0xF3DD, 0xF3D4, 
	0xF3DA, 0xF3EA, 0xF3FB, 0xF408, 0xF40A, 0xF3FB, 0xF3D4, 0xF2A7, 0xF322, 
	0xF5EB, 0xFCCB, 0xF52B, 0xDC5E, 0xD1D4, 0xD6E0, 0xE0ED, 0xE804, 0xEB03, 
	0xECE4, 0xED8B, 0xFFFE, 0x0001, 0xC170, 0xBDC5, 0xBDC4, 0xBDBE, 0xBDAD, 
	0xBD8E, 0xBD59, 0xB55A, 0xB136, 0xB1D7, 0xAD0D, 0x316C, 0x381A, 0x4CA7, 
	0x5551, 0x5B68, 0xDFD5, 0xE1BE, 0xDEF9, 0xD751, 0xCCD5, 0xC193, 0x32A9, 
	0x2126, 0x1511, 0x0F3F, 0x0B06, 0x0828, 0x0668, 0x0588, 0x054B, 0x10EA, 
	0x1156, 0x12A2, 0x14D8, 0x1804, 0x1C2E, 0x1FE9, 0x2059, 0x25D7, 0x26C7, 
	0x54EA, 0x521B, 0x55D8, 0x5C51, 0x5F8E, 0x1CEC, 0x1950, 0x1366, 0x0B36, 
	0x0450, 0x0244, 0x7640, 0x6840, 0x5BBE, 0x51E0, 0x473C, 0x3CF7, 0x3436, 
	0x2E1F, 0x2BD6, 0x4EB0, 0x4EA1, 0x4E7C, 0x4E4A, 0x4E15, 0x4DE5, 0x4C5B, 
	0x4814, 0x4A0E, 0x44CB, 0xCA1B, 0xD181, 0xE96A, 0xF361, 0xFAFC, 0x818C, 
	0x8660, 0x88C6, 0x88A3, 0x8626, 0x8180, 0xF745, 0xE916, 0xDEBC, 0xD95D, 
	0xD4EF, 0xD177, 0xCEF8, 0xCD76, 0xCCF5, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xF8AA, 
	0xF877, 0xF8C3, 0xF813, 0xF4EF, 0xEE20, 0xE4BE, 0xDAC4, 0xD22C, 0xCCF2, 
	0xCAE7, 0xCA51, 0xCAE2, 0xCC49, 0xCE35, 0xD056, 0xD25C, 0xD4C0, 0xD7FA, 
	0xDBB8, 0xDFA5, 0xE371, 0xE6C6, 0xE954, 0xEAC6, 0xEACA, 0xE4E0, 0xD8EC, 
	0xCD2B, 0xC7DC, 0xF32B, 0xF5A3, 0xF7E2, 0xFA92, 0xFE58, 0x03DF, 0x0AAB, 
	0x11AB, 0x17CE, 0x1C05, 0x1E9B, 0x2090, 0x21E6, 0x229E, 0x22BA, 0x223A, 
	0x2120, 0x1F60, 0x1D02, 0x1A29, 0x16F6, 0x138A, 0x1008, 0x0C91, 0x0946, 
	0x0648, 0x03BB, 0x01BF, 0x0075, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x066E, 
	0x06BB, 0x06FA, 0x0755, 0x07F4, 0x0910, 0x0A8A, 0x0C0A, 0x0D39, 0x0DBE, 
	0x0D9B, 0x0D1F, 0x0C62, 0x0B7D, 0x0A89, 0x099E, 0x08D5, 0x0819, 0x0749, 
	0x066B, 0x0585, 0x049D, 0x03BA, 0x02E2, 0x0219, 0x0168, 0x00D3, 0x0062, 
	0x0019, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xF3C6, 0xF44A, 0xF4C2, 0xF553, 
	0xF627, 0xF772, 0xF915, 0xFABF, 0xFC1B, 0xFCD6, 0xFCF1, 0xFCB6, 0xFC3C, 
	0xFB9D, 0xFAF1, 0xFA52, 0xF9D6, 0xF970, 0xF902, 0xF88D, 0xF816, 0xF79F, 
	0xF72A, 0xF6BC, 0xF657, 0xF5FD, 0xF5B2, 0xF579, 0xF555, 0xF548, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xBF5E, 0xE71D, 0xE850, 
	0xEAFC, 0xEDC0, 0xEF3C, 0xEF0C, 0xEE09, 0xECA5, 0xEB53, 0xEA86, 0xEA4B, 
	0xEA51, 0xEA7D, 0xEAB4, 0xEADA, 0xEAD4, 0xEA86, 0xEA0C, 0xE990, 0xE90B, 
	0xE878, 0xE7CE, 0xE70A, 0xE623, 0xE514, 0xE3D7, 0xE265, 0xDF3C, 0xDA6D, 
	0xD649, 0xE79B, 0xE9F7, 0xEF20, 0xF42E, 0xF63D, 0xF453, 0xF03F, 0xEB4C, 
	0xE6C6, 0xE3F7, 0xE2E6, 0xE298, 0xE2CD, 0xE348, 0xE3CC, 0xE41B, 0xE3F7, 
	0xE355, 0xE265, 0xE143, 0xE008, 0xDECE, 0xDDB0, 0xDCC8, 0xDC31, 0xDC04, 
	0xDC5C, 0xDFE1, 0xE681, 0xEC40, 0x9BA3, 0x9FCB, 0xA966, 0xB430, 0xBBE1, 
	0xBFD3, 0xC277, 0xC427, 0xC53F, 0xC61A, 0xC6F5, 0xC7BF, 0xC854, 0xC896, 
	0xC863, 0xC799, 0xC61A, 0xC3C6, 0xC0B8, 0xBD23, 0xB939, 0xB52C, 0xB130, 
	0xAD76, 0xAA32, 0xA795, 0xA5D3, 0xA87A, 0xAF7C, 0xB59D, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x4A2F, 0x4409, 0x3602, 0x26B8, 0x1CCA, 
	0x1945, 0x1848, 0x190D, 0x1ACF, 0x1CCA, 0x1F08, 0x21F0, 0x254B, 0x28E0, 
	0x2C77, 0x2FD8, 0x32CB, 0x35B1, 0x38F2, 0x3C5F, 0x3FCB, 0x4306, 0x45E3, 
	0x4832, 0x49C6, 0x4A6F, 0x4A00, 0x420B, 0x329B, 0x2537, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xBA4C, 0xBD25, 0xC3A4, 0xCAB8, 0xCF52, 
	0xD0D0, 0xD100, 0xD071, 0xCFB1, 0xCF52, 0xCF6E, 0xCFAF, 0xCFF9, 0xD031, 
	0xD03A, 0xCFF9, 0xCF52, 0xCE3F, 0xCCDB, 0xCB3B, 0xC974, 0xC79B, 0xC5C6, 
	0xC409, 0xC279, 0xC12B, 0xC034, 0xC141, 0xC3F5, 0xC55C, 0xBF3F, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xBF5E, 0x2333, 0x23DA, 
	0x24E2, 0x24E3, 0x2279, 0x1C94, 0x1441, 0x0B45, 0x0361, 0xFE5A, 0xFB53, 
	0xF88E, 0xF67F, 0xF599, 0xF64F, 0xF913, 0xFE5A, 0x0F77, 0x2AF8, 0xC125, 
	0x484F, 0x45C4, 0x31C5, 0x198C, 0x1ADA, 0x1B13, 0x1B10, 0x1B13, 0x1B0D, 
	0x1B09, 0x170B, 0x157C, 0x1235, 0x0F50, 0x0EE5, 0x11DB, 0x16D2, 0x1C7E, 
	0x2193, 0x24C6, 0x262D, 0x26D7, 0x26EF, 0x269C, 0x2609, 0x255F, 0x24C6, 
	0x23FE, 0x226A, 0x6053, 0x195D, 0x1386, 0x182A, 0x2263, 0x1EC7, 0x1838, 
	0x12E4, 0x115C, 0x1144, 0xAA09, 0xAD3B, 0xB3D5, 0xB95F, 0xB961, 0xB1CC, 
	0xA598, 0x97D1, 0x8B87, 0x83C6, 0x8039, 0x7E50, 0x7DC4, 0x7E51, 0x7FAF, 
	0x8198, 0x83C6, 0x8892, 0x90D4, 0x1A04, 0xA5AA, 0xAFC7, 0xAB2D, 0x96E5, 
	0x9DBB, 0xA14A, 0xA41A, 0xA70E, 0xA9E3, 0xAC43, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x2741, 
	0x275A, 0x27F8, 0x2992, 0x2CA2, 0x32AE, 0x3B3E, 0x43CC, 0x49D2, 0x4AC8, 
	0x45EB, 0x3D37, 0x3242, 0x26A4, 0x1BF3, 0x13C6, 0x0FB4, 0x18B6, 0x2C8A, 
	0x3BED, 0x3C06, 0x3824, 0x3C4A, 0x38E9, 0x3465, 0x26F1, 0x1C15, 0x1A91, 
	0x1C7D, 0x1E4A, 0xFFE9, 0xFFEC, 0xFFF3, 0xFFFB, 0xFFFF, 0x0001, 0x0001, 
	0x0001, 0x0000, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFFD, 0xFFFC, 0xFFFC, 0xFFFD, 
	0xFFFF, 0x0052, 0x00A9, 0x0022, 0xFCB1, 0xF9B1, 0xFEFE, 0x012A, 0x050D, 
	0xFFF0, 0xFA59, 0xFB62, 0xFD71, 0x000B, 0xFFFF, 0xFF2F, 0xFF2F, 0xFF2F, 
	0xFF2F, 0xFF2F, 0xFF2F, 0xFF2F, 0xFF2F, 0xFF2F, 0xFF2F, 0xFF2F, 0xFF2F, 
	0xFF2F, 0xFF2F, 0xFF2F, 0xFF2F, 0xFF2F, 0xFF71, 0xFFB3, 0xFF32, 0xFC47, 
	0xF982, 0xFCB2, 0xF7AE, 0xF8CD, 0xF8E6, 0xF9C5, 0xFF88, 0x018F, 0xFF2F, 
	0xCE0A, 0xCD6D, 0xCC07, 0xCA80, 0xC983, 0xC930, 0xC926, 0xC945, 0xC96E, 
	0xC983, 0xC998, 0xC9CA, 0xCA03, 0xCA2D, 0xCA35, 0xCA03, 0xC983, 0xC750, 
	0xC40E, 0xC2B5, 0xC855, 0xCC7D, 0xBBB7, 0xC17E, 0xB978, 0xC03E, 0xC85C, 
	0xC86D, 0xC6CB, 0xC765, 0xC9D7, 
},
{
	0x0022, 0x0000, 0x0022, 0x0022, 0x001D, 0x0044, 0x0001, 0x0061, 0x0001, 
	0x0062, 0x0001, 0x0063, 0x001F, 0x0064, 0x001F, 0x0083, 0x001F, 0x00A2, 
	0x0022, 0x00C1, 0x0022, 0x00E3, 0x0022, 0x0105, 0x0022, 0x0127, 0x0022, 
	0x0149, 0x0022, 0x016B, 0x0001, 0x018D, 0x0001, 0x018E, 0x0001, 0x018F, 
	0x001E, 0x0190, 0x001E, 0x01AE, 0x001E, 0x01CC, 0x0018, 0x01EA, 0x0018, 
	0x0202, 0x001E, 0x021A, 0x001F, 0x0238, 0x001E, 0x0257, 0x001E, 0x0275, 
	0x0001, 0x0293, 0x0001, 0x0294, 0x0001, 0x0295, 0x001E, 0x0296, 0x001E, 
	0x02B4, 0x001E, 0x02D2, 0x0021, 0x02F0, 0x0021, 0x0311, 0x001E, 0x0332, 
	0x0021, 0x0350, 0x0021, 0x0371, 0x001E, 0x0392, 0x001F, 0x03B0, 0x001E, 
	0x03CF, 0x0001, 0x03ED, 0x001E, 0x03EE, 0x001E, 0x040C, 0x001E, 0x042A, 
	0x001D, 0x0448, 0x001F, 0x0465, 0x001E, 0x0484, 0x001F, 0x04A2, 0x001D, 
	0x04C1, 0x001F, 0x04DE, 0x001F, 0x04FD, 0x001E, 0x051C, 0x0001, 0x053A, 
	0x001E, 0x053B, 0x001D, 0x0559, 0x001E, 0x0576, 0x001F, 0x0594, 0x0019, 
	0x05B3, 0x001E, 0x05CC, 0x001F, 0x05EA, 0x001E, 0x0609, 0x001F, 0x0627, 
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_CLIMB_DOWN_LEDGE], 0, 189, 0, 9, 9, {
	0x0000, 0x0001, 0x0002, 0x0003, 0x0004, 0x0005, 0x0006, 0x0006, 0x0007, 
	0x008F, 0x0053, 0x001C, 0xFFC9, 0xFF89, 0xFF5C, 0xFF02, 0xFEB9, 0xFE7F, 
	0xFE6E, 0xFFF9, 0xFFD7, 0xFFBE, 0xFFB6, 0xFFAA, 0xFFA0, 0xFF9A, 0xFF8E, 
	0xFF70, 0xFF8C, 0x0000, 0x3FFF, 0x0000, 0x5589, 0x487B, 0x3835, 0x1969, 
	0x011F, 0xFBC9, 0xFAC1, 0xFC3D, 0xFE71, 0xFF93, 0xDE18, 0xD19C, 0xCAAB, 
	0xD55E, 0xE396, 0xEC7E, 0xF593, 0xFD99, 0x0352, 0x0580, 0x3DF7, 0x33C6, 
	0x2DBF, 0x35BC, 0x3EE0, 0x408E, 0x40E7, 0x4078, 0x3FCE, 0x3F76, 0xCFA9, 
	0xCEFE, 0xD2FB, 0xE869, 0xFB8F, 0x001C, 0x01B0, 0x016B, 0x006E, 0xFFDA, 
	0x0EC2, 0x100A, 0x1158, 0x13D4, 0x1422, 0x0FB5, 0x0986, 0x0329, 0xFE31, 
	0xFC2F, 0xF8D8, 0xF1E1, 0xEE00, 0xF49F, 0xFBDF, 0xFD30, 0xFD68, 0xFCFD, 
	0xFC67, 0xFC1B, 0x3A19, 0x3B0D, 0x3DBE, 0x45E6, 0x4809, 0x3B44, 0x292F, 
	0x1698, 0x07F2, 0x0215, 0xF0EE, 0xFA6D, 0x0547, 0x016E, 0xFBC7, 0xFB89, 
	0xFC43, 0xFF8B, 0xFFFC, 0xFF8D, 0xF4BE, 0xF443, 0xF404, 0xF5B1, 0xF696, 
	0xF4D3, 0xF232, 0xEC01, 0xE5C2, 0xE0FA, 0xFFFE, 0x0001, 0xC170, 0x2709, 
	0xDD37, 0x909A, 0xFCD0, 0xF17F, 0xA62E, 0x2560, 0x34CF, 0x3183, 0x343C, 
	0xE3DC, 0xDA25, 0xDE09, 0xAD6B, 0xA98C, 0xADA5, 0xDB70, 0xDBF2, 0xE5D4, 
	0xE4A6, 0xA065, 0xD096, 0x1FBD, 0xBA98, 0xC593, 0xF1B6, 0x661A, 0x506B, 
	0x54CF, 0x505B, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xE59A, 0xBE8A, 0xB4FF, 0xB578, 0xC35E, 
	0xD1A3, 0xE643, 0xEE04, 0xF327, 0xF502, 0x0000, 0x1A7D, 0xE5DA, 0xE7B5, 
	0xEB91, 0xFFAF, 0xFFCE, 0x08C7, 0x1312, 0x17FE, 0xF97B, 0xFC7E, 0xFB04, 
	0xFB8A, 0xF074, 0xFFF4, 0xFD61, 0xFDC4, 0xFEAF, 0xFF32, 0xED8B, 0xE780, 
	0xEEB6, 0xF029, 0xF45A, 0xEA85, 0xEE5C, 0xF018, 0xF163, 0xF1E4, 0xFFFE, 
	0x0001, 0xC170, 0x054B, 0xDEF3, 0x41FE, 0x348E, 0x49C0, 0xC075, 0xC786, 
	0xC3E1, 0xC00E, 0xBDC5, 0x2BD6, 0x1E05, 0x6BCB, 0x7221, 0x6363, 0x1305, 
	0x0E23, 0x0F5C, 0x110D, 0x10EA, 0xCCF5, 0x9EF3, 0xFC18, 0xEFFD, 0x046E, 
	0x658D, 0x6799, 0x5908, 0x5454, 0x4EB0, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xC7DC, 0xD03B, 0xD4FA, 0xCB41, 0xC518, 0xEAD3, 
	0xF14F, 0xF596, 0xF7F1, 0xF8AA, 0xFFFF, 0xFD14, 0xFC8D, 0x057C, 0x0C40, 
	0xF616, 0xF3FD, 0xF32B, 0xF314, 0xF32B, 0xFFFF, 0x00DA, 0x01BA, 0xFF07, 
	0x03A9, 0x1E80, 0x17FB, 0x1004, 0x0946, 0x066E, 0xF548, 0xF515, 0xF4E0, 
	0xF5A4, 0xF46C, 0xED2F, 0xEEF9, 0xF127, 0xF2FF, 0xF3C6, 0x0000, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xBF5E, 
	0xED51, 0xF036, 0xEF4B, 0xDFAF, 0xD2CE, 0xD42B, 0xD91D, 0xDF67, 0xE4D0, 
	0xE71D, 0xFF66, 0xF511, 0xEC7B, 0xE8B7, 0xE794, 0xE722, 0xE716, 0xE742, 
	0xE77D, 0xE79B, 0xAB33, 0xA233, 0x9EC9, 0xB04B, 0xBF17, 0xBB1E, 0xB24A, 
	0xA7E7, 0x9F41, 0x9BA3, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 
	0xFFFF, 0x0000, 0xFFFF, 0x2124, 0x1E8B, 0x1C3B, 0x18C7, 0x198E, 0x22D0, 
	0x2F66, 0x3C38, 0x462D, 0x4A2F, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0xD195, 0xCE99, 0xCD63, 0xD36C, 
	0xD75E, 0xD29A, 0xCB2C, 0xC339, 0xBCE2, 0xBA4C, 0x0000, 0x0000, 0x0000, 
	0x0000, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xBF5E, 0x056C, 
	0x028B, 0xFAA6, 0x05A9, 0x1123, 0x16B9, 0x1BAA, 0x1F9F, 0x1CEE, 0x2333, 
	0x1EFC, 0x3240, 0x21A7, 0x293A, 0x305D, 0x2CC2, 0x265C, 0x1F3B, 0x1F9D, 
	0x170B, 0x87CF, 0x5D05, 0x8177, 0x9168, 0x9A12, 0x9F70, 0xA3DD, 0xA732, 
	0xA117, 0xAA09, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0x0000, 0xFFFF, 0x0000, 0x4FFE, 0x51AF, 0x4AA3, 0x23F3, 0x0728, 
	0x0742, 0x0ED1, 0x1987, 0x231B, 0x2741, 0x00D4, 0x06BC, 0x0084, 0xFFE7, 
	0x0051, 0x0038, 0x001C, 0x0003, 0xFFF0, 0xFFE9, 0xEDC0, 0xF6F0, 0xFF73, 
	0x001E, 0xFF5D, 0xFF52, 0xFF46, 0xFF3A, 0xFF32, 0xFF2F, 0x9A39, 0xBBDE, 
	0xABAF, 0xAF8D, 0xB6BB, 0xBC4C, 0xC278, 0xC830, 0xCC66, 0xCE0A, 
},
{
	0x0009, 0x0000, 0x000A, 0x0009, 0x000A, 0x0013, 0x0001, 0x001D, 0x0001, 
	0x001E, 0x0001, 0x001F, 0x000A, 0x0020, 0x000A, 0x002A, 0x000A, 0x0034, 
	0x000A, 0x003E, 0x000A, 0x0048, 0x000A, 0x0052, 0x000A, 0x005C, 0x000A, 
	0x0066, 0x000A, 0x0070, 0x0001, 0x007A, 0x0001, 0x007B, 0x0001, 0x007C, 
	0x000A, 0x007D, 0x000A, 0x0087, 0x000A, 0x0091, 0x000A, 0x009B, 0x000A, 
	0x00A5, 0x000A, 0x00AF, 0x000A, 0x00B9, 0x000A, 0x00C3, 0x000A, 0x00CD, 
	0x0001, 0x00D7, 0x0001, 0x00D8, 0x0001, 0x00D9, 0x000A, 0x00DA, 0x000A, 
	0x00E4, 0x000A, 0x00EE, 0x000A, 0x00F8, 0x0006, 0x0102, 0x000A, 0x0108, 
	0x000A, 0x0112, 0x000A, 0x011C, 0x000A, 0x0126, 0x0009, 0x0130, 0x000A, 
	0x0139, 0x0001, 0x0143, 0x000A, 0x0144, 0x000A, 0x014E, 0x000A, 0x0158, 
	0x0008, 0x0162, 0x000A, 0x016A, 0x000A, 0x0174, 0x0009, 0x017E, 0x000A, 
	0x0187, 0x000A, 0x0191, 0x0009, 0x019B, 0x000A, 0x01A4, 0x0001, 0x01AE, 
	0x000A, 0x01AF, 0x000A, 0x01B9, 0x000A, 0x01C3, 0x000A, 0x01CD, 0x000A, 
	0x01D7, 0x000A, 0x01E1, 0x000A, 0x01EB, 0x000A, 0x01F5, 0x000A, 0x01FF, 
})

smlua_anim_util_register_animation(bowsAnimTable[MARIO_ANIM_CROUCH_FROM_FAST_LONGJUMP], 0, 189, 0, 15, 15, {
	0x0000, 0x008E, 0x007F, 0x0076, 0x0070, 0x006C, 0x006A, 0x0069, 0xFFDD, 
	0x0000, 0x3FFF, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0x3AC3, 0x38B5, 0x3B3A, 0x413B, 0x4866, 
	0x4E68, 0x50ED, 0x106C, 0x0F32, 0x0C26, 0x0832, 0x0440, 0x0137, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xFFFF, 
	0xFA19, 0xFA7F, 0xFB11, 0xFC6F, 0xFE0F, 0xFF6D, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x2E21, 0x3215, 
	0x2F9C, 0x29B6, 0x22AD, 0x1CC7, 0x1A4E, 0x1A5D, 0x1A6D, 0x1A1A, 0x1947, 
	0x1826, 0x16EB, 0x15CA, 0x14F6, 0x14A4, 0xF53C, 0xF297, 0xF2D7, 0xF387, 
	0xF48D, 0xF5D2, 0xF73D, 0xF8B4, 0xFA22, 0xFB7C, 0xFCB8, 0xFDCF, 0xFEB7, 
	0xFF67, 0xFFD8, 0xFFFF, 0xFE30, 0xF8FF, 0xF903, 0xF914, 0xF939, 0xF97A, 
	0xF9DF, 0xFA6E, 0xFB2B, 0xFC08, 0xFCF4, 0xFDDD, 0xFEB1, 0xFF5F, 0xFFD4, 
	0x0000, 0xE618, 0xE2D2, 0xE1E2, 0xDF8A, 0xDC7D, 0xD971, 0xD718, 0xD628, 
	0xD666, 0xD709, 0xD7F0, 0xD8F9, 0xDA01, 0xDAE8, 0xDB8B, 0xDBC9, 0x0001, 
	0xFFFE, 0xC170, 0xBB6C, 0xB991, 0xB8F5, 0xB772, 0xB57A, 0xB381, 0xB1FE, 
	0xB163, 0xB281, 0xB574, 0xB99F, 0xBE66, 0xC32E, 0xC759, 0xCA4C, 0xCB6A, 
	0x9FBF, 0x9A34, 0x9CA7, 0xA2C8, 0xAABF, 0xB2B6, 0xB8D6, 0xBB49, 0xBAB8, 
	0xB93A, 0xB71C, 0xB4B0, 0xB244, 0xB026, 0xAEA8, 0xAE17, 0xF69A, 0xECC5, 
	0xECD5, 0xECFC, 0xED2F, 0xED62, 0xED89, 0xED99, 0xED44, 0xEC65, 0xEB2A, 
	0xE9C1, 0xE857, 0xE71C, 0xE63D, 0xE5E8, 0x0000, 0x0000, 0x0000, 0x0000, 
	0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 
	0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xEB82, 
	0xEC41, 0xEBBE, 0xEA4F, 0xE81C, 0xE54C, 0xE206, 0xDE71, 0xDAB5, 0xD6F9, 
	0xD364, 0xD01E, 0xCD4D, 0xCB1A, 0xC9AC, 0xC929, 0xE6CF, 0xF06C, 0xF093, 
	0xF0FE, 0xF1A2, 0xF275, 0xF36A, 0xF476, 0xF58D, 0xF6A5, 0xF7B1, 0xF8A6, 
	0xF978, 0xFA1D, 0xFA88, 0xFAAE, 0xE8BD, 0xFBF4, 0xF90E, 0xF692, 0xF477, 
	0xF2B6, 0xF146, 0xF020, 0xEF3B, 0xEE8F, 0xEE13, 0xEDC0, 0xED8E, 0xED74, 
	0xED6B, 0xED69, 0xF321, 0xF7A8, 0xF700, 0xF670, 0xF5F6, 0xF591, 0xF53D, 
	0xF4FB, 0xF4C7, 0xF4A0, 0xF484, 0xF471, 0xF466, 0xF460, 0xF45E, 0x0001, 
	0xFFFE, 0xC170, 0x18B9, 0x3C65, 0x33D4, 0x1E52, 0x0226, 0x6597, 0x4EF0, 
	0x4476, 0x4272, 0x40EE, 0x3FD8, 0x3F1D, 0x3EAC, 0x3E72, 0x3E5D, 0x3E5A, 
	0x4A8E, 0x48B5, 0x47A3, 0x44D1, 0x40D9, 0x43AC, 0x4827, 0x4BFE, 0x4EEB, 
	0x511D, 0x52B0, 0x53BE, 0x5462, 0x54B6, 0x54D5, 0x54D9, 0xD8C5, 0xDC2D, 
	0xD28B, 0xBA76, 0x9B27, 0xFBD8, 0xE3C3, 0xDA21, 0xDAEA, 0xDCFC, 0xDFE9, 
	0xE344, 0xE69F, 0xE98C, 0xEB9E, 0xEC67, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 
	0x0000, 0x0000, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 
	0x0000, 0xEE31, 0xE5B0, 0xE030, 0xDB79, 0xD77B, 0xD427, 0xD16D, 0xCF3F, 
	0xCD8C, 0xCC45, 0xCB5B, 0xCABE, 0xCA5F, 0xCA2E, 0xCA1C, 0xCA19, 0x1DA9, 
	0x1104, 0x0E0B, 0x0B7F, 0x0957, 0x078B, 0x0612, 0x04E5, 0x03FA, 0x0349, 
	0x02CB, 0x0276, 0x0242, 0x0228, 0x021E, 0x021D, 0x184A, 0x0CF6, 0x0D0A, 
	0x0D41, 0x0D96, 0x0E02, 0x0E80, 0x0F0A, 0x0F9A, 0x102A, 0x10B4, 0x1132, 
	0x119E, 0x11F3, 0x122A, 0x123E, 0xF971, 0xFB0F, 0xFAFC, 0xFAC7, 0xFA75, 
	0xFA0C, 0xF992, 0xF90D, 0xF882, 0xF7F8, 0xF773, 0xF6F9, 0xF690, 0xF63E, 
	0xF609, 0xF5F6, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 
	0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xBF5E, 0x02DE, 0x0182, 
	0xFFE0, 0xFEBC, 0xFE03, 0xFDA2, 0xFD86, 0xF952, 0xFC9B, 0xF948, 0xF15A, 
	0xE7E3, 0xDFF5, 0xDCA1, 0x8CC7, 0x8BD1, 0x88B1, 0x843B, 0x7F99, 0x7BF7, 
	0x7A7E, 0x0000, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0x0000, 0xFFFF, 0x330E, 0x425A, 0x4738, 0x4A2C, 0x4BB0, 0x4C3F, 0x4C54, 
	0xFB89, 0xFD47, 0xFCF8, 0xFC3A, 0xFB58, 0xFA9A, 0xFA4B, 0xFF13, 0xFF07, 
	0xFF21, 0xFF5E, 0xFFA8, 0xFFE5, 0x0000, 0xAF2D, 0xAEAA, 0xAFF7, 0xB311, 
	0xB6C5, 0xB9DF, 0xBB2C, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0xFFFF, 0xFFFF, 0x0000, 0xBF5E, 0xFD6D, 
	0xFF90, 0x000F, 0x013B, 0x02A2, 0x03CE, 0x044C, 0x0046, 0x003E, 0x03D0, 
	0x0C53, 0x167D, 0x1F00, 0x2292, 0x9563, 0x8EE4, 0x861C, 0x7ED0, 0x7945, 
	0x75BF, 0x7484, 0xFFFF, 0x0000, 0xFFFF, 0x0000, 0x0000, 0xFFFF, 0x0000, 
	0xFFFF, 0xFFFF, 0xFFFF, 0x0000, 0x14E1, 0x3084, 0x3A82, 0x4091, 0x43AE, 
	0x44D4, 0x44FE, 0xFCE1, 0xFD14, 0xFD64, 0xFE21, 0xFF04, 0xFFC1, 0x0012, 
	0xFD81, 0xFD50, 0xFD82, 0xFDF9, 0xFE87, 0xFEFE, 0xFF30, 0xC2FA, 0xC043, 
	0xC0E1, 0xC258, 0xC418, 0xC58F, 0xC62C, 
},
{
	0x0001, 0x0000, 0x0007, 0x0001, 0x0001, 0x0008, 0x0001, 0x0009, 0x0001, 
	0x000A, 0x0001, 0x000B, 0x0004, 0x000C, 0x0006, 0x0010, 0x0007, 0x0016, 
	0x0010, 0x001D, 0x0010, 0x002D, 0x0010, 0x003D, 0x0010, 0x004D, 0x0010, 
	0x005D, 0x0010, 0x006D, 0x0001, 0x007D, 0x0001, 0x007E, 0x0001, 0x007F, 
	0x0010, 0x0080, 0x0010, 0x0090, 0x0010, 0x00A0, 0x000F, 0x00B0, 0x000F, 
	0x00BF, 0x0010, 0x00CE, 0x0010, 0x00DE, 0x0010, 0x00EE, 0x000F, 0x00FE, 
	0x0001, 0x010D, 0x0001, 0x010E, 0x0001, 0x010F, 0x0010, 0x0110, 0x0010, 
	0x0120, 0x0010, 0x0130, 0x0010, 0x0140, 0x0010, 0x0150, 0x0010, 0x0160, 
	0x0010, 0x0170, 0x0010, 0x0180, 0x0010, 0x0190, 0x0007, 0x01A0, 0x0006, 
	0x01A7, 0x0001, 0x01AD, 0x0007, 0x01AE, 0x0007, 0x01B5, 0x0007, 0x01BC, 
	0x0005, 0x01C3, 0x0005, 0x01C8, 0x0007, 0x01CD, 0x0007, 0x01D4, 0x0007, 
	0x01DB, 0x0007, 0x01E2, 0x0007, 0x01E9, 0x0006, 0x01F0, 0x0001, 0x01F6, 
	0x0007, 0x01F7, 0x0007, 0x01FE, 0x0007, 0x0205, 0x0006, 0x020C, 0x0005, 
	0x0212, 0x0007, 0x0217, 0x0007, 0x021E, 0x0007, 0x0225, 0x0007, 0x022C, 
})


-- handling custom anims
---@param m MarioState
hook_event(HOOK_MARIO_UPDATE, function (m)
	local bowserState = gPlayerSyncTable[m.playerIndex].bowserState
    local animID = bowsAnimTable[m.marioObj.header.gfx.animInfo.animID]

    if animID ~= nil and bowserState ~= 0 then
		-- clauses for different animation types, could be better idk
		local animType = string.sub(animID, 1, 1)
		if (bowserState & bowsMoveset.FLAG_STYLE_ANIMS ~= 0 and animType == '0')
		or (bowserState & bowsMoveset.FLAG_SIZE_ANIMS ~= 0 and animType == '1')
		or (bowserState & bowsMoveset.FLAG_CAN_USE_FIREBALL ~= 0 and animType == '2')
		then
			smlua_anim_util_set_animation(m.marioObj, animID)
		end
    end
end)